#include "ibis_mad_names.h"
#include <iostream>
using namespace std;

IbisMadNames::IbisMadNames() : m_maxLenMadName(0) {
    /* --- IBIS_IB_CLASS_SMI attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_smi_map;
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_NODE_DESC] = "NodeDescription";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_NODE_INFO] = "NodeInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_SWITCH_INFO] = "SwitchInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_GUID_INFO] = "GUIDInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PORT_INFO] = "PortInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PKEY_TBL] = "P_KeyTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_SLVL_TABLE] = "SLtoVLMappingTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VL_ARBITRATION] = "VLArbitrationTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_LINEARFORWTBL] = "LinearForwardingTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_MULTICASTFORWTBL] = "MulticastForwardingTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_LINKSPEEDWIDTHPAIRSTBL] = "LinkSpeedWidthPairsTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VENDORMADSTBL] = "VendorSpecificMadsTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_SMINFO] = "SMInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PORT_INFO_EXTENDED] = "PortInfoExtended";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_SWITCH_PORT_STATE_TABLE] = "SwitchPortStateTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_HIERARCHY_INFO] = "HierarchyInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PLFT_INFO] = "PrivateLFTInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PLFT_DEF] = "PrivateLFTDef";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PLFT_MAP] = "PrivateLFTMap";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PORT_SL_TO_PLFT_MAP] = "PortSLToPrivateLFTMapT";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VS_GENERAL_INFO] = "GeneralInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_AR_INFO] = "AdaptiveRoutingInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_AR_GROUP_TABLE] = "ARGroupTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_AR_LINEAR_FORWARDING_TABLE] = "ARLinearFowardingTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_AR_LINEAR_FORWARDING_TABLE_SX] = "ARLinearFowardingTableSX";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_HBF_CONFIG] = "HBFConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_WHBF_CONFIG] = "WHBFConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_LINEAR_FORWARDING_TABLE_SPLIT] = "LinearForwardingTableSplit";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_NVL_HBF_CONFIG] = "NVLHBFConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_TEMP_SENSING] = "TemperatureSensing";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_END_PORT_PLANE_FILTER_CONFIG] = "EndPortPlaneFilterConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PFRN_CONFIG] = "pFRNConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_CREDIT_WATCHDOG_CONFIG] = "CreditWatchdogConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_BER_CONFIG] = "BERConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_PROFILES_CONFIG] = "ProfilesConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_QOS_CONFIG_SL] = "QosConfigSL";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_QOS_CONFIG_VL] = "QosConfigVL";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_CONTAIN_AND_DRAIN_INFO] = "SMPContainAndDrainInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_CONTAIN_AND_DRAIN_PORT_STATE] = "SMPContainAndDrainPortState";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_ANYCAST_LID_INFO] = "SMPAnycastLIDInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RAIL_FILTER_CONFIG] = "SMPRailFilterConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_ENTRY_PLANE_FILTER_CONFIG] = "EntryPlaneFilterConfig";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_MLNXEXTPORTINFO] = "ExtendedPortInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_EXTENDED_NODE_INFO] = "ExtendedNodeInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VIRTUALIZATION_INFO] = "VirtualizationInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VPORT_INFO] = "VPortInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VPORT_STATE] = "VPortState";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VNODE_INFO] = "VNodeInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VNODE_DESC] = "VNodeDescription";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VPORT_PKEY_TBL] = "VPortPartitionTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_VPORT_GUID_INFO] = "VPortGUIDInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RN_GEN_STRING_TABLE ] = "RNGenStringTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RN_RCV_STRING] = "RNRcvString";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RN_SUB_GROUP_DIRECTION_TABLE] = "RNSubGroupDirectionTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RN_XMIT_PORT_MASK] = "RNSubGroupDirectionTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_AR_GROUP_TABLE_COPY] = "AdaptiveRoutingGroupTableCopy";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RN_GEN_BY_SUB_GROUP_PRIORITY] = "RNGenBySubGroupPriority";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_ROUTER_INFO] = "RouterInfo";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RTR_NEXT_HOP_TABLE] = "RoutersNextHopTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RTR_ADJ_SITE_LOCAL_SUBNETS_TABLE] = "RoutersAdjacentSiteLocalSubnetsTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RTR_ADJ_SUBNETS_RTR_LID_INFO_TABLE] = "RoutersAdjacentSubnetRouterLIDInfoTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_RTR_LID_TABLE] = "Routers RouterLIDTable";
    ibis_ib_class_smi_map[IBIS_IB_ATTR_SMP_EXTENDED_SWITCH_INFO] = "ExtendedSwitchInfo";
    m_mad_names[IBIS_IB_CLASS_SMI] = ibis_ib_class_smi_map;
    m_mad_names[IBIS_IB_CLASS_SMI_DIRECT] = ibis_ib_class_smi_map;


    /* --- IBIS_IB_CLASS_PERFORMANCE attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_performance_map;
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_SAMPLES_CONTROL] = "PortSamplesControl";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_SAMPLES_RESULT] = "PortSamplesResult";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_COUNTERS] = "PortCounters";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_RCV_ERROR_DETAILS] = "PortRcvErrorDetails";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_XMIT_DISCARD_DETAILS] = "PortXmitDiscardDetails";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_VL_XMIT_FLOW_CTL_UPDATE_ERRORS] = "PortVLXmitFlowCtlUpdateErrors";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_VL_XMIT_WAIT] = "PortVLXmitWaitCounters";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_COUNTERS_EXT] = "PortCountersExtended";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_EXT_SPEEDS_COUNTERS] = "PortExtendedSpeedsCounters";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_XMIT_CON_CTRL] = "PortXmitConCtrl";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_VL_XMIT_TIME_CONG] = "PortXmitTimeCong";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_XMIT_DATA_SL] = "PortXmitDataSL";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_RCV_DATA_SL] = "PortRcvDataSL";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_XMIT_DATA_SL_EXT] = "PortXmitDataSLExt";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_RCV_DATA_SL_EXT] = "PortRcvDataSLExt";
    ibis_ib_class_performance_map[IBIS_IB_ATTR_PERF_MANAGEMENT_PORT_SAMPLES_RESULT] = "PortSamplesResult";
    m_mad_names[IBIS_IB_CLASS_PERFORMANCE] = ibis_ib_class_performance_map;


    /* --- IBIS_IB_CLASS_AM attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_am_map;
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_KEY_INFO] = "AMKeyInfo";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_AN_INFO] = "ANInfo";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_QP_ALLOCATION] = "QPAlloc";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_QPC_CONFIG] = "QPCConfig";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_TREE_CONFIG] = "TreeConfig";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_QUOTA_CONFIG] = "ANQuota";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_AN_SEMAPHORE_INFO] = "ANSemaphoreInfo";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_AN_SAT_QP_INFO] = "ANSATQPInfo";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_RESOURCE_CLEANUP] = "ResourceCleanup";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_PERFORMANCE_COUNTERS] = "ANPerformanceCounters";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_QP_DATABASE] = "QPDatabase";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_AN_ACTIVE_JOBS] = "ANActiveJobs";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_PORT_CREDIT_RESOURCES_ALLOCATION] = "PortCreditResourcesAllocation";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_TREE_TO_JOB_BIND] = "TreeToJobBinding";
    ibis_ib_class_am_map[IBIS_IB_ATTR_AM_MULTICAST_PRIVATE_LFT] = "MulticastPrivateLFT";
    m_mad_names[IBIS_IB_CLASS_AM] = ibis_ib_class_am_map;


    /* --- IBIS_IB_CLASS_E attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_e_map;
    ibis_ib_class_e_map[IBIS_RDM_ATTR_NVL_REDUCTION_INFO] = "NVLReductionInfo";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_REDUCTION_FORWARDING_TABLE] = "ReductionForwardingTable";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_PENALTY_BOX_CONFIG] = "PenaltyBoxConfig";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_NVL_REDUCTION_PORT_INFO] = "NVLReductionPortInfo";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_NVL_REDUCTION_PROFILES_CONFIG] = "NVLReductionProfilesConfig";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_NVL_REDUCTION_CONFIGURE_MLID_MONITORS] = "NVLReductionConfigureMlidMonitors";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_NVL_REDUCTION_COUNTERS] = "NVLReductionCounters";
    ibis_ib_class_e_map[IBIS_RDM_ATTR_NVL_REDUCTION_ROUNDING_MODE] = "NVLReductionRoundingMode";
    m_mad_names[IBIS_IB_CLASS_E] = ibis_ib_class_e_map;


    /* --- IBIS_IB_CLASS_VENDOR_MELLANOX attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_vendor_mellanox_map;
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_GENERAL_INFO] = "GeneralInfo";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_MIRRORING_INFO] = "MirroringInfo";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_MIRRORING_AGENT] = "MirroringAgent";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_MIRRORING_GLOBAL_TRIGGER] = "MirroringGlobalTrigger";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_CONGESTION_MIRRORING] = "CongestionMirroring";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_SWITCH_NETWORK_INFO] = "SwitchNetworkInfo";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_RCV_DATA_VL] = "PortRcvDataVL";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_XMIT_DATA_VL] = "PortXmitDataVL";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_RCV_PKT_VL] = "PortRcvPktsVL";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_XMIT_PKT_VL] = "PortXmitPktsVL";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_LLR_STATISTICS] = "PortLLRStatistics";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_RCV_DATA_VL_EXT] = "PortRcvDataVLExtended";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_XMIT_DATA_VL_EXT] = "PortXmitDataVLExtended";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_RCV_PKT_VL_EXT] = "PortRcvPktsVLExtended";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_XMIT_PKT_VL_EXT] = "PortXmitPktsVLExtended";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_XMIT_WAIT_VL_EXT] = "PortXmitWaitVLExtended";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_DIAGNOSTIC_COUNTERS] = "DiagnosticData";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_ROUTING_DECISION_COUNTERS] = "PortRoutingDecisionCounters";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_CREDIT_WATCHDOG_TIMEOUT_COUNTERS] = "CreditWatchdogTimeoutCounters";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_FAST_RECOVERY_COUNTERS] = "FastRecoveryCounters";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_VL_XMIT_TIME_CONG_EXT] = " PortVLXmitTimeCongExtended";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_RN_COUNTERS] = "PortRNCounters";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PERFORMANCE_HISTOGRAM_INFO] = "PerformanceHistogramInfo";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PERFORMANCE_HISTOGRAM_BUFFER_CONTROL] = "PerformanceHistogramBufferControl";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PERFORMANCE_HISTOGRAM_BUFFER_DATA] = "PerformanceHistogramBufferData";
    ibis_ib_class_vendor_mellanox_map[IBIS_IB_ATTR_VENDOR_SPEC_MELLANOX_PORT_GENERAL_COUNTERS] = "PortGeneralCounters";
    m_mad_names[IBIS_IB_CLASS_VENDOR_MELLANOX] = ibis_ib_class_vendor_mellanox_map;


    /* --- IBIS_IB_CLASS_CC attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_cc_map;
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_CONG_INFO] = "CongestionInfo";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_CONG_KEY_INFO] = "CongestionKeyInfo";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_CONG_LOG] = "CongestionLog";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_SW_CONG_SETTING] = "SwitchCongestionSetting";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_SW_PORT_CONG_SETTING] = "SwitchPortCongestionSetting";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_CA_CONG_SETTING] = "CACongestionSetting";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_CC_TBL] = "CongestionControlTable";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_TIME_STAMP] = "TimeStamp";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_ENHANCED_INFO] = "EnhancedCongestionInfo";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_SW_GENERAL_SETTINGS] = "CongestionSwitchGeneralSettings";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_PORT_PROFILE_SETTINGS] = "CongestionPortProfileSettings";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_SL_MAPPING_SETTINGS] = "CongestionSLMappingSettings";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_GENERAL_SETTINGS] = "CongestionHCAGeneralSettings";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_RP_PARAMETERS] = "CongestionHCARPParameters";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_NP_PARAMETERS] = "CongestionHCANPParameters";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_STATISTICS_QUERY] = "CongestionHCAStatisticsQuery";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_ALGO_CONFIG] = "CongestionHCAAlgoConfig";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_ALGO_CONFIG_PARAMS] = "CongestionHCAConfigParam";
    ibis_ib_class_cc_map[IBIS_IB_ATTR_CONGESTION_CONT_HCA_ALGO_COUNTERS] = "CongestionHCACounters";
    m_mad_names[IBIS_IB_CLASS_CC] = ibis_ib_class_cc_map;


    /* --- IBIS_IB_CLASS_C attributes --- */
    map < u_int32_t, const char * > ibis_ib_class_c_map;
    ibis_ib_class_c_map[IBIS_IB_ATTR_CLASS_C_KEY_INFO] = "KeyInfo";
    ibis_ib_class_c_map[IBIS_IB_ATTR_CLASS_C_NEIGHBORS_INFO] = "NeighborsInfo";
    m_mad_names[IBIS_IB_CLASS_C] = ibis_ib_class_c_map;

    for (mad_names_map::iterator class_map_it = m_mad_names.begin();
        class_map_it != m_mad_names.end(); ++class_map_it) {
        for (std::map <u_int32_t, const char* >::iterator it = class_map_it->second.begin();
            it != class_map_it->second.end(); ++it) {
            if (strlen(it->second) > m_maxLenMadName) {
                m_maxLenMadName = strlen(it->second);
            }
        }
    }
}

const char* IbisMadNames::getMadName(u_int32_t class_id, u_int32_t attribute_id) {
    IbisMadNames& inst_ = getInstance();
    mad_names_map::iterator it = inst_.m_mad_names.find(class_id);
    if (it == inst_.m_mad_names.end())
        return NULL;
    map<u_int32_t, const char *>::iterator attr_name_entry = it->second.find(attribute_id);
    if (attr_name_entry == it->second.end())
        return NULL;
    return attr_name_entry->second;
}

u_int8_t IbisMadNames::getMaxMadNameLen() {
    IbisMadNames& inst_ = getInstance();
    return inst_.m_maxLenMadName;
}
