
/*     - NVIDIA CORPORATION & AFFILIATES Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2021, Mellanox Technologies Ltd. ALL RIGHTS RESERVED.
 *  Copyright (C) 2021-2024, NVIDIA CORPORATION & AFFILIATES. ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 */


/***
         *** This file was generated at "2024-07-11 11:08:05"
         *** by:
         ***    > /mswg/release/tools/a-me/a-me-1.0.99/adabe_plugins/adb2c/adb2pack.py --input adb/internal_packets.adb --file-prefix internal_packets --copyright=copyrights
         ***/
#include "internal_packets_layouts.h"

void pddr_advanced_opcode_pack(const struct pddr_advanced_opcode *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->advanced_opcode);

}

void pddr_advanced_opcode_unpack(struct pddr_advanced_opcode *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->advanced_opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_advanced_opcode_print(const struct pddr_advanced_opcode *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_advanced_opcode ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "advanced_opcode      : " UH_FMT "\n", ptr_struct->advanced_opcode);

}

int pddr_advanced_opcode_size(void)
{
	return 4;
}

void pddr_advanced_opcode_dump(const struct pddr_advanced_opcode *ptr_struct, FILE *file)
{
	pddr_advanced_opcode_print(ptr_struct, file, 0);
}

void pddr_c2p_link_enabed_eth_pack(const struct pddr_c2p_link_enabed_eth *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->core_to_phy_link_eth_enabled);

}

void pddr_c2p_link_enabed_eth_unpack(struct pddr_c2p_link_enabed_eth *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->core_to_phy_link_eth_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pddr_c2p_link_enabed_eth_print(const struct pddr_c2p_link_enabed_eth *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_c2p_link_enabed_eth ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_link_eth_enabled : " U32H_FMT "\n", ptr_struct->core_to_phy_link_eth_enabled);

}

int pddr_c2p_link_enabed_eth_size(void)
{
	return 4;
}

void pddr_c2p_link_enabed_eth_dump(const struct pddr_c2p_link_enabed_eth *ptr_struct, FILE *file)
{
	pddr_c2p_link_enabed_eth_print(ptr_struct, file, 0);
}

void pddr_c2p_link_enabed_ib_pack(const struct pddr_c2p_link_enabed_ib *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->core_to_phy_link_proto_enabled);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->core_to_phy_link_width_enabled);

}

void pddr_c2p_link_enabed_ib_unpack(struct pddr_c2p_link_enabed_ib *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->core_to_phy_link_proto_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->core_to_phy_link_width_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_c2p_link_enabed_ib_print(const struct pddr_c2p_link_enabed_ib *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_c2p_link_enabed_ib ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_link_proto_enabled : %s (" UH_FMT ")\n", (ptr_struct->core_to_phy_link_proto_enabled == 1 ? ("SDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 2 ? ("DDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 4 ? ("QDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 8 ? ("FDR10") : ((ptr_struct->core_to_phy_link_proto_enabled == 16 ? ("FDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 32 ? ("EDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 64 ? ("HDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 128 ? ("NDR") : ((ptr_struct->core_to_phy_link_proto_enabled == 256 ? ("XDR") : ("unknown")))))))))))))))))), ptr_struct->core_to_phy_link_proto_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_link_width_enabled : " UH_FMT "\n", ptr_struct->core_to_phy_link_width_enabled);

}

int pddr_c2p_link_enabed_ib_size(void)
{
	return 4;
}

void pddr_c2p_link_enabed_ib_dump(const struct pddr_c2p_link_enabed_ib *ptr_struct, FILE *file)
{
	pddr_c2p_link_enabed_ib_print(ptr_struct, file, 0);
}

void pddr_cable_cap_eth_pack(const struct pddr_cable_cap_eth *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_ext_eth_proto_cap);

}

void pddr_cable_cap_eth_unpack(struct pddr_cable_cap_eth *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->cable_ext_eth_proto_cap = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pddr_cable_cap_eth_print(const struct pddr_cable_cap_eth *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_cable_cap_eth ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_ext_eth_proto_cap : " U32H_FMT "\n", ptr_struct->cable_ext_eth_proto_cap);

}

int pddr_cable_cap_eth_size(void)
{
	return 4;
}

void pddr_cable_cap_eth_dump(const struct pddr_cable_cap_eth *ptr_struct, FILE *file)
{
	pddr_cable_cap_eth_print(ptr_struct, file, 0);
}

void pddr_cable_cap_ib_pack(const struct pddr_cable_cap_ib *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cable_link_speed_cap);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cable_link_width_cap);

}

void pddr_cable_cap_ib_unpack(struct pddr_cable_cap_ib *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->cable_link_speed_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->cable_link_width_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_cable_cap_ib_print(const struct pddr_cable_cap_ib *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_cable_cap_ib ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_link_speed_cap : %s (" UH_FMT ")\n", (ptr_struct->cable_link_speed_cap == 1 ? ("SDR") : ((ptr_struct->cable_link_speed_cap == 2 ? ("DDR") : ((ptr_struct->cable_link_speed_cap == 4 ? ("QDR") : ((ptr_struct->cable_link_speed_cap == 8 ? ("FDR10") : ((ptr_struct->cable_link_speed_cap == 16 ? ("FDR") : ((ptr_struct->cable_link_speed_cap == 32 ? ("EDR") : ((ptr_struct->cable_link_speed_cap == 64 ? ("HDR") : ((ptr_struct->cable_link_speed_cap == 128 ? ("NDR") : ((ptr_struct->cable_link_speed_cap == 256 ? ("XDR") : ("unknown")))))))))))))))))), ptr_struct->cable_link_speed_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_link_width_cap : " UH_FMT "\n", ptr_struct->cable_link_width_cap);

}

int pddr_cable_cap_ib_size(void)
{
	return 4;
}

void pddr_cable_cap_ib_dump(const struct pddr_cable_cap_ib *ptr_struct, FILE *file)
{
	pddr_cable_cap_ib_print(ptr_struct, file, 0);
}

void pddr_link_active_eth_pack(const struct pddr_link_active_eth *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->link_eth_active);

}

void pddr_link_active_eth_unpack(struct pddr_link_active_eth *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->link_eth_active = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pddr_link_active_eth_print(const struct pddr_link_active_eth *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_link_active_eth ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_eth_active      : " U32H_FMT "\n", ptr_struct->link_eth_active);

}

int pddr_link_active_eth_size(void)
{
	return 4;
}

void pddr_link_active_eth_dump(const struct pddr_link_active_eth *ptr_struct, FILE *file)
{
	pddr_link_active_eth_print(ptr_struct, file, 0);
}

void pddr_link_active_ib_pack(const struct pddr_link_active_ib *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_speed_active);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_width_active);

}

void pddr_link_active_ib_unpack(struct pddr_link_active_ib *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->link_speed_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->link_width_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_link_active_ib_print(const struct pddr_link_active_ib *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_link_active_ib ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_active    : %s (" UH_FMT ")\n", (ptr_struct->link_speed_active == 1 ? ("SDR") : ((ptr_struct->link_speed_active == 2 ? ("DDR") : ((ptr_struct->link_speed_active == 4 ? ("QDR") : ((ptr_struct->link_speed_active == 8 ? ("FDR10") : ((ptr_struct->link_speed_active == 16 ? ("FDR") : ((ptr_struct->link_speed_active == 32 ? ("EDR") : ((ptr_struct->link_speed_active == 64 ? ("HDR") : ((ptr_struct->link_speed_active == 128 ? ("NDR") : ((ptr_struct->link_speed_active == 256 ? ("XDR") : ("unknown")))))))))))))))))), ptr_struct->link_speed_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_active    : " UH_FMT "\n", ptr_struct->link_width_active);

}

int pddr_link_active_ib_size(void)
{
	return 4;
}

void pddr_link_active_ib_dump(const struct pddr_link_active_ib *ptr_struct, FILE *file)
{
	pddr_link_active_ib_print(ptr_struct, file, 0);
}

void pddr_monitor_opcode_pack(const struct pddr_monitor_opcode *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->monitor_opcode);

}

void pddr_monitor_opcode_unpack(struct pddr_monitor_opcode *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->monitor_opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_monitor_opcode_print(const struct pddr_monitor_opcode *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_monitor_opcode ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monitor_opcode       : " UH_FMT "\n", ptr_struct->monitor_opcode);

}

int pddr_monitor_opcode_size(void)
{
	return 4;
}

void pddr_monitor_opcode_dump(const struct pddr_monitor_opcode *ptr_struct, FILE *file)
{
	pddr_monitor_opcode_print(ptr_struct, file, 0);
}

void pddr_phy_manager_link_enabed_eth_pack(const struct pddr_phy_manager_link_enabed_eth *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phy_manager_link_eth_enabled);

}

void pddr_phy_manager_link_enabed_eth_unpack(struct pddr_phy_manager_link_enabed_eth *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->phy_manager_link_eth_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pddr_phy_manager_link_enabed_eth_print(const struct pddr_phy_manager_link_enabed_eth *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_phy_manager_link_enabed_eth ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_link_eth_enabled : " U32H_FMT "\n", ptr_struct->phy_manager_link_eth_enabled);

}

int pddr_phy_manager_link_enabed_eth_size(void)
{
	return 4;
}

void pddr_phy_manager_link_enabed_eth_dump(const struct pddr_phy_manager_link_enabed_eth *ptr_struct, FILE *file)
{
	pddr_phy_manager_link_enabed_eth_print(ptr_struct, file, 0);
}

void pddr_phy_manager_link_enabed_ib_pack(const struct pddr_phy_manager_link_enabed_ib *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phy_manager_link_proto_enabled);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phy_manager_link_width_enabled);

}

void pddr_phy_manager_link_enabed_ib_unpack(struct pddr_phy_manager_link_enabed_ib *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->phy_manager_link_proto_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->phy_manager_link_width_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_phy_manager_link_enabed_ib_print(const struct pddr_phy_manager_link_enabed_ib *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_phy_manager_link_enabed_ib ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_link_proto_enabled : " UH_FMT "\n", ptr_struct->phy_manager_link_proto_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_link_width_enabled : " UH_FMT "\n", ptr_struct->phy_manager_link_width_enabled);

}

int pddr_phy_manager_link_enabed_ib_size(void)
{
	return 4;
}

void pddr_phy_manager_link_enabed_ib_dump(const struct pddr_phy_manager_link_enabed_ib *ptr_struct, FILE *file)
{
	pddr_phy_manager_link_enabed_ib_print(ptr_struct, file, 0);
}

void pddr_operation_info_page_cable_proto_cap_auto_pack(const union pddr_operation_info_page_cable_proto_cap_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pddr_cable_cap_eth_pack(&(ptr_struct->pddr_cable_cap_eth), ptr_buff);
}

void pddr_operation_info_page_cable_proto_cap_auto_unpack(union pddr_operation_info_page_cable_proto_cap_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pddr_cable_cap_eth_unpack(&(ptr_struct->pddr_cable_cap_eth), ptr_buff);
}

void pddr_operation_info_page_cable_proto_cap_auto_print(const union pddr_operation_info_page_cable_proto_cap_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_operation_info_page_cable_proto_cap_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_cable_cap_ib:\n");
	pddr_cable_cap_ib_print(&(ptr_struct->pddr_cable_cap_ib), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_cable_cap_eth:\n");
	pddr_cable_cap_eth_print(&(ptr_struct->pddr_cable_cap_eth), file, indent_level + 1);

}

int pddr_operation_info_page_cable_proto_cap_auto_size(void)
{
	return 4;
}

void pddr_operation_info_page_cable_proto_cap_auto_dump(const union pddr_operation_info_page_cable_proto_cap_auto *ptr_struct, FILE *file)
{
	pddr_operation_info_page_cable_proto_cap_auto_print(ptr_struct, file, 0);
}

void pddr_operation_info_page_core_to_phy_link_enabled_auto_pack(const union pddr_operation_info_page_core_to_phy_link_enabled_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pddr_c2p_link_enabed_eth_pack(&(ptr_struct->pddr_c2p_link_enabed_eth), ptr_buff);
}

void pddr_operation_info_page_core_to_phy_link_enabled_auto_unpack(union pddr_operation_info_page_core_to_phy_link_enabled_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pddr_c2p_link_enabed_eth_unpack(&(ptr_struct->pddr_c2p_link_enabed_eth), ptr_buff);
}

void pddr_operation_info_page_core_to_phy_link_enabled_auto_print(const union pddr_operation_info_page_core_to_phy_link_enabled_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_operation_info_page_core_to_phy_link_enabled_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_c2p_link_enabed_ib:\n");
	pddr_c2p_link_enabed_ib_print(&(ptr_struct->pddr_c2p_link_enabed_ib), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_c2p_link_enabed_eth:\n");
	pddr_c2p_link_enabed_eth_print(&(ptr_struct->pddr_c2p_link_enabed_eth), file, indent_level + 1);

}

int pddr_operation_info_page_core_to_phy_link_enabled_auto_size(void)
{
	return 4;
}

void pddr_operation_info_page_core_to_phy_link_enabled_auto_dump(const union pddr_operation_info_page_core_to_phy_link_enabled_auto *ptr_struct, FILE *file)
{
	pddr_operation_info_page_core_to_phy_link_enabled_auto_print(ptr_struct, file, 0);
}

void pddr_operation_info_page_link_active_auto_pack(const union pddr_operation_info_page_link_active_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pddr_link_active_eth_pack(&(ptr_struct->pddr_link_active_eth), ptr_buff);
}

void pddr_operation_info_page_link_active_auto_unpack(union pddr_operation_info_page_link_active_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pddr_link_active_eth_unpack(&(ptr_struct->pddr_link_active_eth), ptr_buff);
}

void pddr_operation_info_page_link_active_auto_print(const union pddr_operation_info_page_link_active_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_operation_info_page_link_active_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_link_active_ib:\n");
	pddr_link_active_ib_print(&(ptr_struct->pddr_link_active_ib), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_link_active_eth:\n");
	pddr_link_active_eth_print(&(ptr_struct->pddr_link_active_eth), file, indent_level + 1);

}

int pddr_operation_info_page_link_active_auto_size(void)
{
	return 4;
}

void pddr_operation_info_page_link_active_auto_dump(const union pddr_operation_info_page_link_active_auto *ptr_struct, FILE *file)
{
	pddr_operation_info_page_link_active_auto_print(ptr_struct, file, 0);
}

void pddr_operation_info_page_phy_manager_link_enabled_auto_pack(const union pddr_operation_info_page_phy_manager_link_enabled_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pddr_phy_manager_link_enabed_eth_pack(&(ptr_struct->pddr_phy_manager_link_enabed_eth), ptr_buff);
}

void pddr_operation_info_page_phy_manager_link_enabled_auto_unpack(union pddr_operation_info_page_phy_manager_link_enabled_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pddr_phy_manager_link_enabed_eth_unpack(&(ptr_struct->pddr_phy_manager_link_enabed_eth), ptr_buff);
}

void pddr_operation_info_page_phy_manager_link_enabled_auto_print(const union pddr_operation_info_page_phy_manager_link_enabled_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_operation_info_page_phy_manager_link_enabled_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_phy_manager_link_enabed_ib:\n");
	pddr_phy_manager_link_enabed_ib_print(&(ptr_struct->pddr_phy_manager_link_enabed_ib), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_phy_manager_link_enabed_eth:\n");
	pddr_phy_manager_link_enabed_eth_print(&(ptr_struct->pddr_phy_manager_link_enabed_eth), file, indent_level + 1);

}

int pddr_operation_info_page_phy_manager_link_enabled_auto_size(void)
{
	return 4;
}

void pddr_operation_info_page_phy_manager_link_enabled_auto_dump(const union pddr_operation_info_page_phy_manager_link_enabled_auto *ptr_struct, FILE *file)
{
	pddr_operation_info_page_phy_manager_link_enabled_auto_print(ptr_struct, file, 0);
}

void pddr_troubleshooting_page_status_opcode_auto_pack(const union pddr_troubleshooting_page_status_opcode_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pddr_advanced_opcode_pack(&(ptr_struct->pddr_advanced_opcode), ptr_buff);
}

void pddr_troubleshooting_page_status_opcode_auto_unpack(union pddr_troubleshooting_page_status_opcode_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pddr_advanced_opcode_unpack(&(ptr_struct->pddr_advanced_opcode), ptr_buff);
}

void pddr_troubleshooting_page_status_opcode_auto_print(const union pddr_troubleshooting_page_status_opcode_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_troubleshooting_page_status_opcode_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_monitor_opcode:\n");
	pddr_monitor_opcode_print(&(ptr_struct->pddr_monitor_opcode), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_advanced_opcode:\n");
	pddr_advanced_opcode_print(&(ptr_struct->pddr_advanced_opcode), file, indent_level + 1);

}

int pddr_troubleshooting_page_status_opcode_auto_size(void)
{
	return 4;
}

void pddr_troubleshooting_page_status_opcode_auto_dump(const union pddr_troubleshooting_page_status_opcode_auto *ptr_struct, FILE *file)
{
	pddr_troubleshooting_page_status_opcode_auto_print(ptr_struct, file, 0);
}

void pll_28nm_pack(const struct pll_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->f_ctrl_measure);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->analog_algo_num_var);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->algo_f_ctrl);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lock_status);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock_cal);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->mid_var);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->low_var);

	offset = 42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->high_var);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->analog_var);

}

void pll_28nm_unpack(struct pll_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 22;
	ptr_struct->f_ctrl_measure = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 16;
	ptr_struct->analog_algo_num_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 6;
	ptr_struct->algo_f_ctrl = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 2;
	ptr_struct->lock_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1;
	ptr_struct->lock_cal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 58;
	ptr_struct->mid_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 50;
	ptr_struct->low_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 42;
	ptr_struct->high_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 34;
	ptr_struct->analog_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void pll_28nm_print(const struct pll_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pll_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f_ctrl_measure       : " UH_FMT "\n", ptr_struct->f_ctrl_measure);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "analog_algo_num_var  : " UH_FMT "\n", ptr_struct->analog_algo_num_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algo_f_ctrl          : " UH_FMT "\n", ptr_struct->algo_f_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_status          : " UH_FMT "\n", ptr_struct->lock_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_cal             : " UH_FMT "\n", ptr_struct->lock_cal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_var              : " UH_FMT "\n", ptr_struct->mid_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "low_var              : " UH_FMT "\n", ptr_struct->low_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "high_var             : " UH_FMT "\n", ptr_struct->high_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "analog_var           : " UH_FMT "\n", ptr_struct->analog_var);

}

int pll_28nm_size(void)
{
	return 8;
}

void pll_28nm_dump(const struct pll_28nm *ptr_struct, FILE *file)
{
	pll_28nm_print(ptr_struct, file, 0);
}

void pll_status_data_pack(const struct pll_status_data *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->pll_speed);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clock_valid);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->plllock_clk_val);

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lock_clk_val_cause);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clear_cause);

	offset = 23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ae);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lock_lost_counter);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lock_pulse);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pll_pwrup);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lock_status);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fctrl_measure);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->mid_var);

	offset = 43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->low_var);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->high_var);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->analog_var);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock);

}

void pll_status_data_unpack(struct pll_status_data *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->pll_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 28;
	ptr_struct->clock_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->plllock_clk_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 25;
	ptr_struct->lock_clk_val_cause = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 24;
	ptr_struct->clear_cause = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 23;
	ptr_struct->ae = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 7;
	ptr_struct->lock_lost_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 3;
	ptr_struct->lock_pulse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 2;
	ptr_struct->pll_pwrup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->lock_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 54;
	ptr_struct->fctrl_measure = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 48;
	ptr_struct->mid_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 43;
	ptr_struct->low_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 38;
	ptr_struct->high_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 33;
	ptr_struct->analog_var = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 32;
	ptr_struct->lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void pll_status_data_print(const struct pll_status_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pll_status_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_speed            : " UH_FMT "\n", ptr_struct->pll_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clock_valid          : " UH_FMT "\n", ptr_struct->clock_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plllock_clk_val      : " UH_FMT "\n", ptr_struct->plllock_clk_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_clk_val_cause   : " UH_FMT "\n", ptr_struct->lock_clk_val_cause);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clear_cause          : " UH_FMT "\n", ptr_struct->clear_cause);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ae                   : " UH_FMT "\n", ptr_struct->ae);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_lost_counter    : " UH_FMT "\n", ptr_struct->lock_lost_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_pulse           : " UH_FMT "\n", ptr_struct->lock_pulse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_pwrup            : " UH_FMT "\n", ptr_struct->pll_pwrup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_status          : " UH_FMT "\n", ptr_struct->lock_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fctrl_measure        : " UH_FMT "\n", ptr_struct->fctrl_measure);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_var              : " UH_FMT "\n", ptr_struct->mid_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "low_var              : " UH_FMT "\n", ptr_struct->low_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "high_var             : " UH_FMT "\n", ptr_struct->high_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "analog_var           : " UH_FMT "\n", ptr_struct->analog_var);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock                 : " UH_FMT "\n", ptr_struct->lock);

}

int pll_status_data_size(void)
{
	return 8;
}

void pll_status_data_dump(const struct pll_status_data *ptr_struct, FILE *file)
{
	pll_status_data_print(ptr_struct, file, 0);
}

void module_latched_flag_info_pack(const struct module_latched_flag_info *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_los_cap);

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dp_fw_fault);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mod_fw_fault);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vcc_flags);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->temp_flags);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_ad_eq_fault);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_cdr_lol);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_los);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_fault);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_lo_war);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_hi_war);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_lo_al);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_hi_al);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_lo_war);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_hi_war);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_lo_al);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_hi_al);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_cdr_lol);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_los);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_lo_war);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_hi_war);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_lo_al);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_hi_al);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_output_valid_change);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->flag_in_use);

}

void module_latched_flag_info_unpack(struct module_latched_flag_info *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->rx_los_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 9;
	ptr_struct->dp_fw_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->mod_fw_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->vcc_flags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->temp_flags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->tx_ad_eq_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->tx_cdr_lol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->tx_los = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->tx_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->tx_power_lo_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->tx_power_hi_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->tx_power_lo_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->tx_power_hi_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->tx_bias_lo_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->tx_bias_hi_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->tx_bias_lo_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->tx_bias_hi_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->rx_cdr_lol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->rx_los = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->rx_power_lo_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->rx_power_hi_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->rx_power_lo_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->rx_power_hi_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->rx_output_valid_change = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 224;
	ptr_struct->flag_in_use = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void module_latched_flag_info_print(const struct module_latched_flag_info *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== module_latched_flag_info ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_los_cap           : " UH_FMT "\n", ptr_struct->rx_los_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_fw_fault          : " UH_FMT "\n", ptr_struct->dp_fw_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mod_fw_fault         : " UH_FMT "\n", ptr_struct->mod_fw_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcc_flags            : %s (" UH_FMT ")\n", (ptr_struct->vcc_flags == 1 ? ("high_vcc_alarm") : ((ptr_struct->vcc_flags == 2 ? ("low_vcc_alarm") : ((ptr_struct->vcc_flags == 4 ? ("high_vcc_warning") : ((ptr_struct->vcc_flags == 8 ? ("low_vcc_warning") : ("unknown")))))))), ptr_struct->vcc_flags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_flags           : %s (" UH_FMT ")\n", (ptr_struct->temp_flags == 1 ? ("high_temp_alarm") : ((ptr_struct->temp_flags == 2 ? ("low_temp_alarm") : ((ptr_struct->temp_flags == 4 ? ("high_temp_warning") : ((ptr_struct->temp_flags == 8 ? ("low_temp_warning") : ("unknown")))))))), ptr_struct->temp_flags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_ad_eq_fault       : " UH_FMT "\n", ptr_struct->tx_ad_eq_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_lol           : " UH_FMT "\n", ptr_struct->tx_cdr_lol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_los               : " UH_FMT "\n", ptr_struct->tx_los);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_fault             : " UH_FMT "\n", ptr_struct->tx_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lo_war      : " UH_FMT "\n", ptr_struct->tx_power_lo_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_hi_war      : " UH_FMT "\n", ptr_struct->tx_power_hi_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lo_al       : " UH_FMT "\n", ptr_struct->tx_power_lo_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_hi_al       : " UH_FMT "\n", ptr_struct->tx_power_hi_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lo_war       : " UH_FMT "\n", ptr_struct->tx_bias_lo_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_hi_war       : " UH_FMT "\n", ptr_struct->tx_bias_hi_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lo_al        : " UH_FMT "\n", ptr_struct->tx_bias_lo_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_hi_al        : " UH_FMT "\n", ptr_struct->tx_bias_hi_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_lol           : " UH_FMT "\n", ptr_struct->rx_cdr_lol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_los               : " UH_FMT "\n", ptr_struct->rx_los);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lo_war      : " UH_FMT "\n", ptr_struct->rx_power_lo_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_hi_war      : " UH_FMT "\n", ptr_struct->rx_power_hi_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lo_al       : " UH_FMT "\n", ptr_struct->rx_power_lo_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_hi_al       : " UH_FMT "\n", ptr_struct->rx_power_hi_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_output_valid_change : " UH_FMT "\n", ptr_struct->rx_output_valid_change);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flag_in_use          : %s (" U32H_FMT ")\n", (ptr_struct->flag_in_use == 1 ? ("temp_flags") : ((ptr_struct->flag_in_use == 2 ? ("vcc_flags") : ((ptr_struct->flag_in_use == 4 ? ("mod_fw_fault") : ((ptr_struct->flag_in_use == 8 ? ("dp_fw_fault") : ((ptr_struct->flag_in_use == 16 ? ("tx_fault") : ((ptr_struct->flag_in_use == 32 ? ("tx_los") : ((ptr_struct->flag_in_use == 64 ? ("tx_cdr_lol") : ((ptr_struct->flag_in_use == 128 ? ("tx_ad_eq_fault") : ((ptr_struct->flag_in_use == 256 ? ("tx_power_hi_al") : ((ptr_struct->flag_in_use == 512 ? ("tx_power_lo_al") : ((ptr_struct->flag_in_use == 1024 ? ("tx_power_hi_war") : ((ptr_struct->flag_in_use == 2048 ? ("tx_power_lo_war") : ((ptr_struct->flag_in_use == 4096 ? ("tx_bias_hi_al") : ((ptr_struct->flag_in_use == 8192 ? ("tx_bias_lo_al") : ((ptr_struct->flag_in_use == 16384 ? ("tx_bias_hi_war") : ((ptr_struct->flag_in_use == 32768 ? ("tx_bias_lo_war") : ((ptr_struct->flag_in_use == 65536 ? ("rx_los") : ((ptr_struct->flag_in_use == 131072 ? ("rx_cdr_lol") : ((ptr_struct->flag_in_use == 262144 ? ("rx_output_valid") : ("unknown")))))))))))))))))))))))))))))))))))))), ptr_struct->flag_in_use);

}

int module_latched_flag_info_size(void)
{
	return 248;
}

void module_latched_flag_info_dump(const struct module_latched_flag_info *ptr_struct, FILE *file)
{
	module_latched_flag_info_print(ptr_struct, file, 0);
}

void mpcnt_RAW_page_data_pack(const struct mpcnt_RAW_page_data *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 96; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 768, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void mpcnt_RAW_page_data_unpack(struct mpcnt_RAW_page_data *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 96; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 768, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void mpcnt_RAW_page_data_print(const struct mpcnt_RAW_page_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpcnt_RAW_page_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 96; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int mpcnt_RAW_page_data_size(void)
{
	return 96;
}

void mpcnt_RAW_page_data_dump(const struct mpcnt_RAW_page_data *ptr_struct, FILE *file)
{
	mpcnt_RAW_page_data_print(ptr_struct, file, 0);
}

void pcie_lanes_counters_pack(const struct pcie_lanes_counters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane0);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane1);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane2);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane3);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane4);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane5);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane6);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane7);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane8);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane9);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane10);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane11);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane12);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane13);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane14);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_counter_lane15);

}

void pcie_lanes_counters_unpack(struct pcie_lanes_counters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->life_time_counter_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->life_time_counter_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->error_counter_lane0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->error_counter_lane1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->error_counter_lane2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->error_counter_lane3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->error_counter_lane4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->error_counter_lane5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->error_counter_lane6 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->error_counter_lane7 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->error_counter_lane8 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->error_counter_lane9 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->error_counter_lane10 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->error_counter_lane11 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->error_counter_lane12 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->error_counter_lane13 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->error_counter_lane14 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->error_counter_lane15 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pcie_lanes_counters_print(const struct pcie_lanes_counters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pcie_lanes_counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_high : " U32H_FMT "\n", ptr_struct->life_time_counter_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_low : " U32H_FMT "\n", ptr_struct->life_time_counter_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane0  : " U32H_FMT "\n", ptr_struct->error_counter_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane1  : " U32H_FMT "\n", ptr_struct->error_counter_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane2  : " U32H_FMT "\n", ptr_struct->error_counter_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane3  : " U32H_FMT "\n", ptr_struct->error_counter_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane4  : " U32H_FMT "\n", ptr_struct->error_counter_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane5  : " U32H_FMT "\n", ptr_struct->error_counter_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane6  : " U32H_FMT "\n", ptr_struct->error_counter_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane7  : " U32H_FMT "\n", ptr_struct->error_counter_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane8  : " U32H_FMT "\n", ptr_struct->error_counter_lane8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane9  : " U32H_FMT "\n", ptr_struct->error_counter_lane9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane10 : " U32H_FMT "\n", ptr_struct->error_counter_lane10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane11 : " U32H_FMT "\n", ptr_struct->error_counter_lane11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane12 : " U32H_FMT "\n", ptr_struct->error_counter_lane12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane13 : " U32H_FMT "\n", ptr_struct->error_counter_lane13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane14 : " U32H_FMT "\n", ptr_struct->error_counter_lane14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_counter_lane15 : " U32H_FMT "\n", ptr_struct->error_counter_lane15);

}

int pcie_lanes_counters_size(void)
{
	return 72;
}

void pcie_lanes_counters_dump(const struct pcie_lanes_counters *ptr_struct, FILE *file)
{
	pcie_lanes_counters_print(ptr_struct, file, 0);
}

void pcie_perf_counters_pack(const struct pcie_perf_counters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_errors);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_errors);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_eieos);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_ts);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_framing);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->l0_to_recovery_retrain);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->crc_error_dllp);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->crc_error_tlp);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->tx_overflow_buffer_pkt);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->outbound_stalled_reads);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->outbound_stalled_writes);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->outbound_stalled_reads_events);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->outbound_stalled_writes_events);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->tx_overflow_buffer_marked_pkt);

	offset = 604;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->effective_ber_coef);

	offset = 592;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->effective_ber_magnitude);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_since_last_clear_high);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_since_last_clear_low);

}

void pcie_perf_counters_unpack(struct pcie_perf_counters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->life_time_counter_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->life_time_counter_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->rx_errors = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->tx_errors = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->l0_to_recovery_eieos = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->l0_to_recovery_ts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->l0_to_recovery_framing = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->l0_to_recovery_retrain = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->crc_error_dllp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->crc_error_tlp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->tx_overflow_buffer_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->outbound_stalled_reads = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->outbound_stalled_writes = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->outbound_stalled_reads_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->outbound_stalled_writes_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->tx_overflow_buffer_marked_pkt = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 604;
	ptr_struct->effective_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 592;
	ptr_struct->effective_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 608;
	ptr_struct->time_since_last_clear_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 640;
	ptr_struct->time_since_last_clear_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pcie_perf_counters_print(const struct pcie_perf_counters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pcie_perf_counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_high : " U32H_FMT "\n", ptr_struct->life_time_counter_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_low : " U32H_FMT "\n", ptr_struct->life_time_counter_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_errors            : " U32H_FMT "\n", ptr_struct->rx_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_errors            : " U32H_FMT "\n", ptr_struct->tx_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_eieos : " U32H_FMT "\n", ptr_struct->l0_to_recovery_eieos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_ts    : " U32H_FMT "\n", ptr_struct->l0_to_recovery_ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_framing : " U32H_FMT "\n", ptr_struct->l0_to_recovery_framing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0_to_recovery_retrain : " U32H_FMT "\n", ptr_struct->l0_to_recovery_retrain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crc_error_dllp       : " U32H_FMT "\n", ptr_struct->crc_error_dllp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crc_error_tlp        : " U32H_FMT "\n", ptr_struct->crc_error_tlp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_overflow_buffer_pkt : " U64H_FMT "\n", ptr_struct->tx_overflow_buffer_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outbound_stalled_reads : " U32H_FMT "\n", ptr_struct->outbound_stalled_reads);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outbound_stalled_writes : " U32H_FMT "\n", ptr_struct->outbound_stalled_writes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outbound_stalled_reads_events : " U32H_FMT "\n", ptr_struct->outbound_stalled_reads_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outbound_stalled_writes_events : " U32H_FMT "\n", ptr_struct->outbound_stalled_writes_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_overflow_buffer_marked_pkt : " U64H_FMT "\n", ptr_struct->tx_overflow_buffer_marked_pkt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "effective_ber_coef   : " UH_FMT "\n", ptr_struct->effective_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "effective_ber_magnitude : " UH_FMT "\n", ptr_struct->effective_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_high : " U32H_FMT "\n", ptr_struct->time_since_last_clear_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_low : " U32H_FMT "\n", ptr_struct->time_since_last_clear_low);

}

int pcie_perf_counters_size(void)
{
	return 84;
}

void pcie_perf_counters_dump(const struct pcie_perf_counters *ptr_struct, FILE *file)
{
	pcie_perf_counters_print(ptr_struct, file, 0);
}

void pcie_physical_layer_pack(const struct pcie_physical_layer *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eqlz_timeout_ph0);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eqlz_timeout_ph1);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eqlz_timeout_ph2);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eqlz_timeout_ph3);

}

void pcie_physical_layer_unpack(struct pcie_physical_layer *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->eqlz_timeout_ph0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->eqlz_timeout_ph1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->eqlz_timeout_ph2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->eqlz_timeout_ph3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void pcie_physical_layer_print(const struct pcie_physical_layer *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pcie_physical_layer ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqlz_timeout_ph0     : " UH_FMT "\n", ptr_struct->eqlz_timeout_ph0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqlz_timeout_ph1     : " UH_FMT "\n", ptr_struct->eqlz_timeout_ph1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqlz_timeout_ph2     : " UH_FMT "\n", ptr_struct->eqlz_timeout_ph2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqlz_timeout_ph3     : " UH_FMT "\n", ptr_struct->eqlz_timeout_ph3);

}

int pcie_physical_layer_size(void)
{
	return 4;
}

void pcie_physical_layer_dump(const struct pcie_physical_layer *ptr_struct, FILE *file)
{
	pcie_physical_layer_print(ptr_struct, file, 0);
}

void pcie_timers_states_pack(const struct pcie_timers_states *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->life_time_counter_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_boot_image_start);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_image);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->calibration_time);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_first_perst);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_detect_state);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_l0);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_crs_en);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_plastic_image_start);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_iron_image_start);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->perst_handler);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->times_in_l1);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->times_in_l23);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dl_down);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->config_cycle1usec);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->config_cycle2to7usec);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->config_cycle8to15usec);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->config_cycle16to63usec);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->config_cycle64usec);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->correctable_err_msg_sent);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->non_fatal_err_msg_sent);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fatal_err_msg_sent);

}

void pcie_timers_states_unpack(struct pcie_timers_states *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->life_time_counter_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->life_time_counter_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->time_to_boot_image_start = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->time_to_link_image = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->calibration_time = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->time_to_first_perst = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->time_to_detect_state = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->time_to_l0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->time_to_crs_en = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->time_to_plastic_image_start = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->time_to_iron_image_start = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->perst_handler = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->times_in_l1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->times_in_l23 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->dl_down = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->config_cycle1usec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->config_cycle2to7usec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->config_cycle8to15usec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->config_cycle16to63usec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->config_cycle64usec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 640;
	ptr_struct->correctable_err_msg_sent = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 672;
	ptr_struct->non_fatal_err_msg_sent = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 704;
	ptr_struct->fatal_err_msg_sent = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pcie_timers_states_print(const struct pcie_timers_states *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pcie_timers_states ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_high : " U32H_FMT "\n", ptr_struct->life_time_counter_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "life_time_counter_low : " U32H_FMT "\n", ptr_struct->life_time_counter_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_boot_image_start : " U32H_FMT "\n", ptr_struct->time_to_boot_image_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_image   : " U32H_FMT "\n", ptr_struct->time_to_link_image);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "calibration_time     : " U32H_FMT "\n", ptr_struct->calibration_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_first_perst  : " U32H_FMT "\n", ptr_struct->time_to_first_perst);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_detect_state : " U32H_FMT "\n", ptr_struct->time_to_detect_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_l0           : " U32H_FMT "\n", ptr_struct->time_to_l0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_crs_en       : " U32H_FMT "\n", ptr_struct->time_to_crs_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_plastic_image_start : " U32H_FMT "\n", ptr_struct->time_to_plastic_image_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_iron_image_start : " U32H_FMT "\n", ptr_struct->time_to_iron_image_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perst_handler        : " U32H_FMT "\n", ptr_struct->perst_handler);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "times_in_l1          : " U32H_FMT "\n", ptr_struct->times_in_l1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "times_in_l23         : " U32H_FMT "\n", ptr_struct->times_in_l23);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dl_down              : " U32H_FMT "\n", ptr_struct->dl_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config_cycle1usec    : " U32H_FMT "\n", ptr_struct->config_cycle1usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config_cycle2to7usec : " U32H_FMT "\n", ptr_struct->config_cycle2to7usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config_cycle8to15usec : " U32H_FMT "\n", ptr_struct->config_cycle8to15usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config_cycle16to63usec : " U32H_FMT "\n", ptr_struct->config_cycle16to63usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config_cycle64usec   : " U32H_FMT "\n", ptr_struct->config_cycle64usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "correctable_err_msg_sent : " U32H_FMT "\n", ptr_struct->correctable_err_msg_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "non_fatal_err_msg_sent : " U32H_FMT "\n", ptr_struct->non_fatal_err_msg_sent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fatal_err_msg_sent   : " U32H_FMT "\n", ptr_struct->fatal_err_msg_sent);

}

int pcie_timers_states_size(void)
{
	return 92;
}

void pcie_timers_states_dump(const struct pcie_timers_states *ptr_struct, FILE *file)
{
	pcie_timers_states_print(ptr_struct, file, 0);
}

void pddr_RAW_page_data_pack(const struct pddr_RAW_page_data *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1632, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void pddr_RAW_page_data_unpack(struct pddr_RAW_page_data *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1632, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void pddr_RAW_page_data_print(const struct pddr_RAW_page_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_RAW_page_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 204; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int pddr_RAW_page_data_size(void)
{
	return 204;
}

void pddr_RAW_page_data_dump(const struct pddr_RAW_page_data *ptr_struct, FILE *file)
{
	pddr_RAW_page_data_print(ptr_struct, file, 0);
}

void pddr_link_down_info_page_pack(const struct pddr_link_down_info_page *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->down_blame);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_reason_opcode);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->remote_reason_opcode);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->e2e_reason_opcode);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts1_opcode);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_symbol_ber_alarms);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->last_raw_ber_magnitude);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_raw_ber_coef);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cons_raw_norm_ber);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_raw_ber_magnitude);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_raw_ber_coef);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_raw_ber_magnitude);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->min_raw_ber_coef);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_raw_ber_alarms);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_eff_ber_alarms);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_down_to_disable);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_down_to_rx_loss);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_eff_ber_magnitude);

	offset = 308;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->min_eff_ber_coef);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->last_eff_ber_magnitude);

	offset = 292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_eff_ber_coef);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cons_eff_norm_ber);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_eff_ber_magnitude);

	offset = 340;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_eff_ber_coef);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_symbol_ber_magnitude);

	offset = 324;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_symbol_ber_coef);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cons_symbol_norm_ber);

	offset = 376;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_symbol_ber_magnitude);

	offset = 372;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->min_symbol_ber_coef);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->last_symbol_ber_magnitude);

	offset = 356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->last_symbol_ber_coef);

	offset = 408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_est_eff_ber_magnitude);

	offset = 404;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->min_est_eff_ber_coef);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mean_est_eff_ber_magnitude);

	offset = 388;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mean_est_eff_ber_coef);

	offset = 440;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_est_eff_ber_magnitude);

	offset = 436;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_est_eff_ber_coef);

	offset = 464;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_est_eff_ber_alarms);

	offset = 448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_est_eff_ber_warnings);

}

void pddr_link_down_info_page_unpack(struct pddr_link_down_info_page *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->down_blame = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->local_reason_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->remote_reason_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->e2e_reason_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->ts1_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 144;
	ptr_struct->num_of_symbol_ber_alarms = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->last_raw_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 132;
	ptr_struct->last_raw_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->cons_raw_norm_ber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 184;
	ptr_struct->max_raw_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 180;
	ptr_struct->max_raw_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 168;
	ptr_struct->min_raw_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 164;
	ptr_struct->min_raw_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->num_of_raw_ber_alarms = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->num_of_eff_ber_alarms = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->time_to_link_down_to_disable = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->time_to_link_down_to_rx_loss = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 312;
	ptr_struct->min_eff_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 308;
	ptr_struct->min_eff_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 296;
	ptr_struct->last_eff_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 292;
	ptr_struct->last_eff_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->cons_eff_norm_ber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 344;
	ptr_struct->max_eff_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 340;
	ptr_struct->max_eff_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 328;
	ptr_struct->max_symbol_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 324;
	ptr_struct->max_symbol_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->cons_symbol_norm_ber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 376;
	ptr_struct->min_symbol_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 372;
	ptr_struct->min_symbol_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 360;
	ptr_struct->last_symbol_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 356;
	ptr_struct->last_symbol_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 408;
	ptr_struct->min_est_eff_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 404;
	ptr_struct->min_est_eff_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 392;
	ptr_struct->mean_est_eff_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 388;
	ptr_struct->mean_est_eff_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 440;
	ptr_struct->max_est_eff_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 436;
	ptr_struct->max_est_eff_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 464;
	ptr_struct->num_of_est_eff_ber_alarms = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 448;
	ptr_struct->num_of_est_eff_ber_warnings = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_link_down_info_page_print(const struct pddr_link_down_info_page *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_link_down_info_page ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "down_blame           : %s (" UH_FMT ")\n", (ptr_struct->down_blame == 0 ? ("Unknown") : ((ptr_struct->down_blame == 1 ? ("Local_phy") : ((ptr_struct->down_blame == 2 ? ("Remote_phy") : ("unknown")))))), ptr_struct->down_blame);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_reason_opcode  : %s (" UH_FMT ")\n", (ptr_struct->local_reason_opcode == 0 ? ("No_link_down_indication") : ((ptr_struct->local_reason_opcode == 1 ? ("Unknown_reason") : ((ptr_struct->local_reason_opcode == 2 ? ("Hi_SER_or_Hi_BER") : ((ptr_struct->local_reason_opcode == 3 ? ("Block_Lock_loss") : ((ptr_struct->local_reason_opcode == 4 ? ("Alignment_loss") : ((ptr_struct->local_reason_opcode == 5 ? ("FEC_sync_loss") : ((ptr_struct->local_reason_opcode == 6 ? ("PLL_lock_loss") : ((ptr_struct->local_reason_opcode == 7 ? ("FIFO_overflow") : ((ptr_struct->local_reason_opcode == 8 ? ("false_SKIP_condition") : ((ptr_struct->local_reason_opcode == 9 ? ("Minor_Error_threshold_exceeded") : ((ptr_struct->local_reason_opcode == 10 ? ("Physical_layer_retransmission_timeout") : ((ptr_struct->local_reason_opcode == 11 ? ("Heartbeat_errors") : ((ptr_struct->local_reason_opcode == 12 ? ("Link_Layer_credit_monitoring_watchdog") : ((ptr_struct->local_reason_opcode == 13 ? ("Link_Layer_integrity_threshold_exceeded") : ((ptr_struct->local_reason_opcode == 14 ? ("Link_Layer_buffer_overrun") : ((ptr_struct->local_reason_opcode == 15 ? ("Down_by_outband_command_with_healthy_link") : ((ptr_struct->local_reason_opcode == 16 ? ("Down_by_outband_command_for_link_with_hi_ber") : ((ptr_struct->local_reason_opcode == 17 ? ("Down_by_inband_command_with_healthy_link") : ((ptr_struct->local_reason_opcode == 18 ? ("Down_by_inband_command_for_link_with_hi_ber") : ((ptr_struct->local_reason_opcode == 19 ? ("Down_by_verification_GW") : ((ptr_struct->local_reason_opcode == 20 ? ("Received_Remote_Fault") : ((ptr_struct->local_reason_opcode == 21 ? ("Received_TS1") : ((ptr_struct->local_reason_opcode == 22 ? ("Down_by_management_command") : ((ptr_struct->local_reason_opcode == 23 ? ("Cable_was_unplugged") : ((ptr_struct->local_reason_opcode == 24 ? ("Cable_access_issue") : ((ptr_struct->local_reason_opcode == 25 ? ("Thermal_shutdown") : ((ptr_struct->local_reason_opcode == 26 ? ("Current_issue") : ((ptr_struct->local_reason_opcode == 27 ? ("Power_budget") : ((ptr_struct->local_reason_opcode == 28 ? ("Fast_recovery_raw_ber") : ((ptr_struct->local_reason_opcode == 29 ? ("Fast_recovery_effective_ber") : ((ptr_struct->local_reason_opcode == 30 ? ("Fast_recovery_symbol_ber") : ((ptr_struct->local_reason_opcode == 31 ? ("Fast_recovery_credit_watchdog") : ((ptr_struct->local_reason_opcode == 32 ? ("Timeout") : ("unknown")))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))), ptr_struct->local_reason_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_reason_opcode : " UH_FMT "\n", ptr_struct->remote_reason_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_reason_opcode    : " UH_FMT "\n", ptr_struct->e2e_reason_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts1_opcode           : " UH_FMT "\n", ptr_struct->ts1_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_symbol_ber_alarms : " UH_FMT "\n", ptr_struct->num_of_symbol_ber_alarms);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_raw_ber_magnitude : " UH_FMT "\n", ptr_struct->last_raw_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_raw_ber_coef    : " UH_FMT "\n", ptr_struct->last_raw_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cons_raw_norm_ber    : " UH_FMT "\n", ptr_struct->cons_raw_norm_ber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_raw_ber_magnitude : " UH_FMT "\n", ptr_struct->max_raw_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_raw_ber_coef     : " UH_FMT "\n", ptr_struct->max_raw_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_raw_ber_magnitude : " UH_FMT "\n", ptr_struct->min_raw_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_raw_ber_coef     : " UH_FMT "\n", ptr_struct->min_raw_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_raw_ber_alarms : " UH_FMT "\n", ptr_struct->num_of_raw_ber_alarms);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_eff_ber_alarms : " UH_FMT "\n", ptr_struct->num_of_eff_ber_alarms);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_down_to_disable : " U32H_FMT "\n", ptr_struct->time_to_link_down_to_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_down_to_rx_loss : " U32H_FMT "\n", ptr_struct->time_to_link_down_to_rx_loss);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_eff_ber_magnitude : " UH_FMT "\n", ptr_struct->min_eff_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_eff_ber_coef     : " UH_FMT "\n", ptr_struct->min_eff_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_eff_ber_magnitude : " UH_FMT "\n", ptr_struct->last_eff_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_eff_ber_coef    : " UH_FMT "\n", ptr_struct->last_eff_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cons_eff_norm_ber    : " UH_FMT "\n", ptr_struct->cons_eff_norm_ber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_eff_ber_magnitude : " UH_FMT "\n", ptr_struct->max_eff_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_eff_ber_coef     : " UH_FMT "\n", ptr_struct->max_eff_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_symbol_ber_magnitude : " UH_FMT "\n", ptr_struct->max_symbol_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_symbol_ber_coef  : " UH_FMT "\n", ptr_struct->max_symbol_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cons_symbol_norm_ber : " UH_FMT "\n", ptr_struct->cons_symbol_norm_ber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_symbol_ber_magnitude : " UH_FMT "\n", ptr_struct->min_symbol_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_symbol_ber_coef  : " UH_FMT "\n", ptr_struct->min_symbol_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_symbol_ber_magnitude : " UH_FMT "\n", ptr_struct->last_symbol_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_symbol_ber_coef : " UH_FMT "\n", ptr_struct->last_symbol_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_est_eff_ber_magnitude : " UH_FMT "\n", ptr_struct->min_est_eff_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_est_eff_ber_coef : " UH_FMT "\n", ptr_struct->min_est_eff_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mean_est_eff_ber_magnitude : " UH_FMT "\n", ptr_struct->mean_est_eff_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mean_est_eff_ber_coef : " UH_FMT "\n", ptr_struct->mean_est_eff_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_est_eff_ber_magnitude : " UH_FMT "\n", ptr_struct->max_est_eff_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_est_eff_ber_coef : " UH_FMT "\n", ptr_struct->max_est_eff_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_est_eff_ber_alarms : " UH_FMT "\n", ptr_struct->num_of_est_eff_ber_alarms);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_est_eff_ber_warnings : " UH_FMT "\n", ptr_struct->num_of_est_eff_ber_warnings);

}

int pddr_link_down_info_page_size(void)
{
	return 244;
}

void pddr_link_down_info_page_dump(const struct pddr_link_down_info_page *ptr_struct, FILE *file)
{
	pddr_link_down_info_page_print(ptr_struct, file, 0);
}

void pddr_link_up_info_page_pack(const struct pddr_link_up_info_page *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->up_reason_mng);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->up_reason_drv);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->up_reason_pwr);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_up);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fast_link_up_status);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lt_cnt);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_up_phy_up_to_active);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_up_sd_to_phy_up);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_up_disable_to_sd);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_to_link_up_disable_to_pd);

}

void pddr_link_up_info_page_unpack(struct pddr_link_up_info_page *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->up_reason_mng = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->up_reason_drv = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 12;
	ptr_struct->up_reason_pwr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->time_to_link_up = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 92;
	ptr_struct->fast_link_up_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 84;
	ptr_struct->lt_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->time_to_link_up_phy_up_to_active = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->time_to_link_up_sd_to_phy_up = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->time_to_link_up_disable_to_sd = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->time_to_link_up_disable_to_pd = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pddr_link_up_info_page_print(const struct pddr_link_up_info_page *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_link_up_info_page ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "up_reason_mng        : " UH_FMT "\n", ptr_struct->up_reason_mng);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "up_reason_drv        : " UH_FMT "\n", ptr_struct->up_reason_drv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "up_reason_pwr        : " UH_FMT "\n", ptr_struct->up_reason_pwr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_up      : " U32H_FMT "\n", ptr_struct->time_to_link_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_link_up_status  : " UH_FMT "\n", ptr_struct->fast_link_up_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lt_cnt               : " UH_FMT "\n", ptr_struct->lt_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_up_phy_up_to_active : " U32H_FMT "\n", ptr_struct->time_to_link_up_phy_up_to_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_up_sd_to_phy_up : " U32H_FMT "\n", ptr_struct->time_to_link_up_sd_to_phy_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_up_disable_to_sd : " U32H_FMT "\n", ptr_struct->time_to_link_up_disable_to_sd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_to_link_up_disable_to_pd : " U32H_FMT "\n", ptr_struct->time_to_link_up_disable_to_pd);

}

int pddr_link_up_info_page_size(void)
{
	return 248;
}

void pddr_link_up_info_page_dump(const struct pddr_link_up_info_page *ptr_struct, FILE *file)
{
	pddr_link_up_info_page_print(ptr_struct, file, 0);
}

void pddr_module_info_pack(const struct pddr_module_info *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ethernet_compliance_code);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ext_ethernet_compliance_code);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_breakout);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_technology);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_power_class);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_identifier);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_length);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_vendor);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_type);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_tx_equalization);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_emphasis);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_amp);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_power);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_5g);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_7g);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_12g);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_25g);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_cdr_state);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_cdr_state);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_cdr_cap);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_cdr_cap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_post_emphasis);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 1728, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_name[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(312, 8, i, 1728, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_pn[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(440, 8, i, 1728, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_rev[i]);
	}

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fw_version);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1728, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_sn[i]);
	}

	offset = 624;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage);

	offset = 608;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset = 656;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane1);

	offset = 640;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane0);

	offset = 688;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane3);

	offset = 672;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane2);

	offset = 720;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane5);

	offset = 704;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane4);

	offset = 752;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane7);

	offset = 736;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane6);

	offset = 784;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane1);

	offset = 768;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane0);

	offset = 816;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane3);

	offset = 800;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane2);

	offset = 848;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane5);

	offset = 832;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane4);

	offset = 880;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane7);

	offset = 864;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane6);

	offset = 912;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane1);

	offset = 896;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane0);

	offset = 944;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane3);

	offset = 928;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane2);

	offset = 976;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane5);

	offset = 960;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane4);

	offset = 1008;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane7);

	offset = 992;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane6);

	offset = 1040;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_low_th);

	offset = 1024;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_high_th);

	offset = 1072;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_low_th);

	offset = 1056;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_high_th);

	offset = 1104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_low_th);

	offset = 1088;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_high_th);

	offset = 1136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_low_th);

	offset = 1120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_high_th);

	offset = 1168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_low_th);

	offset = 1152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_high_th);

	offset = 1200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wavelength);

	offset = 1190;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->smf_length);

	offset = 1189;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_output_valid_cap);

	offset = 1188;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->did_cap);

	offset = 1187;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_power_type);

	offset = 1184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->module_st);

	offset = 1240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ib_compliance_code);

	offset = 1224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->active_set_media_compliance_code);

	offset = 1216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->active_set_host_compliance_code);

	offset = 1274;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ib_width);

	offset = 1264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->monitor_cap_mask);

	offset = 1256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nbr100);

	offset = 1248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nbr250);

	offset = 1308;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane7);

	offset = 1304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane6);

	offset = 1300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane5);

	offset = 1296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane4);

	offset = 1292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane3);

	offset = 1288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane2);

	offset = 1284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane1);

	offset = 1280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane0);

	offset = 1336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om5);

	offset = 1328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om4);

	offset = 1320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om3);

	offset = 1312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om2);

	offset = 1368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->memory_map_rev);

	offset = 1352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wavelength_tolerance);

	offset = 1344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om1);

	offset = 1376;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->memory_map_compliance);

	offset = 1408;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->date_code);

	offset = 1480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vendor_oui);

	offset = 1472;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->connector_type);

	offset = 1528;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_output_valid);

	offset = 1520;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_53g);

	offset = 1518;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_input_freq_sync);

	offset = 1564;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_code);

	offset = 1560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cdr_vendor);

	offset = 1536;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_fiber_length);

}

void pddr_module_info_unpack(struct pddr_module_info *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->ethernet_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->ext_ethernet_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->cable_breakout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->cable_technology = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->cable_power_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->cable_identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->cable_length = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 36;
	ptr_struct->cable_vendor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->cable_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->cable_tx_equalization = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->cable_rx_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->cable_rx_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->max_power = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->cable_attenuation_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->cable_attenuation_7g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->cable_attenuation_12g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->cable_attenuation_25g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->tx_cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->rx_cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 140;
	ptr_struct->tx_cdr_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 136;
	ptr_struct->rx_cdr_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->cable_rx_post_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 1728, 1);
	ptr_struct->vendor_name[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_name[16] = '\0';
	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(312, 8, i, 1728, 1);
	ptr_struct->vendor_pn[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_pn[16] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(440, 8, i, 1728, 1);
	ptr_struct->vendor_rev[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_rev[4] = '\0';
	offset = 448;
	ptr_struct->fw_version = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1728, 1);
	ptr_struct->vendor_sn[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_sn[16] = '\0';
	offset = 624;
	ptr_struct->voltage = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 608;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 656;
	ptr_struct->rx_power_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 640;
	ptr_struct->rx_power_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 688;
	ptr_struct->rx_power_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 672;
	ptr_struct->rx_power_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 720;
	ptr_struct->rx_power_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 704;
	ptr_struct->rx_power_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 752;
	ptr_struct->rx_power_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 736;
	ptr_struct->rx_power_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 784;
	ptr_struct->tx_power_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 768;
	ptr_struct->tx_power_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 816;
	ptr_struct->tx_power_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 800;
	ptr_struct->tx_power_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 848;
	ptr_struct->tx_power_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 832;
	ptr_struct->tx_power_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 880;
	ptr_struct->tx_power_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 864;
	ptr_struct->tx_power_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 912;
	ptr_struct->tx_bias_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 896;
	ptr_struct->tx_bias_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 944;
	ptr_struct->tx_bias_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 928;
	ptr_struct->tx_bias_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 976;
	ptr_struct->tx_bias_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 960;
	ptr_struct->tx_bias_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1008;
	ptr_struct->tx_bias_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 992;
	ptr_struct->tx_bias_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1040;
	ptr_struct->temperature_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1024;
	ptr_struct->temperature_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1072;
	ptr_struct->voltage_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1056;
	ptr_struct->voltage_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1104;
	ptr_struct->rx_power_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1088;
	ptr_struct->rx_power_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1136;
	ptr_struct->tx_power_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1120;
	ptr_struct->tx_power_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1168;
	ptr_struct->tx_bias_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1152;
	ptr_struct->tx_bias_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1200;
	ptr_struct->wavelength = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1190;
	ptr_struct->smf_length = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 1189;
	ptr_struct->rx_output_valid_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1188;
	ptr_struct->did_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1187;
	ptr_struct->rx_power_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1184;
	ptr_struct->module_st = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 1240;
	ptr_struct->ib_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1224;
	ptr_struct->active_set_media_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1216;
	ptr_struct->active_set_host_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1274;
	ptr_struct->ib_width = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 1264;
	ptr_struct->monitor_cap_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1256;
	ptr_struct->nbr100 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1248;
	ptr_struct->nbr250 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1308;
	ptr_struct->dp_st_lane7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1304;
	ptr_struct->dp_st_lane6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1300;
	ptr_struct->dp_st_lane5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1296;
	ptr_struct->dp_st_lane4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1292;
	ptr_struct->dp_st_lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1288;
	ptr_struct->dp_st_lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1284;
	ptr_struct->dp_st_lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1280;
	ptr_struct->dp_st_lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1336;
	ptr_struct->length_om5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1328;
	ptr_struct->length_om4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1320;
	ptr_struct->length_om3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1312;
	ptr_struct->length_om2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1368;
	ptr_struct->memory_map_rev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1352;
	ptr_struct->wavelength_tolerance = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1344;
	ptr_struct->length_om1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1376;
	ptr_struct->memory_map_compliance = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1408;
	ptr_struct->date_code = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1480;
	ptr_struct->vendor_oui = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 1472;
	ptr_struct->connector_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1528;
	ptr_struct->rx_output_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1520;
	ptr_struct->cable_attenuation_53g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1518;
	ptr_struct->tx_input_freq_sync = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1564;
	ptr_struct->error_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1560;
	ptr_struct->cdr_vendor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1536;
	ptr_struct->max_fiber_length = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_module_info_print(const struct pddr_module_info *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_module_info ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ethernet_compliance_code : " UH_FMT "\n", ptr_struct->ethernet_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_ethernet_compliance_code : " UH_FMT "\n", ptr_struct->ext_ethernet_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_breakout       : " UH_FMT "\n", ptr_struct->cable_breakout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_technology     : " UH_FMT "\n", ptr_struct->cable_technology);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_power_class    : " UH_FMT "\n", ptr_struct->cable_power_class);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_identifier     : " UH_FMT "\n", ptr_struct->cable_identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_length         : " UH_FMT "\n", ptr_struct->cable_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_vendor         : %s (" UH_FMT ")\n", (ptr_struct->cable_vendor == 0 ? ("Other") : ((ptr_struct->cable_vendor == 1 ? ("Mellanox") : ((ptr_struct->cable_vendor == 2 ? ("Known_OUI") : ((ptr_struct->cable_vendor == 3 ? ("NVIDIA") : ("unknown")))))))), ptr_struct->cable_vendor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_type           : %s (" UH_FMT ")\n", (ptr_struct->cable_type == 0 ? ("Unidentified") : ((ptr_struct->cable_type == 1 ? ("Active_cable") : ((ptr_struct->cable_type == 2 ? ("Optical_Module") : ((ptr_struct->cable_type == 3 ? ("Passive_copper_cable") : ((ptr_struct->cable_type == 4 ? ("Cable_unplugged") : ((ptr_struct->cable_type == 5 ? ("Twisted_pair") : ("unknown")))))))))))), ptr_struct->cable_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_tx_equalization : " UH_FMT "\n", ptr_struct->cable_tx_equalization);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_emphasis    : " UH_FMT "\n", ptr_struct->cable_rx_emphasis);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_amp         : " UH_FMT "\n", ptr_struct->cable_rx_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_power            : " UH_FMT "\n", ptr_struct->max_power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_5g : " UH_FMT "\n", ptr_struct->cable_attenuation_5g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_7g : " UH_FMT "\n", ptr_struct->cable_attenuation_7g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_12g : " UH_FMT "\n", ptr_struct->cable_attenuation_12g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_25g : " UH_FMT "\n", ptr_struct->cable_attenuation_25g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_state         : " UH_FMT "\n", ptr_struct->tx_cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_state         : " UH_FMT "\n", ptr_struct->rx_cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_cap           : " UH_FMT "\n", ptr_struct->tx_cdr_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_cap           : " UH_FMT "\n", ptr_struct->rx_cdr_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_post_emphasis : " UH_FMT "\n", ptr_struct->cable_rx_post_emphasis);

	fprintf(file, "vendor_name          : \"%s\"\n", ptr_struct->vendor_name);
	fprintf(file, "vendor_pn            : \"%s\"\n", ptr_struct->vendor_pn);
	fprintf(file, "vendor_rev           : \"%s\"\n", ptr_struct->vendor_rev);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_version           : " U32H_FMT "\n", ptr_struct->fw_version);

	fprintf(file, "vendor_sn            : \"%s\"\n", ptr_struct->vendor_sn);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage              : " UH_FMT "\n", ptr_struct->voltage);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : " UH_FMT "\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane1       : " UH_FMT "\n", ptr_struct->rx_power_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane0       : " UH_FMT "\n", ptr_struct->rx_power_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane3       : " UH_FMT "\n", ptr_struct->rx_power_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane2       : " UH_FMT "\n", ptr_struct->rx_power_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane5       : " UH_FMT "\n", ptr_struct->rx_power_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane4       : " UH_FMT "\n", ptr_struct->rx_power_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane7       : " UH_FMT "\n", ptr_struct->rx_power_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane6       : " UH_FMT "\n", ptr_struct->rx_power_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane1       : " UH_FMT "\n", ptr_struct->tx_power_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane0       : " UH_FMT "\n", ptr_struct->tx_power_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane3       : " UH_FMT "\n", ptr_struct->tx_power_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane2       : " UH_FMT "\n", ptr_struct->tx_power_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane5       : " UH_FMT "\n", ptr_struct->tx_power_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane4       : " UH_FMT "\n", ptr_struct->tx_power_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane7       : " UH_FMT "\n", ptr_struct->tx_power_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane6       : " UH_FMT "\n", ptr_struct->tx_power_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane1        : " UH_FMT "\n", ptr_struct->tx_bias_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane0        : " UH_FMT "\n", ptr_struct->tx_bias_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane3        : " UH_FMT "\n", ptr_struct->tx_bias_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane2        : " UH_FMT "\n", ptr_struct->tx_bias_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane5        : " UH_FMT "\n", ptr_struct->tx_bias_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane4        : " UH_FMT "\n", ptr_struct->tx_bias_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane7        : " UH_FMT "\n", ptr_struct->tx_bias_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane6        : " UH_FMT "\n", ptr_struct->tx_bias_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_low_th   : " UH_FMT "\n", ptr_struct->temperature_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_high_th  : " UH_FMT "\n", ptr_struct->temperature_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_low_th       : " UH_FMT "\n", ptr_struct->voltage_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_high_th      : " UH_FMT "\n", ptr_struct->voltage_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_low_th      : " UH_FMT "\n", ptr_struct->rx_power_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_high_th     : " UH_FMT "\n", ptr_struct->rx_power_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_low_th      : " UH_FMT "\n", ptr_struct->tx_power_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_high_th     : " UH_FMT "\n", ptr_struct->tx_power_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_low_th       : " UH_FMT "\n", ptr_struct->tx_bias_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_high_th      : " UH_FMT "\n", ptr_struct->tx_bias_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wavelength           : " UH_FMT "\n", ptr_struct->wavelength);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "smf_length           : " UH_FMT "\n", ptr_struct->smf_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_output_valid_cap  : " UH_FMT "\n", ptr_struct->rx_output_valid_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "did_cap              : " UH_FMT "\n", ptr_struct->did_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_type        : %s (" UH_FMT ")\n", (ptr_struct->rx_power_type == 0 ? ("OMA") : ((ptr_struct->rx_power_type == 1 ? ("Average_power") : ("unknown")))), ptr_struct->rx_power_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_st            : %s (" UH_FMT ")\n", (ptr_struct->module_st == 0 ? ("reserved") : ((ptr_struct->module_st == 1 ? ("LowPwr_state") : ((ptr_struct->module_st == 2 ? ("PwrUp_state") : ((ptr_struct->module_st == 3 ? ("Ready_state") : ((ptr_struct->module_st == 4 ? ("PwrDn_state") : ((ptr_struct->module_st == 5 ? ("Fault_state") : ("unknown")))))))))))), ptr_struct->module_st);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_compliance_code   : " UH_FMT "\n", ptr_struct->ib_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_set_media_compliance_code : " UH_FMT "\n", ptr_struct->active_set_media_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_set_host_compliance_code : " UH_FMT "\n", ptr_struct->active_set_host_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_width             : " UH_FMT "\n", ptr_struct->ib_width);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monitor_cap_mask     : " UH_FMT "\n", ptr_struct->monitor_cap_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nbr100               : " UH_FMT "\n", ptr_struct->nbr100);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nbr250               : " UH_FMT "\n", ptr_struct->nbr250);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane7          : " UH_FMT "\n", ptr_struct->dp_st_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane6          : " UH_FMT "\n", ptr_struct->dp_st_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane5          : " UH_FMT "\n", ptr_struct->dp_st_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane4          : " UH_FMT "\n", ptr_struct->dp_st_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane3          : " UH_FMT "\n", ptr_struct->dp_st_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane2          : " UH_FMT "\n", ptr_struct->dp_st_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane1          : " UH_FMT "\n", ptr_struct->dp_st_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane0          : %s (" UH_FMT ")\n", (ptr_struct->dp_st_lane0 == 1 ? ("DPDeactivated") : ((ptr_struct->dp_st_lane0 == 2 ? ("DPInit") : ((ptr_struct->dp_st_lane0 == 3 ? ("DPDeinit") : ((ptr_struct->dp_st_lane0 == 4 ? ("DPActivated") : ((ptr_struct->dp_st_lane0 == 5 ? ("DPTxTurnOn") : ((ptr_struct->dp_st_lane0 == 6 ? ("DPTxTurnOff") : ((ptr_struct->dp_st_lane0 == 7 ? ("DPInitialized") : ("unknown")))))))))))))), ptr_struct->dp_st_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om5           : " UH_FMT "\n", ptr_struct->length_om5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om4           : " UH_FMT "\n", ptr_struct->length_om4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om3           : " UH_FMT "\n", ptr_struct->length_om3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om2           : " UH_FMT "\n", ptr_struct->length_om2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_map_rev       : " UH_FMT "\n", ptr_struct->memory_map_rev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wavelength_tolerance : " UH_FMT "\n", ptr_struct->wavelength_tolerance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om1           : " UH_FMT "\n", ptr_struct->length_om1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_map_compliance : " U32H_FMT "\n", ptr_struct->memory_map_compliance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "date_code            : " U64H_FMT "\n", ptr_struct->date_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_oui           : " UH_FMT "\n", ptr_struct->vendor_oui);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connector_type       : " UH_FMT "\n", ptr_struct->connector_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_output_valid      : " UH_FMT "\n", ptr_struct->rx_output_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_53g : " UH_FMT "\n", ptr_struct->cable_attenuation_53g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_input_freq_sync   : %s (" UH_FMT ")\n", (ptr_struct->tx_input_freq_sync == 0 ? ("Tx_input_lanes_1_8") : ((ptr_struct->tx_input_freq_sync == 1 ? ("Tx_input_lanes_1_4_and_5") : ((ptr_struct->tx_input_freq_sync == 2 ? ("Tx_input_lanes_1_2_and_3_4_and_5_6_and_7_8") : ((ptr_struct->tx_input_freq_sync == 3 ? ("Lanes_may_be_asynchronous_in_frequency") : ("unknown")))))))), ptr_struct->tx_input_freq_sync);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_code           : %s (" UH_FMT ")\n", (ptr_struct->error_code == 0 ? ("ConfigUndefined") : ((ptr_struct->error_code == 1 ? ("ConfigSuccess") : ((ptr_struct->error_code == 2 ? ("ConfigRejected") : ((ptr_struct->error_code == 3 ? ("ConfigRejectedInvalidAppSel") : ((ptr_struct->error_code == 4 ? ("ConfigRejectedInvalidDataPath") : ((ptr_struct->error_code == 5 ? ("ConfigRejectedInvalidSI") : ((ptr_struct->error_code == 6 ? ("ConfigRejectedLanesInUse") : ((ptr_struct->error_code == 7 ? ("ConfigRejectedPartialDataPath") : ((ptr_struct->error_code == 12 ? ("ConfigInProgress") : ("unknown")))))))))))))))))), ptr_struct->error_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_vendor           : %s (" UH_FMT ")\n", (ptr_struct->cdr_vendor == 0 ? ("Unknown_or_no_CDR") : ((ptr_struct->cdr_vendor == 1 ? ("Mellanox_Menhit") : ((ptr_struct->cdr_vendor == 2 ? ("Inphy_gen1_polaris") : ((ptr_struct->cdr_vendor == 3 ? ("Inphy_gen2_Atlas") : ((ptr_struct->cdr_vendor == 4 ? ("Marvell_Spica_Plus") : ((ptr_struct->cdr_vendor == 5 ? ("Broadcom_TBD_name") : ((ptr_struct->cdr_vendor == 6 ? ("Nvidia_ArcusE") : ((ptr_struct->cdr_vendor == 7 ? ("Marvell_Nova1") : ("unknown")))))))))))))))), ptr_struct->cdr_vendor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_fiber_length     : " UH_FMT "\n", ptr_struct->max_fiber_length);

}

int pddr_module_info_size(void)
{
	return 216;
}

void pddr_module_info_dump(const struct pddr_module_info *ptr_struct, FILE *file)
{
	pddr_module_info_print(ptr_struct, file, 0);
}

void pddr_operation_info_page_pack(const struct pddr_operation_info_page *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pd_fsm_state);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->neg_mode_active);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->proto_active);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phy_hst_fsm_state);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ib_phy_fsm_state);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_an_fsm_state);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phy_mngr_fsm_state);

	offset = 64;
	pddr_operation_info_page_phy_manager_link_enabled_auto_pack(&(ptr_struct->phy_manager_link_enabled), ptr_buff + offset/8);

	offset = 96;
	pddr_operation_info_page_core_to_phy_link_enabled_auto_pack(&(ptr_struct->core_to_phy_link_enabled), ptr_buff + offset/8);

	offset = 128;
	pddr_operation_info_page_cable_proto_cap_auto_pack(&(ptr_struct->cable_proto_cap), ptr_buff + offset/8);

	offset = 160;
	pddr_operation_info_page_link_active_auto_pack(&(ptr_struct->link_active), ptr_buff + offset/8);

	offset = 212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->loopback_mode);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->retran_mode_request);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->retran_mode_active);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fec_mode_request);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fec_mode_active);

	offset = 284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_100g_fec_support);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_25g_50g_fec_support);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nlpn_fsm_state);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->profile_fec_in_use);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pd_link_enabled);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phy_hst_link_enabled);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_an_link_enabled);

	offset = 412;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->psi_fsm_state);

	offset = 404;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->core_to_phy_state);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->linkup_retry_iterations);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_proto_cap_ext);

}

void pddr_operation_info_page_unpack(struct pddr_operation_info_page *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->pd_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 12;
	ptr_struct->neg_mode_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->proto_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->phy_hst_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ib_phy_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->eth_an_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->phy_mngr_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	pddr_operation_info_page_phy_manager_link_enabled_auto_unpack(&(ptr_struct->phy_manager_link_enabled), ptr_buff + offset/8);

	offset = 96;
	pddr_operation_info_page_core_to_phy_link_enabled_auto_unpack(&(ptr_struct->core_to_phy_link_enabled), ptr_buff + offset/8);

	offset = 128;
	pddr_operation_info_page_cable_proto_cap_auto_unpack(&(ptr_struct->cable_proto_cap), ptr_buff + offset/8);

	offset = 160;
	pddr_operation_info_page_link_active_auto_unpack(&(ptr_struct->link_active), ptr_buff + offset/8);

	offset = 212;
	ptr_struct->loopback_mode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 200;
	ptr_struct->retran_mode_request = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->retran_mode_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->fec_mode_request = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->fec_mode_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 284;
	ptr_struct->eth_100g_fec_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 280;
	ptr_struct->eth_25g_50g_fec_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 272;
	ptr_struct->nlpn_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->profile_fec_in_use = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->pd_link_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->phy_hst_link_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->eth_an_link_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 412;
	ptr_struct->psi_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 404;
	ptr_struct->core_to_phy_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->linkup_retry_iterations = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 416;
	ptr_struct->cable_proto_cap_ext = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void pddr_operation_info_page_print(const struct pddr_operation_info_page *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_operation_info_page ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd_fsm_state         : " UH_FMT "\n", ptr_struct->pd_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "neg_mode_active      : %s (" UH_FMT ")\n", (ptr_struct->neg_mode_active == 0 ? ("protocol_was_not_negotiated") : ((ptr_struct->neg_mode_active == 1 ? ("MLPN_rev0_negotiated") : ((ptr_struct->neg_mode_active == 2 ? ("CL73_Ethernet_negotiated") : ((ptr_struct->neg_mode_active == 3 ? ("Protocol_according_to_Parallel_detect") : ((ptr_struct->neg_mode_active == 4 ? ("Standard_IB_negotiated") : ((ptr_struct->neg_mode_active == 7 ? ("Standard_IB_rev2") : ((ptr_struct->neg_mode_active == 8 ? ("NLPN_rev2_negotiated") : ((ptr_struct->neg_mode_active == 9 ? ("HS_NLPN_rev2_negotiated_") : ("unknown")))))))))))))))), ptr_struct->neg_mode_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "proto_active         : %s (" UH_FMT ")\n", (ptr_struct->proto_active == 1 ? ("InfiniBand") : ((ptr_struct->proto_active == 4 ? ("Ethernet") : ((ptr_struct->proto_active == 8 ? ("NVLink") : ("unknown")))))), ptr_struct->proto_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_hst_fsm_state    : " UH_FMT "\n", ptr_struct->phy_hst_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_phy_fsm_state     : %s (" UH_FMT ")\n", (ptr_struct->ib_phy_fsm_state == 0 ? ("IB_AN_FSM_DISABLED") : ((ptr_struct->ib_phy_fsm_state == 1 ? ("IB_AN_FSM_INITIALY") : ((ptr_struct->ib_phy_fsm_state == 2 ? ("IB_AN_FSM_RCVR_CFG") : ((ptr_struct->ib_phy_fsm_state == 3 ? ("IB_AN_FSM_CFG_TEST") : ((ptr_struct->ib_phy_fsm_state == 4 ? ("IB_AN_FSM_WAIT_RMT_TEST") : ((ptr_struct->ib_phy_fsm_state == 5 ? ("IB_AN_FSM_WAIT_CFG_ENHANCED") : ((ptr_struct->ib_phy_fsm_state == 6 ? ("IB_AN_FSM_CFG_IDLE") : ((ptr_struct->ib_phy_fsm_state == 7 ? ("IB_AN_FSM_LINK_UP") : ((ptr_struct->ib_phy_fsm_state == 8 ? ("IB_AN_FSM_POLLING") : ((ptr_struct->ib_phy_fsm_state == 9 ? ("IB_AN_FSM_SYNC_CHECK") : ("unknown")))))))))))))))))))), ptr_struct->ib_phy_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_an_fsm_state     : " UH_FMT "\n", ptr_struct->eth_an_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_mngr_fsm_state   : %s (" UH_FMT ")\n", (ptr_struct->phy_mngr_fsm_state == 0 ? ("Disabled") : ((ptr_struct->phy_mngr_fsm_state == 1 ? ("Open_port") : ((ptr_struct->phy_mngr_fsm_state == 2 ? ("Polling") : ((ptr_struct->phy_mngr_fsm_state == 3 ? ("Active") : ((ptr_struct->phy_mngr_fsm_state == 4 ? ("Close_port") : ((ptr_struct->phy_mngr_fsm_state == 5 ? ("Phy_up") : ((ptr_struct->phy_mngr_fsm_state == 6 ? ("Sleep") : ((ptr_struct->phy_mngr_fsm_state == 7 ? ("Rx_disable") : ((ptr_struct->phy_mngr_fsm_state == 8 ? ("Signal_detect") : ((ptr_struct->phy_mngr_fsm_state == 9 ? ("Receiver_detect") : ((ptr_struct->phy_mngr_fsm_state == 10 ? ("Sync_peer") : ((ptr_struct->phy_mngr_fsm_state == 11 ? ("Negotiation") : ((ptr_struct->phy_mngr_fsm_state == 12 ? ("Training") : ((ptr_struct->phy_mngr_fsm_state == 13 ? ("SubFSM_active") : ("unknown")))))))))))))))))))))))))))), ptr_struct->phy_mngr_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_link_enabled:\n");
	pddr_operation_info_page_phy_manager_link_enabled_auto_print(&(ptr_struct->phy_manager_link_enabled), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_link_enabled:\n");
	pddr_operation_info_page_core_to_phy_link_enabled_auto_print(&(ptr_struct->core_to_phy_link_enabled), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_proto_cap:\n");
	pddr_operation_info_page_cable_proto_cap_auto_print(&(ptr_struct->cable_proto_cap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_active:\n");
	pddr_operation_info_page_link_active_auto_print(&(ptr_struct->link_active), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "loopback_mode        : %s (" UH_FMT ")\n", (ptr_struct->loopback_mode == 0 ? ("No_loopback_active") : ((ptr_struct->loopback_mode == 1 ? ("Phy_remote_loopback") : ((ptr_struct->loopback_mode == 2 ? ("Phy_local_loopback") : ((ptr_struct->loopback_mode == 4 ? ("External_local_loopback") : ((ptr_struct->loopback_mode == 8 ? ("Near_end_analog_loopback") : ((ptr_struct->loopback_mode == 16 ? ("Near_end_digital_loopback") : ((ptr_struct->loopback_mode == 128 ? ("LL_local_loopback") : ((ptr_struct->loopback_mode == 256 ? ("GLoop") : ("unknown")))))))))))))))), ptr_struct->loopback_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retran_mode_request  : %s (" UH_FMT ")\n", (ptr_struct->retran_mode_request == 0 ? ("No_retransmission") : ((ptr_struct->retran_mode_request == 1 ? ("LLR") : ("unknown")))), ptr_struct->retran_mode_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retran_mode_active   : %s (" UH_FMT ")\n", (ptr_struct->retran_mode_active == 0 ? ("No_retransmission") : ((ptr_struct->retran_mode_active == 1 ? ("LLR") : ("unknown")))), ptr_struct->retran_mode_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_mode_request     : " UH_FMT "\n", ptr_struct->fec_mode_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_mode_active      : %s (" UH_FMT ")\n", (ptr_struct->fec_mode_active == 0 ? ("No_FEC") : ((ptr_struct->fec_mode_active == 1 ? ("Firecode_FEC") : ((ptr_struct->fec_mode_active == 2 ? ("Standard_RS_FEC") : ((ptr_struct->fec_mode_active == 3 ? ("Standard_LL_RS_FEC") : ((ptr_struct->fec_mode_active == 4 ? ("Reserved") : ((ptr_struct->fec_mode_active == 6 ? ("Interleaved_Standard_RS") : ((ptr_struct->fec_mode_active == 7 ? ("Standard_RS") : ((ptr_struct->fec_mode_active == 8 ? ("Zero_Latency_FEC") : ((ptr_struct->fec_mode_active == 9 ? ("Ethernet_Consortium_LL_50G_RS_FEC") : ((ptr_struct->fec_mode_active == 10 ? ("Interleaved_Ethernet_Consortium_LL_50G_RS_FEC") : ((ptr_struct->fec_mode_active == 11 ? ("Interleaved_Standard_RS_FEC_PLR") : ((ptr_struct->fec_mode_active == 12 ? ("RS") : ((ptr_struct->fec_mode_active == 13 ? ("LL") : ((ptr_struct->fec_mode_active == 14 ? ("Ethernet_Consortium_LL_50G_RS_FEC_PLR") : ((ptr_struct->fec_mode_active == 15 ? ("Interleaved_Ethernet_Consortium_LL_50G_RS_FEC_PLR") : ("unknown")))))))))))))))))))))))))))))), ptr_struct->fec_mode_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_100g_fec_support : " UH_FMT "\n", ptr_struct->eth_100g_fec_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_25g_50g_fec_support : " UH_FMT "\n", ptr_struct->eth_25g_50g_fec_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nlpn_fsm_state       : %s (" UH_FMT ")\n", (ptr_struct->nlpn_fsm_state == 0 ? ("NLPN_FSM_DISABLE") : ((ptr_struct->nlpn_fsm_state == 1 ? ("NLPN_FSM_ABILITY_DETECT") : ((ptr_struct->nlpn_fsm_state == 2 ? ("NLPN_FSM_ACK_DETECT") : ((ptr_struct->nlpn_fsm_state == 3 ? ("NLPN_FSM_COMPLETE_ACK") : ((ptr_struct->nlpn_fsm_state == 4 ? ("NLPN_FSM_NEXT_PAGE_WAIT") : ((ptr_struct->nlpn_fsm_state == 5 ? ("NLPN_FSM_AN_GOOD") : ("unknown")))))))))))), ptr_struct->nlpn_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "profile_fec_in_use   : " UH_FMT "\n", ptr_struct->profile_fec_in_use);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd_link_enabled      : " U32H_FMT "\n", ptr_struct->pd_link_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_hst_link_enabled : " U32H_FMT "\n", ptr_struct->phy_hst_link_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_an_link_enabled  : " U32H_FMT "\n", ptr_struct->eth_an_link_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psi_fsm_state        : %s (" UH_FMT ")\n", (ptr_struct->psi_fsm_state == 0 ? ("PSI_FSM_IDLE") : ((ptr_struct->psi_fsm_state == 1 ? ("PSI_FSM_WAIT4UCDONE") : ((ptr_struct->psi_fsm_state == 2 ? ("PSI_FSM_SAFE_OPEN_CLOSE") : ((ptr_struct->psi_fsm_state == 3 ? ("PSI_ERROR_STATE") : ("unknown")))))))), ptr_struct->psi_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_to_phy_state    : %s (" UH_FMT ")\n", (ptr_struct->core_to_phy_state == 2 ? ("PHY_STATE_POLLING") : ((ptr_struct->core_to_phy_state == 3 ? ("PHY_STATE_DISABLE") : ((ptr_struct->core_to_phy_state == 5 ? ("PHY_STATE_LINKUP") : ("unknown")))))), ptr_struct->core_to_phy_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "linkup_retry_iterations : " UH_FMT "\n", ptr_struct->linkup_retry_iterations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_proto_cap_ext  : %s (" U32H_FMT ")\n", (ptr_struct->cable_proto_cap_ext == 1 ? ("SDR_1x") : ((ptr_struct->cable_proto_cap_ext == 2 ? ("SDR_2x") : ((ptr_struct->cable_proto_cap_ext == 4 ? ("SDR_4x") : ((ptr_struct->cable_proto_cap_ext == 4096 ? ("FDR_4x") : ((ptr_struct->cable_proto_cap_ext == 16384 ? ("EDR_2x") : ((ptr_struct->cable_proto_cap_ext == 32768 ? ("EDR_4x") : ((ptr_struct->cable_proto_cap_ext == 65536 ? ("HDR_1x") : ((ptr_struct->cable_proto_cap_ext == 131072 ? ("HDR_2x") : ((ptr_struct->cable_proto_cap_ext == 262144 ? ("HDR_4x") : ((ptr_struct->cable_proto_cap_ext == 2097152 ? ("NDR_2x") : ((ptr_struct->cable_proto_cap_ext == 4194304 ? ("NDR_4x") : ((ptr_struct->cable_proto_cap_ext == 16777216 ? ("XDR_1x") : ((ptr_struct->cable_proto_cap_ext == 33554432 ? ("XDR_2x") : ("unknown")))))))))))))))))))))))))), ptr_struct->cable_proto_cap_ext);

}

int pddr_operation_info_page_size(void)
{
	return 248;
}

void pddr_operation_info_page_dump(const struct pddr_operation_info_page *ptr_struct, FILE *file)
{
	pddr_operation_info_page_print(ptr_struct, file, 0);
}

void pddr_phy_info_page_pack(const struct pddr_phy_info_page *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_notifications);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->negotiation_mask);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->remote_device_type);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lp_ib_revision);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ib_revision);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_negotiation_attempts);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->phy_manager_disable_mask);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hw_link_phy_state);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pcs_phy_state);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lp_proto_enabled);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lp_fec_mode_request);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lp_fec_mode_support);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ib_last_link_down_reason);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_last_link_down_lane[i]);
	}

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->speed_deg_db);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_0);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_1);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_2);

	offset = 424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->degrade_grade_lane_3);

	offset = 475;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane_7);

	offset = 467;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane_6);

	offset = 459;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane_5);

	offset = 451;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane_4);

	offset = 496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_5);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_4);

	offset = 528;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_7);

	offset = 512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_6);

	offset = 571;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane3);

	offset = 563;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane2);

	offset = 555;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane1);

	offset = 547;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->num_of_presets_tested_lane0);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(600, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->kr_startup_fsm_lane[i]);
	}

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_an_debug_indication);

	offset = 688;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_phy_fsm_state_trace);

	offset = 683;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rounds_waited_for_peer_to_end_test);

	offset = 681;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->eth_an_watchdog_cnt);

	offset = 678;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fall_from_cfg_idle_cdr_cnt);

	offset = 675;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fall_from_cfg_idle_cnt);

	offset = 672;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->cdr_not_locked_cnt);

	offset = 720;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_1);

	offset = 704;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_0);

	offset = 752;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_3);

	offset = 736;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->kr_startup_debug_indications_2);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(796, 4, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_tuning_stages_lane[i]);
	}

	offset = 824;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->plu_tx_pwrup);

	offset = 816;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->plu_rx_pwrup);

	offset = 808;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->plu_tx_polarity);

	offset = 800;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->plu_rx_polarity);

	offset = 860;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->irisc_status);

	offset = 858;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ib_cfg_delay_timeout);

	offset = 857;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sd_valid);

	offset = 852;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plu_tx_speed);

	offset = 848;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plu_rx_speed);

	offset = 840;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->plr_outstanding_cells);

	offset = 832;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signal_detected);

	offset = 864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->stamping_reason);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->kr_frame_lock_tuning_failure_events_count);

	offset = 928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->kr_full_tuning_failure_count);

	offset = 976;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pm_debug_indication);

	offset = 960;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_debug_indication);

	offset = 1017;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->pm_catastrophic_enum);

	offset = 1016;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pm_cat_val);

	offset = 1009;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->an_catastrophic_enum);

	offset = 1008;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->an_cat_val);

	offset = 1001;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->hst_catastrophic_enum);

	offset = 1000;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->hst_cat_val);

	offset = 993;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->pd_catastrophic_enum);

	offset = 992;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pd_cat_val);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pd_debug_indication);

	offset = 1082;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->pd_count);

	offset = 1074;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->fp_signal_detect_count);

	offset = 1070;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->hst_mismatch_reason);

	offset = 1061;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->psi_collision2);

	offset = 1056;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->psi_collision1);

	offset = 1112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nlpn_debug_ind_mask);

	offset = 1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phy2mod_speed_req);

	offset = 1176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phy2mod_deactivate_lanes);

	offset = 1168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phy2mod_ack_lanes);

	offset = 1154;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->one_pll_mod);

	offset = 1153;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_dme_mod);

	offset = 1152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eeprom_prsnt);

	offset = 1214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_bypass_mux_plt0);

	offset = 1212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_bypass_mux_plt1);

	offset = 1210;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_bypass_mux_plt0);

	offset = 1208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_bypass_mux_plt1);

	offset = 1206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->reconciliation_mux_plt0);

	offset = 1204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->reconciliation_mux_plt1);

	offset = 1203;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->macsec_en_plt0_s0);

	offset = 1202;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->macsec_en_plt0_s1);

	offset = 1201;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->macsec_en_plt1_s0);

	offset = 1200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->macsec_en_plt1_s1);

	offset = 1196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_rx_frame_received_ok_s0);

	offset = 1192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_rx_frame_received_ok_s1);

	offset = 1188;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_pkts_inc_s0);

	offset = 1184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_pkts_inc_s1);

	offset = 1232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->plr_rtt_ndr_threshold);

	offset = 1216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->plr_rtt_hdr_threshold);

	offset = 1248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->plr_rtt_xdr_threshold);

}

void pddr_phy_info_page_unpack(struct pddr_phy_info_page *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_notifications = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->negotiation_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->remote_device_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->lp_ib_revision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ib_revision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->num_of_negotiation_attempts = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->phy_manager_disable_mask = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 64;
	ptr_struct->hw_link_phy_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->pcs_phy_state = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->lp_proto_enabled = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->lp_fec_mode_request = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->lp_fec_mode_support = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->ib_last_link_down_reason = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 1984, 1);
	ptr_struct->eth_last_link_down_lane[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	offset = 288;
	ptr_struct->speed_deg_db = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 328;
	ptr_struct->degrade_grade_lane_0 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 360;
	ptr_struct->degrade_grade_lane_1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 392;
	ptr_struct->degrade_grade_lane_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 424;
	ptr_struct->degrade_grade_lane_3 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 475;
	ptr_struct->num_of_presets_tested_lane_7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 467;
	ptr_struct->num_of_presets_tested_lane_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 459;
	ptr_struct->num_of_presets_tested_lane_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 451;
	ptr_struct->num_of_presets_tested_lane_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 496;
	ptr_struct->kr_startup_debug_indications_5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 480;
	ptr_struct->kr_startup_debug_indications_4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 528;
	ptr_struct->kr_startup_debug_indications_7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 512;
	ptr_struct->kr_startup_debug_indications_6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 571;
	ptr_struct->num_of_presets_tested_lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 563;
	ptr_struct->num_of_presets_tested_lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 555;
	ptr_struct->num_of_presets_tested_lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 547;
	ptr_struct->num_of_presets_tested_lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(600, 8, i, 1984, 1);
	ptr_struct->kr_startup_fsm_lane[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	offset = 640;
	ptr_struct->eth_an_debug_indication = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 688;
	ptr_struct->ib_phy_fsm_state_trace = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 683;
	ptr_struct->rounds_waited_for_peer_to_end_test = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 681;
	ptr_struct->eth_an_watchdog_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 678;
	ptr_struct->fall_from_cfg_idle_cdr_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 675;
	ptr_struct->fall_from_cfg_idle_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 672;
	ptr_struct->cdr_not_locked_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 720;
	ptr_struct->kr_startup_debug_indications_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 704;
	ptr_struct->kr_startup_debug_indications_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 752;
	ptr_struct->kr_startup_debug_indications_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 736;
	ptr_struct->kr_startup_debug_indications_2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(796, 4, i, 1984, 1);
	ptr_struct->tx_tuning_stages_lane[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);
	}

	offset = 824;
	ptr_struct->plu_tx_pwrup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 816;
	ptr_struct->plu_rx_pwrup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 808;
	ptr_struct->plu_tx_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 800;
	ptr_struct->plu_rx_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 860;
	ptr_struct->irisc_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 858;
	ptr_struct->ib_cfg_delay_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 857;
	ptr_struct->sd_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 852;
	ptr_struct->plu_tx_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 848;
	ptr_struct->plu_rx_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 840;
	ptr_struct->plr_outstanding_cells = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 832;
	ptr_struct->signal_detected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 864;
	ptr_struct->stamping_reason = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 896;
	ptr_struct->kr_frame_lock_tuning_failure_events_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 928;
	ptr_struct->kr_full_tuning_failure_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 976;
	ptr_struct->pm_debug_indication = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 960;
	ptr_struct->ib_debug_indication = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1017;
	ptr_struct->pm_catastrophic_enum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 1016;
	ptr_struct->pm_cat_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1009;
	ptr_struct->an_catastrophic_enum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 1008;
	ptr_struct->an_cat_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1001;
	ptr_struct->hst_catastrophic_enum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 1000;
	ptr_struct->hst_cat_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 993;
	ptr_struct->pd_catastrophic_enum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 992;
	ptr_struct->pd_cat_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1024;
	ptr_struct->pd_debug_indication = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1082;
	ptr_struct->pd_count = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 1074;
	ptr_struct->fp_signal_detect_count = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 1070;
	ptr_struct->hst_mismatch_reason = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1061;
	ptr_struct->psi_collision2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1056;
	ptr_struct->psi_collision1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1112;
	ptr_struct->nlpn_debug_ind_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1120;
	ptr_struct->phy2mod_speed_req = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1176;
	ptr_struct->phy2mod_deactivate_lanes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1168;
	ptr_struct->phy2mod_ack_lanes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1154;
	ptr_struct->one_pll_mod = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1153;
	ptr_struct->no_dme_mod = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1152;
	ptr_struct->eeprom_prsnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1214;
	ptr_struct->rx_bypass_mux_plt0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1212;
	ptr_struct->rx_bypass_mux_plt1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1210;
	ptr_struct->tx_bypass_mux_plt0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1208;
	ptr_struct->tx_bypass_mux_plt1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1206;
	ptr_struct->reconciliation_mux_plt0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1204;
	ptr_struct->reconciliation_mux_plt1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1203;
	ptr_struct->macsec_en_plt0_s0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1202;
	ptr_struct->macsec_en_plt0_s1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1201;
	ptr_struct->macsec_en_plt1_s0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1200;
	ptr_struct->macsec_en_plt1_s1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1196;
	ptr_struct->cnt_rx_frame_received_ok_s0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1192;
	ptr_struct->cnt_rx_frame_received_ok_s1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1188;
	ptr_struct->port_xmit_pkts_inc_s0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1184;
	ptr_struct->port_xmit_pkts_inc_s1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1232;
	ptr_struct->plr_rtt_ndr_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1216;
	ptr_struct->plr_rtt_hdr_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1248;
	ptr_struct->plr_rtt_xdr_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pddr_phy_info_page_print(const struct pddr_phy_info_page *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_phy_info_page ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_notifications   : " UH_FMT "\n", ptr_struct->port_notifications);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "negotiation_mask     : " UH_FMT "\n", ptr_struct->negotiation_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_device_type   : " UH_FMT "\n", ptr_struct->remote_device_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_ib_revision       : " UH_FMT "\n", ptr_struct->lp_ib_revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_revision          : " UH_FMT "\n", ptr_struct->ib_revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_negotiation_attempts : " UH_FMT "\n", ptr_struct->num_of_negotiation_attempts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_manager_disable_mask : " UH_FMT "\n", ptr_struct->phy_manager_disable_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_link_phy_state    : " UH_FMT "\n", ptr_struct->hw_link_phy_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcs_phy_state        : " U32H_FMT "\n", ptr_struct->pcs_phy_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_proto_enabled     : " U32H_FMT "\n", ptr_struct->lp_proto_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_fec_mode_request  : " UH_FMT "\n", ptr_struct->lp_fec_mode_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_fec_mode_support  : " UH_FMT "\n", ptr_struct->lp_fec_mode_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_last_link_down_reason : " U32H_FMT "\n", ptr_struct->ib_last_link_down_reason);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_last_link_down_lane_%03d : " UH_FMT "\n", i, ptr_struct->eth_last_link_down_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speed_deg_db         : " U32H_FMT "\n", ptr_struct->speed_deg_db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_0 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_1 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_2 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "degrade_grade_lane_3 : " UH_FMT "\n", ptr_struct->degrade_grade_lane_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane_7 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane_7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane_6 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane_5 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane_4 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_5 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_4 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_7 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_6 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane3 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane2 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane1 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_presets_tested_lane0 : " UH_FMT "\n", ptr_struct->num_of_presets_tested_lane0);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_fsm_lane_%03d : %s (" UH_FMT ")\n", i, (ptr_struct->kr_startup_fsm_lane[i] == 0 ? ("KR_FSM_INITIALIZE") : ((ptr_struct->kr_startup_fsm_lane[i] == 1 ? ("KR_FSM_SEND_TRAINING") : ((ptr_struct->kr_startup_fsm_lane[i] == 2 ? ("KR_FSM_TRAIN_LOCAL_TX") : ((ptr_struct->kr_startup_fsm_lane[i] == 3 ? ("KR_FSM_TRAIN_LOCAL_RX") : ((ptr_struct->kr_startup_fsm_lane[i] == 4 ? ("KR_FSM_TRAIN_REMOTE") : ((ptr_struct->kr_startup_fsm_lane[i] == 5 ? ("KR_FSM_LINK_READY") : ((ptr_struct->kr_startup_fsm_lane[i] == 6 ? ("KR_FSM_SEND_DATA") : ((ptr_struct->kr_startup_fsm_lane[i] == 7 ? ("KR_FSM_NVLT") : ((ptr_struct->kr_startup_fsm_lane[i] == 8 ? ("KR_ABORT") : ((ptr_struct->kr_startup_fsm_lane[i] == 9 ? ("KR_TIMEOUT") : ((ptr_struct->kr_startup_fsm_lane[i] == 10 ? ("KR_FSM_IN_IDLE") : ("unknown")))))))))))))))))))))), ptr_struct->kr_startup_fsm_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_an_debug_indication : " U32H_FMT "\n", ptr_struct->eth_an_debug_indication);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_phy_fsm_state_trace : " UH_FMT "\n", ptr_struct->ib_phy_fsm_state_trace);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rounds_waited_for_peer_to_end_test : " UH_FMT "\n", ptr_struct->rounds_waited_for_peer_to_end_test);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_an_watchdog_cnt  : " UH_FMT "\n", ptr_struct->eth_an_watchdog_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fall_from_cfg_idle_cdr_cnt : " UH_FMT "\n", ptr_struct->fall_from_cfg_idle_cdr_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fall_from_cfg_idle_cnt : " UH_FMT "\n", ptr_struct->fall_from_cfg_idle_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_not_locked_cnt   : " UH_FMT "\n", ptr_struct->cdr_not_locked_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_1 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_0 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_3 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_startup_debug_indications_2 : " UH_FMT "\n", ptr_struct->kr_startup_debug_indications_2);

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_tuning_stages_lane_%03d : " UH_FMT "\n", i, ptr_struct->tx_tuning_stages_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plu_tx_pwrup         : " UH_FMT "\n", ptr_struct->plu_tx_pwrup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plu_rx_pwrup         : " UH_FMT "\n", ptr_struct->plu_rx_pwrup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plu_tx_polarity      : " UH_FMT "\n", ptr_struct->plu_tx_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plu_rx_polarity      : " UH_FMT "\n", ptr_struct->plu_rx_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "irisc_status         : " UH_FMT "\n", ptr_struct->irisc_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_cfg_delay_timeout : " UH_FMT "\n", ptr_struct->ib_cfg_delay_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_valid             : " UH_FMT "\n", ptr_struct->sd_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plu_tx_speed         : " UH_FMT "\n", ptr_struct->plu_tx_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plu_rx_speed         : " UH_FMT "\n", ptr_struct->plu_rx_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_outstanding_cells : " UH_FMT "\n", ptr_struct->plr_outstanding_cells);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signal_detected      : " UH_FMT "\n", ptr_struct->signal_detected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stamping_reason      : " U32H_FMT "\n", ptr_struct->stamping_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_frame_lock_tuning_failure_events_count : " U32H_FMT "\n", ptr_struct->kr_frame_lock_tuning_failure_events_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kr_full_tuning_failure_count : " U32H_FMT "\n", ptr_struct->kr_full_tuning_failure_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pm_debug_indication  : %s (" UH_FMT ")\n", (ptr_struct->pm_debug_indication == 1 ? ("phy_test_mode") : ((ptr_struct->pm_debug_indication == 2 ? ("force_mode_en") : ("unknown")))), ptr_struct->pm_debug_indication);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_debug_indication  : %s (" UH_FMT ")\n", (ptr_struct->ib_debug_indication == 1 ? ("cause_plr_tx_max_outstanding_cells") : ("unknown")), ptr_struct->ib_debug_indication);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pm_catastrophic_enum : " UH_FMT "\n", ptr_struct->pm_catastrophic_enum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pm_cat_val           : " UH_FMT "\n", ptr_struct->pm_cat_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_catastrophic_enum : " UH_FMT "\n", ptr_struct->an_catastrophic_enum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_cat_val           : " UH_FMT "\n", ptr_struct->an_cat_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hst_catastrophic_enum : " UH_FMT "\n", ptr_struct->hst_catastrophic_enum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hst_cat_val          : " UH_FMT "\n", ptr_struct->hst_cat_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd_catastrophic_enum : " UH_FMT "\n", ptr_struct->pd_catastrophic_enum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd_cat_val           : " UH_FMT "\n", ptr_struct->pd_cat_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd_debug_indication  : %s (" U32H_FMT ")\n", (ptr_struct->pd_debug_indication == 1 ? ("speed_change_high_speed_module") : ((ptr_struct->pd_debug_indication == 2 ? ("False_positive_signal_detect") : ((ptr_struct->pd_debug_indication == 4 ? ("Nv2nv_force") : ((ptr_struct->pd_debug_indication == 8 ? ("bad_kr_mask") : ((ptr_struct->pd_debug_indication == 16 ? ("kr_mlx_peer") : ((ptr_struct->pd_debug_indication == 32 ? ("entered_signal_detect") : ((ptr_struct->pd_debug_indication == 64 ? ("entered_rate_config") : ((ptr_struct->pd_debug_indication == 128 ? ("entered_activate_sunfsm") : ((ptr_struct->pd_debug_indication == 256 ? ("entered_done") : ((ptr_struct->pd_debug_indication == 512 ? ("entered_subfsm_fail") : ("unknown")))))))))))))))))))), ptr_struct->pd_debug_indication);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd_count             : " UH_FMT "\n", ptr_struct->pd_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fp_signal_detect_count : " UH_FMT "\n", ptr_struct->fp_signal_detect_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hst_mismatch_reason  : " UH_FMT "\n", ptr_struct->hst_mismatch_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psi_collision2       : " UH_FMT "\n", ptr_struct->psi_collision2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psi_collision1       : " UH_FMT "\n", ptr_struct->psi_collision1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nlpn_debug_ind_mask  : %s (" UH_FMT ")\n", (ptr_struct->nlpn_debug_ind_mask == 1 ? ("nonce_match_fail") : ((ptr_struct->nlpn_debug_ind_mask == 2 ? ("timeout") : ((ptr_struct->nlpn_debug_ind_mask == 4 ? ("hs_neg") : ((ptr_struct->nlpn_debug_ind_mask == 8 ? ("dme_neg") : ("unknown")))))))), ptr_struct->nlpn_debug_ind_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy2mod_speed_req    : " U32H_FMT "\n", ptr_struct->phy2mod_speed_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy2mod_deactivate_lanes : " UH_FMT "\n", ptr_struct->phy2mod_deactivate_lanes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy2mod_ack_lanes    : " UH_FMT "\n", ptr_struct->phy2mod_ack_lanes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_pll_mod          : " UH_FMT "\n", ptr_struct->one_pll_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_dme_mod           : " UH_FMT "\n", ptr_struct->no_dme_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eeprom_prsnt         : " UH_FMT "\n", ptr_struct->eeprom_prsnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_bypass_mux_plt0   : " UH_FMT "\n", ptr_struct->rx_bypass_mux_plt0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_bypass_mux_plt1   : " UH_FMT "\n", ptr_struct->rx_bypass_mux_plt1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bypass_mux_plt0   : " UH_FMT "\n", ptr_struct->tx_bypass_mux_plt0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bypass_mux_plt1   : " UH_FMT "\n", ptr_struct->tx_bypass_mux_plt1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reconciliation_mux_plt0 : " UH_FMT "\n", ptr_struct->reconciliation_mux_plt0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reconciliation_mux_plt1 : " UH_FMT "\n", ptr_struct->reconciliation_mux_plt1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "macsec_en_plt0_s0    : " UH_FMT "\n", ptr_struct->macsec_en_plt0_s0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "macsec_en_plt0_s1    : " UH_FMT "\n", ptr_struct->macsec_en_plt0_s1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "macsec_en_plt1_s0    : " UH_FMT "\n", ptr_struct->macsec_en_plt1_s0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "macsec_en_plt1_s1    : " UH_FMT "\n", ptr_struct->macsec_en_plt1_s1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_rx_frame_received_ok_s0 : " UH_FMT "\n", ptr_struct->cnt_rx_frame_received_ok_s0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_rx_frame_received_ok_s1 : " UH_FMT "\n", ptr_struct->cnt_rx_frame_received_ok_s1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts_inc_s0 : " UH_FMT "\n", ptr_struct->port_xmit_pkts_inc_s0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts_inc_s1 : " UH_FMT "\n", ptr_struct->port_xmit_pkts_inc_s1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rtt_ndr_threshold : " UH_FMT "\n", ptr_struct->plr_rtt_ndr_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rtt_hdr_threshold : " UH_FMT "\n", ptr_struct->plr_rtt_hdr_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rtt_xdr_threshold : " UH_FMT "\n", ptr_struct->plr_rtt_xdr_threshold);

}

int pddr_phy_info_page_size(void)
{
	return 248;
}

void pddr_phy_info_page_dump(const struct pddr_phy_info_page *ptr_struct, FILE *file)
{
	pddr_phy_info_page_print(ptr_struct, file, 0);
}

void pddr_troubleshooting_page_pack(const struct pddr_troubleshooting_page *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->group_opcode);

	offset = 32;
	pddr_troubleshooting_page_status_opcode_auto_pack(&(ptr_struct->status_opcode), ptr_buff + offset/8);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->user_feedback_index);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->user_feedback_data);

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->status_message[i]);
	}

}

void pddr_troubleshooting_page_unpack(struct pddr_troubleshooting_page *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->group_opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	pddr_troubleshooting_page_status_opcode_auto_unpack(&(ptr_struct->status_opcode), ptr_buff + offset/8);

	offset = 80;
	ptr_struct->user_feedback_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->user_feedback_data = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 1984, 1);
	ptr_struct->status_message[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->status_message[204] = '\0';
}

void pddr_troubleshooting_page_print(const struct pddr_troubleshooting_page *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_troubleshooting_page ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_opcode         : %s (" UH_FMT ")\n", (ptr_struct->group_opcode == 0 ? ("Monitor_opcodes") : ((ptr_struct->group_opcode == 1 ? ("Advanced_debug_opcodes") : ("unknown")))), ptr_struct->group_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_opcode:\n");
	pddr_troubleshooting_page_status_opcode_auto_print(&(ptr_struct->status_opcode), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "user_feedback_index  : " UH_FMT "\n", ptr_struct->user_feedback_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "user_feedback_data   : " UH_FMT "\n", ptr_struct->user_feedback_data);

	fprintf(file, "status_message       : \"%s\"\n", ptr_struct->status_message);
}

int pddr_troubleshooting_page_size(void)
{
	return 248;
}

void pddr_troubleshooting_page_dump(const struct pddr_troubleshooting_page *ptr_struct, FILE *file)
{
	pddr_troubleshooting_page_print(ptr_struct, file, 0);
}

void pemi_FERC_Properties_pack(const struct pemi_FERC_Properties *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_cap);

}

void pemi_FERC_Properties_unpack(struct pemi_FERC_Properties *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->ferc_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_FERC_Properties_print(const struct pemi_FERC_Properties *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_FERC_Properties ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_cap             : %s (" UH_FMT ")\n", (ptr_struct->ferc_cap == 1 ? ("ferc_min_media") : ((ptr_struct->ferc_cap == 2 ? ("ferc_min_host") : ((ptr_struct->ferc_cap == 4 ? ("ferc_max_media") : ((ptr_struct->ferc_cap == 8 ? ("ferc_max_host") : ((ptr_struct->ferc_cap == 16 ? ("ferc_avg_media") : ((ptr_struct->ferc_cap == 32 ? ("ferc_avg_host") : ((ptr_struct->ferc_cap == 64 ? ("ferc_val_media") : ((ptr_struct->ferc_cap == 128 ? ("ferc_val_host") : ("unknown")))))))))))))))), ptr_struct->ferc_cap);

}

int pemi_FERC_Properties_size(void)
{
	return 204;
}

void pemi_FERC_Properties_dump(const struct pemi_FERC_Properties *ptr_struct, FILE *file)
{
	pemi_FERC_Properties_print(ptr_struct, file, 0);
}

void pemi_FERC_Samples_pack(const struct pemi_FERC_Samples *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_min_host);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_min_media);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_max_host);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_max_media);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_avg_host);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_avg_media);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_val_host);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ferc_val_media);

}

void pemi_FERC_Samples_unpack(struct pemi_FERC_Samples *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->ferc_min_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->ferc_min_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->ferc_max_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->ferc_max_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->ferc_avg_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->ferc_avg_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->ferc_val_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->ferc_val_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_FERC_Samples_print(const struct pemi_FERC_Samples *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_FERC_Samples ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_min_host        : " UH_FMT "\n", ptr_struct->ferc_min_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_min_media       : " UH_FMT "\n", ptr_struct->ferc_min_media);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_max_host        : " UH_FMT "\n", ptr_struct->ferc_max_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_max_media       : " UH_FMT "\n", ptr_struct->ferc_max_media);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_avg_host        : " UH_FMT "\n", ptr_struct->ferc_avg_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_avg_media       : " UH_FMT "\n", ptr_struct->ferc_avg_media);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_val_host        : " UH_FMT "\n", ptr_struct->ferc_val_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ferc_val_media       : " UH_FMT "\n", ptr_struct->ferc_val_media);

}

int pemi_FERC_Samples_size(void)
{
	return 204;
}

void pemi_FERC_Samples_dump(const struct pemi_FERC_Samples *ptr_struct, FILE *file)
{
	pemi_FERC_Samples_print(ptr_struct, file, 0);
}

void pemi_Laser_Monitors_Properties_pack(const struct pemi_Laser_Monitors_Properties *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_monitor_cap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_age_high_warning);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_age_high_alarm);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tec_current_low_alarm);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tec_current_high_alarm);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tec_current_low_warning);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tec_current_high_warning);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_high_warning);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_high_alarm);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temp_low_alarm);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temp_high_alarm);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temp_low_warning);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temp_high_warning);

}

void pemi_Laser_Monitors_Properties_unpack(struct pemi_Laser_Monitors_Properties *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->laser_monitor_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->laser_age_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->laser_age_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tec_current_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->tec_current_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->tec_current_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->tec_current_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->laser_frequency_error_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->laser_frequency_error_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->laser_temp_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->laser_temp_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->laser_temp_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->laser_temp_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_Laser_Monitors_Properties_print(const struct pemi_Laser_Monitors_Properties *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_Laser_Monitors_Properties ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_monitor_cap    : %s (" UH_FMT ")\n", (ptr_struct->laser_monitor_cap == 1 ? ("laser_age") : ((ptr_struct->laser_monitor_cap == 2 ? ("tec_current") : ((ptr_struct->laser_monitor_cap == 4 ? ("laser_frequency_error") : ((ptr_struct->laser_monitor_cap == 8 ? ("laser_temp") : ("unknown")))))))), ptr_struct->laser_monitor_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_age_high_warning : " UH_FMT "\n", ptr_struct->laser_age_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_age_high_alarm : " UH_FMT "\n", ptr_struct->laser_age_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tec_current_low_alarm : " UH_FMT "\n", ptr_struct->tec_current_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tec_current_high_alarm : " UH_FMT "\n", ptr_struct->tec_current_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tec_current_low_warning : " UH_FMT "\n", ptr_struct->tec_current_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tec_current_high_warning : " UH_FMT "\n", ptr_struct->tec_current_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_high_warning : " UH_FMT "\n", ptr_struct->laser_frequency_error_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_high_alarm : " UH_FMT "\n", ptr_struct->laser_frequency_error_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temp_low_alarm : " UH_FMT "\n", ptr_struct->laser_temp_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temp_high_alarm : " UH_FMT "\n", ptr_struct->laser_temp_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temp_low_warning : " UH_FMT "\n", ptr_struct->laser_temp_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temp_high_warning : " UH_FMT "\n", ptr_struct->laser_temp_high_warning);

}

int pemi_Laser_Monitors_Properties_size(void)
{
	return 204;
}

void pemi_Laser_Monitors_Properties_dump(const struct pemi_Laser_Monitors_Properties *ptr_struct, FILE *file)
{
	pemi_Laser_Monitors_Properties_print(ptr_struct, file, 0);
}

void pemi_Laser_Monitors_Samples_pack(const struct pemi_Laser_Monitors_Samples *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tec_current);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_age);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane1);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane0);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane3);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane2);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane5);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane4);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane7);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_frequency_error_lane6);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane1);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane0);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane3);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane2);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane5);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane4);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane7);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->laser_temperature_lane6);

}

void pemi_Laser_Monitors_Samples_unpack(struct pemi_Laser_Monitors_Samples *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->tec_current = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->laser_age = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->laser_frequency_error_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->laser_frequency_error_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->laser_frequency_error_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->laser_frequency_error_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->laser_frequency_error_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->laser_frequency_error_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->laser_frequency_error_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->laser_frequency_error_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->laser_temperature_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->laser_temperature_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->laser_temperature_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->laser_temperature_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->laser_temperature_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->laser_temperature_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->laser_temperature_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->laser_temperature_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_Laser_Monitors_Samples_print(const struct pemi_Laser_Monitors_Samples *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_Laser_Monitors_Samples ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tec_current          : " UH_FMT "\n", ptr_struct->tec_current);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_age            : " UH_FMT "\n", ptr_struct->laser_age);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane1 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane0 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane3 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane2 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane5 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane4 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane7 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_frequency_error_lane6 : " UH_FMT "\n", ptr_struct->laser_frequency_error_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane1 : " UH_FMT "\n", ptr_struct->laser_temperature_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane0 : " UH_FMT "\n", ptr_struct->laser_temperature_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane3 : " UH_FMT "\n", ptr_struct->laser_temperature_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane2 : " UH_FMT "\n", ptr_struct->laser_temperature_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane5 : " UH_FMT "\n", ptr_struct->laser_temperature_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane4 : " UH_FMT "\n", ptr_struct->laser_temperature_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane7 : " UH_FMT "\n", ptr_struct->laser_temperature_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "laser_temperature_lane6 : " UH_FMT "\n", ptr_struct->laser_temperature_lane6);

}

int pemi_Laser_Monitors_Samples_size(void)
{
	return 204;
}

void pemi_Laser_Monitors_Samples_dump(const struct pemi_Laser_Monitors_Samples *ptr_struct, FILE *file)
{
	pemi_Laser_Monitors_Samples_print(ptr_struct, file, 0);
}

void pemi_Module_Status_Properties_pack(const struct pemi_Module_Status_Properties *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->module_status_cap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temp_low_alarm);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temp_high_alarm);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temp_low_warning);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temp_high_warning);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_low_alarm);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_high_alarm);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_low_warning);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_high_warning);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_low_alarm);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_high_alarm);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_low_warning);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_high_warning);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_low_alarm);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_high_alarm);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_low_warning);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_high_warning);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_low_alarm);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_high_alarm);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_low_warning);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_high_warning);

}

void pemi_Module_Status_Properties_unpack(struct pemi_Module_Status_Properties *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->module_status_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->temp_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->temp_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->temp_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->temp_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->voltage_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->voltage_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->voltage_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->voltage_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->rx_power_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->rx_power_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->rx_power_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->rx_power_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->tx_power_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->tx_power_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->tx_power_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->tx_power_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->tx_bias_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->tx_bias_high_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->tx_bias_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->tx_bias_high_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_Module_Status_Properties_print(const struct pemi_Module_Status_Properties *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_Module_Status_Properties ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_status_cap    : " UH_FMT "\n", ptr_struct->module_status_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_low_alarm       : " UH_FMT "\n", ptr_struct->temp_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_high_alarm      : " UH_FMT "\n", ptr_struct->temp_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_low_warning     : " UH_FMT "\n", ptr_struct->temp_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_high_warning    : " UH_FMT "\n", ptr_struct->temp_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_low_alarm    : " UH_FMT "\n", ptr_struct->voltage_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_high_alarm   : " UH_FMT "\n", ptr_struct->voltage_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_low_warning  : " UH_FMT "\n", ptr_struct->voltage_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_high_warning : " UH_FMT "\n", ptr_struct->voltage_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_low_alarm   : " UH_FMT "\n", ptr_struct->rx_power_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_high_alarm  : " UH_FMT "\n", ptr_struct->rx_power_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_low_warning : " UH_FMT "\n", ptr_struct->rx_power_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_high_warning : " UH_FMT "\n", ptr_struct->rx_power_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_low_alarm   : " UH_FMT "\n", ptr_struct->tx_power_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_high_alarm  : " UH_FMT "\n", ptr_struct->tx_power_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_low_warning : " UH_FMT "\n", ptr_struct->tx_power_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_high_warning : " UH_FMT "\n", ptr_struct->tx_power_high_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_low_alarm    : " UH_FMT "\n", ptr_struct->tx_bias_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_high_alarm   : " UH_FMT "\n", ptr_struct->tx_bias_high_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_low_warning  : " UH_FMT "\n", ptr_struct->tx_bias_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_high_warning : " UH_FMT "\n", ptr_struct->tx_bias_high_warning);

}

int pemi_Module_Status_Properties_size(void)
{
	return 204;
}

void pemi_Module_Status_Properties_dump(const struct pemi_Module_Status_Properties *ptr_struct, FILE *file)
{
	pemi_Module_Status_Properties_print(ptr_struct, file, 0);
}

void pemi_Module_Status_Samples_pack(const struct pemi_Module_Status_Samples *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane1);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane0);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane3);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane2);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane5);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane4);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane7);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane6);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane1);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane0);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane3);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane2);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane5);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane4);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane7);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane6);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane1);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane0);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane3);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane2);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane5);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane4);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane7);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane6);

	offset = 443;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane6);

	offset = 439;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane5);

	offset = 435;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane4);

	offset = 431;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane3);

	offset = 427;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane2);

	offset = 423;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane1);

	offset = 419;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane0);

	offset = 416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->module_st);

	offset = 448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane7);

}

void pemi_Module_Status_Samples_unpack(struct pemi_Module_Status_Samples *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->voltage = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->rx_power_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->rx_power_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->rx_power_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->rx_power_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->rx_power_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->rx_power_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->rx_power_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->rx_power_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->tx_power_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->tx_power_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->tx_power_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->tx_power_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->tx_power_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->tx_power_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->tx_power_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->tx_power_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->tx_bias_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->tx_bias_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->tx_bias_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->tx_bias_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->tx_bias_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->tx_bias_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 400;
	ptr_struct->tx_bias_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 384;
	ptr_struct->tx_bias_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 443;
	ptr_struct->dp_st_lane6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 439;
	ptr_struct->dp_st_lane5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 435;
	ptr_struct->dp_st_lane4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 431;
	ptr_struct->dp_st_lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 427;
	ptr_struct->dp_st_lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 423;
	ptr_struct->dp_st_lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 419;
	ptr_struct->dp_st_lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->module_st = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 448;
	ptr_struct->dp_st_lane7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void pemi_Module_Status_Samples_print(const struct pemi_Module_Status_Samples *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_Module_Status_Samples ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage              : " UH_FMT "\n", ptr_struct->voltage);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : " UH_FMT "\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane1       : " UH_FMT "\n", ptr_struct->rx_power_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane0       : " UH_FMT "\n", ptr_struct->rx_power_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane3       : " UH_FMT "\n", ptr_struct->rx_power_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane2       : " UH_FMT "\n", ptr_struct->rx_power_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane5       : " UH_FMT "\n", ptr_struct->rx_power_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane4       : " UH_FMT "\n", ptr_struct->rx_power_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane7       : " UH_FMT "\n", ptr_struct->rx_power_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane6       : " UH_FMT "\n", ptr_struct->rx_power_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane1       : " UH_FMT "\n", ptr_struct->tx_power_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane0       : " UH_FMT "\n", ptr_struct->tx_power_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane3       : " UH_FMT "\n", ptr_struct->tx_power_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane2       : " UH_FMT "\n", ptr_struct->tx_power_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane5       : " UH_FMT "\n", ptr_struct->tx_power_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane4       : " UH_FMT "\n", ptr_struct->tx_power_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane7       : " UH_FMT "\n", ptr_struct->tx_power_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane6       : " UH_FMT "\n", ptr_struct->tx_power_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane1        : " UH_FMT "\n", ptr_struct->tx_bias_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane0        : " UH_FMT "\n", ptr_struct->tx_bias_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane3        : " UH_FMT "\n", ptr_struct->tx_bias_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane2        : " UH_FMT "\n", ptr_struct->tx_bias_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane5        : " UH_FMT "\n", ptr_struct->tx_bias_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane4        : " UH_FMT "\n", ptr_struct->tx_bias_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane7        : " UH_FMT "\n", ptr_struct->tx_bias_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane6        : " UH_FMT "\n", ptr_struct->tx_bias_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane6          : " UH_FMT "\n", ptr_struct->dp_st_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane5          : " UH_FMT "\n", ptr_struct->dp_st_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane4          : " UH_FMT "\n", ptr_struct->dp_st_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane3          : " UH_FMT "\n", ptr_struct->dp_st_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane2          : " UH_FMT "\n", ptr_struct->dp_st_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane1          : " UH_FMT "\n", ptr_struct->dp_st_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane0          : " UH_FMT "\n", ptr_struct->dp_st_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_st            : " UH_FMT "\n", ptr_struct->module_st);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane7          : " UH_FMT "\n", ptr_struct->dp_st_lane7);

}

int pemi_Module_Status_Samples_size(void)
{
	return 204;
}

void pemi_Module_Status_Samples_dump(const struct pemi_Module_Status_Samples *ptr_struct, FILE *file)
{
	pemi_Module_Status_Samples_print(ptr_struct, file, 0);
}

void pemi_PAM4_Level_Transition_Properties_pack(const struct pemi_PAM4_Level_Transition_Properties *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_cap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_low_warning);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_low_alarm);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_low_warning);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_low_alarm);

}

void pemi_PAM4_Level_Transition_Properties_unpack(struct pemi_PAM4_Level_Transition_Properties *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->pam4_level_transition_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->pam4_level_transition_media_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->pam4_level_transition_media_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->pam4_level_transition_host_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->pam4_level_transition_host_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_PAM4_Level_Transition_Properties_print(const struct pemi_PAM4_Level_Transition_Properties *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_PAM4_Level_Transition_Properties ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_cap : %s (" UH_FMT ")\n", (ptr_struct->pam4_level_transition_cap == 1 ? ("pam4_level_transition_media") : ((ptr_struct->pam4_level_transition_cap == 2 ? ("pam4_level_transition_host") : ("unknown")))), ptr_struct->pam4_level_transition_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_low_warning : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_low_alarm : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_low_warning : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_low_alarm : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_low_alarm);

}

int pemi_PAM4_Level_Transition_Properties_size(void)
{
	return 204;
}

void pemi_PAM4_Level_Transition_Properties_dump(const struct pemi_PAM4_Level_Transition_Properties *ptr_struct, FILE *file)
{
	pemi_PAM4_Level_Transition_Properties_print(ptr_struct, file, 0);
}

void pemi_PAM4_Level_Transition_Samples_pack(const struct pemi_PAM4_Level_Transition_Samples *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane0);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane3);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane2);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane5);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane4);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane7);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_media_lane6);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane0);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane3);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane2);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane5);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane4);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane7);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pam4_level_transition_host_lane6);

}

void pemi_PAM4_Level_Transition_Samples_unpack(struct pemi_PAM4_Level_Transition_Samples *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->pam4_level_transition_media_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->pam4_level_transition_media_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->pam4_level_transition_media_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->pam4_level_transition_media_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->pam4_level_transition_media_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->pam4_level_transition_media_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->pam4_level_transition_media_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->pam4_level_transition_media_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->pam4_level_transition_host_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->pam4_level_transition_host_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->pam4_level_transition_host_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->pam4_level_transition_host_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->pam4_level_transition_host_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->pam4_level_transition_host_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->pam4_level_transition_host_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->pam4_level_transition_host_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_PAM4_Level_Transition_Samples_print(const struct pemi_PAM4_Level_Transition_Samples *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_PAM4_Level_Transition_Samples ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane1 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane0 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane3 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane2 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane5 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane4 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane7 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_media_lane6 : " UH_FMT "\n", ptr_struct->pam4_level_transition_media_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane1 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane0 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane3 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane2 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane5 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane4 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane7 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pam4_level_transition_host_lane6 : " UH_FMT "\n", ptr_struct->pam4_level_transition_host_lane6);

}

int pemi_PAM4_Level_Transition_Samples_size(void)
{
	return 204;
}

void pemi_PAM4_Level_Transition_Samples_dump(const struct pemi_PAM4_Level_Transition_Samples *ptr_struct, FILE *file)
{
	pemi_PAM4_Level_Transition_Samples_print(ptr_struct, file, 0);
}

void pemi_Pre_FEC_BER_Properties_pack(const struct pemi_Pre_FEC_BER_Properties *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_cap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_min_high_media_warning);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_min_high_media_alarm);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_min_high_host_warning);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_min_high_host_alarm);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_max_high_media_warning);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_max_high_media_alarm);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_max_high_host_warning);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_max_high_host_alarm);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_avg_high_media_warning);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_avg_high_media_alarm);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_avg_high_host_warning);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_avg_high_host_alarm);

}

void pemi_Pre_FEC_BER_Properties_unpack(struct pemi_Pre_FEC_BER_Properties *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->pre_fec_ber_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->pre_fec_ber_min_high_media_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->pre_fec_ber_min_high_media_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->pre_fec_ber_min_high_host_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->pre_fec_ber_min_high_host_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->pre_fec_ber_max_high_media_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->pre_fec_ber_max_high_media_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->pre_fec_ber_max_high_host_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->pre_fec_ber_max_high_host_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->pre_fec_ber_avg_high_media_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->pre_fec_ber_avg_high_media_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->pre_fec_ber_avg_high_host_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->pre_fec_ber_avg_high_host_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_Pre_FEC_BER_Properties_print(const struct pemi_Pre_FEC_BER_Properties *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_Pre_FEC_BER_Properties ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_cap      : %s (" UH_FMT ")\n", (ptr_struct->pre_fec_ber_cap == 1 ? ("pre_fec_ber_min_media") : ((ptr_struct->pre_fec_ber_cap == 2 ? ("pre_fec_ber_min_host") : ((ptr_struct->pre_fec_ber_cap == 4 ? ("pre_fec_ber_max_media") : ((ptr_struct->pre_fec_ber_cap == 8 ? ("pre_fec_ber_max_host") : ((ptr_struct->pre_fec_ber_cap == 16 ? ("pre_fec_ber_avg_media") : ((ptr_struct->pre_fec_ber_cap == 32 ? ("pre_fec_ber_avg_host") : ((ptr_struct->pre_fec_ber_cap == 64 ? ("pre_fec_ber_val_media") : ((ptr_struct->pre_fec_ber_cap == 128 ? ("pre_fec_ber_val_host") : ("unknown")))))))))))))))), ptr_struct->pre_fec_ber_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_min_high_media_warning : " UH_FMT "\n", ptr_struct->pre_fec_ber_min_high_media_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_min_high_media_alarm : " UH_FMT "\n", ptr_struct->pre_fec_ber_min_high_media_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_min_high_host_warning : " UH_FMT "\n", ptr_struct->pre_fec_ber_min_high_host_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_min_high_host_alarm : " UH_FMT "\n", ptr_struct->pre_fec_ber_min_high_host_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_max_high_media_warning : " UH_FMT "\n", ptr_struct->pre_fec_ber_max_high_media_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_max_high_media_alarm : " UH_FMT "\n", ptr_struct->pre_fec_ber_max_high_media_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_max_high_host_warning : " UH_FMT "\n", ptr_struct->pre_fec_ber_max_high_host_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_max_high_host_alarm : " UH_FMT "\n", ptr_struct->pre_fec_ber_max_high_host_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_avg_high_media_warning : " UH_FMT "\n", ptr_struct->pre_fec_ber_avg_high_media_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_avg_high_media_alarm : " UH_FMT "\n", ptr_struct->pre_fec_ber_avg_high_media_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_avg_high_host_warning : " UH_FMT "\n", ptr_struct->pre_fec_ber_avg_high_host_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_avg_high_host_alarm : " UH_FMT "\n", ptr_struct->pre_fec_ber_avg_high_host_alarm);

}

int pemi_Pre_FEC_BER_Properties_size(void)
{
	return 204;
}

void pemi_Pre_FEC_BER_Properties_dump(const struct pemi_Pre_FEC_BER_Properties *ptr_struct, FILE *file)
{
	pemi_Pre_FEC_BER_Properties_print(ptr_struct, file, 0);
}

void pemi_Pre_FEC_BER_Samples_pack(const struct pemi_Pre_FEC_BER_Samples *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_min_host);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_min_media);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_max_host);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_max_media);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_avg_host);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_avg_media);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_val_host);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pre_fec_ber_val_media);

}

void pemi_Pre_FEC_BER_Samples_unpack(struct pemi_Pre_FEC_BER_Samples *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->pre_fec_ber_min_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->pre_fec_ber_min_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->pre_fec_ber_max_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->pre_fec_ber_max_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->pre_fec_ber_avg_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->pre_fec_ber_avg_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->pre_fec_ber_val_host = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->pre_fec_ber_val_media = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_Pre_FEC_BER_Samples_print(const struct pemi_Pre_FEC_BER_Samples *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_Pre_FEC_BER_Samples ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_min_host : " UH_FMT "\n", ptr_struct->pre_fec_ber_min_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_min_media : " UH_FMT "\n", ptr_struct->pre_fec_ber_min_media);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_max_host : " UH_FMT "\n", ptr_struct->pre_fec_ber_max_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_max_media : " UH_FMT "\n", ptr_struct->pre_fec_ber_max_media);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_avg_host : " UH_FMT "\n", ptr_struct->pre_fec_ber_avg_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_avg_media : " UH_FMT "\n", ptr_struct->pre_fec_ber_avg_media);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_val_host : " UH_FMT "\n", ptr_struct->pre_fec_ber_val_host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_fec_ber_val_media : " UH_FMT "\n", ptr_struct->pre_fec_ber_val_media);

}

int pemi_Pre_FEC_BER_Samples_size(void)
{
	return 204;
}

void pemi_Pre_FEC_BER_Samples_dump(const struct pemi_Pre_FEC_BER_Samples *ptr_struct, FILE *file)
{
	pemi_Pre_FEC_BER_Samples_print(ptr_struct, file, 0);
}

void pemi_RAW_page_data_pack(const struct pemi_RAW_page_data *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1632, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void pemi_RAW_page_data_unpack(struct pemi_RAW_page_data *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 204; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1632, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void pemi_RAW_page_data_print(const struct pemi_RAW_page_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_RAW_page_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 204; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int pemi_RAW_page_data_size(void)
{
	return 204;
}

void pemi_RAW_page_data_dump(const struct pemi_RAW_page_data *ptr_struct, FILE *file)
{
	pemi_RAW_page_data_print(ptr_struct, file, 0);
}

void pemi_SNR_Properties_pack(const struct pemi_SNR_Properties *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_cap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_low_warning);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_low_alarm);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_low_warning);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_low_alarm);

}

void pemi_SNR_Properties_unpack(struct pemi_SNR_Properties *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->snr_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->snr_media_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->snr_media_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->snr_host_low_warning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->snr_host_low_alarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_SNR_Properties_print(const struct pemi_SNR_Properties *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_SNR_Properties ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_cap              : %s (" UH_FMT ")\n", (ptr_struct->snr_cap == 1 ? ("snr_media") : ((ptr_struct->snr_cap == 2 ? ("snr_host") : ("unknown")))), ptr_struct->snr_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_low_warning : " UH_FMT "\n", ptr_struct->snr_media_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_low_alarm  : " UH_FMT "\n", ptr_struct->snr_media_low_alarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_low_warning : " UH_FMT "\n", ptr_struct->snr_host_low_warning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_low_alarm   : " UH_FMT "\n", ptr_struct->snr_host_low_alarm);

}

int pemi_SNR_Properties_size(void)
{
	return 204;
}

void pemi_SNR_Properties_dump(const struct pemi_SNR_Properties *ptr_struct, FILE *file)
{
	pemi_SNR_Properties_print(ptr_struct, file, 0);
}

void pemi_SNR_Samples_pack(const struct pemi_SNR_Samples *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane1);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane0);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane3);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane2);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane5);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane4);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane7);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_media_lane6);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane0);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane3);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane2);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane5);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane4);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane7);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->snr_host_lane6);

}

void pemi_SNR_Samples_unpack(struct pemi_SNR_Samples *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->snr_media_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->snr_media_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->snr_media_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->snr_media_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->snr_media_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->snr_media_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->snr_media_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->snr_media_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->snr_host_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->snr_host_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->snr_host_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->snr_host_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->snr_host_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->snr_host_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->snr_host_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->snr_host_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void pemi_SNR_Samples_print(const struct pemi_SNR_Samples *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_SNR_Samples ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane1      : " UH_FMT "\n", ptr_struct->snr_media_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane0      : " UH_FMT "\n", ptr_struct->snr_media_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane3      : " UH_FMT "\n", ptr_struct->snr_media_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane2      : " UH_FMT "\n", ptr_struct->snr_media_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane5      : " UH_FMT "\n", ptr_struct->snr_media_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane4      : " UH_FMT "\n", ptr_struct->snr_media_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane7      : " UH_FMT "\n", ptr_struct->snr_media_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_media_lane6      : " UH_FMT "\n", ptr_struct->snr_media_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane1       : " UH_FMT "\n", ptr_struct->snr_host_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane0       : " UH_FMT "\n", ptr_struct->snr_host_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane3       : " UH_FMT "\n", ptr_struct->snr_host_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane2       : " UH_FMT "\n", ptr_struct->snr_host_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane5       : " UH_FMT "\n", ptr_struct->snr_host_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane4       : " UH_FMT "\n", ptr_struct->snr_host_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane7       : " UH_FMT "\n", ptr_struct->snr_host_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snr_host_lane6       : " UH_FMT "\n", ptr_struct->snr_host_lane6);

}

int pemi_SNR_Samples_size(void)
{
	return 204;
}

void pemi_SNR_Samples_dump(const struct pemi_SNR_Samples *ptr_struct, FILE *file)
{
	pemi_SNR_Samples_print(ptr_struct, file, 0);
}

void phys_layer_cntrs_pack(const struct phys_layer_cntrs *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_since_last_clear_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_since_last_clear_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->symbol_errors_high);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->symbol_errors_low);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sync_headers_errors_high);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sync_headers_errors_low);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane0_high);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane0_low);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane1_high);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane1_low);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane2_high);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane2_low);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane3_high);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->edpl_bip_errors_lane3_low);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane0_high);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane0_low);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane1_high);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane1_low);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane2_high);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane2_low);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane3_high);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_corrected_blocks_lane3_low);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane0_high);

	offset = 736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane0_low);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane1_high);

	offset = 800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane1_low);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane2_high);

	offset = 864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane2_low);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane3_high);

	offset = 928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fc_fec_uncorrectable_blocks_lane3_low);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_blocks_high);

	offset = 992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_blocks_low);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_uncorrectable_blocks_high);

	offset = 1056;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_uncorrectable_blocks_low);

	offset = 1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_no_errors_blocks_high);

	offset = 1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_no_errors_blocks_low);

	offset = 1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_single_error_blocks_high);

	offset = 1184;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_single_error_blocks_low);

	offset = 1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_total_high);

	offset = 1248;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_total_low);

	offset = 1280;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane0_high);

	offset = 1312;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane0_low);

	offset = 1344;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane1_high);

	offset = 1376;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane1_low);

	offset = 1408;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane2_high);

	offset = 1440;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane2_low);

	offset = 1472;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane3_high);

	offset = 1504;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_fec_corrected_symbols_lane3_low);

	offset = 1536;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->link_down_events);

	offset = 1568;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->successful_recovery_events);

}

void phys_layer_cntrs_unpack(struct phys_layer_cntrs *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->time_since_last_clear_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->time_since_last_clear_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->symbol_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->symbol_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->sync_headers_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->sync_headers_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->edpl_bip_errors_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->edpl_bip_errors_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->edpl_bip_errors_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->edpl_bip_errors_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->edpl_bip_errors_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->edpl_bip_errors_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->edpl_bip_errors_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->edpl_bip_errors_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->fc_fec_corrected_blocks_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->fc_fec_corrected_blocks_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->fc_fec_corrected_blocks_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->fc_fec_corrected_blocks_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->fc_fec_corrected_blocks_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->fc_fec_corrected_blocks_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 640;
	ptr_struct->fc_fec_corrected_blocks_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 672;
	ptr_struct->fc_fec_corrected_blocks_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 704;
	ptr_struct->fc_fec_uncorrectable_blocks_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 736;
	ptr_struct->fc_fec_uncorrectable_blocks_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 768;
	ptr_struct->fc_fec_uncorrectable_blocks_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 800;
	ptr_struct->fc_fec_uncorrectable_blocks_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 832;
	ptr_struct->fc_fec_uncorrectable_blocks_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 864;
	ptr_struct->fc_fec_uncorrectable_blocks_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 896;
	ptr_struct->fc_fec_uncorrectable_blocks_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 928;
	ptr_struct->fc_fec_uncorrectable_blocks_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 960;
	ptr_struct->rs_fec_corrected_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 992;
	ptr_struct->rs_fec_corrected_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1024;
	ptr_struct->rs_fec_uncorrectable_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1056;
	ptr_struct->rs_fec_uncorrectable_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1088;
	ptr_struct->rs_fec_no_errors_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1120;
	ptr_struct->rs_fec_no_errors_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1152;
	ptr_struct->rs_fec_single_error_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1184;
	ptr_struct->rs_fec_single_error_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1216;
	ptr_struct->rs_fec_corrected_symbols_total_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1248;
	ptr_struct->rs_fec_corrected_symbols_total_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1280;
	ptr_struct->rs_fec_corrected_symbols_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1312;
	ptr_struct->rs_fec_corrected_symbols_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1344;
	ptr_struct->rs_fec_corrected_symbols_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1376;
	ptr_struct->rs_fec_corrected_symbols_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1408;
	ptr_struct->rs_fec_corrected_symbols_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1440;
	ptr_struct->rs_fec_corrected_symbols_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1472;
	ptr_struct->rs_fec_corrected_symbols_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1504;
	ptr_struct->rs_fec_corrected_symbols_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1536;
	ptr_struct->link_down_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1568;
	ptr_struct->successful_recovery_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void phys_layer_cntrs_print(const struct phys_layer_cntrs *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== phys_layer_cntrs ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_high : " U32H_FMT "\n", ptr_struct->time_since_last_clear_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_low : " U32H_FMT "\n", ptr_struct->time_since_last_clear_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_errors_high   : " U32H_FMT "\n", ptr_struct->symbol_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_errors_low    : " U32H_FMT "\n", ptr_struct->symbol_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sync_headers_errors_high : " U32H_FMT "\n", ptr_struct->sync_headers_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sync_headers_errors_low : " U32H_FMT "\n", ptr_struct->sync_headers_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane0_high : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane0_low : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane1_high : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane1_low : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane2_high : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane2_low : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane3_high : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane3_low : " U32H_FMT "\n", ptr_struct->edpl_bip_errors_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane0_high : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane0_low : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane1_high : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane1_low : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane2_high : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane2_low : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane3_high : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane3_low : " U32H_FMT "\n", ptr_struct->fc_fec_corrected_blocks_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane0_high : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane0_low : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane1_high : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane1_low : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane2_high : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane2_low : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane3_high : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane3_low : " U32H_FMT "\n", ptr_struct->fc_fec_uncorrectable_blocks_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_blocks_high : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_blocks_low : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_uncorrectable_blocks_high : " U32H_FMT "\n", ptr_struct->rs_fec_uncorrectable_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_uncorrectable_blocks_low : " U32H_FMT "\n", ptr_struct->rs_fec_uncorrectable_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_no_errors_blocks_high : " U32H_FMT "\n", ptr_struct->rs_fec_no_errors_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_no_errors_blocks_low : " U32H_FMT "\n", ptr_struct->rs_fec_no_errors_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_single_error_blocks_high : " U32H_FMT "\n", ptr_struct->rs_fec_single_error_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_single_error_blocks_low : " U32H_FMT "\n", ptr_struct->rs_fec_single_error_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_total_high : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_total_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_total_low : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_total_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane0_high : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane0_low : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane1_high : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane1_low : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane2_high : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane2_low : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane3_high : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane3_low : " U32H_FMT "\n", ptr_struct->rs_fec_corrected_symbols_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_down_events     : " U32H_FMT "\n", ptr_struct->link_down_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "successful_recovery_events : " U32H_FMT "\n", ptr_struct->successful_recovery_events);

}

int phys_layer_cntrs_size(void)
{
	return 248;
}

void phys_layer_cntrs_dump(const struct phys_layer_cntrs *ptr_struct, FILE *file)
{
	phys_layer_cntrs_print(ptr_struct, file, 0);
}

void ppcnt_infiniband_general_counter_pack(const struct ppcnt_infiniband_general_counter *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_data_qword_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_data_qword_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_data_qword_high);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_data_qword_low);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_general_error_high);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rq_general_error_low);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ebp_high);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ebp_low);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_sw_hoq_lifetime_limit_discards_high);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_sw_hoq_lifetime_limit_discards_low);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dqs2llu_xmit_wait_arb_global_high);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dqs2llu_xmit_wait_arb_global_low);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->grxb_fecn_mark_high);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->grxb_fecn_mark_low);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->general_transmit_discard_external_contain_high);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->general_transmit_discard_external_contain_low);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->general_receive_discard_external_contain_high);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->general_receive_discard_external_contain_low);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_receive_poison_high);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_receive_poison_low);

}

void ppcnt_infiniband_general_counter_unpack(struct ppcnt_infiniband_general_counter *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->port_rcv_data_qword_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->port_rcv_data_qword_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->port_xmit_data_qword_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->port_xmit_data_qword_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->rq_general_error_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->rq_general_error_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->port_xmit_ebp_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->port_xmit_ebp_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->port_sw_hoq_lifetime_limit_discards_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->port_sw_hoq_lifetime_limit_discards_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->dqs2llu_xmit_wait_arb_global_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->dqs2llu_xmit_wait_arb_global_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->grxb_fecn_mark_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->grxb_fecn_mark_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->general_transmit_discard_external_contain_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->general_transmit_discard_external_contain_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->general_receive_discard_external_contain_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->general_receive_discard_external_contain_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->port_receive_poison_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->port_receive_poison_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ppcnt_infiniband_general_counter_print(const struct ppcnt_infiniband_general_counter *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_infiniband_general_counter ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data_qword_high : " U32H_FMT "\n", ptr_struct->port_rcv_data_qword_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data_qword_low : " U32H_FMT "\n", ptr_struct->port_rcv_data_qword_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data_qword_high : " U32H_FMT "\n", ptr_struct->port_xmit_data_qword_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data_qword_low : " U32H_FMT "\n", ptr_struct->port_xmit_data_qword_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_general_error_high : " U32H_FMT "\n", ptr_struct->rq_general_error_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_general_error_low : " U32H_FMT "\n", ptr_struct->rq_general_error_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ebp_high   : " U32H_FMT "\n", ptr_struct->port_xmit_ebp_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ebp_low    : " U32H_FMT "\n", ptr_struct->port_xmit_ebp_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_sw_hoq_lifetime_limit_discards_high : " U32H_FMT "\n", ptr_struct->port_sw_hoq_lifetime_limit_discards_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_sw_hoq_lifetime_limit_discards_low : " U32H_FMT "\n", ptr_struct->port_sw_hoq_lifetime_limit_discards_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dqs2llu_xmit_wait_arb_global_high : " U32H_FMT "\n", ptr_struct->dqs2llu_xmit_wait_arb_global_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dqs2llu_xmit_wait_arb_global_low : " U32H_FMT "\n", ptr_struct->dqs2llu_xmit_wait_arb_global_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grxb_fecn_mark_high  : " U32H_FMT "\n", ptr_struct->grxb_fecn_mark_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grxb_fecn_mark_low   : " U32H_FMT "\n", ptr_struct->grxb_fecn_mark_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "general_transmit_discard_external_contain_high : " U32H_FMT "\n", ptr_struct->general_transmit_discard_external_contain_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "general_transmit_discard_external_contain_low : " U32H_FMT "\n", ptr_struct->general_transmit_discard_external_contain_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "general_receive_discard_external_contain_high : " U32H_FMT "\n", ptr_struct->general_receive_discard_external_contain_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "general_receive_discard_external_contain_low : " U32H_FMT "\n", ptr_struct->general_receive_discard_external_contain_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_receive_poison_high : " U32H_FMT "\n", ptr_struct->port_receive_poison_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_receive_poison_low : " U32H_FMT "\n", ptr_struct->port_receive_poison_low);

}

int ppcnt_infiniband_general_counter_size(void)
{
	return 248;
}

void ppcnt_infiniband_general_counter_dump(const struct ppcnt_infiniband_general_counter *ptr_struct, FILE *file)
{
	ppcnt_infiniband_general_counter_print(ptr_struct, file, 0);
}

void ppcnt_infiniband_packet_histograms_pack(const struct ppcnt_infiniband_packet_histograms *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r8_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r8_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r16_high);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r16_low);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_16_24_high);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_16_24_low);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_25_32_high);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_25_32_low);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_33_64_high);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_33_64_low);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_65_128_high);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_65_128_low);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_129_256_high);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_129_256_low);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_257_512_high);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_257_512_low);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_513_mtu_high);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_r_513_mtu_low);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t8_high);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t8_low);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t16_high);

	offset = 672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t16_low);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_16_24_high);

	offset = 736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_16_24_low);

	offset = 768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_25_32_high);

	offset = 800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_25_32_low);

	offset = 832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_33_64_high);

	offset = 864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_33_64_low);

	offset = 896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_65_128_high);

	offset = 928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_65_128_low);

	offset = 960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_129_256_high);

	offset = 992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_129_256_low);

	offset = 1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_257_512_high);

	offset = 1056;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_257_512_low);

	offset = 1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_513_mtu_high);

	offset = 1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cnt_t_513_mtu_low);

}

void ppcnt_infiniband_packet_histograms_unpack(struct ppcnt_infiniband_packet_histograms *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->cnt_r8_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->cnt_r8_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->cnt_r16_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->cnt_r16_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->cnt_r_16_24_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->cnt_r_16_24_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->cnt_r_25_32_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->cnt_r_25_32_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->cnt_r_33_64_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->cnt_r_33_64_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->cnt_r_65_128_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->cnt_r_65_128_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->cnt_r_129_256_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->cnt_r_129_256_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->cnt_r_257_512_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->cnt_r_257_512_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->cnt_r_513_mtu_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->cnt_r_513_mtu_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->cnt_t8_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->cnt_t8_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 640;
	ptr_struct->cnt_t16_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 672;
	ptr_struct->cnt_t16_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 704;
	ptr_struct->cnt_t_16_24_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 736;
	ptr_struct->cnt_t_16_24_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 768;
	ptr_struct->cnt_t_25_32_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 800;
	ptr_struct->cnt_t_25_32_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 832;
	ptr_struct->cnt_t_33_64_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 864;
	ptr_struct->cnt_t_33_64_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 896;
	ptr_struct->cnt_t_65_128_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 928;
	ptr_struct->cnt_t_65_128_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 960;
	ptr_struct->cnt_t_129_256_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 992;
	ptr_struct->cnt_t_129_256_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1024;
	ptr_struct->cnt_t_257_512_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1056;
	ptr_struct->cnt_t_257_512_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1088;
	ptr_struct->cnt_t_513_mtu_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1120;
	ptr_struct->cnt_t_513_mtu_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ppcnt_infiniband_packet_histograms_print(const struct ppcnt_infiniband_packet_histograms *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_infiniband_packet_histograms ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r8_high          : " U32H_FMT "\n", ptr_struct->cnt_r8_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r8_low           : " U32H_FMT "\n", ptr_struct->cnt_r8_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r16_high         : " U32H_FMT "\n", ptr_struct->cnt_r16_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r16_low          : " U32H_FMT "\n", ptr_struct->cnt_r16_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_16_24_high     : " U32H_FMT "\n", ptr_struct->cnt_r_16_24_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_16_24_low      : " U32H_FMT "\n", ptr_struct->cnt_r_16_24_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_25_32_high     : " U32H_FMT "\n", ptr_struct->cnt_r_25_32_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_25_32_low      : " U32H_FMT "\n", ptr_struct->cnt_r_25_32_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_33_64_high     : " U32H_FMT "\n", ptr_struct->cnt_r_33_64_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_33_64_low      : " U32H_FMT "\n", ptr_struct->cnt_r_33_64_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_65_128_high    : " U32H_FMT "\n", ptr_struct->cnt_r_65_128_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_65_128_low     : " U32H_FMT "\n", ptr_struct->cnt_r_65_128_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_129_256_high   : " U32H_FMT "\n", ptr_struct->cnt_r_129_256_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_129_256_low    : " U32H_FMT "\n", ptr_struct->cnt_r_129_256_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_257_512_high   : " U32H_FMT "\n", ptr_struct->cnt_r_257_512_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_257_512_low    : " U32H_FMT "\n", ptr_struct->cnt_r_257_512_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_513_mtu_high   : " U32H_FMT "\n", ptr_struct->cnt_r_513_mtu_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_r_513_mtu_low    : " U32H_FMT "\n", ptr_struct->cnt_r_513_mtu_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t8_high          : " U32H_FMT "\n", ptr_struct->cnt_t8_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t8_low           : " U32H_FMT "\n", ptr_struct->cnt_t8_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t16_high         : " U32H_FMT "\n", ptr_struct->cnt_t16_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t16_low          : " U32H_FMT "\n", ptr_struct->cnt_t16_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_16_24_high     : " U32H_FMT "\n", ptr_struct->cnt_t_16_24_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_16_24_low      : " U32H_FMT "\n", ptr_struct->cnt_t_16_24_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_25_32_high     : " U32H_FMT "\n", ptr_struct->cnt_t_25_32_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_25_32_low      : " U32H_FMT "\n", ptr_struct->cnt_t_25_32_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_33_64_high     : " U32H_FMT "\n", ptr_struct->cnt_t_33_64_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_33_64_low      : " U32H_FMT "\n", ptr_struct->cnt_t_33_64_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_65_128_high    : " U32H_FMT "\n", ptr_struct->cnt_t_65_128_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_65_128_low     : " U32H_FMT "\n", ptr_struct->cnt_t_65_128_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_129_256_high   : " U32H_FMT "\n", ptr_struct->cnt_t_129_256_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_129_256_low    : " U32H_FMT "\n", ptr_struct->cnt_t_129_256_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_257_512_high   : " U32H_FMT "\n", ptr_struct->cnt_t_257_512_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_257_512_low    : " U32H_FMT "\n", ptr_struct->cnt_t_257_512_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_513_mtu_high   : " U32H_FMT "\n", ptr_struct->cnt_t_513_mtu_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cnt_t_513_mtu_low    : " U32H_FMT "\n", ptr_struct->cnt_t_513_mtu_low);

}

int ppcnt_infiniband_packet_histograms_size(void)
{
	return 144;
}

void ppcnt_infiniband_packet_histograms_dump(const struct ppcnt_infiniband_packet_histograms *ptr_struct, FILE *file)
{
	ppcnt_infiniband_packet_histograms_print(ptr_struct, file, 0);
}

void ppcnt_infiniband_vl_counter_pack(const struct ppcnt_infiniband_vl_counter *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dqs2llu_xmit_wait_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dqs2llu_xmit_wait_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dqs2llu_xmit_wait_arb_high);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dqs2llu_xmit_wait_arb_low);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_pkts_vl_high);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_pkts_vl_low);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_pkts_vl15_high);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_pkts_vl15_low);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_data_vl_high);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_data_vl_low);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_data_vl15_high);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_data_vl15_low);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_pkts_vl_high);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_pkts_vl_low);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_pkts_vl15_high);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_pkts_vl15_low);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_data_vl_high);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_data_vl_low);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_data_vl15_high);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_data_vl15_low);

}

void ppcnt_infiniband_vl_counter_unpack(struct ppcnt_infiniband_vl_counter *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->dqs2llu_xmit_wait_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->dqs2llu_xmit_wait_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->dqs2llu_xmit_wait_arb_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->dqs2llu_xmit_wait_arb_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->port_rcv_pkts_vl_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->port_rcv_pkts_vl_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->port_rcv_pkts_vl15_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->port_rcv_pkts_vl15_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->port_rcv_data_vl_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->port_rcv_data_vl_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->port_rcv_data_vl15_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->port_rcv_data_vl15_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->port_xmit_pkts_vl_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->port_xmit_pkts_vl_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->port_xmit_pkts_vl15_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->port_xmit_pkts_vl15_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->port_xmit_data_vl_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->port_xmit_data_vl_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->port_xmit_data_vl15_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->port_xmit_data_vl15_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ppcnt_infiniband_vl_counter_print(const struct ppcnt_infiniband_vl_counter *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_infiniband_vl_counter ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dqs2llu_xmit_wait_high : " U32H_FMT "\n", ptr_struct->dqs2llu_xmit_wait_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dqs2llu_xmit_wait_low : " U32H_FMT "\n", ptr_struct->dqs2llu_xmit_wait_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dqs2llu_xmit_wait_arb_high : " U32H_FMT "\n", ptr_struct->dqs2llu_xmit_wait_arb_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dqs2llu_xmit_wait_arb_low : " U32H_FMT "\n", ptr_struct->dqs2llu_xmit_wait_arb_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_pkts_vl_high : " U32H_FMT "\n", ptr_struct->port_rcv_pkts_vl_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_pkts_vl_low : " U32H_FMT "\n", ptr_struct->port_rcv_pkts_vl_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_pkts_vl15_high : " U32H_FMT "\n", ptr_struct->port_rcv_pkts_vl15_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_pkts_vl15_low : " U32H_FMT "\n", ptr_struct->port_rcv_pkts_vl15_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data_vl_high : " U32H_FMT "\n", ptr_struct->port_rcv_data_vl_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data_vl_low : " U32H_FMT "\n", ptr_struct->port_rcv_data_vl_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data_vl15_high : " U32H_FMT "\n", ptr_struct->port_rcv_data_vl15_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data_vl15_low : " U32H_FMT "\n", ptr_struct->port_rcv_data_vl15_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts_vl_high : " U32H_FMT "\n", ptr_struct->port_xmit_pkts_vl_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts_vl_low : " U32H_FMT "\n", ptr_struct->port_xmit_pkts_vl_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts_vl15_high : " U32H_FMT "\n", ptr_struct->port_xmit_pkts_vl15_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts_vl15_low : " U32H_FMT "\n", ptr_struct->port_xmit_pkts_vl15_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data_vl_high : " U32H_FMT "\n", ptr_struct->port_xmit_data_vl_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data_vl_low : " U32H_FMT "\n", ptr_struct->port_xmit_data_vl_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data_vl15_high : " U32H_FMT "\n", ptr_struct->port_xmit_data_vl15_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data_vl15_low : " U32H_FMT "\n", ptr_struct->port_xmit_data_vl15_low);

}

int ppcnt_infiniband_vl_counter_size(void)
{
	return 248;
}

void ppcnt_infiniband_vl_counter_dump(const struct ppcnt_infiniband_vl_counter *ptr_struct, FILE *file)
{
	ppcnt_infiniband_vl_counter_print(ptr_struct, file, 0);
}

void ppcnt_packet_type_counter_pack(const struct ppcnt_packet_type_counter *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_ibg1_nvl_pkts_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_ibg1_nvl_pkts_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_ibg1_non_nvl_pkts_high);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_ibg1_non_nvl_pkts_low);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_ibg2_pkts_high);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_rcv_ibg2_pkts_low);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ibg1_nvl_pkts_high);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ibg1_nvl_pkts_low);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ibg1_non_nvl_pkts_high);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ibg1_non_nvl_pkts_low);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ibg2_pkts_high);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_xmit_ibg2_pkts_low);

}

void ppcnt_packet_type_counter_unpack(struct ppcnt_packet_type_counter *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->port_rcv_ibg1_nvl_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->port_rcv_ibg1_nvl_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->port_rcv_ibg1_non_nvl_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->port_rcv_ibg1_non_nvl_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->port_rcv_ibg2_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->port_rcv_ibg2_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->port_xmit_ibg1_nvl_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->port_xmit_ibg1_nvl_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->port_xmit_ibg1_non_nvl_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->port_xmit_ibg1_non_nvl_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->port_xmit_ibg2_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->port_xmit_ibg2_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ppcnt_packet_type_counter_print(const struct ppcnt_packet_type_counter *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_packet_type_counter ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_ibg1_nvl_pkts_high : " U32H_FMT "\n", ptr_struct->port_rcv_ibg1_nvl_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_ibg1_nvl_pkts_low : " U32H_FMT "\n", ptr_struct->port_rcv_ibg1_nvl_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_ibg1_non_nvl_pkts_high : " U32H_FMT "\n", ptr_struct->port_rcv_ibg1_non_nvl_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_ibg1_non_nvl_pkts_low : " U32H_FMT "\n", ptr_struct->port_rcv_ibg1_non_nvl_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_ibg2_pkts_high : " U32H_FMT "\n", ptr_struct->port_rcv_ibg2_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_ibg2_pkts_low : " U32H_FMT "\n", ptr_struct->port_rcv_ibg2_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ibg1_nvl_pkts_high : " U32H_FMT "\n", ptr_struct->port_xmit_ibg1_nvl_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ibg1_nvl_pkts_low : " U32H_FMT "\n", ptr_struct->port_xmit_ibg1_nvl_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ibg1_non_nvl_pkts_high : " U32H_FMT "\n", ptr_struct->port_xmit_ibg1_non_nvl_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ibg1_non_nvl_pkts_low : " U32H_FMT "\n", ptr_struct->port_xmit_ibg1_non_nvl_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ibg2_pkts_high : " U32H_FMT "\n", ptr_struct->port_xmit_ibg2_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_ibg2_pkts_low : " U32H_FMT "\n", ptr_struct->port_xmit_ibg2_pkts_low);

}

int ppcnt_packet_type_counter_size(void)
{
	return 248;
}

void ppcnt_packet_type_counter_dump(const struct ppcnt_packet_type_counter *ptr_struct, FILE *file)
{
	ppcnt_packet_type_counter_print(ptr_struct, file, 0);
}

void ppcnt_plr_counters_pack(const struct ppcnt_plr_counters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_rcv_codes_high);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_rcv_codes_low);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_rcv_code_err_high);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_rcv_code_err_low);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_rcv_uncorrectable_code_high);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_rcv_uncorrectable_code_low);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_codes_high);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_codes_low);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_retry_codes_high);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_retry_codes_low);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_retry_events_high);

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_retry_events_low);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_sync_events_high);

	offset = 416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_sync_events_low);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_codes_loss_high);

	offset = 480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_codes_loss_low);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_retry_events_within_t_sec_max_high);

	offset = 544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plr_xmit_retry_events_within_t_sec_max_low);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_since_last_clear_high);

	offset = 608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->time_since_last_clear_low);

}

void ppcnt_plr_counters_unpack(struct ppcnt_plr_counters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->plr_rcv_codes_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->plr_rcv_codes_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->plr_rcv_code_err_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->plr_rcv_code_err_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->plr_rcv_uncorrectable_code_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->plr_rcv_uncorrectable_code_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->plr_xmit_codes_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->plr_xmit_codes_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->plr_xmit_retry_codes_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->plr_xmit_retry_codes_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->plr_xmit_retry_events_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 352;
	ptr_struct->plr_xmit_retry_events_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 384;
	ptr_struct->plr_sync_events_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 416;
	ptr_struct->plr_sync_events_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 448;
	ptr_struct->plr_codes_loss_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 480;
	ptr_struct->plr_codes_loss_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 512;
	ptr_struct->plr_xmit_retry_events_within_t_sec_max_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 544;
	ptr_struct->plr_xmit_retry_events_within_t_sec_max_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 576;
	ptr_struct->time_since_last_clear_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 608;
	ptr_struct->time_since_last_clear_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ppcnt_plr_counters_print(const struct ppcnt_plr_counters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_plr_counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_codes_high   : " U32H_FMT "\n", ptr_struct->plr_rcv_codes_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_codes_low    : " U32H_FMT "\n", ptr_struct->plr_rcv_codes_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_code_err_high : " U32H_FMT "\n", ptr_struct->plr_rcv_code_err_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_code_err_low : " U32H_FMT "\n", ptr_struct->plr_rcv_code_err_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_uncorrectable_code_high : " U32H_FMT "\n", ptr_struct->plr_rcv_uncorrectable_code_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_rcv_uncorrectable_code_low : " U32H_FMT "\n", ptr_struct->plr_rcv_uncorrectable_code_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_codes_high  : " U32H_FMT "\n", ptr_struct->plr_xmit_codes_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_codes_low   : " U32H_FMT "\n", ptr_struct->plr_xmit_codes_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_codes_high : " U32H_FMT "\n", ptr_struct->plr_xmit_retry_codes_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_codes_low : " U32H_FMT "\n", ptr_struct->plr_xmit_retry_codes_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_events_high : " U32H_FMT "\n", ptr_struct->plr_xmit_retry_events_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_events_low : " U32H_FMT "\n", ptr_struct->plr_xmit_retry_events_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_sync_events_high : " U32H_FMT "\n", ptr_struct->plr_sync_events_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_sync_events_low  : " U32H_FMT "\n", ptr_struct->plr_sync_events_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_codes_loss_high  : " U32H_FMT "\n", ptr_struct->plr_codes_loss_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_codes_loss_low   : " U32H_FMT "\n", ptr_struct->plr_codes_loss_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_events_within_t_sec_max_high : " U32H_FMT "\n", ptr_struct->plr_xmit_retry_events_within_t_sec_max_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plr_xmit_retry_events_within_t_sec_max_low : " U32H_FMT "\n", ptr_struct->plr_xmit_retry_events_within_t_sec_max_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_high : " U32H_FMT "\n", ptr_struct->time_since_last_clear_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_low : " U32H_FMT "\n", ptr_struct->time_since_last_clear_low);

}

int ppcnt_plr_counters_size(void)
{
	return 248;
}

void ppcnt_plr_counters_dump(const struct ppcnt_plr_counters *ptr_struct, FILE *file)
{
	ppcnt_plr_counters_print(ptr_struct, file, 0);
}

void ppcnt_rs_fec_histograms_counters_pack(const struct ppcnt_rs_fec_histograms_counters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 21; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1984, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hist[i]);
	}

}

void ppcnt_rs_fec_histograms_counters_unpack(struct ppcnt_rs_fec_histograms_counters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 21; i++) {
	offset = adb2c_calc_array_field_address(0, 64, i, 1984, 1);
	ptr_struct->hist[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

}

void ppcnt_rs_fec_histograms_counters_print(const struct ppcnt_rs_fec_histograms_counters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_rs_fec_histograms_counters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 21; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_%03d            : " U64H_FMT "\n", i, ptr_struct->hist[i]);
	}

}

int ppcnt_rs_fec_histograms_counters_size(void)
{
	return 248;
}

void ppcnt_rs_fec_histograms_counters_dump(const struct ppcnt_rs_fec_histograms_counters *ptr_struct, FILE *file)
{
	ppcnt_rs_fec_histograms_counters_print(ptr_struct, file, 0);
}

void ppll_28nm_pack(const struct ppll_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ae);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 288, 1);
	pll_28nm_pack(&(ptr_struct->pll_status[i]), ptr_buff + offset/8);
	}

}

void ppll_28nm_unpack(struct ppll_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->ae = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 288, 1);
	pll_28nm_unpack(&(ptr_struct->pll_status[i]), ptr_buff + offset/8);
	}

}

void ppll_28nm_print(const struct ppll_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ae                   : " UH_FMT "\n", ptr_struct->ae);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status_%03d:\n", i);
	pll_28nm_print(&(ptr_struct->pll_status[i]), file, indent_level + 1);
	}

}

int ppll_28nm_size(void)
{
	return 36;
}

void ppll_28nm_dump(const struct ppll_28nm *ptr_struct, FILE *file)
{
	ppll_28nm_print(ptr_struct, file, 0);
}

void ppll_data_set_pack(const struct ppll_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 36; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void ppll_data_set_unpack(struct ppll_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 36; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 288, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void ppll_data_set_print(const struct ppll_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 36; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int ppll_data_set_size(void)
{
	return 36;
}

void ppll_data_set_dump(const struct ppll_data_set *ptr_struct, FILE *file)
{
	ppll_data_set_print(ptr_struct, file, 0);
}

void ppll_reg_16nm_pack(const struct ppll_reg_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 288, 1);
	pll_status_data_pack(&(ptr_struct->pll_status[i]), ptr_buff + offset/8);
	}

}

void ppll_reg_16nm_unpack(struct ppll_reg_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(32, 64, i, 288, 1);
	pll_status_data_unpack(&(ptr_struct->pll_status[i]), ptr_buff + offset/8);
	}

}

void ppll_reg_16nm_print(const struct ppll_reg_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_reg_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_status_%03d:\n", i);
	pll_status_data_print(&(ptr_struct->pll_status[i]), file, indent_level + 1);
	}

}

int ppll_reg_16nm_size(void)
{
	return 36;
}

void ppll_reg_16nm_dump(const struct ppll_reg_16nm *ptr_struct, FILE *file)
{
	ppll_reg_16nm_print(ptr_struct, file, 0);
}

void ppll_reg_5nm_pack(const struct ppll_reg_5nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lockdet_error_count);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dlf2_phlock_det_status_sticky);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_cnt_active_lock);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_cnt_locked_sticky);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_cnt_unlocked_sticky);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_cnt_based_lock);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lockdet_err_state);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_measure_done);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->lockdet_mode_retimer);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bg_trim_valid);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cvb_trim_valid);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->speedo_valid);

	offset = 91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bg_trim);

	offset = 86;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->cvb_trim);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->speedo);

}

void ppll_reg_5nm_unpack(struct ppll_reg_5nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->lockdet_error_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->dlf2_phlock_det_status_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 7;
	ptr_struct->lockdet_err_cnt_active_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->lockdet_err_cnt_locked_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 5;
	ptr_struct->lockdet_err_cnt_unlocked_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->lockdet_cnt_based_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->lockdet_err_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 0;
	ptr_struct->lockdet_err_measure_done = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 59;
	ptr_struct->lockdet_mode_retimer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 34;
	ptr_struct->bg_trim_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->cvb_trim_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->speedo_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 91;
	ptr_struct->bg_trim = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 86;
	ptr_struct->cvb_trim = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 64;
	ptr_struct->speedo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void ppll_reg_5nm_print(const struct ppll_reg_5nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_reg_5nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_error_count  : " UH_FMT "\n", ptr_struct->lockdet_error_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dlf2_phlock_det_status_sticky : " UH_FMT "\n", ptr_struct->dlf2_phlock_det_status_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_cnt_active_lock : " UH_FMT "\n", ptr_struct->lockdet_err_cnt_active_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_cnt_locked_sticky : " UH_FMT "\n", ptr_struct->lockdet_err_cnt_locked_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_cnt_unlocked_sticky : " UH_FMT "\n", ptr_struct->lockdet_err_cnt_unlocked_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_cnt_based_lock : " UH_FMT "\n", ptr_struct->lockdet_cnt_based_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_state    : " UH_FMT "\n", ptr_struct->lockdet_err_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_measure_done : " UH_FMT "\n", ptr_struct->lockdet_err_measure_done);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_mode_retimer : " UH_FMT "\n", ptr_struct->lockdet_mode_retimer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bg_trim_valid        : " UH_FMT "\n", ptr_struct->bg_trim_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cvb_trim_valid       : " UH_FMT "\n", ptr_struct->cvb_trim_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speedo_valid         : " UH_FMT "\n", ptr_struct->speedo_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bg_trim              : " UH_FMT "\n", ptr_struct->bg_trim);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cvb_trim             : " UH_FMT "\n", ptr_struct->cvb_trim);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speedo               : " UH_FMT "\n", ptr_struct->speedo);

}

int ppll_reg_5nm_size(void)
{
	return 36;
}

void ppll_reg_5nm_dump(const struct ppll_reg_5nm *ptr_struct, FILE *file)
{
	ppll_reg_5nm_print(ptr_struct, file, 0);
}

void ppll_reg_7nm_pack(const struct ppll_reg_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pll_ugl_state);

	offset = 63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_cnt_active_lock);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_cnt_locked_sticky);

	offset = 61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_cnt_unlocked_sticky);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_cnt_based_lock);

	offset = 57;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lockdet_err_state);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lockdet_err_measure_done);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lokcdet_error_count);

	offset = 91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->pwr_up_state);

	offset = 89;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pll_lockdet_state);

	offset = 82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->cal_main_state);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cal_internal_state);

	offset = 121;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->dco_coarse_bin);

	offset = 115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cal_en);

	offset = 114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cal_done);

	offset = 105;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->dco_coarse);

	offset = 99;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cal_valid_sticky);

	offset = 98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cal_abort);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cal_abort_sticky);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cal_error_counter);

	offset = 191;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bg_trim_valid);

	offset = 190;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cvb_trim_valid);

	offset = 189;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->speedo_valid);

	offset = 175;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rcal_fsm_done);

	offset = 174;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rcal_tx_n_valid_sticky);

	offset = 173;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rcal_tx_p_valid_sticky);

	offset = 172;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rcal_done_valid_sticky);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lma_rcal_tx_n_code);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lma_rcal_tx_p_code);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lma_rcal_code);

	offset = 220;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->bg_trim);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cvb_trim);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->speedo);

}

void ppll_reg_7nm_unpack(struct ppll_reg_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->pll_ugl_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 63;
	ptr_struct->lockdet_err_cnt_active_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 62;
	ptr_struct->lockdet_err_cnt_locked_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 61;
	ptr_struct->lockdet_err_cnt_unlocked_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 60;
	ptr_struct->lockdet_cnt_based_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 57;
	ptr_struct->lockdet_err_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 56;
	ptr_struct->lockdet_err_measure_done = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->lokcdet_error_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 91;
	ptr_struct->pwr_up_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 89;
	ptr_struct->pll_lockdet_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 82;
	ptr_struct->cal_main_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 80;
	ptr_struct->cal_internal_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 121;
	ptr_struct->dco_coarse_bin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 115;
	ptr_struct->cal_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 114;
	ptr_struct->cal_done = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 105;
	ptr_struct->dco_coarse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 99;
	ptr_struct->cal_valid_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 98;
	ptr_struct->cal_abort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 97;
	ptr_struct->cal_abort_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 144;
	ptr_struct->cal_error_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 191;
	ptr_struct->bg_trim_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 190;
	ptr_struct->cvb_trim_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 189;
	ptr_struct->speedo_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 175;
	ptr_struct->rcal_fsm_done = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 174;
	ptr_struct->rcal_tx_n_valid_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 173;
	ptr_struct->rcal_tx_p_valid_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 172;
	ptr_struct->rcal_done_valid_sticky = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 168;
	ptr_struct->lma_rcal_tx_n_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 164;
	ptr_struct->lma_rcal_tx_p_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->lma_rcal_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 220;
	ptr_struct->bg_trim = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 216;
	ptr_struct->cvb_trim = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->speedo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void ppll_reg_7nm_print(const struct ppll_reg_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_reg_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_ugl_state        : " UH_FMT "\n", ptr_struct->pll_ugl_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_cnt_active_lock : " UH_FMT "\n", ptr_struct->lockdet_err_cnt_active_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_cnt_locked_sticky : " UH_FMT "\n", ptr_struct->lockdet_err_cnt_locked_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_cnt_unlocked_sticky : " UH_FMT "\n", ptr_struct->lockdet_err_cnt_unlocked_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_cnt_based_lock : " UH_FMT "\n", ptr_struct->lockdet_cnt_based_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_state    : " UH_FMT "\n", ptr_struct->lockdet_err_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lockdet_err_measure_done : " UH_FMT "\n", ptr_struct->lockdet_err_measure_done);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lokcdet_error_count  : " UH_FMT "\n", ptr_struct->lokcdet_error_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pwr_up_state         : " UH_FMT "\n", ptr_struct->pwr_up_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_lockdet_state    : " UH_FMT "\n", ptr_struct->pll_lockdet_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_main_state       : " UH_FMT "\n", ptr_struct->cal_main_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_internal_state   : " UH_FMT "\n", ptr_struct->cal_internal_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dco_coarse_bin       : " UH_FMT "\n", ptr_struct->dco_coarse_bin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_en               : " UH_FMT "\n", ptr_struct->cal_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_done             : " UH_FMT "\n", ptr_struct->cal_done);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dco_coarse           : " UH_FMT "\n", ptr_struct->dco_coarse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_valid_sticky     : " UH_FMT "\n", ptr_struct->cal_valid_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_abort            : " UH_FMT "\n", ptr_struct->cal_abort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_abort_sticky     : " UH_FMT "\n", ptr_struct->cal_abort_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_error_counter    : " UH_FMT "\n", ptr_struct->cal_error_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bg_trim_valid        : " UH_FMT "\n", ptr_struct->bg_trim_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cvb_trim_valid       : " UH_FMT "\n", ptr_struct->cvb_trim_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speedo_valid         : " UH_FMT "\n", ptr_struct->speedo_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_fsm_done        : " UH_FMT "\n", ptr_struct->rcal_fsm_done);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_tx_n_valid_sticky : " UH_FMT "\n", ptr_struct->rcal_tx_n_valid_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_tx_p_valid_sticky : " UH_FMT "\n", ptr_struct->rcal_tx_p_valid_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_done_valid_sticky : " UH_FMT "\n", ptr_struct->rcal_done_valid_sticky);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lma_rcal_tx_n_code   : " UH_FMT "\n", ptr_struct->lma_rcal_tx_n_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lma_rcal_tx_p_code   : " UH_FMT "\n", ptr_struct->lma_rcal_tx_p_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lma_rcal_code        : " UH_FMT "\n", ptr_struct->lma_rcal_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bg_trim              : " UH_FMT "\n", ptr_struct->bg_trim);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cvb_trim             : " UH_FMT "\n", ptr_struct->cvb_trim);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speedo               : " UH_FMT "\n", ptr_struct->speedo);

}

int ppll_reg_7nm_size(void)
{
	return 36;
}

void ppll_reg_7nm_dump(const struct ppll_reg_7nm *ptr_struct, FILE *file)
{
	ppll_reg_7nm_print(ptr_struct, file, 0);
}

void sllm_16nm_pack(const struct sllm_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lm_clk90_fl_err_max);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lm_en);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pib_gw_lock);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lm_was_active);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lm_active);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lm_clk90_fl_err_acc);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->lm_counter_up);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ib3_max_lm_90_tries);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->lm_counter_mid);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ib1_max_lm_90_tries);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->lm_counter_dn);

}

void sllm_16nm_unpack(struct sllm_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->lm_clk90_fl_err_max = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 14;
	ptr_struct->lm_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 2;
	ptr_struct->pib_gw_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->lm_was_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->lm_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->lm_clk90_fl_err_acc = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 76;
	ptr_struct->lm_counter_up = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 64;
	ptr_struct->ib3_max_lm_90_tries = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 108;
	ptr_struct->lm_counter_mid = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset = 96;
	ptr_struct->ib1_max_lm_90_tries = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 140;
	ptr_struct->lm_counter_dn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

}

void sllm_16nm_print(const struct sllm_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sllm_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_clk90_fl_err_max  : " UH_FMT "\n", ptr_struct->lm_clk90_fl_err_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_en                : " UH_FMT "\n", ptr_struct->lm_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pib_gw_lock          : " UH_FMT "\n", ptr_struct->pib_gw_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_was_active        : " UH_FMT "\n", ptr_struct->lm_was_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_active            : " UH_FMT "\n", ptr_struct->lm_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_clk90_fl_err_acc  : " U32H_FMT "\n", ptr_struct->lm_clk90_fl_err_acc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_counter_up        : " UH_FMT "\n", ptr_struct->lm_counter_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib3_max_lm_90_tries  : " UH_FMT "\n", ptr_struct->ib3_max_lm_90_tries);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_counter_mid       : " UH_FMT "\n", ptr_struct->lm_counter_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib1_max_lm_90_tries  : " UH_FMT "\n", ptr_struct->ib1_max_lm_90_tries);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_counter_dn        : " UH_FMT "\n", ptr_struct->lm_counter_dn);

}

int sllm_16nm_size(void)
{
	return 44;
}

void sllm_16nm_dump(const struct sllm_16nm *ptr_struct, FILE *file)
{
	sllm_16nm_print(ptr_struct, file, 0);
}

void sllm_7nm_pack(const struct sllm_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ctle_peq_en);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->peq_vref_iters);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->peq_train_mode);

	offset = 35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dffe_peq_scout_skip);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vref_peq_en);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->peq_f1_adapt_skip);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->peq_tsense_en);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->peq_dffe_delay);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->peq_dffe_iters);

	offset = 79;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dffe_peq_en);

	offset = 74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->peq_adc_vref_step);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ber_mon_exp);

	offset = 116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ber_mon_mantissa);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ctle_peq_cnt);

}

void sllm_7nm_unpack(struct sllm_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->ctle_peq_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->peq_vref_iters = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->peq_train_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 35;
	ptr_struct->dffe_peq_scout_skip = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 34;
	ptr_struct->vref_peq_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->peq_f1_adapt_skip = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->peq_tsense_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 92;
	ptr_struct->peq_dffe_delay = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->peq_dffe_iters = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 79;
	ptr_struct->dffe_peq_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 74;
	ptr_struct->peq_adc_vref_step = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 120;
	ptr_struct->ber_mon_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 116;
	ptr_struct->ber_mon_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->ctle_peq_cnt = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void sllm_7nm_print(const struct sllm_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sllm_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_peq_en          : " UH_FMT "\n", ptr_struct->ctle_peq_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_vref_iters       : " UH_FMT "\n", ptr_struct->peq_vref_iters);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_train_mode       : " UH_FMT "\n", ptr_struct->peq_train_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_peq_scout_skip  : " UH_FMT "\n", ptr_struct->dffe_peq_scout_skip);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vref_peq_en          : " UH_FMT "\n", ptr_struct->vref_peq_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_f1_adapt_skip    : " UH_FMT "\n", ptr_struct->peq_f1_adapt_skip);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_tsense_en        : " UH_FMT "\n", ptr_struct->peq_tsense_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_dffe_delay       : " UH_FMT "\n", ptr_struct->peq_dffe_delay);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_dffe_iters       : " UH_FMT "\n", ptr_struct->peq_dffe_iters);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_peq_en          : " UH_FMT "\n", ptr_struct->dffe_peq_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_adc_vref_step    : " UH_FMT "\n", ptr_struct->peq_adc_vref_step);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_mon_exp          : " UH_FMT "\n", ptr_struct->ber_mon_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_mon_mantissa     : " UH_FMT "\n", ptr_struct->ber_mon_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_peq_cnt         : " UH_FMT "\n", ptr_struct->ctle_peq_cnt);

}

int sllm_7nm_size(void)
{
	return 36;
}

void sllm_7nm_dump(const struct sllm_7nm *ptr_struct, FILE *file)
{
	sllm_7nm_print(ptr_struct, file, 0);
}

void sllm_data_set_pack(const struct sllm_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void sllm_data_set_unpack(struct sllm_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 44; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 352, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void sllm_data_set_print(const struct sllm_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sllm_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 44; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int sllm_data_set_size(void)
{
	return 44;
}

void sllm_data_set_dump(const struct sllm_data_set *ptr_struct, FILE *file)
{
	sllm_data_set_print(ptr_struct, file, 0);
}

void sllm_usr_pack(const struct sllm_usr *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->lm_fixes_counter);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->lm_activation_counter);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lm_catastrophic_bit);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_offset_maintenance);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_phase_maintenance);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_lm);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_tuning_error);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->optimal_phase);

	offset = 42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->lane_under_maintenance);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane_correctable_errors);

}

void sllm_usr_unpack(struct sllm_usr *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 26;
	ptr_struct->lm_fixes_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 18;
	ptr_struct->lm_activation_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 7;
	ptr_struct->lm_catastrophic_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->enable_offset_maintenance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->enable_phase_maintenance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->enable_lm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->link_tuning_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 50;
	ptr_struct->optimal_phase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 42;
	ptr_struct->lane_under_maintenance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 64;
	ptr_struct->lane_correctable_errors = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void sllm_usr_print(const struct sllm_usr *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sllm_usr ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_fixes_counter     : " UH_FMT "\n", ptr_struct->lm_fixes_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_activation_counter : " UH_FMT "\n", ptr_struct->lm_activation_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lm_catastrophic_bit  : " UH_FMT "\n", ptr_struct->lm_catastrophic_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_offset_maintenance : " UH_FMT "\n", ptr_struct->enable_offset_maintenance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_phase_maintenance : " UH_FMT "\n", ptr_struct->enable_phase_maintenance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_lm            : " UH_FMT "\n", ptr_struct->enable_lm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_tuning_error    : " UH_FMT "\n", ptr_struct->link_tuning_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "optimal_phase        : " UH_FMT "\n", ptr_struct->optimal_phase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_under_maintenance : " UH_FMT "\n", ptr_struct->lane_under_maintenance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_correctable_errors : " U32H_FMT "\n", ptr_struct->lane_correctable_errors);

}

int sllm_usr_size(void)
{
	return 44;
}

void sllm_usr_dump(const struct sllm_usr *ptr_struct, FILE *file)
{
	sllm_usr_print(ptr_struct, file, 0);
}

void slreg_16nm_pack(const struct slreg_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->eye_grade);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->initial_error);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->post_error);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->initial_area);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->post_area);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->post_area_after_centering);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gd_iter_num_area);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gd_iter_num_errors);

	offset = 214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->initial_sel_enc_slave);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->post_sel_enc_slave);

	offset = 194;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->post_sel_enc_slave_centering);

	offset = 246;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->rect_size);

	offset = 239;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->cur_phase_ib);

	offset = 226;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->ffe_gain);

	offset = 287;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->init_all_gains_bad_value);

	offset = 286;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->update_single_gain_bad_value);

	offset = 285;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->monotonic_flow_height_inconsistent);

	offset = 284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->monotonic_reached_high_limit);

	offset = 283;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->monotonic_reached_low_limit);

	offset = 275;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->area_zero_event_counter);

	offset = 267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc_tune_area_failure);

}

void slreg_16nm_unpack(struct slreg_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->initial_error = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->post_error = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->initial_area = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->post_area = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->post_area_after_centering = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->gd_iter_num_area = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->gd_iter_num_errors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 214;
	ptr_struct->initial_sel_enc_slave = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 204;
	ptr_struct->post_sel_enc_slave = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 194;
	ptr_struct->post_sel_enc_slave_centering = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 246;
	ptr_struct->rect_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 239;
	ptr_struct->cur_phase_ib = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 226;
	ptr_struct->ffe_gain = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset = 287;
	ptr_struct->init_all_gains_bad_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 286;
	ptr_struct->update_single_gain_bad_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 285;
	ptr_struct->monotonic_flow_height_inconsistent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 284;
	ptr_struct->monotonic_reached_high_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 283;
	ptr_struct->monotonic_reached_low_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 275;
	ptr_struct->area_zero_event_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 267;
	ptr_struct->sel_enc_tune_area_failure = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void slreg_16nm_print(const struct slreg_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_grade            : " UH_FMT "\n", ptr_struct->eye_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_error        : " UH_FMT "\n", ptr_struct->initial_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_error           : " U32H_FMT "\n", ptr_struct->post_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_area         : " U32H_FMT "\n", ptr_struct->initial_area);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_area            : " U32H_FMT "\n", ptr_struct->post_area);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_area_after_centering : " U32H_FMT "\n", ptr_struct->post_area_after_centering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gd_iter_num_area     : " UH_FMT "\n", ptr_struct->gd_iter_num_area);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gd_iter_num_errors   : " UH_FMT "\n", ptr_struct->gd_iter_num_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_sel_enc_slave : " UH_FMT "\n", ptr_struct->initial_sel_enc_slave);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_sel_enc_slave   : " UH_FMT "\n", ptr_struct->post_sel_enc_slave);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_sel_enc_slave_centering : " UH_FMT "\n", ptr_struct->post_sel_enc_slave_centering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rect_size            : " UH_FMT "\n", ptr_struct->rect_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cur_phase_ib         : " UH_FMT "\n", ptr_struct->cur_phase_ib);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_gain             : " UH_FMT "\n", ptr_struct->ffe_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_all_gains_bad_value : " UH_FMT "\n", ptr_struct->init_all_gains_bad_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "update_single_gain_bad_value : " UH_FMT "\n", ptr_struct->update_single_gain_bad_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monotonic_flow_height_inconsistent : " UH_FMT "\n", ptr_struct->monotonic_flow_height_inconsistent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monotonic_reached_high_limit : " UH_FMT "\n", ptr_struct->monotonic_reached_high_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monotonic_reached_low_limit : " UH_FMT "\n", ptr_struct->monotonic_reached_low_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "area_zero_event_counter : " UH_FMT "\n", ptr_struct->area_zero_event_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc_tune_area_failure : " UH_FMT "\n", ptr_struct->sel_enc_tune_area_failure);

}

int slreg_16nm_size(void)
{
	return 36;
}

void slreg_16nm_dump(const struct slreg_16nm *ptr_struct, FILE *file)
{
	slreg_16nm_print(ptr_struct, file, 0);
}

void slreg_7nm_pack(const struct slreg_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eom_en);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->eom_status);

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->eom_mode);

	offset = 93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ber_grad_inv);

	offset = 90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fom_timeout);

	offset = 81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eom_vsign);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sth_start_mode);

	offset = 111;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_test_mode);

	offset = 110;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vos_test_mode);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->latch_test_mode);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->phos_test_en);

	offset = 107;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_retest_mode);

	offset = 103;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->latch_adc_gos_test_en);

	offset = 102;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->latch_adc_vos_test_en);

	offset = 101;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->latch_phos_test_en);

	offset = 99;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vos_ctle_test_en);

	offset = 98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vos_vga_test_en);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gos_adc_test_en);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vos_adc_test_en);

	offset = 155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->adc_gos_threshold);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->adc_vos_threshold);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fom_threshold);

	offset = 131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos_threshold);

	offset = 170;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ctle_vos_threshold);

	offset = 162;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->vga_vos_threshold);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nerrs_min);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->nblks_max);

	offset = 206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ber_mode);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->eom_grad);

	offset = 203;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_norm_max_en);

	offset = 198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eom_fmr_ovrd);

	offset = 195;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->eom_fmr_sel);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fom_mode);

	offset = 245;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->ber_v);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ber_t);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ber_eye_sel);

	offset = 229;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->eyeo_range);

	offset = 283;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->margin_t);

	offset = 274;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->margin_v);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->margin_en);

}

void slreg_7nm_unpack(struct slreg_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 14;
	ptr_struct->eom_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->eom_status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 94;
	ptr_struct->eom_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 93;
	ptr_struct->ber_grad_inv = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 90;
	ptr_struct->fom_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 81;
	ptr_struct->eom_vsign = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 80;
	ptr_struct->sth_start_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 111;
	ptr_struct->fom_test_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 110;
	ptr_struct->vos_test_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 109;
	ptr_struct->latch_test_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 108;
	ptr_struct->phos_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 107;
	ptr_struct->fom_retest_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 103;
	ptr_struct->latch_adc_gos_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 102;
	ptr_struct->latch_adc_vos_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 101;
	ptr_struct->latch_phos_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 99;
	ptr_struct->vos_ctle_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 98;
	ptr_struct->vos_vga_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 97;
	ptr_struct->gos_adc_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 96;
	ptr_struct->vos_adc_test_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 155;
	ptr_struct->adc_gos_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 144;
	ptr_struct->adc_vos_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->fom_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 131;
	ptr_struct->phos_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 170;
	ptr_struct->ctle_vos_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 162;
	ptr_struct->vga_vos_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 216;
	ptr_struct->nerrs_min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->nblks_max = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 206;
	ptr_struct->ber_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 204;
	ptr_struct->eom_grad = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 203;
	ptr_struct->fom_norm_max_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 198;
	ptr_struct->eom_fmr_ovrd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 195;
	ptr_struct->eom_fmr_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 192;
	ptr_struct->fom_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 245;
	ptr_struct->ber_v = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 240;
	ptr_struct->ber_t = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 232;
	ptr_struct->ber_eye_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 229;
	ptr_struct->eyeo_range = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 283;
	ptr_struct->margin_t = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 274;
	ptr_struct->margin_v = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 272;
	ptr_struct->margin_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void slreg_7nm_print(const struct slreg_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_en               : " UH_FMT "\n", ptr_struct->eom_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_status           : " UH_FMT "\n", ptr_struct->eom_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_mode             : " UH_FMT "\n", ptr_struct->eom_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_grad_inv         : " UH_FMT "\n", ptr_struct->ber_grad_inv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_timeout          : " UH_FMT "\n", ptr_struct->fom_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_vsign            : " UH_FMT "\n", ptr_struct->eom_vsign);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sth_start_mode       : " UH_FMT "\n", ptr_struct->sth_start_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_test_mode        : " UH_FMT "\n", ptr_struct->fom_test_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vos_test_mode        : " UH_FMT "\n", ptr_struct->vos_test_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latch_test_mode      : " UH_FMT "\n", ptr_struct->latch_test_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos_test_en         : " UH_FMT "\n", ptr_struct->phos_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_retest_mode      : " UH_FMT "\n", ptr_struct->fom_retest_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latch_adc_gos_test_en : " UH_FMT "\n", ptr_struct->latch_adc_gos_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latch_adc_vos_test_en : " UH_FMT "\n", ptr_struct->latch_adc_vos_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latch_phos_test_en   : " UH_FMT "\n", ptr_struct->latch_phos_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vos_ctle_test_en     : " UH_FMT "\n", ptr_struct->vos_ctle_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vos_vga_test_en      : " UH_FMT "\n", ptr_struct->vos_vga_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gos_adc_test_en      : " UH_FMT "\n", ptr_struct->gos_adc_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vos_adc_test_en      : " UH_FMT "\n", ptr_struct->vos_adc_test_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_gos_threshold    : " UH_FMT "\n", ptr_struct->adc_gos_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_vos_threshold    : " UH_FMT "\n", ptr_struct->adc_vos_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_threshold        : " UH_FMT "\n", ptr_struct->fom_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos_threshold       : " UH_FMT "\n", ptr_struct->phos_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_vos_threshold   : " UH_FMT "\n", ptr_struct->ctle_vos_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vga_vos_threshold    : " UH_FMT "\n", ptr_struct->vga_vos_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nerrs_min            : " UH_FMT "\n", ptr_struct->nerrs_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nblks_max            : " UH_FMT "\n", ptr_struct->nblks_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_mode             : " UH_FMT "\n", ptr_struct->ber_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_grad             : %s (" UH_FMT ")\n", (ptr_struct->eom_grad == 0 ? ("EOM_GRAD_NONE") : ((ptr_struct->eom_grad == 1 ? ("EOM_Gradient_sign") : ((ptr_struct->eom_grad == 2 ? ("EOM_Gradient") : ((ptr_struct->eom_grad == 3 ? ("EOM_Gradient_PR1_INV_slicer_BER") : ("unknown")))))))), ptr_struct->eom_grad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_norm_max_en      : " UH_FMT "\n", ptr_struct->fom_norm_max_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_fmr_ovrd         : " UH_FMT "\n", ptr_struct->eom_fmr_ovrd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_fmr_sel          : " UH_FMT "\n", ptr_struct->eom_fmr_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_mode             : " UH_FMT "\n", ptr_struct->fom_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_v                : " UH_FMT "\n", ptr_struct->ber_v);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_t                : " UH_FMT "\n", ptr_struct->ber_t);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_eye_sel          : " UH_FMT "\n", ptr_struct->ber_eye_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eyeo_range           : " UH_FMT "\n", ptr_struct->eyeo_range);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "margin_t             : " UH_FMT "\n", ptr_struct->margin_t);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "margin_v             : " UH_FMT "\n", ptr_struct->margin_v);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "margin_en            : " UH_FMT "\n", ptr_struct->margin_en);

}

int slreg_7nm_size(void)
{
	return 36;
}

void slreg_7nm_dump(const struct slreg_7nm *ptr_struct, FILE *file)
{
	slreg_7nm_print(ptr_struct, file, 0);
}

void slreg_data_set_pack(const struct slreg_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 72; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 576, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void slreg_data_set_unpack(struct slreg_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 72; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 576, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slreg_data_set_print(const struct slreg_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 72; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int slreg_data_set_size(void)
{
	return 72;
}

void slreg_data_set_dump(const struct slreg_data_set *ptr_struct, FILE *file)
{
	slreg_data_set_print(ptr_struct, file, 0);
}

void slreg_usr_pack(const struct slreg_usr *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->grade);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->optimal_phase);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->eye_symmetry_command);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->phase_bounds);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase1);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase0);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase3);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase2);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase5);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase4);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase7);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase6);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase9);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase8);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase11);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase10);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase13);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase12);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase15);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase14);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase17);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase16);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase19);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase18);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase21);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase20);

	offset = 432;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase23);

	offset = 416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase22);

	offset = 464;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase25);

	offset = 448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase24);

	offset = 496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase27);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase26);

	offset = 528;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase29);

	offset = 512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase28);

	offset = 560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase31);

	offset = 544;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amp_phase30);

}

void slreg_usr_unpack(struct slreg_usr *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 3;
	ptr_struct->grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

	offset = 58;
	ptr_struct->optimal_phase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 46;
	ptr_struct->eye_symmetry_command = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 32;
	ptr_struct->phase_bounds = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 80;
	ptr_struct->amp_phase1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->amp_phase0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->amp_phase3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->amp_phase2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->amp_phase5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->amp_phase4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->amp_phase7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->amp_phase6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->amp_phase9 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->amp_phase8 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->amp_phase11 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->amp_phase10 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->amp_phase13 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->amp_phase12 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->amp_phase15 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->amp_phase14 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->amp_phase17 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->amp_phase16 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->amp_phase19 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->amp_phase18 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 400;
	ptr_struct->amp_phase21 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 384;
	ptr_struct->amp_phase20 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 432;
	ptr_struct->amp_phase23 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 416;
	ptr_struct->amp_phase22 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 464;
	ptr_struct->amp_phase25 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 448;
	ptr_struct->amp_phase24 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 496;
	ptr_struct->amp_phase27 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 480;
	ptr_struct->amp_phase26 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 528;
	ptr_struct->amp_phase29 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 512;
	ptr_struct->amp_phase28 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 560;
	ptr_struct->amp_phase31 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 544;
	ptr_struct->amp_phase30 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void slreg_usr_print(const struct slreg_usr *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_usr ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade                : " UH_FMT "\n", ptr_struct->grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "optimal_phase        : " UH_FMT "\n", ptr_struct->optimal_phase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_symmetry_command : " UH_FMT "\n", ptr_struct->eye_symmetry_command);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_bounds         : " UH_FMT "\n", ptr_struct->phase_bounds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase1           : " UH_FMT "\n", ptr_struct->amp_phase1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase0           : " UH_FMT "\n", ptr_struct->amp_phase0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase3           : " UH_FMT "\n", ptr_struct->amp_phase3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase2           : " UH_FMT "\n", ptr_struct->amp_phase2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase5           : " UH_FMT "\n", ptr_struct->amp_phase5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase4           : " UH_FMT "\n", ptr_struct->amp_phase4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase7           : " UH_FMT "\n", ptr_struct->amp_phase7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase6           : " UH_FMT "\n", ptr_struct->amp_phase6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase9           : " UH_FMT "\n", ptr_struct->amp_phase9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase8           : " UH_FMT "\n", ptr_struct->amp_phase8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase11          : " UH_FMT "\n", ptr_struct->amp_phase11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase10          : " UH_FMT "\n", ptr_struct->amp_phase10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase13          : " UH_FMT "\n", ptr_struct->amp_phase13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase12          : " UH_FMT "\n", ptr_struct->amp_phase12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase15          : " UH_FMT "\n", ptr_struct->amp_phase15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase14          : " UH_FMT "\n", ptr_struct->amp_phase14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase17          : " UH_FMT "\n", ptr_struct->amp_phase17);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase16          : " UH_FMT "\n", ptr_struct->amp_phase16);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase19          : " UH_FMT "\n", ptr_struct->amp_phase19);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase18          : " UH_FMT "\n", ptr_struct->amp_phase18);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase21          : " UH_FMT "\n", ptr_struct->amp_phase21);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase20          : " UH_FMT "\n", ptr_struct->amp_phase20);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase23          : " UH_FMT "\n", ptr_struct->amp_phase23);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase22          : " UH_FMT "\n", ptr_struct->amp_phase22);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase25          : " UH_FMT "\n", ptr_struct->amp_phase25);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase24          : " UH_FMT "\n", ptr_struct->amp_phase24);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase27          : " UH_FMT "\n", ptr_struct->amp_phase27);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase26          : " UH_FMT "\n", ptr_struct->amp_phase26);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase29          : " UH_FMT "\n", ptr_struct->amp_phase29);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase28          : " UH_FMT "\n", ptr_struct->amp_phase28);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase31          : " UH_FMT "\n", ptr_struct->amp_phase31);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amp_phase30          : " UH_FMT "\n", ptr_struct->amp_phase30);

}

int slreg_usr_size(void)
{
	return 72;
}

void slreg_usr_dump(const struct slreg_usr *ptr_struct, FILE *file)
{
	slreg_usr_print(ptr_struct, file, 0);
}

void slrg_16nm_pack(const struct slrg_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->grade_lane_speed);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->grade);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grade_version);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_neg_up);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_pos_up);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_pos_mid);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_neg_up);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_pos_up);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_neg_mid);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_pos_mid);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_neg_mid);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_neg_low);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_pos_low);

	offset = 220;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phase_grade_type);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->height_grade_type);

	offset = 214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->phase_units);

	offset = 212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->offset_units);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_neg_low);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_pos_low);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->up_eye_grade);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mid_eye_grade);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dn_eye_grade);

}

void slrg_16nm_unpack(struct slrg_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->grade_lane_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 32;
	ptr_struct->grade_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->height_eo_neg_up = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->height_eo_pos_up = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->height_eo_pos_mid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->phase_eo_neg_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->phase_eo_pos_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->phase_eo_neg_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->phase_eo_pos_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->height_eo_neg_mid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->height_eo_neg_low = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->height_eo_pos_low = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 220;
	ptr_struct->phase_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 216;
	ptr_struct->height_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 214;
	ptr_struct->phase_units = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 212;
	ptr_struct->offset_units = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 200;
	ptr_struct->phase_eo_neg_low = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->phase_eo_pos_low = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->up_eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->mid_eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->dn_eye_grade = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void slrg_16nm_print(const struct slrg_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_lane_speed     : " UH_FMT "\n", ptr_struct->grade_lane_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade                : " UH_FMT "\n", ptr_struct->grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_version        : " UH_FMT "\n", ptr_struct->grade_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_neg_up     : " UH_FMT "\n", ptr_struct->height_eo_neg_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_pos_up     : " UH_FMT "\n", ptr_struct->height_eo_pos_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_pos_mid    : " UH_FMT "\n", ptr_struct->height_eo_pos_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_neg_up      : " UH_FMT "\n", ptr_struct->phase_eo_neg_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_pos_up      : " UH_FMT "\n", ptr_struct->phase_eo_pos_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_neg_mid     : " UH_FMT "\n", ptr_struct->phase_eo_neg_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_pos_mid     : " UH_FMT "\n", ptr_struct->phase_eo_pos_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_neg_mid    : " UH_FMT "\n", ptr_struct->height_eo_neg_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_neg_low    : " UH_FMT "\n", ptr_struct->height_eo_neg_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_pos_low    : " UH_FMT "\n", ptr_struct->height_eo_pos_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_type     : " UH_FMT "\n", ptr_struct->phase_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_type    : " UH_FMT "\n", ptr_struct->height_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_units          : " UH_FMT "\n", ptr_struct->phase_units);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_units         : " UH_FMT "\n", ptr_struct->offset_units);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_neg_low     : " UH_FMT "\n", ptr_struct->phase_eo_neg_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_pos_low     : " UH_FMT "\n", ptr_struct->phase_eo_pos_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "up_eye_grade         : " UH_FMT "\n", ptr_struct->up_eye_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_eye_grade        : " UH_FMT "\n", ptr_struct->mid_eye_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dn_eye_grade         : " UH_FMT "\n", ptr_struct->dn_eye_grade);

}

int slrg_16nm_size(void)
{
	return 36;
}

void slrg_16nm_dump(const struct slrg_16nm *ptr_struct, FILE *file)
{
	slrg_16nm_print(ptr_struct, file, 0);
}

void slrg_40nm_28nm_pack(const struct slrg_40nm_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->grade_lane_speed);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->grade);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grade_version);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->height_grade);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->height_grade_type);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->phase_units);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->offset_units);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_dv);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_dz);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_sigma);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_neg);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->height_eo_pos);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->phase_grade);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phase_grade_type);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_neg);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_eo_pos);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->test_errors_per_lane);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ffe_set_tested);

}

void slrg_40nm_28nm_unpack(struct slrg_40nm_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->grade_lane_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 32;
	ptr_struct->grade_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->height_grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 68;
	ptr_struct->height_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 66;
	ptr_struct->phase_units = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	ptr_struct->offset_units = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 112;
	ptr_struct->height_dv = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->height_dz = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->height_sigma = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->height_eo_neg = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->height_eo_pos = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 200;
	ptr_struct->phase_grade = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 196;
	ptr_struct->phase_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 248;
	ptr_struct->phase_eo_neg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->phase_eo_pos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 272;
	ptr_struct->test_errors_per_lane = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->ffe_set_tested = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void slrg_40nm_28nm_print(const struct slrg_40nm_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_40nm_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_lane_speed     : " UH_FMT "\n", ptr_struct->grade_lane_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade                : " UH_FMT "\n", ptr_struct->grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_version        : " UH_FMT "\n", ptr_struct->grade_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade         : " UH_FMT "\n", ptr_struct->height_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_type    : " UH_FMT "\n", ptr_struct->height_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_units          : " UH_FMT "\n", ptr_struct->phase_units);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_units         : " UH_FMT "\n", ptr_struct->offset_units);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_dv            : " UH_FMT "\n", ptr_struct->height_dv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_dz            : " UH_FMT "\n", ptr_struct->height_dz);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_sigma         : " UH_FMT "\n", ptr_struct->height_sigma);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_neg        : " UH_FMT "\n", ptr_struct->height_eo_neg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_eo_pos        : " UH_FMT "\n", ptr_struct->height_eo_pos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade          : " UH_FMT "\n", ptr_struct->phase_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_type     : " UH_FMT "\n", ptr_struct->phase_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_neg         : " UH_FMT "\n", ptr_struct->phase_eo_neg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_eo_pos         : " UH_FMT "\n", ptr_struct->phase_eo_pos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "test_errors_per_lane : " UH_FMT "\n", ptr_struct->test_errors_per_lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_set_tested       : " UH_FMT "\n", ptr_struct->ffe_set_tested);

}

int slrg_40nm_28nm_size(void)
{
	return 36;
}

void slrg_40nm_28nm_dump(const struct slrg_40nm_28nm *ptr_struct, FILE *file)
{
	slrg_40nm_28nm_print(ptr_struct, file, 0);
}

void slrg_5nm_pack(const struct slrg_5nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fom_measurment);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->initial_fom);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fom_mode);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->upper_eye);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->last_fom);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lower_eye);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mid_eye);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nerrs_min);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->nblks_max);

	offset = 129;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_ext_conf_cap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_ext_conf);

}

void slrg_5nm_unpack(struct slrg_5nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->fom_measurment = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->initial_fom = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 44;
	ptr_struct->fom_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->upper_eye = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->last_fom = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->lower_eye = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->mid_eye = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 152;
	ptr_struct->nerrs_min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->nblks_max = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 129;
	ptr_struct->fom_ext_conf_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 128;
	ptr_struct->fom_ext_conf = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void slrg_5nm_print(const struct slrg_5nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_5nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_measurment       : " UH_FMT "\n", ptr_struct->fom_measurment);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_fom          : " UH_FMT "\n", ptr_struct->initial_fom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_mode             : %s (" UH_FMT ")\n", (ptr_struct->fom_mode == 0 ? ("FOM_MODE_EYE_OPEN") : ((ptr_struct->fom_mode == 1 ? ("FOM_MODE_EYEO_SNR") : ((ptr_struct->fom_mode == 2 ? ("FOM_MODE_NORM_SNR") : ((ptr_struct->fom_mode == 3 ? ("FOM_MODE_EYE_LVLN") : ((ptr_struct->fom_mode == 4 ? ("FOM_MODE_EYE_LVLP") : ((ptr_struct->fom_mode == 5 ? ("FOM_MODE_THRES_NERR") : ((ptr_struct->fom_mode == 6 ? ("FOM_MODE_CDR_NERR") : ((ptr_struct->fom_mode == 7 ? ("FOM_MODE_CSDET_NERR") : ((ptr_struct->fom_mode == 8 ? ("FOM_MODE_MLSE_NERR") : ((ptr_struct->fom_mode == 9 ? ("FOM_MODE_SFEC_NERR") : ("unknown")))))))))))))))))))), ptr_struct->fom_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upper_eye            : " UH_FMT "\n", ptr_struct->upper_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_fom             : " UH_FMT "\n", ptr_struct->last_fom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lower_eye            : " UH_FMT "\n", ptr_struct->lower_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_eye              : " UH_FMT "\n", ptr_struct->mid_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nerrs_min            : " UH_FMT "\n", ptr_struct->nerrs_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nblks_max            : " UH_FMT "\n", ptr_struct->nblks_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_ext_conf_cap     : " UH_FMT "\n", ptr_struct->fom_ext_conf_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_ext_conf         : " UH_FMT "\n", ptr_struct->fom_ext_conf);

}

int slrg_5nm_size(void)
{
	return 24;
}

void slrg_5nm_dump(const struct slrg_5nm *ptr_struct, FILE *file)
{
	slrg_5nm_print(ptr_struct, file, 0);
}

void slrg_7nm_pack(const struct slrg_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fom_measurment);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->initial_fom);

	offset = 45;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fom_mode);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lower_eye);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mid_eye);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->upper_eye);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->last_fom);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nerrs_min);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->nblks_max);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_ext_conf_cap);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fom_ext_conf);

}

void slrg_7nm_unpack(struct slrg_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->fom_measurment = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->initial_fom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 45;
	ptr_struct->fom_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 88;
	ptr_struct->lower_eye = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->mid_eye = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->upper_eye = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->last_fom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->nerrs_min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->nblks_max = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 97;
	ptr_struct->fom_ext_conf_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 96;
	ptr_struct->fom_ext_conf = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void slrg_7nm_print(const struct slrg_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_measurment       : " UH_FMT "\n", ptr_struct->fom_measurment);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_fom          : " UH_FMT "\n", ptr_struct->initial_fom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_mode             : %s (" UH_FMT ")\n", (ptr_struct->fom_mode == 0 ? ("FOM_MODE_EYEC") : ((ptr_struct->fom_mode == 1 ? ("FOM_MODE_EYEO") : ((ptr_struct->fom_mode == 2 ? ("FOM_MODE_EYEM") : ((ptr_struct->fom_mode == 3 ? ("FOM_MODE_BER") : ((ptr_struct->fom_mode == 4 ? ("FOM_MODE_EYEC_VN") : ((ptr_struct->fom_mode == 5 ? ("FOM_MODE_EYEC_VP") : ((ptr_struct->fom_mode == 6 ? ("FOM_MODE_EYEM_VN") : ((ptr_struct->fom_mode == 7 ? ("FOM_MODE_EYEM_VP") : ("unknown")))))))))))))))), ptr_struct->fom_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lower_eye            : " UH_FMT "\n", ptr_struct->lower_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mid_eye              : " UH_FMT "\n", ptr_struct->mid_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upper_eye            : " UH_FMT "\n", ptr_struct->upper_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_fom             : " UH_FMT "\n", ptr_struct->last_fom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nerrs_min            : " UH_FMT "\n", ptr_struct->nerrs_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nblks_max            : " UH_FMT "\n", ptr_struct->nblks_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_ext_conf_cap     : " UH_FMT "\n", ptr_struct->fom_ext_conf_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fom_ext_conf         : " UH_FMT "\n", ptr_struct->fom_ext_conf);

}

int slrg_7nm_size(void)
{
	return 24;
}

void slrg_7nm_dump(const struct slrg_7nm *ptr_struct, FILE *file)
{
	slrg_7nm_print(ptr_struct, file, 0);
}

void slrg_data_set_pack(const struct slrg_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 164; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1312, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void slrg_data_set_unpack(struct slrg_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 164; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1312, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slrg_data_set_print(const struct slrg_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 164; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int slrg_data_set_size(void)
{
	return 164;
}

void slrg_data_set_dump(const struct slrg_data_set *ptr_struct, FILE *file)
{
	slrg_data_set_print(ptr_struct, file, 0);
}

void slrip_16nm_pack(const struct slrip_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ib_sel);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap3);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap2);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap1);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap0);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap7);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap6);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap5);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap4);

	offset = 119;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->ffe_tap_en);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc0);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap8);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset1);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset0);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc2);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc1);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved1_mixer_offset0);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved1_sel_enc0);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved0_mixer_offset0);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->saved0_sel_enc0);

}

void slrip_16nm_unpack(struct slrip_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->ib_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 56;
	ptr_struct->ffe_tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ffe_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->ffe_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->ffe_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->ffe_tap7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->ffe_tap6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->ffe_tap5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->ffe_tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 119;
	ptr_struct->ffe_tap_en = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 104;
	ptr_struct->sel_enc0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->ffe_tap8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->mixer_offset1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->mixer_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->sel_enc2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->sel_enc1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->saved1_mixer_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->saved1_sel_enc0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->saved0_mixer_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->saved0_sel_enc0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void slrip_16nm_print(const struct slrip_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_sel               : " UH_FMT "\n", ptr_struct->ib_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap3             : " UH_FMT "\n", ptr_struct->ffe_tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap2             : " UH_FMT "\n", ptr_struct->ffe_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap1             : " UH_FMT "\n", ptr_struct->ffe_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap0             : " UH_FMT "\n", ptr_struct->ffe_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap7             : " UH_FMT "\n", ptr_struct->ffe_tap7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap6             : " UH_FMT "\n", ptr_struct->ffe_tap6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap5             : " UH_FMT "\n", ptr_struct->ffe_tap5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap4             : " UH_FMT "\n", ptr_struct->ffe_tap4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_en           : " UH_FMT "\n", ptr_struct->ffe_tap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc0             : " UH_FMT "\n", ptr_struct->sel_enc0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap8             : " UH_FMT "\n", ptr_struct->ffe_tap8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset1        : " UH_FMT "\n", ptr_struct->mixer_offset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset0        : " UH_FMT "\n", ptr_struct->mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc2             : " UH_FMT "\n", ptr_struct->sel_enc2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc1             : " UH_FMT "\n", ptr_struct->sel_enc1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved1_mixer_offset0 : " UH_FMT "\n", ptr_struct->saved1_mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved1_sel_enc0      : " UH_FMT "\n", ptr_struct->saved1_sel_enc0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved0_mixer_offset0 : " UH_FMT "\n", ptr_struct->saved0_mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "saved0_sel_enc0      : " UH_FMT "\n", ptr_struct->saved0_sel_enc0);

}

int slrip_16nm_size(void)
{
	return 40;
}

void slrip_16nm_dump(const struct slrip_16nm *ptr_struct, FILE *file)
{
	slrip_16nm_print(ptr_struct, file, 0);
}

void slrip_5nm_pack(const struct slrip_5nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->hf_gain);

	offset = 85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dc_gain);

	offset = 81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mf_pol);

	offset = 77;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mf_gain);

	offset = 73;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lf_pol);

	offset = 69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lf_gain);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tah_amp_gain);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_fm5);

	offset = 115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_fm4);

	offset = 105;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_fm3);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_fm2);

	offset = 141;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->ffe_fm1);

	offset = 131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_f1);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_f2);

	offset = 175;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ffe_f3);

	offset = 166;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ffe_f4);

	offset = 217;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ffe_f5);

	offset = 209;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f6);

	offset = 201;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f7);

	offset = 193;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f8);

	offset = 250;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f9);

	offset = 243;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_f10);

	offset = 236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_f11);

	offset = 229;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_f12);

	offset = 282;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel0);

	offset = 278;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef0);

	offset = 271;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel1);

	offset = 267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef1);

	offset = 260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel2);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef2);

	offset = 314;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel3);

	offset = 310;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef3);

	offset = 303;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel4);

	offset = 299;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef4);

	offset = 292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel5);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef5);

	offset = 346;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel6);

	offset = 342;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef6);

	offset = 335;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel7);

	offset = 331;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef7);

	offset = 324;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel8);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef8);

	offset = 378;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel9);

	offset = 374;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef9);

	offset = 367;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel10);

	offset = 363;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef10);

	offset = 356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel11);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef11);

	offset = 410;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel12);

	offset = 406;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef12);

	offset = 399;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel13);

	offset = 395;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef13);

	offset = 388;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel14);

	offset = 384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef14);

	offset = 442;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dffe_dsel15);

	offset = 438;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef15);

	offset = 427;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th0);

	offset = 416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th1);

	offset = 470;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th2);

	offset = 459;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th3);

	offset = 448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th4);

	offset = 502;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th5);

	offset = 491;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th6);

	offset = 480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th7);

	offset = 534;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th8);

	offset = 523;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th9);

	offset = 512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th10);

	offset = 566;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th11);

	offset = 555;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->fb_slicer_th12);

	offset = 544;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th0);

	offset = 598;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th1);

	offset = 587;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th2);

	offset = 576;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th3);

	offset = 630;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th4);

	offset = 619;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th5);

	offset = 608;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th6);

	offset = 662;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th7);

	offset = 651;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th8);

	offset = 640;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th9);

	offset = 694;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th10);

	offset = 683;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th11);

	offset = 672;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->ff_slicer_th12);

}

void slrip_5nm_unpack(struct slrip_5nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 90;
	ptr_struct->hf_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 85;
	ptr_struct->dc_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 81;
	ptr_struct->mf_pol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 77;
	ptr_struct->mf_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 73;
	ptr_struct->lf_pol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 69;
	ptr_struct->lf_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	ptr_struct->tah_amp_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 123;
	ptr_struct->ffe_fm5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 115;
	ptr_struct->ffe_fm4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 105;
	ptr_struct->ffe_fm3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->ffe_fm2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 141;
	ptr_struct->ffe_fm1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 131;
	ptr_struct->ffe_f1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->ffe_f2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 175;
	ptr_struct->ffe_f3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 166;
	ptr_struct->ffe_f4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 217;
	ptr_struct->ffe_f5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 209;
	ptr_struct->ffe_f6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 201;
	ptr_struct->ffe_f7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 193;
	ptr_struct->ffe_f8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 250;
	ptr_struct->ffe_f9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 243;
	ptr_struct->ffe_f10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 236;
	ptr_struct->ffe_f11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 229;
	ptr_struct->ffe_f12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 282;
	ptr_struct->dffe_dsel0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 278;
	ptr_struct->dffe_coef0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 271;
	ptr_struct->dffe_dsel1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 267;
	ptr_struct->dffe_coef1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 260;
	ptr_struct->dffe_dsel2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 256;
	ptr_struct->dffe_coef2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 314;
	ptr_struct->dffe_dsel3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 310;
	ptr_struct->dffe_coef3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 303;
	ptr_struct->dffe_dsel4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 299;
	ptr_struct->dffe_coef4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 292;
	ptr_struct->dffe_dsel5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 288;
	ptr_struct->dffe_coef5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 346;
	ptr_struct->dffe_dsel6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 342;
	ptr_struct->dffe_coef6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 335;
	ptr_struct->dffe_dsel7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 331;
	ptr_struct->dffe_coef7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 324;
	ptr_struct->dffe_dsel8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 320;
	ptr_struct->dffe_coef8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 378;
	ptr_struct->dffe_dsel9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 374;
	ptr_struct->dffe_coef9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 367;
	ptr_struct->dffe_dsel10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 363;
	ptr_struct->dffe_coef10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 356;
	ptr_struct->dffe_dsel11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 352;
	ptr_struct->dffe_coef11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 410;
	ptr_struct->dffe_dsel12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 406;
	ptr_struct->dffe_coef12 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 399;
	ptr_struct->dffe_dsel13 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 395;
	ptr_struct->dffe_coef13 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 388;
	ptr_struct->dffe_dsel14 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 384;
	ptr_struct->dffe_coef14 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 442;
	ptr_struct->dffe_dsel15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 438;
	ptr_struct->dffe_coef15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 427;
	ptr_struct->fb_slicer_th0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 416;
	ptr_struct->fb_slicer_th1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 470;
	ptr_struct->fb_slicer_th2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 459;
	ptr_struct->fb_slicer_th3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 448;
	ptr_struct->fb_slicer_th4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 502;
	ptr_struct->fb_slicer_th5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 491;
	ptr_struct->fb_slicer_th6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 480;
	ptr_struct->fb_slicer_th7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 534;
	ptr_struct->fb_slicer_th8 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 523;
	ptr_struct->fb_slicer_th9 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 512;
	ptr_struct->fb_slicer_th10 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 566;
	ptr_struct->fb_slicer_th11 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 555;
	ptr_struct->fb_slicer_th12 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 544;
	ptr_struct->ff_slicer_th0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 598;
	ptr_struct->ff_slicer_th1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 587;
	ptr_struct->ff_slicer_th2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 576;
	ptr_struct->ff_slicer_th3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 630;
	ptr_struct->ff_slicer_th4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 619;
	ptr_struct->ff_slicer_th5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 608;
	ptr_struct->ff_slicer_th6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 662;
	ptr_struct->ff_slicer_th7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 651;
	ptr_struct->ff_slicer_th8 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 640;
	ptr_struct->ff_slicer_th9 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 694;
	ptr_struct->ff_slicer_th10 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 683;
	ptr_struct->ff_slicer_th11 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 672;
	ptr_struct->ff_slicer_th12 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void slrip_5nm_print(const struct slrip_5nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_5nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hf_gain              : " UH_FMT "\n", ptr_struct->hf_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_gain              : " UH_FMT "\n", ptr_struct->dc_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mf_pol               : " UH_FMT "\n", ptr_struct->mf_pol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mf_gain              : " UH_FMT "\n", ptr_struct->mf_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lf_pol               : " UH_FMT "\n", ptr_struct->lf_pol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lf_gain              : " UH_FMT "\n", ptr_struct->lf_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tah_amp_gain         : " UH_FMT "\n", ptr_struct->tah_amp_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm5              : " UH_FMT "\n", ptr_struct->ffe_fm5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm4              : " UH_FMT "\n", ptr_struct->ffe_fm4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm3              : " UH_FMT "\n", ptr_struct->ffe_fm3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm2              : " UH_FMT "\n", ptr_struct->ffe_fm2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm1              : " UH_FMT "\n", ptr_struct->ffe_fm1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f1               : " UH_FMT "\n", ptr_struct->ffe_f1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f2               : " UH_FMT "\n", ptr_struct->ffe_f2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f3               : " UH_FMT "\n", ptr_struct->ffe_f3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f4               : " UH_FMT "\n", ptr_struct->ffe_f4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f5               : " UH_FMT "\n", ptr_struct->ffe_f5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f6               : " UH_FMT "\n", ptr_struct->ffe_f6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f7               : " UH_FMT "\n", ptr_struct->ffe_f7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f8               : " UH_FMT "\n", ptr_struct->ffe_f8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f9               : " UH_FMT "\n", ptr_struct->ffe_f9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f10              : " UH_FMT "\n", ptr_struct->ffe_f10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f11              : " UH_FMT "\n", ptr_struct->ffe_f11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f12              : " UH_FMT "\n", ptr_struct->ffe_f12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel0           : " UH_FMT "\n", ptr_struct->dffe_dsel0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef0           : " UH_FMT "\n", ptr_struct->dffe_coef0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel1           : " UH_FMT "\n", ptr_struct->dffe_dsel1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef1           : " UH_FMT "\n", ptr_struct->dffe_coef1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel2           : " UH_FMT "\n", ptr_struct->dffe_dsel2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef2           : " UH_FMT "\n", ptr_struct->dffe_coef2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel3           : " UH_FMT "\n", ptr_struct->dffe_dsel3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef3           : " UH_FMT "\n", ptr_struct->dffe_coef3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel4           : " UH_FMT "\n", ptr_struct->dffe_dsel4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef4           : " UH_FMT "\n", ptr_struct->dffe_coef4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel5           : " UH_FMT "\n", ptr_struct->dffe_dsel5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef5           : " UH_FMT "\n", ptr_struct->dffe_coef5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel6           : " UH_FMT "\n", ptr_struct->dffe_dsel6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef6           : " UH_FMT "\n", ptr_struct->dffe_coef6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel7           : " UH_FMT "\n", ptr_struct->dffe_dsel7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef7           : " UH_FMT "\n", ptr_struct->dffe_coef7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel8           : " UH_FMT "\n", ptr_struct->dffe_dsel8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef8           : " UH_FMT "\n", ptr_struct->dffe_coef8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel9           : " UH_FMT "\n", ptr_struct->dffe_dsel9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef9           : " UH_FMT "\n", ptr_struct->dffe_coef9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel10          : " UH_FMT "\n", ptr_struct->dffe_dsel10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef10          : " UH_FMT "\n", ptr_struct->dffe_coef10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel11          : " UH_FMT "\n", ptr_struct->dffe_dsel11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef11          : " UH_FMT "\n", ptr_struct->dffe_coef11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel12          : " UH_FMT "\n", ptr_struct->dffe_dsel12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef12          : " UH_FMT "\n", ptr_struct->dffe_coef12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel13          : " UH_FMT "\n", ptr_struct->dffe_dsel13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef13          : " UH_FMT "\n", ptr_struct->dffe_coef13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel14          : " UH_FMT "\n", ptr_struct->dffe_dsel14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef14          : " UH_FMT "\n", ptr_struct->dffe_coef14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel15          : " UH_FMT "\n", ptr_struct->dffe_dsel15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef15          : " UH_FMT "\n", ptr_struct->dffe_coef15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th0        : " UH_FMT "\n", ptr_struct->fb_slicer_th0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th1        : " UH_FMT "\n", ptr_struct->fb_slicer_th1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th2        : " UH_FMT "\n", ptr_struct->fb_slicer_th2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th3        : " UH_FMT "\n", ptr_struct->fb_slicer_th3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th4        : " UH_FMT "\n", ptr_struct->fb_slicer_th4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th5        : " UH_FMT "\n", ptr_struct->fb_slicer_th5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th6        : " UH_FMT "\n", ptr_struct->fb_slicer_th6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th7        : " UH_FMT "\n", ptr_struct->fb_slicer_th7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th8        : " UH_FMT "\n", ptr_struct->fb_slicer_th8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th9        : " UH_FMT "\n", ptr_struct->fb_slicer_th9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th10       : " UH_FMT "\n", ptr_struct->fb_slicer_th10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th11       : " UH_FMT "\n", ptr_struct->fb_slicer_th11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fb_slicer_th12       : " UH_FMT "\n", ptr_struct->fb_slicer_th12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th0        : " UH_FMT "\n", ptr_struct->ff_slicer_th0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th1        : " UH_FMT "\n", ptr_struct->ff_slicer_th1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th2        : " UH_FMT "\n", ptr_struct->ff_slicer_th2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th3        : " UH_FMT "\n", ptr_struct->ff_slicer_th3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th4        : " UH_FMT "\n", ptr_struct->ff_slicer_th4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th5        : " UH_FMT "\n", ptr_struct->ff_slicer_th5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th6        : " UH_FMT "\n", ptr_struct->ff_slicer_th6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th7        : " UH_FMT "\n", ptr_struct->ff_slicer_th7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th8        : " UH_FMT "\n", ptr_struct->ff_slicer_th8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th9        : " UH_FMT "\n", ptr_struct->ff_slicer_th9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th10       : " UH_FMT "\n", ptr_struct->ff_slicer_th10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th11       : " UH_FMT "\n", ptr_struct->ff_slicer_th11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ff_slicer_th12       : " UH_FMT "\n", ptr_struct->ff_slicer_th12);

}

int slrip_5nm_size(void)
{
	return 88;
}

void slrip_5nm_dump(const struct slrip_5nm *ptr_struct, FILE *file)
{
	slrip_5nm_print(ptr_struct, file, 0);
}

void slrip_7nm_pack(const struct slrip_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->feq_train_mode);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->term_attn_override_ctrl);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_gain_override_ctrl);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lf_gain_override_ctrl);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lf_pole_override_ctrl);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mf_gain_override_ctrl);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mf_pole_override_ctrl);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->hf_gain_override_ctrl);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->vga_gain_override_ctrl);

	offset = 42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dffe_override_ctrl);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->vref_val_mode_ctrl);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->term_lpf_override_ctrl);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_override_ctrl);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fm3_override_ctrl);

	offset = 82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fm2_override_ctrl);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fm1_override_ctrl);

	offset = 78;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f8_override_ctrl);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f7_override_ctrl);

	offset = 74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f6_override_ctrl);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f5_override_ctrl);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f4_override_ctrl);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f3_override_ctrl);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f2_override_ctrl);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->f1_override_ctrl);

	offset = 125;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dc_gain);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hf_gain);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->term_attn_ctrl);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lf_gain);

	offset = 105;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lf_pole);

	offset = 101;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mf_gain);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mf_pole);

	offset = 157;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->vga_gain);

	offset = 146;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->adc_vref_val);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_fm3);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ffe_fm2);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_fm1);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_f1);

	offset = 209;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ffe_f2);

	offset = 202;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f3);

	offset = 194;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f4);

	offset = 250;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ffe_f5);

	offset = 243;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_f6);

	offset = 235;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ffe_f7);

	offset = 228;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ffe_f8);

	offset = 284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef0);

	offset = 281;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel0);

	offset = 276;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef1);

	offset = 273;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel1);

	offset = 268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef2);

	offset = 265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel2);

	offset = 260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef3);

	offset = 257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel3);

	offset = 316;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef4);

	offset = 313;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel4);

	offset = 308;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef5);

	offset = 305;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel5);

	offset = 300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef6);

	offset = 297;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel6);

	offset = 292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef7);

	offset = 289;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dffe_dsel7);

	offset = 348;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dffe_coef8);

	offset = 343;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->dffe_dsel8);

	offset = 373;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th0);

	offset = 357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th1);

	offset = 405;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th2);

	offset = 389;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th3);

	offset = 437;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th4);

	offset = 421;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th5);

	offset = 469;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th6);

	offset = 453;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th7);

	offset = 501;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th8);

	offset = 485;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th9);

	offset = 533;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th10);

	offset = 517;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th11);

	offset = 565;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th12);

	offset = 549;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th13);

	offset = 597;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th14);

	offset = 581;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th15);

	offset = 629;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th16);

	offset = 613;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th17);

	offset = 661;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th18);

	offset = 645;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th19);

	offset = 693;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th20);

	offset = 677;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->th21);

}

void slrip_7nm_unpack(struct slrip_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->feq_train_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 62;
	ptr_struct->term_attn_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 60;
	ptr_struct->dc_gain_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 58;
	ptr_struct->lf_gain_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 56;
	ptr_struct->lf_pole_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 54;
	ptr_struct->mf_gain_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 52;
	ptr_struct->mf_pole_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 50;
	ptr_struct->hf_gain_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 48;
	ptr_struct->vga_gain_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 42;
	ptr_struct->dffe_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 38;
	ptr_struct->vref_val_mode_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 34;
	ptr_struct->term_lpf_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 88;
	ptr_struct->eth_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 84;
	ptr_struct->fm3_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 82;
	ptr_struct->fm2_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 80;
	ptr_struct->fm1_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 78;
	ptr_struct->f8_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 76;
	ptr_struct->f7_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 74;
	ptr_struct->f6_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 72;
	ptr_struct->f5_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 70;
	ptr_struct->f4_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 68;
	ptr_struct->f3_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 66;
	ptr_struct->f2_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	ptr_struct->f1_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 125;
	ptr_struct->dc_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 120;
	ptr_struct->hf_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 118;
	ptr_struct->term_attn_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 109;
	ptr_struct->lf_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 105;
	ptr_struct->lf_pole = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 101;
	ptr_struct->mf_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 97;
	ptr_struct->mf_pole = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 157;
	ptr_struct->vga_gain = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 146;
	ptr_struct->adc_vref_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 176;
	ptr_struct->ffe_fm3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 168;
	ptr_struct->ffe_fm2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 160;
	ptr_struct->ffe_fm1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->ffe_f1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 209;
	ptr_struct->ffe_f2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 202;
	ptr_struct->ffe_f3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 194;
	ptr_struct->ffe_f4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 250;
	ptr_struct->ffe_f5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 243;
	ptr_struct->ffe_f6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 235;
	ptr_struct->ffe_f7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 228;
	ptr_struct->ffe_f8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 284;
	ptr_struct->dffe_coef0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 281;
	ptr_struct->dffe_dsel0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 276;
	ptr_struct->dffe_coef1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 273;
	ptr_struct->dffe_dsel1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 268;
	ptr_struct->dffe_coef2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 265;
	ptr_struct->dffe_dsel2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 260;
	ptr_struct->dffe_coef3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 257;
	ptr_struct->dffe_dsel3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 316;
	ptr_struct->dffe_coef4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 313;
	ptr_struct->dffe_dsel4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 308;
	ptr_struct->dffe_coef5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 305;
	ptr_struct->dffe_dsel5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 300;
	ptr_struct->dffe_coef6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 297;
	ptr_struct->dffe_dsel6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 292;
	ptr_struct->dffe_coef7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 289;
	ptr_struct->dffe_dsel7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 348;
	ptr_struct->dffe_coef8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 343;
	ptr_struct->dffe_dsel8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 373;
	ptr_struct->th0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 357;
	ptr_struct->th1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 405;
	ptr_struct->th2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 389;
	ptr_struct->th3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 437;
	ptr_struct->th4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 421;
	ptr_struct->th5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 469;
	ptr_struct->th6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 453;
	ptr_struct->th7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 501;
	ptr_struct->th8 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 485;
	ptr_struct->th9 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 533;
	ptr_struct->th10 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 517;
	ptr_struct->th11 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 565;
	ptr_struct->th12 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 549;
	ptr_struct->th13 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 597;
	ptr_struct->th14 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 581;
	ptr_struct->th15 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 629;
	ptr_struct->th16 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 613;
	ptr_struct->th17 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 661;
	ptr_struct->th18 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 645;
	ptr_struct->th19 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 693;
	ptr_struct->th20 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 677;
	ptr_struct->th21 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void slrip_7nm_print(const struct slrip_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "feq_train_mode       : " UH_FMT "\n", ptr_struct->feq_train_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "term_attn_override_ctrl : " UH_FMT "\n", ptr_struct->term_attn_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_gain_override_ctrl : " UH_FMT "\n", ptr_struct->dc_gain_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lf_gain_override_ctrl : " UH_FMT "\n", ptr_struct->lf_gain_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lf_pole_override_ctrl : " UH_FMT "\n", ptr_struct->lf_pole_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mf_gain_override_ctrl : " UH_FMT "\n", ptr_struct->mf_gain_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mf_pole_override_ctrl : " UH_FMT "\n", ptr_struct->mf_pole_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hf_gain_override_ctrl : " UH_FMT "\n", ptr_struct->hf_gain_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vga_gain_override_ctrl : " UH_FMT "\n", ptr_struct->vga_gain_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_override_ctrl   : " UH_FMT "\n", ptr_struct->dffe_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vref_val_mode_ctrl   : " UH_FMT "\n", ptr_struct->vref_val_mode_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "term_lpf_override_ctrl : " UH_FMT "\n", ptr_struct->term_lpf_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_override_ctrl    : " UH_FMT "\n", ptr_struct->eth_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fm3_override_ctrl    : " UH_FMT "\n", ptr_struct->fm3_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fm2_override_ctrl    : " UH_FMT "\n", ptr_struct->fm2_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fm1_override_ctrl    : " UH_FMT "\n", ptr_struct->fm1_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f8_override_ctrl     : " UH_FMT "\n", ptr_struct->f8_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f7_override_ctrl     : " UH_FMT "\n", ptr_struct->f7_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f6_override_ctrl     : " UH_FMT "\n", ptr_struct->f6_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f5_override_ctrl     : " UH_FMT "\n", ptr_struct->f5_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f4_override_ctrl     : " UH_FMT "\n", ptr_struct->f4_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f3_override_ctrl     : " UH_FMT "\n", ptr_struct->f3_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f2_override_ctrl     : " UH_FMT "\n", ptr_struct->f2_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f1_override_ctrl     : " UH_FMT "\n", ptr_struct->f1_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_gain              : " UH_FMT "\n", ptr_struct->dc_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hf_gain              : " UH_FMT "\n", ptr_struct->hf_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "term_attn_ctrl       : " UH_FMT "\n", ptr_struct->term_attn_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lf_gain              : " UH_FMT "\n", ptr_struct->lf_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lf_pole              : " UH_FMT "\n", ptr_struct->lf_pole);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mf_gain              : " UH_FMT "\n", ptr_struct->mf_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mf_pole              : " UH_FMT "\n", ptr_struct->mf_pole);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vga_gain             : " UH_FMT "\n", ptr_struct->vga_gain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_vref_val         : " UH_FMT "\n", ptr_struct->adc_vref_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm3              : " UH_FMT "\n", ptr_struct->ffe_fm3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm2              : " UH_FMT "\n", ptr_struct->ffe_fm2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_fm1              : " UH_FMT "\n", ptr_struct->ffe_fm1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f1               : " UH_FMT "\n", ptr_struct->ffe_f1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f2               : " UH_FMT "\n", ptr_struct->ffe_f2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f3               : " UH_FMT "\n", ptr_struct->ffe_f3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f4               : " UH_FMT "\n", ptr_struct->ffe_f4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f5               : " UH_FMT "\n", ptr_struct->ffe_f5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f6               : " UH_FMT "\n", ptr_struct->ffe_f6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f7               : " UH_FMT "\n", ptr_struct->ffe_f7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_f8               : " UH_FMT "\n", ptr_struct->ffe_f8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef0           : " UH_FMT "\n", ptr_struct->dffe_coef0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel0           : " UH_FMT "\n", ptr_struct->dffe_dsel0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef1           : " UH_FMT "\n", ptr_struct->dffe_coef1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel1           : " UH_FMT "\n", ptr_struct->dffe_dsel1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef2           : " UH_FMT "\n", ptr_struct->dffe_coef2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel2           : " UH_FMT "\n", ptr_struct->dffe_dsel2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef3           : " UH_FMT "\n", ptr_struct->dffe_coef3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel3           : " UH_FMT "\n", ptr_struct->dffe_dsel3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef4           : " UH_FMT "\n", ptr_struct->dffe_coef4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel4           : " UH_FMT "\n", ptr_struct->dffe_dsel4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef5           : " UH_FMT "\n", ptr_struct->dffe_coef5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel5           : " UH_FMT "\n", ptr_struct->dffe_dsel5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef6           : " UH_FMT "\n", ptr_struct->dffe_coef6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel6           : " UH_FMT "\n", ptr_struct->dffe_dsel6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef7           : " UH_FMT "\n", ptr_struct->dffe_coef7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel7           : " UH_FMT "\n", ptr_struct->dffe_dsel7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_coef8           : " UH_FMT "\n", ptr_struct->dffe_coef8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dffe_dsel8           : " UH_FMT "\n", ptr_struct->dffe_dsel8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th0                  : " UH_FMT "\n", ptr_struct->th0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th1                  : " UH_FMT "\n", ptr_struct->th1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th2                  : " UH_FMT "\n", ptr_struct->th2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th3                  : " UH_FMT "\n", ptr_struct->th3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th4                  : " UH_FMT "\n", ptr_struct->th4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th5                  : " UH_FMT "\n", ptr_struct->th5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th6                  : " UH_FMT "\n", ptr_struct->th6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th7                  : " UH_FMT "\n", ptr_struct->th7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th8                  : " UH_FMT "\n", ptr_struct->th8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th9                  : " UH_FMT "\n", ptr_struct->th9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th10                 : " UH_FMT "\n", ptr_struct->th10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th11                 : " UH_FMT "\n", ptr_struct->th11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th12                 : " UH_FMT "\n", ptr_struct->th12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th13                 : " UH_FMT "\n", ptr_struct->th13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th14                 : " UH_FMT "\n", ptr_struct->th14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th15                 : " UH_FMT "\n", ptr_struct->th15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th16                 : " UH_FMT "\n", ptr_struct->th16);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th17                 : " UH_FMT "\n", ptr_struct->th17);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th18                 : " UH_FMT "\n", ptr_struct->th18);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th19                 : " UH_FMT "\n", ptr_struct->th19);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th20                 : " UH_FMT "\n", ptr_struct->th20);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "th21                 : " UH_FMT "\n", ptr_struct->th21);

}

int slrip_7nm_size(void)
{
	return 88;
}

void slrip_7nm_dump(const struct slrip_7nm *ptr_struct, FILE *file)
{
	slrip_7nm_print(ptr_struct, file, 0);
}

void slrip_data_set_pack(const struct slrip_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 88; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 704, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void slrip_data_set_unpack(struct slrip_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 88; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 704, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slrip_data_set_print(const struct slrip_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 88; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int slrip_data_set_size(void)
{
	return 88;
}

void slrip_data_set_dump(const struct slrip_data_set *ptr_struct, FILE *file)
{
	slrip_data_set_print(ptr_struct, file, 0);
}

void slrp_16nm_pack(const struct slrp_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dp_sel);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sel_enc);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset_down);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset_up);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_eo);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_down);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_mid);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_out_mixer_biasgen_up);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_eo);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_down);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_mid);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_ref_in_mixer_biasgen_up);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn1_p);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn1_n);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn0_p);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->gctrl_bin_bgn0_n);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset_eye_scan);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_eo);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_down);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_mid);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sel_amp_mixer_biasgen_up);

	offset = 122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_2);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_1);

	offset = 114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_0);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->selgc_ref_op1_alev_ctle);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->selgc_ref_op0_alev_ctle);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sel_bias2ctle);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sel_digital_gctrl);

	offset = 153;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_2);

	offset = 149;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_1);

	offset = 145;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_0);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->sel_bias_en_6);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_5);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_4);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_bias_en_3);

	offset = 188;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_3);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_2);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_1);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_0);

	offset = 172;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_6);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_5);

	offset = 164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_4);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrln_en_3);

	offset = 219;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->crnt_bgn_offset_n0);

	offset = 214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->crnt_bgn_offset_p0);

	offset = 209;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->crnt_bgn_offset_n1);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->crnt_bgn_offset_p1);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_6);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_5);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sel_gctrlp_en_4);

}

void slrp_16nm_unpack(struct slrp_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->dp_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->sel_enc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->mixer_offset_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->mixer_offset_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 60;
	ptr_struct->sel_ref_out_mixer_biasgen_eo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->sel_ref_out_mixer_biasgen_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 52;
	ptr_struct->sel_ref_out_mixer_biasgen_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->sel_ref_out_mixer_biasgen_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 44;
	ptr_struct->sel_ref_in_mixer_biasgen_eo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->sel_ref_in_mixer_biasgen_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 36;
	ptr_struct->sel_ref_in_mixer_biasgen_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->sel_ref_in_mixer_biasgen_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 92;
	ptr_struct->gctrl_bin_bgn1_p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->gctrl_bin_bgn1_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 84;
	ptr_struct->gctrl_bin_bgn0_p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->gctrl_bin_bgn0_n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->mixer_offset_eye_scan = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 70;
	ptr_struct->sel_amp_mixer_biasgen_eo = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 68;
	ptr_struct->sel_amp_mixer_biasgen_down = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 66;
	ptr_struct->sel_amp_mixer_biasgen_mid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	ptr_struct->sel_amp_mixer_biasgen_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 122;
	ptr_struct->sel_bias_en_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 118;
	ptr_struct->sel_bias_en_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 114;
	ptr_struct->sel_bias_en_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 109;
	ptr_struct->selgc_ref_op1_alev_ctle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 104;
	ptr_struct->selgc_ref_op0_alev_ctle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 97;
	ptr_struct->sel_bias2ctle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 96;
	ptr_struct->sel_digital_gctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 153;
	ptr_struct->sel_gctrln_en_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 149;
	ptr_struct->sel_gctrln_en_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 145;
	ptr_struct->sel_gctrln_en_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 140;
	ptr_struct->sel_bias_en_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 136;
	ptr_struct->sel_bias_en_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 132;
	ptr_struct->sel_bias_en_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->sel_bias_en_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 188;
	ptr_struct->sel_gctrlp_en_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 184;
	ptr_struct->sel_gctrlp_en_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 180;
	ptr_struct->sel_gctrlp_en_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->sel_gctrlp_en_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 172;
	ptr_struct->sel_gctrln_en_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 168;
	ptr_struct->sel_gctrln_en_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 164;
	ptr_struct->sel_gctrln_en_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 160;
	ptr_struct->sel_gctrln_en_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 219;
	ptr_struct->crnt_bgn_offset_n0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 214;
	ptr_struct->crnt_bgn_offset_p0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 209;
	ptr_struct->crnt_bgn_offset_n1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 204;
	ptr_struct->crnt_bgn_offset_p1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 200;
	ptr_struct->sel_gctrlp_en_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 196;
	ptr_struct->sel_gctrlp_en_5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->sel_gctrlp_en_4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void slrp_16nm_print(const struct slrp_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_sel               : " UH_FMT "\n", ptr_struct->dp_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_enc              : " UH_FMT "\n", ptr_struct->sel_enc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_down    : " UH_FMT "\n", ptr_struct->mixer_offset_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_up      : " UH_FMT "\n", ptr_struct->mixer_offset_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_eo : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_eo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_down : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_mid : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_out_mixer_biasgen_up : " UH_FMT "\n", ptr_struct->sel_ref_out_mixer_biasgen_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_eo : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_eo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_down : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_mid : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_ref_in_mixer_biasgen_up : " UH_FMT "\n", ptr_struct->sel_ref_in_mixer_biasgen_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn1_p     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn1_p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn1_n     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn1_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn0_p     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn0_p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gctrl_bin_bgn0_n     : " UH_FMT "\n", ptr_struct->gctrl_bin_bgn0_n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_eye_scan : " UH_FMT "\n", ptr_struct->mixer_offset_eye_scan);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_eo : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_eo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_down : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_down);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_mid : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_mid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_amp_mixer_biasgen_up : " UH_FMT "\n", ptr_struct->sel_amp_mixer_biasgen_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_2        : " UH_FMT "\n", ptr_struct->sel_bias_en_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_1        : " UH_FMT "\n", ptr_struct->sel_bias_en_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_0        : " UH_FMT "\n", ptr_struct->sel_bias_en_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "selgc_ref_op1_alev_ctle : " UH_FMT "\n", ptr_struct->selgc_ref_op1_alev_ctle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "selgc_ref_op0_alev_ctle : " UH_FMT "\n", ptr_struct->selgc_ref_op0_alev_ctle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias2ctle        : " UH_FMT "\n", ptr_struct->sel_bias2ctle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_digital_gctrl    : " UH_FMT "\n", ptr_struct->sel_digital_gctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_2      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_1      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_0      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_6        : " UH_FMT "\n", ptr_struct->sel_bias_en_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_5        : " UH_FMT "\n", ptr_struct->sel_bias_en_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_4        : " UH_FMT "\n", ptr_struct->sel_bias_en_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_bias_en_3        : " UH_FMT "\n", ptr_struct->sel_bias_en_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_3      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_2      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_1      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_0      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_6      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_5      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_4      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrln_en_3      : " UH_FMT "\n", ptr_struct->sel_gctrln_en_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crnt_bgn_offset_n0   : " UH_FMT "\n", ptr_struct->crnt_bgn_offset_n0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crnt_bgn_offset_p0   : " UH_FMT "\n", ptr_struct->crnt_bgn_offset_p0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crnt_bgn_offset_n1   : " UH_FMT "\n", ptr_struct->crnt_bgn_offset_n1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crnt_bgn_offset_p1   : " UH_FMT "\n", ptr_struct->crnt_bgn_offset_p1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_6      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_5      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_gctrlp_en_4      : " UH_FMT "\n", ptr_struct->sel_gctrlp_en_4);

}

int slrp_16nm_size(void)
{
	return 28;
}

void slrp_16nm_dump(const struct slrp_16nm *ptr_struct, FILE *file)
{
	slrp_16nm_print(ptr_struct, file, 0);
}

void slrp_40nm_28nm_pack(const struct slrp_40nm_28nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mix90phase);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp90sel);

	offset = 19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dp_sel);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ib_sel);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap3);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap2);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap1);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap0);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap7);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap6);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap5);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap4);

	offset = 119;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->ffe_tap_en);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbias_tap_amp);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap8);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->slicer_offset0);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap_offset1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap_offset0);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset1);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset0);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_refn);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_refp);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_inn);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixerbgn_inp);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mixer_offset_cm1);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lctrl_input);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->slicer_gctrl);

	offset = 227;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ref_mixer_vreg);

	offset = 225;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sel_slicer_lctrl_l);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sel_slicer_lctrl_h);

	offset = 279;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->slicer_offset_cm);

	offset = 263;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->mixer_offset_cm0);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->common_mode);

}

void slrp_40nm_28nm_unpack(struct slrp_40nm_28nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->mix90phase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 20;
	ptr_struct->dp90sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 19;
	ptr_struct->dp_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->ib_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 56;
	ptr_struct->ffe_tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ffe_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->ffe_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->ffe_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->ffe_tap7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->ffe_tap6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->ffe_tap5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->ffe_tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 119;
	ptr_struct->ffe_tap_en = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 104;
	ptr_struct->mixerbias_tap_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->ffe_tap8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->slicer_offset0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->ffe_tap_offset1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->ffe_tap_offset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->mixer_offset1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->mixer_offset0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 216;
	ptr_struct->mixerbgn_refn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->mixerbgn_refp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->mixerbgn_inn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->mixerbgn_inp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 248;
	ptr_struct->mixer_offset_cm1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 240;
	ptr_struct->lctrl_input = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->slicer_gctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 227;
	ptr_struct->ref_mixer_vreg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 225;
	ptr_struct->sel_slicer_lctrl_l = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 224;
	ptr_struct->sel_slicer_lctrl_h = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 279;
	ptr_struct->slicer_offset_cm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 263;
	ptr_struct->mixer_offset_cm0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset = 256;
	ptr_struct->common_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void slrp_40nm_28nm_print(const struct slrp_40nm_28nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_40nm_28nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mix90phase           : " UH_FMT "\n", ptr_struct->mix90phase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp90sel              : " UH_FMT "\n", ptr_struct->dp90sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_sel               : " UH_FMT "\n", ptr_struct->dp_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_sel               : " UH_FMT "\n", ptr_struct->ib_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap3             : " UH_FMT "\n", ptr_struct->ffe_tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap2             : " UH_FMT "\n", ptr_struct->ffe_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap1             : " UH_FMT "\n", ptr_struct->ffe_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap0             : " UH_FMT "\n", ptr_struct->ffe_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap7             : " UH_FMT "\n", ptr_struct->ffe_tap7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap6             : " UH_FMT "\n", ptr_struct->ffe_tap6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap5             : " UH_FMT "\n", ptr_struct->ffe_tap5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap4             : " UH_FMT "\n", ptr_struct->ffe_tap4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_en           : " UH_FMT "\n", ptr_struct->ffe_tap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbias_tap_amp    : " UH_FMT "\n", ptr_struct->mixerbias_tap_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap8             : " UH_FMT "\n", ptr_struct->ffe_tap8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_offset0       : " UH_FMT "\n", ptr_struct->slicer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_offset1      : " UH_FMT "\n", ptr_struct->ffe_tap_offset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_offset0      : " UH_FMT "\n", ptr_struct->ffe_tap_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset1        : " UH_FMT "\n", ptr_struct->mixer_offset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset0        : " UH_FMT "\n", ptr_struct->mixer_offset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_refn        : " UH_FMT "\n", ptr_struct->mixerbgn_refn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_refp        : " UH_FMT "\n", ptr_struct->mixerbgn_refp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_inn         : " UH_FMT "\n", ptr_struct->mixerbgn_inn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixerbgn_inp         : " UH_FMT "\n", ptr_struct->mixerbgn_inp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_cm1     : " UH_FMT "\n", ptr_struct->mixer_offset_cm1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lctrl_input          : " UH_FMT "\n", ptr_struct->lctrl_input);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_gctrl         : " UH_FMT "\n", ptr_struct->slicer_gctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_mixer_vreg       : " UH_FMT "\n", ptr_struct->ref_mixer_vreg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_slicer_lctrl_l   : " UH_FMT "\n", ptr_struct->sel_slicer_lctrl_l);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sel_slicer_lctrl_h   : " UH_FMT "\n", ptr_struct->sel_slicer_lctrl_h);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_offset_cm     : " UH_FMT "\n", ptr_struct->slicer_offset_cm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_cm0     : " UH_FMT "\n", ptr_struct->mixer_offset_cm0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_mode          : " UH_FMT "\n", ptr_struct->common_mode);

}

int slrp_40nm_28nm_size(void)
{
	return 36;
}

void slrp_40nm_28nm_dump(const struct slrp_40nm_28nm *ptr_struct, FILE *file)
{
	slrp_40nm_28nm_print(ptr_struct, file, 0);
}

void slrp_5nm_pack(const struct slrp_5nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ctle_vos_aux);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ctle_vos_stg1);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ctle_vos_val);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->coarse_val);

	offset = 53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->fine_val);

	offset = 49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fixed_val);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_recording_status);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_recording_admin);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(88, 8, i, 1184, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tah_vos[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(216, 8, i, 1184, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->adc_vos[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 1184, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->adc_gos[i]);
	}

}

void slrp_5nm_unpack(struct slrp_5nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->ctle_vos_aux = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 16;
	ptr_struct->ctle_vos_stg1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 7;
	ptr_struct->ctle_vos_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 59;
	ptr_struct->coarse_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 53;
	ptr_struct->fine_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 49;
	ptr_struct->fixed_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 38;
	ptr_struct->adc_recording_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 34;
	ptr_struct->adc_recording_admin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(88, 8, i, 1184, 1);
	ptr_struct->tah_vos[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(216, 8, i, 1184, 1);
	ptr_struct->adc_vos[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 1184, 1);
	ptr_struct->adc_gos[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slrp_5nm_print(const struct slrp_5nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_5nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_vos_aux         : " UH_FMT "\n", ptr_struct->ctle_vos_aux);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_vos_stg1        : " UH_FMT "\n", ptr_struct->ctle_vos_stg1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_vos_val         : " UH_FMT "\n", ptr_struct->ctle_vos_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "coarse_val           : " UH_FMT "\n", ptr_struct->coarse_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fine_val             : " UH_FMT "\n", ptr_struct->fine_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fixed_val            : " UH_FMT "\n", ptr_struct->fixed_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_recording_status : " UH_FMT "\n", ptr_struct->adc_recording_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_recording_admin  : " UH_FMT "\n", ptr_struct->adc_recording_admin);

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tah_vos_%03d         : " UH_FMT "\n", i, ptr_struct->tah_vos[i]);
	}

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_vos_%03d         : " UH_FMT "\n", i, ptr_struct->adc_vos[i]);
	}

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_gos_%03d         : " UH_FMT "\n", i, ptr_struct->adc_gos[i]);
	}

}

int slrp_5nm_size(void)
{
	return 148;
}

void slrp_5nm_dump(const struct slrp_5nm *ptr_struct, FILE *file)
{
	slrp_5nm_print(ptr_struct, file, 0);
}

void slrp_7nm_pack(const struct slrp_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ccal_mode);

	offset = 23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adc_gain_shift_auto);

	offset = 22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->edge_vos_ccal_en);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_rocording_lanes);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_recording_status);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_recording_admin);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ccal_op);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ccal_state);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cal_error_cnt);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->phos_override_ctrl);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_gain_override_ctrl);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->adc_vos_override_ctrl);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->vga_override_ctrl);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ctle_override_ctrl);

	offset = 89;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ctle_vos0);

	offset = 82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->vga_vos0);

	offset = 74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->vga_vos1);

	offset = 66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos);

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 1184, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->adc_vos[i]);
	}

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(632, 8, i, 1184, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->adc_gos[i]);
	}

	offset = 1147;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos0);

	offset = 1139;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos1);

	offset = 1131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos2);

	offset = 1123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos3);

	offset = 1179;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos4);

	offset = 1171;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos5);

	offset = 1163;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos6);

	offset = 1155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phos7);

}

void slrp_7nm_unpack(struct slrp_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->ccal_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 23;
	ptr_struct->adc_gain_shift_auto = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 22;
	ptr_struct->edge_vos_ccal_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 14;
	ptr_struct->adc_rocording_lanes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 6;
	ptr_struct->adc_recording_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 2;
	ptr_struct->adc_recording_admin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 62;
	ptr_struct->ccal_op = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 58;
	ptr_struct->ccal_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 48;
	ptr_struct->cal_error_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->phos_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 38;
	ptr_struct->adc_gain_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 36;
	ptr_struct->adc_vos_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 34;
	ptr_struct->vga_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 32;
	ptr_struct->ctle_override_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 89;
	ptr_struct->ctle_vos0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 82;
	ptr_struct->vga_vos0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 74;
	ptr_struct->vga_vos1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 66;
	ptr_struct->phos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 1184, 1);
	ptr_struct->adc_vos[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(632, 8, i, 1184, 1);
	ptr_struct->adc_gos[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	offset = 1147;
	ptr_struct->phos0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1139;
	ptr_struct->phos1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1131;
	ptr_struct->phos2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1123;
	ptr_struct->phos3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1179;
	ptr_struct->phos4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1171;
	ptr_struct->phos5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1163;
	ptr_struct->phos6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 1155;
	ptr_struct->phos7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void slrp_7nm_print(const struct slrp_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccal_mode            : " UH_FMT "\n", ptr_struct->ccal_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_gain_shift_auto  : " UH_FMT "\n", ptr_struct->adc_gain_shift_auto);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edge_vos_ccal_en     : " UH_FMT "\n", ptr_struct->edge_vos_ccal_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_rocording_lanes  : " UH_FMT "\n", ptr_struct->adc_rocording_lanes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_recording_status : " UH_FMT "\n", ptr_struct->adc_recording_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_recording_admin  : " UH_FMT "\n", ptr_struct->adc_recording_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccal_op              : %s (" UH_FMT ")\n", (ptr_struct->ccal_op == 0 ? ("OFF") : ((ptr_struct->ccal_op == 1 ? ("NOP") : ((ptr_struct->ccal_op == 2 ? ("INIT") : ((ptr_struct->ccal_op == 3 ? ("START") : ("unknown")))))))), ptr_struct->ccal_op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccal_state           : %s (" UH_FMT ")\n", (ptr_struct->ccal_state == 0 ? ("IDLE") : ((ptr_struct->ccal_state == 1 ? ("START") : ((ptr_struct->ccal_state == 2 ? ("ON") : ((ptr_struct->ccal_state == 3 ? ("ABORT") : ("unknown")))))))), ptr_struct->ccal_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_error_cnt        : " UH_FMT "\n", ptr_struct->cal_error_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos_override_ctrl   : " UH_FMT "\n", ptr_struct->phos_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_gain_override_ctrl : " UH_FMT "\n", ptr_struct->adc_gain_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_vos_override_ctrl : " UH_FMT "\n", ptr_struct->adc_vos_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vga_override_ctrl    : " UH_FMT "\n", ptr_struct->vga_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_override_ctrl   : " UH_FMT "\n", ptr_struct->ctle_override_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_vos0            : " UH_FMT "\n", ptr_struct->ctle_vos0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vga_vos0             : " UH_FMT "\n", ptr_struct->vga_vos0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vga_vos1             : " UH_FMT "\n", ptr_struct->vga_vos1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos                 : " UH_FMT "\n", ptr_struct->phos);

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_vos_%03d         : " UH_FMT "\n", i, ptr_struct->adc_vos[i]);
	}

	for (i = 0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adc_gos_%03d         : " UH_FMT "\n", i, ptr_struct->adc_gos[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos0                : " UH_FMT "\n", ptr_struct->phos0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos1                : " UH_FMT "\n", ptr_struct->phos1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos2                : " UH_FMT "\n", ptr_struct->phos2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos3                : " UH_FMT "\n", ptr_struct->phos3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos4                : " UH_FMT "\n", ptr_struct->phos4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos5                : " UH_FMT "\n", ptr_struct->phos5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos6                : " UH_FMT "\n", ptr_struct->phos6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phos7                : " UH_FMT "\n", ptr_struct->phos7);

}

int slrp_7nm_size(void)
{
	return 148;
}

void slrp_7nm_dump(const struct slrp_7nm *ptr_struct, FILE *file)
{
	slrp_7nm_print(ptr_struct, file, 0);
}

void slrp_data_set_pack(const struct slrp_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 148; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1184, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void slrp_data_set_unpack(struct slrp_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 148; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1184, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void slrp_data_set_print(const struct slrp_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 148; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int slrp_data_set_size(void)
{
	return 148;
}

void slrp_data_set_dump(const struct slrp_data_set *ptr_struct, FILE *file)
{
	slrp_data_set_print(ptr_struct, file, 0);
}

void sltp_16nm_pack(const struct sltp_16nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->post_tap);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->main_tap);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pre_tap);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pre_2_tap);

	offset = 91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ob_alev_out);

	offset = 81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ob_amp);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ob_m2lp);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ob_bad_stat);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->regp_bfm1n);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->regn_bfm1p);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->obnlev);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->obplev);

	offset = 186;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->alev_minus_bfm2);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->alev_plus_bfm2);

	offset = 175;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->tx_alev);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->blev);

}

void sltp_16nm_unpack(struct sltp_16nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	ptr_struct->post_tap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->main_tap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->pre_tap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->pre_2_tap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 91;
	ptr_struct->ob_alev_out = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 81;
	ptr_struct->ob_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 64;
	ptr_struct->ob_m2lp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 96;
	ptr_struct->ob_bad_stat = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 152;
	ptr_struct->regp_bfm1n = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->regn_bfm1p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->obnlev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->obplev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 186;
	ptr_struct->alev_minus_bfm2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 180;
	ptr_struct->alev_plus_bfm2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 175;
	ptr_struct->tx_alev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 160;
	ptr_struct->blev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void sltp_16nm_print(const struct sltp_16nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_16nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_tap             : " UH_FMT "\n", ptr_struct->post_tap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "main_tap             : " UH_FMT "\n", ptr_struct->main_tap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_tap              : " UH_FMT "\n", ptr_struct->pre_tap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_2_tap            : " UH_FMT "\n", ptr_struct->pre_2_tap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_alev_out          : " UH_FMT "\n", ptr_struct->ob_alev_out);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_amp               : " UH_FMT "\n", ptr_struct->ob_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_m2lp              : " UH_FMT "\n", ptr_struct->ob_m2lp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bad_stat          : %s (" UH_FMT ")\n", (ptr_struct->ob_bad_stat == 0 ? ("configuration_warning") : ((ptr_struct->ob_bad_stat == 11 ? ("Illegal_ob_combination") : ((ptr_struct->ob_bad_stat == 12 ? ("Illegal_ob_m2lp") : ((ptr_struct->ob_bad_stat == 13 ? ("Illegal_ob_amp") : ((ptr_struct->ob_bad_stat == 14 ? ("Illegal_ob_alev_out") : ((ptr_struct->ob_bad_stat == 15 ? ("Illegal_taps") : ("unknown")))))))))))), ptr_struct->ob_bad_stat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "regp_bfm1n           : " UH_FMT "\n", ptr_struct->regp_bfm1n);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "regn_bfm1p           : " UH_FMT "\n", ptr_struct->regn_bfm1p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "obnlev               : " UH_FMT "\n", ptr_struct->obnlev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "obplev               : " UH_FMT "\n", ptr_struct->obplev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alev_minus_bfm2      : " UH_FMT "\n", ptr_struct->alev_minus_bfm2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alev_plus_bfm2       : " UH_FMT "\n", ptr_struct->alev_plus_bfm2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_alev              : " UH_FMT "\n", ptr_struct->tx_alev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "blev                 : " UH_FMT "\n", ptr_struct->blev);

}

int sltp_16nm_size(void)
{
	return 24;
}

void sltp_16nm_dump(const struct sltp_16nm *ptr_struct, FILE *file)
{
	sltp_16nm_print(ptr_struct, file, 0);
}

void sltp_28nm_40nm_pack(const struct sltp_28nm_40nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_tap2);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_tap1);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_tap0);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->polarity);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_bias);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_reg);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ob_preemp_mode);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ob_leva);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ob_bad_stat);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ob_norm);

}

void sltp_28nm_40nm_unpack(struct sltp_28nm_40nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	ptr_struct->ob_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->ob_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->ob_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 39;
	ptr_struct->polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 88;
	ptr_struct->ob_bias = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->ob_reg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 76;
	ptr_struct->ob_preemp_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->ob_leva = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 97;
	ptr_struct->ob_bad_stat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 96;
	ptr_struct->ob_norm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void sltp_28nm_40nm_print(const struct sltp_28nm_40nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_28nm_40nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_tap2              : " UH_FMT "\n", ptr_struct->ob_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_tap1              : " UH_FMT "\n", ptr_struct->ob_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_tap0              : " UH_FMT "\n", ptr_struct->ob_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "polarity             : " UH_FMT "\n", ptr_struct->polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bias              : " UH_FMT "\n", ptr_struct->ob_bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_reg               : " UH_FMT "\n", ptr_struct->ob_reg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_preemp_mode       : " UH_FMT "\n", ptr_struct->ob_preemp_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_leva              : " UH_FMT "\n", ptr_struct->ob_leva);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bad_stat          : " UH_FMT "\n", ptr_struct->ob_bad_stat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_norm              : " UH_FMT "\n", ptr_struct->ob_norm);

}

int sltp_28nm_40nm_size(void)
{
	return 16;
}

void sltp_28nm_40nm_dump(const struct sltp_28nm_40nm *ptr_struct, FILE *file)
{
	sltp_28nm_40nm_print(ptr_struct, file, 0);
}

void sltp_5nm_pack(const struct sltp_5nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ob_bad_stat);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap0);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap1);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap3);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap4);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap5);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap6);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap7);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap8);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap9);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap10);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tap11);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lower_eye_amp);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->middle_eye_amp);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->upper_eye_amp);

}

void sltp_5nm_unpack(struct sltp_5nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->ob_bad_stat = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 56;
	ptr_struct->tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->tap5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->tap6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->tap7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->tap8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->tap9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->tap10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->tap11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->lower_eye_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->middle_eye_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->upper_eye_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void sltp_5nm_print(const struct sltp_5nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_5nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bad_stat          : %s (" UH_FMT ")\n", (ptr_struct->ob_bad_stat == 1 ? ("tap0_is_out_of_range") : ((ptr_struct->ob_bad_stat == 2 ? ("tap1_is_out_of_range") : ((ptr_struct->ob_bad_stat == 4 ? ("tap2_is_out_of_range") : ((ptr_struct->ob_bad_stat == 8 ? ("tap3_is_out_of_range") : ((ptr_struct->ob_bad_stat == 16 ? ("tap4_is_out_of_range") : ((ptr_struct->ob_bad_stat == 32 ? ("tap5_is_out_of_range") : ((ptr_struct->ob_bad_stat == 64 ? ("tap6_is_out_of_range") : ((ptr_struct->ob_bad_stat == 128 ? ("tap7_is_out_of_range") : ((ptr_struct->ob_bad_stat == 256 ? ("tap8_is_out_of_range") : ((ptr_struct->ob_bad_stat == 512 ? ("tap9_is_out_of_range") : ((ptr_struct->ob_bad_stat == 1024 ? ("tap10_is_out_of_range") : ((ptr_struct->ob_bad_stat == 2048 ? ("tap11_is_out_of_range") : ((ptr_struct->ob_bad_stat == 512 ? ("sum_of_taps_is_out_of_range") : ((ptr_struct->ob_bad_stat == 1024 ? ("taps_not_alinged_with_speed") : ((ptr_struct->ob_bad_stat == 2048 ? ("upper_eye_amp_is_out_of_range") : ((ptr_struct->ob_bad_stat == 4096 ? ("midle_eye_amp_is_out_of_range") : ((ptr_struct->ob_bad_stat == 8192 ? ("lower_eye_amp_is_out_of_range") : ((ptr_struct->ob_bad_stat == 16384 ? ("sum_of_eye_amplitudes_is_out_of_range") : ("unknown")))))))))))))))))))))))))))))))))))), ptr_struct->ob_bad_stat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap0                 : " UH_FMT "\n", ptr_struct->tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap1                 : " UH_FMT "\n", ptr_struct->tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap2                 : " UH_FMT "\n", ptr_struct->tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap3                 : " UH_FMT "\n", ptr_struct->tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap4                 : " UH_FMT "\n", ptr_struct->tap4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap5                 : " UH_FMT "\n", ptr_struct->tap5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap6                 : " UH_FMT "\n", ptr_struct->tap6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap7                 : " UH_FMT "\n", ptr_struct->tap7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap8                 : " UH_FMT "\n", ptr_struct->tap8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap9                 : " UH_FMT "\n", ptr_struct->tap9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap10                : " UH_FMT "\n", ptr_struct->tap10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tap11                : " UH_FMT "\n", ptr_struct->tap11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lower_eye_amp        : " UH_FMT "\n", ptr_struct->lower_eye_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "middle_eye_amp       : " UH_FMT "\n", ptr_struct->middle_eye_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upper_eye_amp        : " UH_FMT "\n", ptr_struct->upper_eye_amp);

}

int sltp_5nm_size(void)
{
	return 72;
}

void sltp_5nm_dump(const struct sltp_5nm *ptr_struct, FILE *file)
{
	sltp_5nm_print(ptr_struct, file, 0);
}

void sltp_7nm_pack(const struct sltp_7nm *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fir_pre2);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fir_pre3);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ob_bad_stat);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->drv_amp);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->vs_peer_db);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fir_post1);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fir_main);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fir_pre1);

}

void sltp_7nm_unpack(struct sltp_7nm *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->fir_pre2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->fir_pre3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->ob_bad_stat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->drv_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 0;
	ptr_struct->vs_peer_db = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 48;
	ptr_struct->fir_post1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->fir_main = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->fir_pre1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void sltp_7nm_print(const struct sltp_7nm *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_7nm ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fir_pre2             : " UH_FMT "\n", ptr_struct->fir_pre2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fir_pre3             : " UH_FMT "\n", ptr_struct->fir_pre3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bad_stat          : %s (" UH_FMT ")\n", (ptr_struct->ob_bad_stat == 1 ? ("pre3_is_out_of_range") : ((ptr_struct->ob_bad_stat == 2 ? ("pre2_is_out_of_range") : ((ptr_struct->ob_bad_stat == 4 ? ("pre1_is_out_of_range") : ((ptr_struct->ob_bad_stat == 8 ? ("main_tap_is_out_of_range") : ((ptr_struct->ob_bad_stat == 16 ? ("post1_is_out_of_range") : ((ptr_struct->ob_bad_stat == 32 ? ("sum_of_taps_is_out_of_range") : ((ptr_struct->ob_bad_stat == 64 ? ("taps_not_alinged_with_speed") : ("unknown")))))))))))))), ptr_struct->ob_bad_stat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drv_amp              : " UH_FMT "\n", ptr_struct->drv_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vs_peer_db           : " UH_FMT "\n", ptr_struct->vs_peer_db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fir_post1            : " UH_FMT "\n", ptr_struct->fir_post1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fir_main             : " UH_FMT "\n", ptr_struct->fir_main);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fir_pre1             : " UH_FMT "\n", ptr_struct->fir_pre1);

}

int sltp_7nm_size(void)
{
	return 24;
}

void sltp_7nm_dump(const struct sltp_7nm *ptr_struct, FILE *file)
{
	sltp_7nm_print(ptr_struct, file, 0);
}

void sltp_data_set_pack(const struct sltp_data_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 72; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 576, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data[i]);
	}

}

void sltp_data_set_unpack(struct sltp_data_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 72; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 576, 1);
	ptr_struct->data[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void sltp_data_set_print(const struct sltp_data_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_data_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 72; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : " UH_FMT "\n", i, ptr_struct->data[i]);
	}

}

int sltp_data_set_size(void)
{
	return 72;
}

void sltp_data_set_dump(const struct sltp_data_set *ptr_struct, FILE *file)
{
	sltp_data_set_print(ptr_struct, file, 0);
}

void ctle_calib_set_pack(const struct ctle_calib_set *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_n0);

	offset = 19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_p0);

	offset = 11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_n1);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->bgn_offset_p1);

}

void ctle_calib_set_unpack(struct ctle_calib_set *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	ptr_struct->bgn_offset_n0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 19;
	ptr_struct->bgn_offset_p0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 11;
	ptr_struct->bgn_offset_n1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 3;
	ptr_struct->bgn_offset_p1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void ctle_calib_set_print(const struct ctle_calib_set *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ctle_calib_set ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_n0        : " UH_FMT "\n", ptr_struct->bgn_offset_n0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_p0        : " UH_FMT "\n", ptr_struct->bgn_offset_p0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_n1        : " UH_FMT "\n", ptr_struct->bgn_offset_n1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bgn_offset_p1        : " UH_FMT "\n", ptr_struct->bgn_offset_p1);

}

int ctle_calib_set_size(void)
{
	return 4;
}

void ctle_calib_set_dump(const struct ctle_calib_set *ptr_struct, FILE *file)
{
	ctle_calib_set_print(ptr_struct, file, 0);
}

void int64bit_pack(const struct int64bit *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->High);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Low);

}

void int64bit_unpack(struct int64bit *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->High = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->Low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void int64bit_print(const struct int64bit *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== int64bit ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "High                 : " U32H_FMT "\n", ptr_struct->High);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Low                  : " U32H_FMT "\n", ptr_struct->Low);

}

int int64bit_size(void)
{
	return 8;
}

void int64bit_dump(const struct int64bit *ptr_struct, FILE *file)
{
	int64bit_print(ptr_struct, file, 0);
}

void mpcnt_reg_counter_set_auto_pack(const union mpcnt_reg_counter_set_auto *ptr_struct, u_int8_t *ptr_buff)
{
	mpcnt_RAW_page_data_pack(&(ptr_struct->raw), ptr_buff);
}

void mpcnt_reg_counter_set_auto_unpack(union mpcnt_reg_counter_set_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	mpcnt_RAW_page_data_unpack(&(ptr_struct->raw), ptr_buff);
}

void mpcnt_reg_counter_set_auto_print(const union mpcnt_reg_counter_set_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpcnt_reg_counter_set_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_perf_counters:\n");
	pcie_perf_counters_print(&(ptr_struct->pcie_perf_counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_lanes_counters:\n");
	pcie_lanes_counters_print(&(ptr_struct->pcie_lanes_counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_timers_states:\n");
	pcie_timers_states_print(&(ptr_struct->pcie_timers_states), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_physical_layer:\n");
	pcie_physical_layer_print(&(ptr_struct->pcie_physical_layer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw:\n");
	mpcnt_RAW_page_data_print(&(ptr_struct->raw), file, indent_level + 1);

}

int mpcnt_reg_counter_set_auto_size(void)
{
	return 96;
}

void mpcnt_reg_counter_set_auto_dump(const union mpcnt_reg_counter_set_auto *ptr_struct, FILE *file)
{
	mpcnt_reg_counter_set_auto_print(ptr_struct, file, 0);
}

void pddr_reg_page_data_auto_pack(const union pddr_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pddr_RAW_page_data_pack(&(ptr_struct->raw), ptr_buff);
}

void pddr_reg_page_data_auto_unpack(union pddr_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pddr_RAW_page_data_unpack(&(ptr_struct->raw), ptr_buff);
}

void pddr_reg_page_data_auto_print(const union pddr_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_operation_info_page:\n");
	pddr_operation_info_page_print(&(ptr_struct->pddr_operation_info_page), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_troubleshooting_page:\n");
	pddr_troubleshooting_page_print(&(ptr_struct->pddr_troubleshooting_page), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_phy_info_page:\n");
	pddr_phy_info_page_print(&(ptr_struct->pddr_phy_info_page), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_module_info:\n");
	pddr_module_info_print(&(ptr_struct->pddr_module_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_link_down_info_page:\n");
	pddr_link_down_info_page_print(&(ptr_struct->pddr_link_down_info_page), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_link_up_info_page:\n");
	pddr_link_up_info_page_print(&(ptr_struct->pddr_link_up_info_page), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_latched_flag_info:\n");
	module_latched_flag_info_print(&(ptr_struct->module_latched_flag_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw:\n");
	pddr_RAW_page_data_print(&(ptr_struct->raw), file, indent_level + 1);

}

int pddr_reg_page_data_auto_size(void)
{
	return 248;
}

void pddr_reg_page_data_auto_dump(const union pddr_reg_page_data_auto *ptr_struct, FILE *file)
{
	pddr_reg_page_data_auto_print(ptr_struct, file, 0);
}

void pemi_page_data_auto_pack(const union pemi_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	pemi_RAW_page_data_pack(&(ptr_struct->raw), ptr_buff);
}

void pemi_page_data_auto_unpack(union pemi_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	pemi_RAW_page_data_unpack(&(ptr_struct->raw), ptr_buff);
}

void pemi_page_data_auto_print(const union pemi_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_Module_Status_Samples:\n");
	pemi_Module_Status_Samples_print(&(ptr_struct->pemi_Module_Status_Samples), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_SNR_Samples:\n");
	pemi_SNR_Samples_print(&(ptr_struct->pemi_SNR_Samples), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_Laser_Monitors_Samples:\n");
	pemi_Laser_Monitors_Samples_print(&(ptr_struct->pemi_Laser_Monitors_Samples), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_PAM4_Level_Transition_Samples:\n");
	pemi_PAM4_Level_Transition_Samples_print(&(ptr_struct->pemi_PAM4_Level_Transition_Samples), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_Pre_FEC_BER_Samples:\n");
	pemi_Pre_FEC_BER_Samples_print(&(ptr_struct->pemi_Pre_FEC_BER_Samples), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_FERC_Samples:\n");
	pemi_FERC_Samples_print(&(ptr_struct->pemi_FERC_Samples), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_Module_Status_Properties:\n");
	pemi_Module_Status_Properties_print(&(ptr_struct->pemi_Module_Status_Properties), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_SNR_Properties:\n");
	pemi_SNR_Properties_print(&(ptr_struct->pemi_SNR_Properties), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_Laser_Monitors_Properties:\n");
	pemi_Laser_Monitors_Properties_print(&(ptr_struct->pemi_Laser_Monitors_Properties), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_PAM4_Level_Transition_Properties:\n");
	pemi_PAM4_Level_Transition_Properties_print(&(ptr_struct->pemi_PAM4_Level_Transition_Properties), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_Pre_FEC_BER_Properties:\n");
	pemi_Pre_FEC_BER_Properties_print(&(ptr_struct->pemi_Pre_FEC_BER_Properties), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_FERC_Properties:\n");
	pemi_FERC_Properties_print(&(ptr_struct->pemi_FERC_Properties), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw:\n");
	pemi_RAW_page_data_print(&(ptr_struct->raw), file, indent_level + 1);

}

int pemi_page_data_auto_size(void)
{
	return 204;
}

void pemi_page_data_auto_dump(const union pemi_page_data_auto *ptr_struct, FILE *file)
{
	pemi_page_data_auto_print(ptr_struct, file, 0);
}

void peucg_page_data_pack(const struct peucg_page_data *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->address);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rxtx);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->payload_data);

}

void peucg_page_data_unpack(struct peucg_page_data *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 22;
	ptr_struct->address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 16;
	ptr_struct->rxtx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->payload_data = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void peucg_page_data_print(const struct peucg_page_data *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== peucg_page_data ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : " UH_FMT "\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rxtx                 : " UH_FMT "\n", ptr_struct->rxtx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_data         : " UH_FMT "\n", ptr_struct->payload_data);

}

int peucg_page_data_size(void)
{
	return 4;
}

void peucg_page_data_dump(const struct peucg_page_data *ptr_struct, FILE *file)
{
	peucg_page_data_print(ptr_struct, file, 0);
}

void ppbmp_monitor_parameters_pack(const struct ppbmp_monitor_parameters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->warning_th_exp);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->warning_th_mantissa);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->alarm_th_exp);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->alarm_th_mantissa);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->normal_th_exp);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->normal_th_mantissa);

}

void ppbmp_monitor_parameters_unpack(struct ppbmp_monitor_parameters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->warning_th_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 20;
	ptr_struct->warning_th_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->alarm_th_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->alarm_th_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->normal_th_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 36;
	ptr_struct->normal_th_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void ppbmp_monitor_parameters_print(const struct ppbmp_monitor_parameters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppbmp_monitor_parameters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "warning_th_exp       : " UH_FMT "\n", ptr_struct->warning_th_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "warning_th_mantissa  : " UH_FMT "\n", ptr_struct->warning_th_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alarm_th_exp         : " UH_FMT "\n", ptr_struct->alarm_th_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alarm_th_mantissa    : " UH_FMT "\n", ptr_struct->alarm_th_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "normal_th_exp        : " UH_FMT "\n", ptr_struct->normal_th_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "normal_th_mantissa   : " UH_FMT "\n", ptr_struct->normal_th_mantissa);

}

int ppbmp_monitor_parameters_size(void)
{
	return 8;
}

void ppbmp_monitor_parameters_dump(const struct ppbmp_monitor_parameters *ptr_struct, FILE *file)
{
	ppbmp_monitor_parameters_print(ptr_struct, file, 0);
}

void ppcnt_reg_counter_set_auto_pack(const union ppcnt_reg_counter_set_auto *ptr_struct, u_int8_t *ptr_buff)
{
	ppcnt_infiniband_vl_counter_pack(&(ptr_struct->ppcnt_infiniband_vl_counter), ptr_buff);
}

void ppcnt_reg_counter_set_auto_unpack(union ppcnt_reg_counter_set_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	ppcnt_infiniband_vl_counter_unpack(&(ptr_struct->ppcnt_infiniband_vl_counter), ptr_buff);
}

void ppcnt_reg_counter_set_auto_print(const union ppcnt_reg_counter_set_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_reg_counter_set_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phys_layer_cntrs:\n");
	phys_layer_cntrs_print(&(ptr_struct->phys_layer_cntrs), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_plr_counters:\n");
	ppcnt_plr_counters_print(&(ptr_struct->ppcnt_plr_counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_rs_fec_histograms_counters:\n");
	ppcnt_rs_fec_histograms_counters_print(&(ptr_struct->ppcnt_rs_fec_histograms_counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_infiniband_general_counter:\n");
	ppcnt_infiniband_general_counter_print(&(ptr_struct->ppcnt_infiniband_general_counter), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_infiniband_packet_histograms:\n");
	ppcnt_infiniband_packet_histograms_print(&(ptr_struct->ppcnt_infiniband_packet_histograms), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_packet_type_counter:\n");
	ppcnt_packet_type_counter_print(&(ptr_struct->ppcnt_packet_type_counter), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_infiniband_vl_counter:\n");
	ppcnt_infiniband_vl_counter_print(&(ptr_struct->ppcnt_infiniband_vl_counter), file, indent_level + 1);

}

int ppcnt_reg_counter_set_auto_size(void)
{
	return 248;
}

void ppcnt_reg_counter_set_auto_dump(const union ppcnt_reg_counter_set_auto *ptr_struct, FILE *file)
{
	ppcnt_reg_counter_set_auto_print(ptr_struct, file, 0);
}

void pphcr_bin_range_pack(const struct pphcr_bin_range *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->low_val);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->high_val);

}

void pphcr_bin_range_unpack(struct pphcr_bin_range *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->low_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 12;
	ptr_struct->high_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void pphcr_bin_range_print(const struct pphcr_bin_range *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pphcr_bin_range ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "low_val              : " UH_FMT "\n", ptr_struct->low_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "high_val             : " UH_FMT "\n", ptr_struct->high_val);

}

int pphcr_bin_range_size(void)
{
	return 4;
}

void pphcr_bin_range_dump(const struct pphcr_bin_range *ptr_struct, FILE *file)
{
	pphcr_bin_range_print(ptr_struct, file, 0);
}

void ppll_reg_page_data_auto_pack(const union ppll_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	ppll_data_set_pack(&(ptr_struct->ppll_data_set), ptr_buff);
}

void ppll_reg_page_data_auto_unpack(union ppll_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	ppll_data_set_unpack(&(ptr_struct->ppll_data_set), ptr_buff);
}

void ppll_reg_page_data_auto_print(const union ppll_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_28nm:\n");
	ppll_28nm_print(&(ptr_struct->ppll_28nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_reg_16nm:\n");
	ppll_reg_16nm_print(&(ptr_struct->ppll_reg_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_reg_7nm:\n");
	ppll_reg_7nm_print(&(ptr_struct->ppll_reg_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_reg_5nm:\n");
	ppll_reg_5nm_print(&(ptr_struct->ppll_reg_5nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_data_set:\n");
	ppll_data_set_print(&(ptr_struct->ppll_data_set), file, indent_level + 1);

}

int ppll_reg_page_data_auto_size(void)
{
	return 36;
}

void ppll_reg_page_data_auto_dump(const union ppll_reg_page_data_auto *ptr_struct, FILE *file)
{
	ppll_reg_page_data_auto_print(ptr_struct, file, 0);
}

void psu_status_pack(const struct psu_status *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ac_status);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_status);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->alert);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->present);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fan);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->temp);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->power_consumption);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->power_cap);

	offset = 127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->snp);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 640, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->serial_number[i]);
	}

}

void psu_status_unpack(struct psu_status *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->ac_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 26;
	ptr_struct->dc_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 6;
	ptr_struct->alert = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->present = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 62;
	ptr_struct->fan = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 58;
	ptr_struct->temp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 80;
	ptr_struct->power_consumption = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->power_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 127;
	ptr_struct->snp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 640, 1);
	ptr_struct->serial_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->serial_number[24] = '\0';
}

void psu_status_print(const struct psu_status *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== psu_status ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ac_status            : " UH_FMT "\n", ptr_struct->ac_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_status            : " UH_FMT "\n", ptr_struct->dc_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alert                : " UH_FMT "\n", ptr_struct->alert);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "present              : " UH_FMT "\n", ptr_struct->present);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan                  : " UH_FMT "\n", ptr_struct->fan);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp                 : " UH_FMT "\n", ptr_struct->temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power_consumption    : " UH_FMT "\n", ptr_struct->power_consumption);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power_cap            : " UH_FMT "\n", ptr_struct->power_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "snp                  : " UH_FMT "\n", ptr_struct->snp);

	fprintf(file, "serial_number        : \"%s\"\n", ptr_struct->serial_number);
}

int psu_status_size(void)
{
	return 80;
}

void psu_status_dump(const struct psu_status *ptr_struct, FILE *file)
{
	psu_status_print(ptr_struct, file, 0);
}

void ref_clock_stat_db_pack(const struct ref_clock_stat_db *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->measured_freq);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->min_freq);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->max_freq);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_delta_freq);

}

void ref_clock_stat_db_unpack(struct ref_clock_stat_db *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 8;
	ptr_struct->measured_freq = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 40;
	ptr_struct->min_freq = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 72;
	ptr_struct->max_freq = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 64;
	ptr_struct->max_delta_freq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void ref_clock_stat_db_print(const struct ref_clock_stat_db *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ref_clock_stat_db ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measured_freq        : " UH_FMT "\n", ptr_struct->measured_freq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_freq             : " UH_FMT "\n", ptr_struct->min_freq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_freq             : " UH_FMT "\n", ptr_struct->max_freq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_delta_freq       : " UH_FMT "\n", ptr_struct->max_delta_freq);

}

int ref_clock_stat_db_size(void)
{
	return 12;
}

void ref_clock_stat_db_dump(const struct ref_clock_stat_db *ptr_struct, FILE *file)
{
	ref_clock_stat_db_print(ptr_struct, file, 0);
}

void sllm_reg_page_data_auto_pack(const union sllm_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	sllm_data_set_pack(&(ptr_struct->sllm_data_set), ptr_buff);
}

void sllm_reg_page_data_auto_unpack(union sllm_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	sllm_data_set_unpack(&(ptr_struct->sllm_data_set), ptr_buff);
}

void sllm_reg_page_data_auto_print(const union sllm_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sllm_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sllm_16nm:\n");
	sllm_16nm_print(&(ptr_struct->sllm_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sllm_usr:\n");
	sllm_usr_print(&(ptr_struct->sllm_usr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sllm_7nm:\n");
	sllm_7nm_print(&(ptr_struct->sllm_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sllm_data_set:\n");
	sllm_data_set_print(&(ptr_struct->sllm_data_set), file, indent_level + 1);

}

int sllm_reg_page_data_auto_size(void)
{
	return 44;
}

void sllm_reg_page_data_auto_dump(const union sllm_reg_page_data_auto *ptr_struct, FILE *file)
{
	sllm_reg_page_data_auto_print(ptr_struct, file, 0);
}

void slreg_reg_page_data_auto_pack(const union slreg_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	slreg_data_set_pack(&(ptr_struct->slreg_data_set), ptr_buff);
}

void slreg_reg_page_data_auto_unpack(union slreg_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	slreg_data_set_unpack(&(ptr_struct->slreg_data_set), ptr_buff);
}

void slreg_reg_page_data_auto_print(const union slreg_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slreg_16nm:\n");
	slreg_16nm_print(&(ptr_struct->slreg_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slreg_usr:\n");
	slreg_usr_print(&(ptr_struct->slreg_usr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slreg_7nm:\n");
	slreg_7nm_print(&(ptr_struct->slreg_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slreg_data_set:\n");
	slreg_data_set_print(&(ptr_struct->slreg_data_set), file, indent_level + 1);

}

int slreg_reg_page_data_auto_size(void)
{
	return 72;
}

void slreg_reg_page_data_auto_dump(const union slreg_reg_page_data_auto *ptr_struct, FILE *file)
{
	slreg_reg_page_data_auto_print(ptr_struct, file, 0);
}

void slrg_reg_page_data_auto_pack(const union slrg_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	slrg_data_set_pack(&(ptr_struct->slrg_data_set), ptr_buff);
}

void slrg_reg_page_data_auto_unpack(union slrg_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	slrg_data_set_unpack(&(ptr_struct->slrg_data_set), ptr_buff);
}

void slrg_reg_page_data_auto_print(const union slrg_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_40nm_28nm:\n");
	slrg_40nm_28nm_print(&(ptr_struct->slrg_40nm_28nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_16nm:\n");
	slrg_16nm_print(&(ptr_struct->slrg_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_7nm:\n");
	slrg_7nm_print(&(ptr_struct->slrg_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_5nm:\n");
	slrg_5nm_print(&(ptr_struct->slrg_5nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_data_set:\n");
	slrg_data_set_print(&(ptr_struct->slrg_data_set), file, indent_level + 1);

}

int slrg_reg_page_data_auto_size(void)
{
	return 164;
}

void slrg_reg_page_data_auto_dump(const union slrg_reg_page_data_auto *ptr_struct, FILE *file)
{
	slrg_reg_page_data_auto_print(ptr_struct, file, 0);
}

void slrip_reg_page_data_auto_pack(const union slrip_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	slrip_data_set_pack(&(ptr_struct->slrip_data_set), ptr_buff);
}

void slrip_reg_page_data_auto_unpack(union slrip_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	slrip_data_set_unpack(&(ptr_struct->slrip_data_set), ptr_buff);
}

void slrip_reg_page_data_auto_print(const union slrip_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrip_16nm:\n");
	slrip_16nm_print(&(ptr_struct->slrip_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrip_7nm:\n");
	slrip_7nm_print(&(ptr_struct->slrip_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrip_5nm:\n");
	slrip_5nm_print(&(ptr_struct->slrip_5nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrip_data_set:\n");
	slrip_data_set_print(&(ptr_struct->slrip_data_set), file, indent_level + 1);

}

int slrip_reg_page_data_auto_size(void)
{
	return 88;
}

void slrip_reg_page_data_auto_dump(const union slrip_reg_page_data_auto *ptr_struct, FILE *file)
{
	slrip_reg_page_data_auto_print(ptr_struct, file, 0);
}

void slrp_reg_page_data_auto_pack(const union slrp_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	slrp_data_set_pack(&(ptr_struct->slrp_data_set), ptr_buff);
}

void slrp_reg_page_data_auto_unpack(union slrp_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	slrp_data_set_unpack(&(ptr_struct->slrp_data_set), ptr_buff);
}

void slrp_reg_page_data_auto_print(const union slrp_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_40nm_28nm:\n");
	slrp_40nm_28nm_print(&(ptr_struct->slrp_40nm_28nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_16nm:\n");
	slrp_16nm_print(&(ptr_struct->slrp_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_7nm:\n");
	slrp_7nm_print(&(ptr_struct->slrp_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_5nm:\n");
	slrp_5nm_print(&(ptr_struct->slrp_5nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_data_set:\n");
	slrp_data_set_print(&(ptr_struct->slrp_data_set), file, indent_level + 1);

}

int slrp_reg_page_data_auto_size(void)
{
	return 148;
}

void slrp_reg_page_data_auto_dump(const union slrp_reg_page_data_auto *ptr_struct, FILE *file)
{
	slrp_reg_page_data_auto_print(ptr_struct, file, 0);
}

void sltp_reg_page_data_auto_pack(const union sltp_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff)
{
	sltp_data_set_pack(&(ptr_struct->sltp_data_set), ptr_buff);
}

void sltp_reg_page_data_auto_unpack(union sltp_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff)
{
	sltp_data_set_unpack(&(ptr_struct->sltp_data_set), ptr_buff);
}

void sltp_reg_page_data_auto_print(const union sltp_reg_page_data_auto *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_reg_page_data_auto ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_28nm_40nm:\n");
	sltp_28nm_40nm_print(&(ptr_struct->sltp_28nm_40nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_16nm:\n");
	sltp_16nm_print(&(ptr_struct->sltp_16nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_7nm:\n");
	sltp_7nm_print(&(ptr_struct->sltp_7nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_5nm:\n");
	sltp_5nm_print(&(ptr_struct->sltp_5nm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_data_set:\n");
	sltp_data_set_print(&(ptr_struct->sltp_data_set), file, indent_level + 1);

}

int sltp_reg_page_data_auto_size(void)
{
	return 72;
}

void sltp_reg_page_data_auto_dump(const union sltp_reg_page_data_auto *ptr_struct, FILE *file)
{
	sltp_reg_page_data_auto_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_0_47_pack(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CDRTXRXLossIndicator);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->RevisionComplaince);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Identifier);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VoltageAlarmAndWarning);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TemperatureAlarmandWarning);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXRXLOLIndicator);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdaptiveEqualizationFault);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXBiasAlarmAndWarningHigh);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->RXPowerAlarmAndWarning);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->TXPowerAlarmAndWarning);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXBiasAlarmAndWarningLow);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagDeviceTemperature);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagSupplyVoltage);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX1Power);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX3Power);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX2Power);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX1Bias);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagRX4Power);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX3Bias);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX2Bias);

}

void CableInfo_Payload_Addr_0_47_unpack(struct CableInfo_Payload_Addr_0_47 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->CDRTXRXLossIndicator = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->RevisionComplaince = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->Identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->VoltageAlarmAndWarning = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->TemperatureAlarmandWarning = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->TXRXLOLIndicator = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->AdaptiveEqualizationFault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->TXBiasAlarmAndWarningHigh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->RXPowerAlarmAndWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->TXPowerAlarmAndWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->TXBiasAlarmAndWarningLow = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->DiagDeviceTemperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->DiagSupplyVoltage = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 272;
	ptr_struct->DiagRX1Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->DiagRX3Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->DiagRX2Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->DiagTX1Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->DiagRX4Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->DiagTX3Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->DiagTX2Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Addr_0_47_print(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_0_47 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CDRTXRXLossIndicator : " UH_FMT "\n", ptr_struct->CDRTXRXLossIndicator);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RevisionComplaince   : " UH_FMT "\n", ptr_struct->RevisionComplaince);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Identifier           : " UH_FMT "\n", ptr_struct->Identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VoltageAlarmAndWarning : " UH_FMT "\n", ptr_struct->VoltageAlarmAndWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TemperatureAlarmandWarning : " UH_FMT "\n", ptr_struct->TemperatureAlarmandWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXRXLOLIndicator     : " UH_FMT "\n", ptr_struct->TXRXLOLIndicator);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdaptiveEqualizationFault : " UH_FMT "\n", ptr_struct->AdaptiveEqualizationFault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXBiasAlarmAndWarningHigh : " UH_FMT "\n", ptr_struct->TXBiasAlarmAndWarningHigh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "RXPowerAlarmAndWarning : " UH_FMT "\n", ptr_struct->RXPowerAlarmAndWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXPowerAlarmAndWarning : " UH_FMT "\n", ptr_struct->TXPowerAlarmAndWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXBiasAlarmAndWarningLow : " UH_FMT "\n", ptr_struct->TXBiasAlarmAndWarningLow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagDeviceTemperature : " UH_FMT "\n", ptr_struct->DiagDeviceTemperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagSupplyVoltage    : " UH_FMT "\n", ptr_struct->DiagSupplyVoltage);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX1Power         : " UH_FMT "\n", ptr_struct->DiagRX1Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX3Power         : " UH_FMT "\n", ptr_struct->DiagRX3Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX2Power         : " UH_FMT "\n", ptr_struct->DiagRX2Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX1Bias          : " UH_FMT "\n", ptr_struct->DiagTX1Bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagRX4Power         : " UH_FMT "\n", ptr_struct->DiagRX4Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX3Bias          : " UH_FMT "\n", ptr_struct->DiagTX3Bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX2Bias          : " UH_FMT "\n", ptr_struct->DiagTX2Bias);

}

int CableInfo_Payload_Addr_0_47_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_0_47_dump(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_0_47_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_128_167_pack(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance0);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Connector);

	offset = 14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ExtPowerClass);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->CdrPresent);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PowerClass);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Identifier);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance4);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance3);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance2);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance1);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Encoding);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance7);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance6);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SpecCompliance5);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthOM3);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthSMFiber);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ExtendedRateSelect);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->BRNominal);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DeviceTech);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthCopperOrActive);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthOM1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LengthOM2);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorName[i]);
	}

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->VendorOUI);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ExtendedModuleCodes);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->NotUsed);

}

void CableInfo_Payload_Addr_128_167_unpack(struct CableInfo_Payload_Addr_128_167 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->SpecCompliance0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->Connector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 14;
	ptr_struct->ExtPowerClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 12;
	ptr_struct->CdrPresent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->PowerClass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 0;
	ptr_struct->Identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->SpecCompliance4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->SpecCompliance3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->SpecCompliance2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->SpecCompliance1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->Encoding = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->SpecCompliance7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->SpecCompliance6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->SpecCompliance5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->LengthOM3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->LengthSMFiber = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->ExtendedRateSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->BRNominal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->DeviceTech = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->LengthCopperOrActive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->LengthOM1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->LengthOM2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 384, 1);
	ptr_struct->VendorName[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorName[16] = '\0';
	offset = 296;
	ptr_struct->VendorOUI = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 288;
	ptr_struct->ExtendedModuleCodes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->NotUsed = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void CableInfo_Payload_Addr_128_167_print(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_128_167 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance0      : " UH_FMT "\n", ptr_struct->SpecCompliance0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Connector            : " UH_FMT "\n", ptr_struct->Connector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExtPowerClass        : " UH_FMT "\n", ptr_struct->ExtPowerClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CdrPresent           : " UH_FMT "\n", ptr_struct->CdrPresent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PowerClass           : " UH_FMT "\n", ptr_struct->PowerClass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Identifier           : " UH_FMT "\n", ptr_struct->Identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance4      : " UH_FMT "\n", ptr_struct->SpecCompliance4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance3      : " UH_FMT "\n", ptr_struct->SpecCompliance3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance2      : " UH_FMT "\n", ptr_struct->SpecCompliance2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance1      : " UH_FMT "\n", ptr_struct->SpecCompliance1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Encoding             : " UH_FMT "\n", ptr_struct->Encoding);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance7      : " UH_FMT "\n", ptr_struct->SpecCompliance7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance6      : " UH_FMT "\n", ptr_struct->SpecCompliance6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SpecCompliance5      : " UH_FMT "\n", ptr_struct->SpecCompliance5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthOM3            : " UH_FMT "\n", ptr_struct->LengthOM3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthSMFiber        : " UH_FMT "\n", ptr_struct->LengthSMFiber);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExtendedRateSelect   : " UH_FMT "\n", ptr_struct->ExtendedRateSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BRNominal            : " UH_FMT "\n", ptr_struct->BRNominal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DeviceTech           : " UH_FMT "\n", ptr_struct->DeviceTech);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthCopperOrActive : " UH_FMT "\n", ptr_struct->LengthCopperOrActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthOM1            : " UH_FMT "\n", ptr_struct->LengthOM1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LengthOM2            : " UH_FMT "\n", ptr_struct->LengthOM2);

	fprintf(file, "VendorName           : \"%s\"\n", ptr_struct->VendorName);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorOUI            : " UH_FMT "\n", ptr_struct->VendorOUI);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ExtendedModuleCodes  : " UH_FMT "\n", ptr_struct->ExtendedModuleCodes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NotUsed              : " U64H_FMT "\n", ptr_struct->NotUsed);

}

int CableInfo_Payload_Addr_128_167_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_128_167_dump(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_128_167_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_168_211_pack(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorPN[i]);
	}

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_5g);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_2_5g);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorRev[i]);
	}

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_12g);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Attenuation_7g);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->QSFPOptions);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->EthComCodesExt);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->VendorSN[i]);
	}

	offset = 352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->NotUsed);

}

void CableInfo_Payload_Addr_168_211_unpack(struct CableInfo_Payload_Addr_168_211 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	ptr_struct->VendorPN[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorPN[16] = '\0';
	offset = 152;
	ptr_struct->Attenuation_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->Attenuation_2_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 384, 1);
	ptr_struct->VendorRev[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorRev[2] = '\0';
	offset = 168;
	ptr_struct->Attenuation_12g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->Attenuation_7g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->QSFPOptions = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 192;
	ptr_struct->EthComCodesExt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 384, 1);
	ptr_struct->VendorSN[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->VendorSN[16] = '\0';
	offset = 352;
	ptr_struct->NotUsed = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CableInfo_Payload_Addr_168_211_print(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_168_211 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "VendorPN             : \"%s\"\n", ptr_struct->VendorPN);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_5g       : " UH_FMT "\n", ptr_struct->Attenuation_5g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_2_5g     : " UH_FMT "\n", ptr_struct->Attenuation_2_5g);

	fprintf(file, "VendorRev            : \"%s\"\n", ptr_struct->VendorRev);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_12g      : " UH_FMT "\n", ptr_struct->Attenuation_12g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Attenuation_7g       : " UH_FMT "\n", ptr_struct->Attenuation_7g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QSFPOptions          : " UH_FMT "\n", ptr_struct->QSFPOptions);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "EthComCodesExt       : " UH_FMT "\n", ptr_struct->EthComCodesExt);

	fprintf(file, "VendorSN             : \"%s\"\n", ptr_struct->VendorSN);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NotUsed              : " U32H_FMT "\n", ptr_struct->NotUsed);

}

int CableInfo_Payload_Addr_168_211_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_168_211_dump(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_168_211_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_212_255_pack(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DateCode[i]);
	}

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NominalBr_250);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->DDMIType);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MlnxSFGSN[i]);
	}

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MlnxVendorByte);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->MlnxRevision);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MellanoxCap);

}

void CableInfo_Payload_Addr_212_255_unpack(struct CableInfo_Payload_Addr_212_255 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 384, 1);
	ptr_struct->DateCode[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->DateCode[8] = '\0';
	offset = 80;
	ptr_struct->NominalBr_250 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->DDMIType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(120, 8, i, 384, 1);
	ptr_struct->MlnxSFGSN[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->MlnxSFGSN[16] = '\0';
	offset = 312;
	ptr_struct->MlnxVendorByte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 304;
	ptr_struct->MlnxRevision = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->MellanoxCap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Addr_212_255_print(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_212_255 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "DateCode             : \"%s\"\n", ptr_struct->DateCode);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NominalBr_250        : " UH_FMT "\n", ptr_struct->NominalBr_250);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDMIType             : " UH_FMT "\n", ptr_struct->DDMIType);

	fprintf(file, "MlnxSFGSN            : \"%s\"\n", ptr_struct->MlnxSFGSN);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MlnxVendorByte       : " UH_FMT "\n", ptr_struct->MlnxVendorByte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MlnxRevision         : " UH_FMT "\n", ptr_struct->MlnxRevision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MellanoxCap          : " UH_FMT "\n", ptr_struct->MellanoxCap);

}

int CableInfo_Payload_Addr_212_255_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_212_255_dump(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_212_255_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_48_79_pack(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX1Power);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX4Bias);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX3Power);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX2Power);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet4_1);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->DiagTX4Power);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ReservedSet4_2);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet5_1);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet4_3);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ReservedSet5_2);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->VendorSpecific_1);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ReservedSet5_3);

	offset = 224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VendorSpecific_2);

}

void CableInfo_Payload_Addr_48_79_unpack(struct CableInfo_Payload_Addr_48_79 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->DiagTX1Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->DiagTX4Bias = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->DiagTX3Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->DiagTX2Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->ReservedSet4_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	ptr_struct->DiagTX4Power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->ReservedSet4_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 144;
	ptr_struct->ReservedSet5_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->ReservedSet4_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->ReservedSet5_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 208;
	ptr_struct->VendorSpecific_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->ReservedSet5_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->VendorSpecific_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void CableInfo_Payload_Addr_48_79_print(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_48_79 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX1Power         : " UH_FMT "\n", ptr_struct->DiagTX1Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX4Bias          : " UH_FMT "\n", ptr_struct->DiagTX4Bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX3Power         : " UH_FMT "\n", ptr_struct->DiagTX3Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX2Power         : " UH_FMT "\n", ptr_struct->DiagTX2Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet4_1       : " UH_FMT "\n", ptr_struct->ReservedSet4_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DiagTX4Power         : " UH_FMT "\n", ptr_struct->DiagTX4Power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet4_2       : " U32H_FMT "\n", ptr_struct->ReservedSet4_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet5_1       : " UH_FMT "\n", ptr_struct->ReservedSet5_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet4_3       : " UH_FMT "\n", ptr_struct->ReservedSet4_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet5_2       : " U32H_FMT "\n", ptr_struct->ReservedSet5_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpecific_1     : " UH_FMT "\n", ptr_struct->VendorSpecific_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ReservedSet5_3       : " UH_FMT "\n", ptr_struct->ReservedSet5_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpecific_2     : " U32H_FMT "\n", ptr_struct->VendorSpecific_2);

}

int CableInfo_Payload_Addr_48_79_size(void)
{
	return 32;
}

void CableInfo_Payload_Addr_48_79_dump(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_48_79_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Addr_80_127_pack(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->TXDisable);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->HighPower);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->CdrControl);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->QSFPConnectivity);

}

void CableInfo_Payload_Addr_80_127_unpack(struct CableInfo_Payload_Addr_80_127 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 52;
	ptr_struct->TXDisable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 109;
	ptr_struct->HighPower = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 144;
	ptr_struct->CdrControl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 264;
	ptr_struct->QSFPConnectivity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void CableInfo_Payload_Addr_80_127_print(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Addr_80_127 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXDisable            : " UH_FMT "\n", ptr_struct->TXDisable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighPower            : " UH_FMT "\n", ptr_struct->HighPower);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CdrControl           : " UH_FMT "\n", ptr_struct->CdrControl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "QSFPConnectivity     : " UH_FMT "\n", ptr_struct->QSFPConnectivity);

}

int CableInfo_Payload_Addr_80_127_size(void)
{
	return 48;
}

void CableInfo_Payload_Addr_80_127_dump(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Addr_80_127_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_3_Addr_128_175_pack(const struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LowTempAlarm);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HighTempAlarm);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LowTempWarning);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HighTempWarning);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LowVccAlarm);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HighVccAlarm);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->LowVccWarning);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->HighVccWarning);

}

void CableInfo_Payload_Page_3_Addr_128_175_unpack(struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->LowTempAlarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->HighTempAlarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 48;
	ptr_struct->LowTempWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->HighTempWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->LowVccAlarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->HighVccAlarm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->LowVccWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->HighVccWarning = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Page_3_Addr_128_175_print(const struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_3_Addr_128_175 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowTempAlarm         : " UH_FMT "\n", ptr_struct->LowTempAlarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighTempAlarm        : " UH_FMT "\n", ptr_struct->HighTempAlarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowTempWarning       : " UH_FMT "\n", ptr_struct->LowTempWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighTempWarning      : " UH_FMT "\n", ptr_struct->HighTempWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowVccAlarm          : " UH_FMT "\n", ptr_struct->LowVccAlarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighVccAlarm         : " UH_FMT "\n", ptr_struct->HighVccAlarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowVccWarning        : " UH_FMT "\n", ptr_struct->LowVccWarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighVccWarning       : " UH_FMT "\n", ptr_struct->HighVccWarning);

}

int CableInfo_Payload_Page_3_Addr_128_175_size(void)
{
	return 48;
}

void CableInfo_Payload_Page_3_Addr_128_175_dump(const struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_3_Addr_128_175_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_3_Addr_212_255_pack(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->OutputAmpCap);

	offset = 138;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->OutputEmpType);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->OutputEmpCap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->InputEqCap);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->InputEq);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->TXAdaptiveEqualizationFreeze);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->OutputAmp);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->OutputEmp);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AdaptiveEqControl);

}

void CableInfo_Payload_Page_3_Addr_212_255_unpack(struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 140;
	ptr_struct->OutputAmpCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 138;
	ptr_struct->OutputEmpType = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 132;
	ptr_struct->OutputEmpCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->InputEqCap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 176;
	ptr_struct->InputEq = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 168;
	ptr_struct->TXAdaptiveEqualizationFreeze = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->OutputAmp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->OutputEmp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 232;
	ptr_struct->AdaptiveEqControl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void CableInfo_Payload_Page_3_Addr_212_255_print(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_3_Addr_212_255 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputAmpCap         : " UH_FMT "\n", ptr_struct->OutputAmpCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputEmpType        : " UH_FMT "\n", ptr_struct->OutputEmpType);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputEmpCap         : " UH_FMT "\n", ptr_struct->OutputEmpCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InputEqCap           : " UH_FMT "\n", ptr_struct->InputEqCap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "InputEq              : " UH_FMT "\n", ptr_struct->InputEq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXAdaptiveEqualizationFreeze : " UH_FMT "\n", ptr_struct->TXAdaptiveEqualizationFreeze);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputAmp            : " UH_FMT "\n", ptr_struct->OutputAmp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "OutputEmp            : " UH_FMT "\n", ptr_struct->OutputEmp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AdaptiveEqControl    : " UH_FMT "\n", ptr_struct->AdaptiveEqControl);

}

int CableInfo_Payload_Page_3_Addr_212_255_size(void)
{
	return 48;
}

void CableInfo_Payload_Page_3_Addr_212_255_dump(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_3_Addr_212_255_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_E9_Addr_128_175_pack(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 16, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_rssi_lane[i]);
	}

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->number_of_resets);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(128, 16, i, 384, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_rssi_lane[i]);
	}

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temp_module);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temp_vcsel);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_temp_module);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_temp_vd);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_temp_vd);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_temp_vcsel);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_0_40);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->min_temp_tia);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_temp_tia);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_55_70);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_40_55);

	offset = 368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_85_100);

	offset = 352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vcsel_temp_hist_70_85);

}

void CableInfo_Payload_Page_E9_Addr_128_175_unpack(struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 16, i, 384, 1);
	ptr_struct->max_rssi_lane[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 64;
	ptr_struct->number_of_resets = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(128, 16, i, 384, 1);
	ptr_struct->min_rssi_lane[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 208;
	ptr_struct->max_temp_module = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->max_temp_vcsel = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->min_temp_module = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 280;
	ptr_struct->min_temp_vd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 272;
	ptr_struct->max_temp_vd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->min_temp_vcsel = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->vcsel_temp_hist_0_40 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 296;
	ptr_struct->min_temp_tia = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->max_temp_tia = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 336;
	ptr_struct->vcsel_temp_hist_55_70 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->vcsel_temp_hist_40_55 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 368;
	ptr_struct->vcsel_temp_hist_85_100 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 352;
	ptr_struct->vcsel_temp_hist_70_85 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Page_E9_Addr_128_175_print(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_E9_Addr_128_175 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_rssi_lane_%03d   : " UH_FMT "\n", i, ptr_struct->max_rssi_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_of_resets     : " UH_FMT "\n", ptr_struct->number_of_resets);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_rssi_lane_%03d   : " UH_FMT "\n", i, ptr_struct->min_rssi_lane[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_module      : " UH_FMT "\n", ptr_struct->max_temp_module);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_vcsel       : " UH_FMT "\n", ptr_struct->max_temp_vcsel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_module      : " UH_FMT "\n", ptr_struct->min_temp_module);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_vd          : " UH_FMT "\n", ptr_struct->min_temp_vd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_vd          : " UH_FMT "\n", ptr_struct->max_temp_vd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_vcsel       : " UH_FMT "\n", ptr_struct->min_temp_vcsel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_0_40 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_0_40);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_temp_tia         : " UH_FMT "\n", ptr_struct->min_temp_tia);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp_tia         : " UH_FMT "\n", ptr_struct->max_temp_tia);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_55_70 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_55_70);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_40_55 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_40_55);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_85_100 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_85_100);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcsel_temp_hist_70_85 : " UH_FMT "\n", ptr_struct->vcsel_temp_hist_70_85);

}

int CableInfo_Payload_Page_E9_Addr_128_175_size(void)
{
	return 48;
}

void CableInfo_Payload_Page_E9_Addr_128_175_dump(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_E9_Addr_128_175_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_E9_Addr_176_211_pack(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->bias_counter[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(80, 16, i, 288, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mod_counter[i]);
	}

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_tx);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_tx);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_rx);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_rx);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_bu);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_bu);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_vcc_sd);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vcc_sd);

}

void CableInfo_Payload_Page_E9_Addr_176_211_unpack(struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(16, 16, i, 288, 1);
	ptr_struct->bias_counter[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(80, 16, i, 288, 1);
	ptr_struct->mod_counter[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

	offset = 144;
	ptr_struct->min_vcc_tx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->max_vcc_tx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->min_vcc_rx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->max_vcc_rx = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->min_vcc_bu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->max_vcc_bu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->min_vcc_sd = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->max_vcc_sd = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void CableInfo_Payload_Page_E9_Addr_176_211_print(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_E9_Addr_176_211 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bias_counter_%03d    : " UH_FMT "\n", i, ptr_struct->bias_counter[i]);
	}

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mod_counter_%03d     : " UH_FMT "\n", i, ptr_struct->mod_counter[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_tx           : " UH_FMT "\n", ptr_struct->min_vcc_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_tx           : " UH_FMT "\n", ptr_struct->max_vcc_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_rx           : " UH_FMT "\n", ptr_struct->min_vcc_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_rx           : " UH_FMT "\n", ptr_struct->max_vcc_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_bu           : " UH_FMT "\n", ptr_struct->min_vcc_bu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_bu           : " UH_FMT "\n", ptr_struct->max_vcc_bu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_vcc_sd           : " UH_FMT "\n", ptr_struct->min_vcc_sd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vcc_sd           : " UH_FMT "\n", ptr_struct->max_vcc_sd);

}

int CableInfo_Payload_Page_E9_Addr_176_211_size(void)
{
	return 36;
}

void CableInfo_Payload_Page_E9_Addr_176_211_dump(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_E9_Addr_176_211_print(ptr_struct, file, 0);
}

void CableInfo_Payload_Page_F0_Addr_128_171_pack(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->FWVersion[i]);
	}

}

void CableInfo_Payload_Page_F0_Addr_128_171_unpack(struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(344, 8, i, 352, 1);
	ptr_struct->FWVersion[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->FWVersion[4] = '\0';
}

void CableInfo_Payload_Page_F0_Addr_128_171_print(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== CableInfo_Payload_Page_F0_Addr_128_171 ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "FWVersion            : \"%s\"\n", ptr_struct->FWVersion);
}

int CableInfo_Payload_Page_F0_Addr_128_171_size(void)
{
	return 44;
}

void CableInfo_Payload_Page_F0_Addr_128_171_dump(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, FILE *file)
{
	CableInfo_Payload_Page_F0_Addr_128_171_print(ptr_struct, file, 0);
}

void DDLatchedFlagInfo_pack(const struct DDLatchedFlagInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dp_fw_fault);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mod_fw_fault);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vcc_flags);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->temp_flags);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_ad_eq_fault);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_cdr_lol);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_los);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_fault);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_lo_war);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_hi_war);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_lo_al);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_power_hi_al);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_lo_war);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_hi_war);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_lo_al);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_bias_hi_al);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_cdr_lol);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_los);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_lo_war);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_hi_war);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_lo_al);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_power_hi_al);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_output_valid_change);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_input_valid_change);

}

void DDLatchedFlagInfo_unpack(struct DDLatchedFlagInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 9;
	ptr_struct->dp_fw_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 8;
	ptr_struct->mod_fw_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 4;
	ptr_struct->vcc_flags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->temp_flags = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 56;
	ptr_struct->tx_ad_eq_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->tx_cdr_lol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->tx_los = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->tx_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->tx_power_lo_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->tx_power_hi_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->tx_power_lo_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->tx_power_hi_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->tx_bias_lo_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->tx_bias_hi_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->tx_bias_lo_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->tx_bias_hi_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->rx_cdr_lol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->rx_los = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->rx_power_lo_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->rx_power_hi_war = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->rx_power_lo_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->rx_power_hi_al = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->rx_output_valid_change = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->rx_input_valid_change = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void DDLatchedFlagInfo_print(const struct DDLatchedFlagInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDLatchedFlagInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_fw_fault          : " UH_FMT "\n", ptr_struct->dp_fw_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mod_fw_fault         : " UH_FMT "\n", ptr_struct->mod_fw_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vcc_flags            : %s (" UH_FMT ")\n", (ptr_struct->vcc_flags == 1 ? ("high_vcc_alarm") : ((ptr_struct->vcc_flags == 2 ? ("low_vcc_alarm") : ((ptr_struct->vcc_flags == 4 ? ("high_vcc_warning") : ((ptr_struct->vcc_flags == 8 ? ("low_vcc_warning") : ("unknown")))))))), ptr_struct->vcc_flags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_flags           : %s (" UH_FMT ")\n", (ptr_struct->temp_flags == 1 ? ("high_temp_alarm") : ((ptr_struct->temp_flags == 2 ? ("low_temp_alarm") : ((ptr_struct->temp_flags == 4 ? ("high_temp_warning") : ((ptr_struct->temp_flags == 8 ? ("low_temp_warning") : ("unknown")))))))), ptr_struct->temp_flags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_ad_eq_fault       : " UH_FMT "\n", ptr_struct->tx_ad_eq_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_lol           : " UH_FMT "\n", ptr_struct->tx_cdr_lol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_los               : " UH_FMT "\n", ptr_struct->tx_los);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_fault             : " UH_FMT "\n", ptr_struct->tx_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lo_war      : " UH_FMT "\n", ptr_struct->tx_power_lo_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_hi_war      : " UH_FMT "\n", ptr_struct->tx_power_hi_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lo_al       : " UH_FMT "\n", ptr_struct->tx_power_lo_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_hi_al       : " UH_FMT "\n", ptr_struct->tx_power_hi_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lo_war       : " UH_FMT "\n", ptr_struct->tx_bias_lo_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_hi_war       : " UH_FMT "\n", ptr_struct->tx_bias_hi_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lo_al        : " UH_FMT "\n", ptr_struct->tx_bias_lo_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_hi_al        : " UH_FMT "\n", ptr_struct->tx_bias_hi_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_lol           : " UH_FMT "\n", ptr_struct->rx_cdr_lol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_los               : " UH_FMT "\n", ptr_struct->rx_los);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lo_war      : " UH_FMT "\n", ptr_struct->rx_power_lo_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_hi_war      : " UH_FMT "\n", ptr_struct->rx_power_hi_war);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lo_al       : " UH_FMT "\n", ptr_struct->rx_power_lo_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_hi_al       : " UH_FMT "\n", ptr_struct->rx_power_hi_al);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_output_valid_change : " UH_FMT "\n", ptr_struct->rx_output_valid_change);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_input_valid_change : " UH_FMT "\n", ptr_struct->rx_input_valid_change);

}

int DDLatchedFlagInfo_size(void)
{
	return 248;
}

void DDLatchedFlagInfo_dump(const struct DDLatchedFlagInfo *ptr_struct, FILE *file)
{
	DDLatchedFlagInfo_print(ptr_struct, file, 0);
}

void DDModuleInfo_pack(const struct DDModuleInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ethernet_compliance_code);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ext_ethernet_compliance_code);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_breakout);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_technology);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_power_class);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_identifier);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_length);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_vendor);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cable_type);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_tx_equalization);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_emphasis);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_amp);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_power);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_5g);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_7g);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_12g);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_attenuation_25g);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tx_cdr_state);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_cdr_state);

	offset = 140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_cdr_cap);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_cdr_cap);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cable_rx_post_emphasis);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_name[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(312, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_pn[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(440, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_rev[i]);
	}

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->fw_version);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1984, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_sn[i]);
	}

	offset = 624;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage);

	offset = 608;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset = 656;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane1);

	offset = 640;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane0);

	offset = 688;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane3);

	offset = 672;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane2);

	offset = 720;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane5);

	offset = 704;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane4);

	offset = 752;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane7);

	offset = 736;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_lane6);

	offset = 784;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane1);

	offset = 768;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane0);

	offset = 816;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane3);

	offset = 800;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane2);

	offset = 848;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane5);

	offset = 832;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane4);

	offset = 880;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane7);

	offset = 864;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_lane6);

	offset = 912;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane1);

	offset = 896;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane0);

	offset = 944;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane3);

	offset = 928;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane2);

	offset = 976;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane5);

	offset = 960;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane4);

	offset = 1008;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane7);

	offset = 992;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_lane6);

	offset = 1040;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_low_th);

	offset = 1024;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_high_th);

	offset = 1072;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_low_th);

	offset = 1056;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_high_th);

	offset = 1104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_low_th);

	offset = 1088;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_power_high_th);

	offset = 1136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_low_th);

	offset = 1120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_power_high_th);

	offset = 1168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_low_th);

	offset = 1152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_bias_high_th);

	offset = 1200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wavelength);

	offset = 1190;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->smf_length);

	offset = 1188;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->did_cap);

	offset = 1187;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_power_type);

	offset = 1184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->module_st);

	offset = 1240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ib_compliance_code);

	offset = 1224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->active_set_media_compliance_code);

	offset = 1216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->active_set_host_compliance_code);

	offset = 1274;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ib_width);

	offset = 1264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->monitor_cap_mask);

	offset = 1256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nbr_100);

	offset = 1248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nbr_250);

	offset = 1308;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane7);

	offset = 1304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane6);

	offset = 1300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane5);

	offset = 1296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane4);

	offset = 1292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane3);

	offset = 1288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane2);

	offset = 1284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane1);

	offset = 1280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dp_st_lane0);

	offset = 1336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om5);

	offset = 1328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om4);

	offset = 1320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om3);

	offset = 1312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om2);

	offset = 1368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->memory_map_rev);

	offset = 1352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wavelength_tolerance);

	offset = 1344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length_om1);

	offset = 1376;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->memory_map_compliance);

	offset = 1408;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->date_code);

	offset = 1480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vendor_oui);

	offset = 1472;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->connector_type);

	offset = 1528;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_output_valid);

	offset = 1520;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_input_valid);

	offset = 1518;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_input_freq_sync);

	offset = 1564;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_code);

	offset = 1560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cdr_vendor);

	offset = 1536;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_fiber_length);

}

void DDModuleInfo_unpack(struct DDModuleInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->ethernet_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->ext_ethernet_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->cable_breakout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->cable_technology = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->cable_power_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->cable_identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->cable_length = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 36;
	ptr_struct->cable_vendor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->cable_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->cable_tx_equalization = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->cable_rx_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->cable_rx_amp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->max_power = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->cable_attenuation_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->cable_attenuation_7g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->cable_attenuation_12g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->cable_attenuation_25g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->tx_cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->rx_cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 140;
	ptr_struct->tx_cdr_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 136;
	ptr_struct->rx_cdr_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->cable_rx_post_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(184, 8, i, 1984, 1);
	ptr_struct->vendor_name[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_name[16] = '\0';
	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(312, 8, i, 1984, 1);
	ptr_struct->vendor_pn[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_pn[16] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(440, 8, i, 1984, 1);
	ptr_struct->vendor_rev[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_rev[4] = '\0';
	offset = 448;
	ptr_struct->fw_version = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1984, 1);
	ptr_struct->vendor_sn[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vendor_sn[16] = '\0';
	offset = 624;
	ptr_struct->voltage = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 608;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 656;
	ptr_struct->rx_power_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 640;
	ptr_struct->rx_power_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 688;
	ptr_struct->rx_power_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 672;
	ptr_struct->rx_power_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 720;
	ptr_struct->rx_power_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 704;
	ptr_struct->rx_power_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 752;
	ptr_struct->rx_power_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 736;
	ptr_struct->rx_power_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 784;
	ptr_struct->tx_power_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 768;
	ptr_struct->tx_power_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 816;
	ptr_struct->tx_power_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 800;
	ptr_struct->tx_power_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 848;
	ptr_struct->tx_power_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 832;
	ptr_struct->tx_power_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 880;
	ptr_struct->tx_power_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 864;
	ptr_struct->tx_power_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 912;
	ptr_struct->tx_bias_lane1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 896;
	ptr_struct->tx_bias_lane0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 944;
	ptr_struct->tx_bias_lane3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 928;
	ptr_struct->tx_bias_lane2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 976;
	ptr_struct->tx_bias_lane5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 960;
	ptr_struct->tx_bias_lane4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1008;
	ptr_struct->tx_bias_lane7 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 992;
	ptr_struct->tx_bias_lane6 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1040;
	ptr_struct->temperature_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1024;
	ptr_struct->temperature_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1072;
	ptr_struct->voltage_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1056;
	ptr_struct->voltage_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1104;
	ptr_struct->rx_power_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1088;
	ptr_struct->rx_power_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1136;
	ptr_struct->tx_power_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1120;
	ptr_struct->tx_power_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1168;
	ptr_struct->tx_bias_low_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1152;
	ptr_struct->tx_bias_high_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1200;
	ptr_struct->wavelength = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1190;
	ptr_struct->smf_length = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 1188;
	ptr_struct->did_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1187;
	ptr_struct->rx_power_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1184;
	ptr_struct->module_st = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 1240;
	ptr_struct->ib_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1224;
	ptr_struct->active_set_media_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1216;
	ptr_struct->active_set_host_compliance_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1274;
	ptr_struct->ib_width = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 1264;
	ptr_struct->monitor_cap_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1256;
	ptr_struct->nbr_100 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1248;
	ptr_struct->nbr_250 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1308;
	ptr_struct->dp_st_lane7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1304;
	ptr_struct->dp_st_lane6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1300;
	ptr_struct->dp_st_lane5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1296;
	ptr_struct->dp_st_lane4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1292;
	ptr_struct->dp_st_lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1288;
	ptr_struct->dp_st_lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1284;
	ptr_struct->dp_st_lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1280;
	ptr_struct->dp_st_lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1336;
	ptr_struct->length_om5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1328;
	ptr_struct->length_om4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1320;
	ptr_struct->length_om3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1312;
	ptr_struct->length_om2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1368;
	ptr_struct->memory_map_rev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1352;
	ptr_struct->wavelength_tolerance = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1344;
	ptr_struct->length_om1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1376;
	ptr_struct->memory_map_compliance = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 1408;
	ptr_struct->date_code = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 1480;
	ptr_struct->vendor_oui = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 1472;
	ptr_struct->connector_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1528;
	ptr_struct->rx_output_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1520;
	ptr_struct->rx_input_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 1518;
	ptr_struct->tx_input_freq_sync = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 1564;
	ptr_struct->error_code = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1560;
	ptr_struct->cdr_vendor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 1536;
	ptr_struct->max_fiber_length = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void DDModuleInfo_print(const struct DDModuleInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDModuleInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ethernet_compliance_code : " UH_FMT "\n", ptr_struct->ethernet_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_ethernet_compliance_code : " UH_FMT "\n", ptr_struct->ext_ethernet_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_breakout       : " UH_FMT "\n", ptr_struct->cable_breakout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_technology     : " UH_FMT "\n", ptr_struct->cable_technology);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_power_class    : " UH_FMT "\n", ptr_struct->cable_power_class);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_identifier     : " UH_FMT "\n", ptr_struct->cable_identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_length         : " UH_FMT "\n", ptr_struct->cable_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_vendor         : " UH_FMT "\n", ptr_struct->cable_vendor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_type           : " UH_FMT "\n", ptr_struct->cable_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_tx_equalization : " UH_FMT "\n", ptr_struct->cable_tx_equalization);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_emphasis    : " UH_FMT "\n", ptr_struct->cable_rx_emphasis);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_amp         : " UH_FMT "\n", ptr_struct->cable_rx_amp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_power            : " UH_FMT "\n", ptr_struct->max_power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_5g : " UH_FMT "\n", ptr_struct->cable_attenuation_5g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_7g : " UH_FMT "\n", ptr_struct->cable_attenuation_7g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_12g : " UH_FMT "\n", ptr_struct->cable_attenuation_12g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_attenuation_25g : " UH_FMT "\n", ptr_struct->cable_attenuation_25g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_state         : " UH_FMT "\n", ptr_struct->tx_cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_state         : " UH_FMT "\n", ptr_struct->rx_cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cdr_cap           : " UH_FMT "\n", ptr_struct->tx_cdr_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cdr_cap           : " UH_FMT "\n", ptr_struct->rx_cdr_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_rx_post_emphasis : " UH_FMT "\n", ptr_struct->cable_rx_post_emphasis);

	fprintf(file, "vendor_name          : \"%s\"\n", ptr_struct->vendor_name);
	fprintf(file, "vendor_pn            : \"%s\"\n", ptr_struct->vendor_pn);
	fprintf(file, "vendor_rev           : \"%s\"\n", ptr_struct->vendor_rev);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_version           : " U32H_FMT "\n", ptr_struct->fw_version);

	fprintf(file, "vendor_sn            : \"%s\"\n", ptr_struct->vendor_sn);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage              : " UH_FMT "\n", ptr_struct->voltage);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : " UH_FMT "\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane1       : " UH_FMT "\n", ptr_struct->rx_power_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane0       : " UH_FMT "\n", ptr_struct->rx_power_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane3       : " UH_FMT "\n", ptr_struct->rx_power_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane2       : " UH_FMT "\n", ptr_struct->rx_power_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane5       : " UH_FMT "\n", ptr_struct->rx_power_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane4       : " UH_FMT "\n", ptr_struct->rx_power_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane7       : " UH_FMT "\n", ptr_struct->rx_power_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_lane6       : " UH_FMT "\n", ptr_struct->rx_power_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane1       : " UH_FMT "\n", ptr_struct->tx_power_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane0       : " UH_FMT "\n", ptr_struct->tx_power_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane3       : " UH_FMT "\n", ptr_struct->tx_power_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane2       : " UH_FMT "\n", ptr_struct->tx_power_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane5       : " UH_FMT "\n", ptr_struct->tx_power_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane4       : " UH_FMT "\n", ptr_struct->tx_power_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane7       : " UH_FMT "\n", ptr_struct->tx_power_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_lane6       : " UH_FMT "\n", ptr_struct->tx_power_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane1        : " UH_FMT "\n", ptr_struct->tx_bias_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane0        : " UH_FMT "\n", ptr_struct->tx_bias_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane3        : " UH_FMT "\n", ptr_struct->tx_bias_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane2        : " UH_FMT "\n", ptr_struct->tx_bias_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane5        : " UH_FMT "\n", ptr_struct->tx_bias_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane4        : " UH_FMT "\n", ptr_struct->tx_bias_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane7        : " UH_FMT "\n", ptr_struct->tx_bias_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_lane6        : " UH_FMT "\n", ptr_struct->tx_bias_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_low_th   : " UH_FMT "\n", ptr_struct->temperature_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_high_th  : " UH_FMT "\n", ptr_struct->temperature_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_low_th       : " UH_FMT "\n", ptr_struct->voltage_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_high_th      : " UH_FMT "\n", ptr_struct->voltage_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_low_th      : " UH_FMT "\n", ptr_struct->rx_power_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_high_th     : " UH_FMT "\n", ptr_struct->rx_power_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_low_th      : " UH_FMT "\n", ptr_struct->tx_power_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_power_high_th     : " UH_FMT "\n", ptr_struct->tx_power_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_low_th       : " UH_FMT "\n", ptr_struct->tx_bias_low_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_high_th      : " UH_FMT "\n", ptr_struct->tx_bias_high_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wavelength           : " UH_FMT "\n", ptr_struct->wavelength);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "smf_length           : " UH_FMT "\n", ptr_struct->smf_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "did_cap              : " UH_FMT "\n", ptr_struct->did_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_power_type        : " UH_FMT "\n", ptr_struct->rx_power_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_st            : " UH_FMT "\n", ptr_struct->module_st);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_compliance_code   : " UH_FMT "\n", ptr_struct->ib_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_set_media_compliance_code : " UH_FMT "\n", ptr_struct->active_set_media_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_set_host_compliance_code : " UH_FMT "\n", ptr_struct->active_set_host_compliance_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_width             : " UH_FMT "\n", ptr_struct->ib_width);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monitor_cap_mask     : " UH_FMT "\n", ptr_struct->monitor_cap_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nbr_100              : " UH_FMT "\n", ptr_struct->nbr_100);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nbr_250              : " UH_FMT "\n", ptr_struct->nbr_250);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane7          : " UH_FMT "\n", ptr_struct->dp_st_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane6          : " UH_FMT "\n", ptr_struct->dp_st_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane5          : " UH_FMT "\n", ptr_struct->dp_st_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane4          : " UH_FMT "\n", ptr_struct->dp_st_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane3          : " UH_FMT "\n", ptr_struct->dp_st_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane2          : " UH_FMT "\n", ptr_struct->dp_st_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane1          : " UH_FMT "\n", ptr_struct->dp_st_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dp_st_lane0          : " UH_FMT "\n", ptr_struct->dp_st_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om5           : " UH_FMT "\n", ptr_struct->length_om5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om4           : " UH_FMT "\n", ptr_struct->length_om4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om3           : " UH_FMT "\n", ptr_struct->length_om3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om2           : " UH_FMT "\n", ptr_struct->length_om2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_map_rev       : " UH_FMT "\n", ptr_struct->memory_map_rev);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wavelength_tolerance : " UH_FMT "\n", ptr_struct->wavelength_tolerance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_om1           : " UH_FMT "\n", ptr_struct->length_om1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_map_compliance : " U32H_FMT "\n", ptr_struct->memory_map_compliance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "date_code            : " U64H_FMT "\n", ptr_struct->date_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_oui           : " UH_FMT "\n", ptr_struct->vendor_oui);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connector_type       : " UH_FMT "\n", ptr_struct->connector_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_output_valid      : " UH_FMT "\n", ptr_struct->rx_output_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_input_valid       : " UH_FMT "\n", ptr_struct->rx_input_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_input_freq_sync   : %s (" UH_FMT ")\n", (ptr_struct->tx_input_freq_sync == 0 ? ("Tx_input_lanes_1_8") : ((ptr_struct->tx_input_freq_sync == 1 ? ("Tx_input_lanes_1_4_and_5") : ((ptr_struct->tx_input_freq_sync == 2 ? ("Tx_input_lanes_1_2_and_3_4_and_5_6_and_7_8") : ((ptr_struct->tx_input_freq_sync == 3 ? ("Lanes_may_be_asynchronous_in_frequency") : ("unknown")))))))), ptr_struct->tx_input_freq_sync);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_code           : %s (" UH_FMT ")\n", (ptr_struct->error_code == 0 ? ("ConfigUndefined") : ((ptr_struct->error_code == 1 ? ("ConfigSuccess") : ((ptr_struct->error_code == 2 ? ("ConfigRejected") : ((ptr_struct->error_code == 3 ? ("ConfigRejectedInvalidAppSel") : ((ptr_struct->error_code == 4 ? ("ConfigRejectedInvalidDataPath") : ((ptr_struct->error_code == 5 ? ("ConfigRejectedInvalidSI") : ((ptr_struct->error_code == 6 ? ("ConfigRejectedLanesInUse") : ((ptr_struct->error_code == 7 ? ("ConfigRejectedPartialDataPath") : ((ptr_struct->error_code == 12 ? ("ConfigInProgress") : ("unknown")))))))))))))))))), ptr_struct->error_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_vendor           : %s (" UH_FMT ")\n", (ptr_struct->cdr_vendor == 0 ? ("Unknown_or_no_CDR") : ((ptr_struct->cdr_vendor == 1 ? ("Mellanox_Menhit") : ((ptr_struct->cdr_vendor == 2 ? ("Inphy_gen1_polaris") : ((ptr_struct->cdr_vendor == 3 ? ("Inphy_gen2_Atlas") : ((ptr_struct->cdr_vendor == 4 ? ("Marvell_Spica_Plus") : ((ptr_struct->cdr_vendor == 5 ? ("roadcom_TBD_name") : ((ptr_struct->cdr_vendor == 6 ? ("Nvidia_ArcusE") : ((ptr_struct->cdr_vendor == 7 ? ("Marvell_Nova1") : ("unknown")))))))))))))))), ptr_struct->cdr_vendor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_fiber_length     : " UH_FMT "\n", ptr_struct->max_fiber_length);

}

int DDModuleInfo_size(void)
{
	return 248;
}

void DDModuleInfo_dump(const struct DDModuleInfo *ptr_struct, FILE *file)
{
	DDModuleInfo_print(ptr_struct, file, 0);
}

void DDPageIdentification_pack(const struct DDPageIdentification *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pages_group[i]);
	}

}

void DDPageIdentification_unpack(struct DDPageIdentification *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 8; i++) {
	offset = adb2c_calc_array_field_address(0, 32, i, 256, 1);
	ptr_struct->pages_group[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void DDPageIdentification_print(const struct DDPageIdentification *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DDPageIdentification ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pages_group_%03d     : " U32H_FMT "\n", i, ptr_struct->pages_group[i]);
	}

}

int DDPageIdentification_size(void)
{
	return 32;
}

void DDPageIdentification_dump(const struct DDPageIdentification *ptr_struct, FILE *file)
{
	DDPageIdentification_print(ptr_struct, file, 0);
}

void DD_PhyStatisticalCounters_pack(const struct DD_PhyStatisticalCounters *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->time_since_last_clear);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_received_bits);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_symbol_errors);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_corrected_bits);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane0);

	offset = 320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane1);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane2);

	offset = 448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane3);

	offset = 512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane4);

	offset = 576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane5);

	offset = 640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane6);

	offset = 704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_raw_errors_lane7);

	offset = 796;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef);

	offset = 784;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude);

	offset = 828;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->effective_ber_coef);

	offset = 816;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->effective_ber_magnitude);

	offset = 860;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->symbol_ber_coef);

	offset = 848;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->symbol_ber_magnitude);

	offset = 892;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane1);

	offset = 880;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane1);

	offset = 876;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane0);

	offset = 864;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane0);

	offset = 924;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane3);

	offset = 912;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane3);

	offset = 908;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane2);

	offset = 896;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane2);

	offset = 956;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane5);

	offset = 944;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane5);

	offset = 940;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane4);

	offset = 928;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane4);

	offset = 988;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane7);

	offset = 976;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane7);

	offset = 972;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->raw_ber_coef_lane6);

	offset = 960;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->raw_ber_magnitude_lane6);

	offset = 992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->phy_effective_errors);

}

void DD_PhyStatisticalCounters_unpack(struct DD_PhyStatisticalCounters *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->time_since_last_clear = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->phy_received_bits = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 128;
	ptr_struct->phy_symbol_errors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->phy_corrected_bits = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->phy_raw_errors_lane0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 320;
	ptr_struct->phy_raw_errors_lane1 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 384;
	ptr_struct->phy_raw_errors_lane2 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 448;
	ptr_struct->phy_raw_errors_lane3 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 512;
	ptr_struct->phy_raw_errors_lane4 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 576;
	ptr_struct->phy_raw_errors_lane5 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 640;
	ptr_struct->phy_raw_errors_lane6 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 704;
	ptr_struct->phy_raw_errors_lane7 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset = 796;
	ptr_struct->raw_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 784;
	ptr_struct->raw_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 828;
	ptr_struct->effective_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 816;
	ptr_struct->effective_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 860;
	ptr_struct->symbol_ber_coef = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 848;
	ptr_struct->symbol_ber_magnitude = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 892;
	ptr_struct->raw_ber_coef_lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 880;
	ptr_struct->raw_ber_magnitude_lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 876;
	ptr_struct->raw_ber_coef_lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 864;
	ptr_struct->raw_ber_magnitude_lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 924;
	ptr_struct->raw_ber_coef_lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 912;
	ptr_struct->raw_ber_magnitude_lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 908;
	ptr_struct->raw_ber_coef_lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 896;
	ptr_struct->raw_ber_magnitude_lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 956;
	ptr_struct->raw_ber_coef_lane5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 944;
	ptr_struct->raw_ber_magnitude_lane5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 940;
	ptr_struct->raw_ber_coef_lane4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 928;
	ptr_struct->raw_ber_magnitude_lane4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 988;
	ptr_struct->raw_ber_coef_lane7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 976;
	ptr_struct->raw_ber_magnitude_lane7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 972;
	ptr_struct->raw_ber_coef_lane6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 960;
	ptr_struct->raw_ber_magnitude_lane6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 992;
	ptr_struct->phy_effective_errors = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void DD_PhyStatisticalCounters_print(const struct DD_PhyStatisticalCounters *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== DD_PhyStatisticalCounters ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear : " U64H_FMT "\n", ptr_struct->time_since_last_clear);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_received_bits    : " U64H_FMT "\n", ptr_struct->phy_received_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_symbol_errors    : " U64H_FMT "\n", ptr_struct->phy_symbol_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_corrected_bits   : " U64H_FMT "\n", ptr_struct->phy_corrected_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane0 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane1 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane2 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane3 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane4 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane5 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane6 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_raw_errors_lane7 : " U64H_FMT "\n", ptr_struct->phy_raw_errors_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef         : " UH_FMT "\n", ptr_struct->raw_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude    : " UH_FMT "\n", ptr_struct->raw_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "effective_ber_coef   : " UH_FMT "\n", ptr_struct->effective_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "effective_ber_magnitude : " UH_FMT "\n", ptr_struct->effective_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_ber_coef      : " UH_FMT "\n", ptr_struct->symbol_ber_coef);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_ber_magnitude : " UH_FMT "\n", ptr_struct->symbol_ber_magnitude);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane1   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane1 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane0   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane0 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane3   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane3 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane2   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane2 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane5   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane5 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane4   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane4 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane7   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane7 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_coef_lane6   : " UH_FMT "\n", ptr_struct->raw_ber_coef_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_ber_magnitude_lane6 : " UH_FMT "\n", ptr_struct->raw_ber_magnitude_lane6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_effective_errors : " U64H_FMT "\n", ptr_struct->phy_effective_errors);

}

int DD_PhyStatisticalCounters_size(void)
{
	return 132;
}

void DD_PhyStatisticalCounters_dump(const struct DD_PhyStatisticalCounters *ptr_struct, FILE *file)
{
	DD_PhyStatisticalCounters_print(ptr_struct, file, 0);
}

void SMP_CableInfo_pack(const struct SMP_CableInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->address);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->page_number);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->device_address);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->size);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pw_clr);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pw_v);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->password);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->Reserved1);

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Byte[i]);
	}

}

void SMP_CableInfo_unpack(struct SMP_CableInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 8;
	ptr_struct->page_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->device_address = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 33;
	ptr_struct->pw_clr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->pw_v = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->password = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->Reserved1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 48; i++) {
	offset = adb2c_calc_array_field_address(152, 8, i, 512, 1);
	ptr_struct->Byte[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void SMP_CableInfo_print(const struct SMP_CableInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_CableInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : " UH_FMT "\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_number          : " UH_FMT "\n", ptr_struct->page_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_address       : " UH_FMT "\n", ptr_struct->device_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : " UH_FMT "\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pw_clr               : " UH_FMT "\n", ptr_struct->pw_clr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pw_v                 : " UH_FMT "\n", ptr_struct->pw_v);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "password             : " U32H_FMT "\n", ptr_struct->password);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1            : " U32H_FMT "\n", ptr_struct->Reserved1);

	for (i = 0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Byte_%03d            : " UH_FMT "\n", i, ptr_struct->Byte[i]);
	}

}

int SMP_CableInfo_size(void)
{
	return 64;
}

void SMP_CableInfo_dump(const struct SMP_CableInfo *ptr_struct, FILE *file)
{
	SMP_CableInfo_print(ptr_struct, file, 0);
}

void SMP_EyeOpen_pack(const struct SMP_EyeOpen *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LinkWidthActive);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Reserved1);

	offset = 12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->AutoNegoState);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->Reserved0);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane0);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane0);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane0);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane0);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane0);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane0);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane0);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane1);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane1);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane1);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane1);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane1);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane1);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane1);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane2);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane2);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane2);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane2);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane2);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane2);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane2);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->HighAmplitude_Lane3);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->LowAmplitude_Lane3);

	offset = 376;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PositiveBound_Lane3);

	offset = 360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->NegativeBound_Lane3);

	offset = 408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionTX_Lane3);

	offset = 400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->SelectedOptionRX_Lane3);

	offset = 392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->AmpCalibration_Lane3);

}

void SMP_EyeOpen_unpack(struct SMP_EyeOpen *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->LinkWidthActive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->Reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 12;
	ptr_struct->AutoNegoState = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->Reserved0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 56;
	ptr_struct->HighAmplitude_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 40;
	ptr_struct->LowAmplitude_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->PositiveBound_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->NegativeBound_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 120;
	ptr_struct->SelectedOptionTX_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->SelectedOptionRX_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->AmpCalibration_Lane0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->HighAmplitude_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 136;
	ptr_struct->LowAmplitude_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 184;
	ptr_struct->PositiveBound_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->NegativeBound_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->SelectedOptionTX_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->SelectedOptionRX_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->AmpCalibration_Lane1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 248;
	ptr_struct->HighAmplitude_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 232;
	ptr_struct->LowAmplitude_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 280;
	ptr_struct->PositiveBound_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 264;
	ptr_struct->NegativeBound_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 312;
	ptr_struct->SelectedOptionTX_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 304;
	ptr_struct->SelectedOptionRX_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 296;
	ptr_struct->AmpCalibration_Lane2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 344;
	ptr_struct->HighAmplitude_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 328;
	ptr_struct->LowAmplitude_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 376;
	ptr_struct->PositiveBound_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 360;
	ptr_struct->NegativeBound_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 408;
	ptr_struct->SelectedOptionTX_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 400;
	ptr_struct->SelectedOptionRX_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 392;
	ptr_struct->AmpCalibration_Lane3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_EyeOpen_print(const struct SMP_EyeOpen *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_EyeOpen ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LinkWidthActive      : " UH_FMT "\n", ptr_struct->LinkWidthActive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved1            : " UH_FMT "\n", ptr_struct->Reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AutoNegoState        : " UH_FMT "\n", ptr_struct->AutoNegoState);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved0            : " UH_FMT "\n", ptr_struct->Reserved0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane0  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane0   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane0  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane0  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane0 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane0 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane0 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane1  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane1   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane1  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane1  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane1 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane1 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane1 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane2  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane2   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane2  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane2  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane2 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane2 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane2 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "HighAmplitude_Lane3  : " UH_FMT "\n", ptr_struct->HighAmplitude_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "LowAmplitude_Lane3   : " UH_FMT "\n", ptr_struct->LowAmplitude_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PositiveBound_Lane3  : " UH_FMT "\n", ptr_struct->PositiveBound_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "NegativeBound_Lane3  : " UH_FMT "\n", ptr_struct->NegativeBound_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionTX_Lane3 : " UH_FMT "\n", ptr_struct->SelectedOptionTX_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SelectedOptionRX_Lane3 : " UH_FMT "\n", ptr_struct->SelectedOptionRX_Lane3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "AmpCalibration_Lane3 : " UH_FMT "\n", ptr_struct->AmpCalibration_Lane3);

}

int SMP_EyeOpen_size(void)
{
	return 64;
}

void SMP_EyeOpen_dump(const struct SMP_EyeOpen *ptr_struct, FILE *file)
{
	SMP_EyeOpen_print(ptr_struct, file, 0);
}

void SMP_LossyLinkConfig_pack(const struct SMP_LossyLinkConfig *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Ignore_Credits_Mask);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Ignore_Buffer_Overrun_Mask);

}

void SMP_LossyLinkConfig_unpack(struct SMP_LossyLinkConfig *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->Ignore_Credits_Mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 0;
	ptr_struct->Ignore_Buffer_Overrun_Mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void SMP_LossyLinkConfig_print(const struct SMP_LossyLinkConfig *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_LossyLinkConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Ignore_Credits_Mask  : " UH_FMT "\n", ptr_struct->Ignore_Credits_Mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Ignore_Buffer_Overrun_Mask : " UH_FMT "\n", ptr_struct->Ignore_Buffer_Overrun_Mask);

}

int SMP_LossyLinkConfig_size(void)
{
	return 4;
}

void SMP_LossyLinkConfig_dump(const struct SMP_LossyLinkConfig *ptr_struct, FILE *file)
{
	SMP_LossyLinkConfig_print(ptr_struct, file, 0);
}

void SMP_MAD_AttrMod_CableInfo_pack(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->PortSelect);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->Reserved);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->BitLock);

}

void SMP_MAD_AttrMod_CableInfo_unpack(struct SMP_MAD_AttrMod_CableInfo *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->PortSelect = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 1;
	ptr_struct->Reserved = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset = 0;
	ptr_struct->BitLock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void SMP_MAD_AttrMod_CableInfo_print(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MAD_AttrMod_CableInfo ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Reserved             : " UH_FMT "\n", ptr_struct->Reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "BitLock              : " UH_FMT "\n", ptr_struct->BitLock);

}

int SMP_MAD_AttrMod_CableInfo_size(void)
{
	return 4;
}

void SMP_MAD_AttrMod_CableInfo_dump(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, FILE *file)
{
	SMP_MAD_AttrMod_CableInfo_print(ptr_struct, file, 0);
}

void SMP_MAD_AttrMod_EyeOpen_pack(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortSelect);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->GroupLane);

}

void SMP_MAD_AttrMod_EyeOpen_unpack(struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->PortSelect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 16;
	ptr_struct->GroupLane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void SMP_MAD_AttrMod_EyeOpen_print(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_MAD_AttrMod_EyeOpen ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortSelect           : " UH_FMT "\n", ptr_struct->PortSelect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "GroupLane            : " UH_FMT "\n", ptr_struct->GroupLane);

}

int SMP_MAD_AttrMod_EyeOpen_size(void)
{
	return 4;
}

void SMP_MAD_AttrMod_EyeOpen_dump(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, FILE *file)
{
	SMP_MAD_AttrMod_EyeOpen_print(ptr_struct, file, 0);
}

void SMP_TemperatureSensing_pack(const struct SMP_TemperatureSensing *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tss);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->stgs);

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->stge);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtts);

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtte);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtgs);

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wtge);

	offset = 53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->current_temp);

	offset = 37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->max_temp);

	offset = 85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->overtemp_warning_threshold_hi);

	offset = 69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->overtemp_warning_threshold_lo);

	offset = 127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ws);

	offset = 126;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wga);

	offset = 125;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wgp);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->wgm);

}

void SMP_TemperatureSensing_unpack(struct SMP_TemperatureSensing *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->tss = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->stgs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 29;
	ptr_struct->stge = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->wtts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 27;
	ptr_struct->wtte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 26;
	ptr_struct->wtgs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 25;
	ptr_struct->wtge = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 53;
	ptr_struct->current_temp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 37;
	ptr_struct->max_temp = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 85;
	ptr_struct->overtemp_warning_threshold_hi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 69;
	ptr_struct->overtemp_warning_threshold_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 127;
	ptr_struct->ws = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 126;
	ptr_struct->wga = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 125;
	ptr_struct->wgp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 123;
	ptr_struct->wgm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void SMP_TemperatureSensing_print(const struct SMP_TemperatureSensing *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== SMP_TemperatureSensing ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tss                  : " UH_FMT "\n", ptr_struct->tss);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stgs                 : " UH_FMT "\n", ptr_struct->stgs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stge                 : " UH_FMT "\n", ptr_struct->stge);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtts                 : " UH_FMT "\n", ptr_struct->wtts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtte                 : " UH_FMT "\n", ptr_struct->wtte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtgs                 : " UH_FMT "\n", ptr_struct->wtgs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wtge                 : " UH_FMT "\n", ptr_struct->wtge);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_temp         : " UH_FMT "\n", ptr_struct->current_temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temp             : " UH_FMT "\n", ptr_struct->max_temp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overtemp_warning_threshold_hi : " UH_FMT "\n", ptr_struct->overtemp_warning_threshold_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overtemp_warning_threshold_lo : " UH_FMT "\n", ptr_struct->overtemp_warning_threshold_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ws                   : " UH_FMT "\n", ptr_struct->ws);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wga                  : " UH_FMT "\n", ptr_struct->wga);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wgp                  : " UH_FMT "\n", ptr_struct->wgp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wgm                  : " UH_FMT "\n", ptr_struct->wgm);

}

int SMP_TemperatureSensing_size(void)
{
	return 16;
}

void SMP_TemperatureSensing_dump(const struct SMP_TemperatureSensing *ptr_struct, FILE *file)
{
	SMP_TemperatureSensing_print(ptr_struct, file, 0);
}

void VendorSpec_PhyConfig_pack(const struct VendorSpec_PhyConfig *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->PortMode);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->MasterPort);

	offset = 23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->Sloop);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->SerDesParamsLinkSpeeds);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->PortCommand);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->TxPolarity);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->TxReserveLane);

	offset = 45;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->TXReverseSub0);

	offset = 43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->TXReverseSub1);

	offset = 41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->TXReverseSub2);

	offset = 39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ClusterEnable);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->SerDesParameterLanesEnable);

}

void VendorSpec_PhyConfig_unpack(struct VendorSpec_PhyConfig *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->PortMode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 24;
	ptr_struct->MasterPort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 23;
	ptr_struct->Sloop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 16;
	ptr_struct->SerDesParamsLinkSpeeds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->PortCommand = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 52;
	ptr_struct->TxPolarity = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 46;
	ptr_struct->TxReserveLane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 45;
	ptr_struct->TXReverseSub0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 43;
	ptr_struct->TXReverseSub1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 41;
	ptr_struct->TXReverseSub2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 39;
	ptr_struct->ClusterEnable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 84;
	ptr_struct->SerDesParameterLanesEnable = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void VendorSpec_PhyConfig_print(const struct VendorSpec_PhyConfig *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== VendorSpec_PhyConfig ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortMode             : " UH_FMT "\n", ptr_struct->PortMode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MasterPort           : " UH_FMT "\n", ptr_struct->MasterPort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Sloop                : " UH_FMT "\n", ptr_struct->Sloop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SerDesParamsLinkSpeeds : " UH_FMT "\n", ptr_struct->SerDesParamsLinkSpeeds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PortCommand          : " UH_FMT "\n", ptr_struct->PortCommand);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TxPolarity           : " UH_FMT "\n", ptr_struct->TxPolarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TxReserveLane        : " UH_FMT "\n", ptr_struct->TxReserveLane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXReverseSub0        : " UH_FMT "\n", ptr_struct->TXReverseSub0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXReverseSub1        : " UH_FMT "\n", ptr_struct->TXReverseSub1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TXReverseSub2        : " UH_FMT "\n", ptr_struct->TXReverseSub2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ClusterEnable        : " UH_FMT "\n", ptr_struct->ClusterEnable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SerDesParameterLanesEnable : " UH_FMT "\n", ptr_struct->SerDesParameterLanesEnable);

}

int VendorSpec_PhyConfig_size(void)
{
	return 156;
}

void VendorSpec_PhyConfig_dump(const struct VendorSpec_PhyConfig *ptr_struct, FILE *file)
{
	VendorSpec_PhyConfig_print(ptr_struct, file, 0);
}

void fore_reg_pack(const struct fore_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fan_under_limit);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fan_over_limit);

}

void fore_reg_unpack(struct fore_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->fan_under_limit = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 32;
	ptr_struct->fan_over_limit = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void fore_reg_print(const struct fore_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== fore_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan_under_limit      : " UH_FMT "\n", ptr_struct->fan_under_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan_over_limit       : " UH_FMT "\n", ptr_struct->fan_over_limit);

}

int fore_reg_size(void)
{
	return 12;
}

void fore_reg_dump(const struct fore_reg *ptr_struct, FILE *file)
{
	fore_reg_print(ptr_struct, file, 0);
}

void mfcr_reg_pack(const struct mfcr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->pwm_frequency);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->pwm_active);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tacho_active);

}

void mfcr_reg_unpack(struct mfcr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->pwm_frequency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 59;
	ptr_struct->pwm_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 32;
	ptr_struct->tacho_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mfcr_reg_print(const struct mfcr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfcr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pwm_frequency        : " UH_FMT "\n", ptr_struct->pwm_frequency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pwm_active           : " UH_FMT "\n", ptr_struct->pwm_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tacho_active         : " UH_FMT "\n", ptr_struct->tacho_active);

}

int mfcr_reg_size(void)
{
	return 8;
}

void mfcr_reg_dump(const struct mfcr_reg *ptr_struct, FILE *file)
{
	mfcr_reg_print(ptr_struct, file, 0);
}

void mfnr_reg_pack(const struct mfnr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->fan_index);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(56, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->serial_number[i]);
	}

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->part_number[i]);
	}

}

void mfnr_reg_unpack(struct mfnr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 27;
	ptr_struct->fan_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(56, 8, i, 352, 1);
	ptr_struct->serial_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->serial_number[24] = '\0';
	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 352, 1);
	ptr_struct->part_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->part_number[16] = '\0';
}

void mfnr_reg_print(const struct mfnr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfnr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fan_index            : " UH_FMT "\n", ptr_struct->fan_index);

	fprintf(file, "serial_number        : \"%s\"\n", ptr_struct->serial_number);
	fprintf(file, "part_number          : \"%s\"\n", ptr_struct->part_number);
}

int mfnr_reg_size(void)
{
	return 44;
}

void mfnr_reg_dump(const struct mfnr_reg *ptr_struct, FILE *file)
{
	mfnr_reg_print(ptr_struct, file, 0);
}

void mfsl_reg_pack(const struct mfsl_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ie);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ee);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tacho);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tach_min);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tach_max);

}

void mfsl_reg_unpack(struct mfsl_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->ie = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->ee = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 4;
	ptr_struct->tacho = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->tach_min = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->tach_max = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mfsl_reg_print(const struct mfsl_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfsl_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ie                   : " UH_FMT "\n", ptr_struct->ie);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ee                   : " UH_FMT "\n", ptr_struct->ee);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tacho                : " UH_FMT "\n", ptr_struct->tacho);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tach_min             : " UH_FMT "\n", ptr_struct->tach_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tach_max             : " UH_FMT "\n", ptr_struct->tach_max);

}

int mfsl_reg_size(void)
{
	return 12;
}

void mfsl_reg_dump(const struct mfsl_reg *ptr_struct, FILE *file)
{
	mfsl_reg_print(ptr_struct, file, 0);
}

void mfsm_reg_pack(const struct mfsm_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tacho);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rpm);

}

void mfsm_reg_unpack(struct mfsm_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 4;
	ptr_struct->tacho = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 48;
	ptr_struct->rpm = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mfsm_reg_print(const struct mfsm_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mfsm_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tacho                : " UH_FMT "\n", ptr_struct->tacho);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rpm                  : " UH_FMT "\n", ptr_struct->rpm);

}

int mfsm_reg_size(void)
{
	return 8;
}

void mfsm_reg_dump(const struct mfsm_reg *ptr_struct, FILE *file)
{
	mfsm_reg_print(ptr_struct, file, 0);
}

void mpcnt_reg_pack(const struct mpcnt_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->grp);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pcie_index);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->depth);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clr);

	offset = 64;
	mpcnt_reg_counter_set_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void mpcnt_reg_unpack(struct mpcnt_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 26;
	ptr_struct->grp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 16;
	ptr_struct->node = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->pcie_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->depth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 32;
	ptr_struct->clr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	mpcnt_reg_counter_set_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void mpcnt_reg_print(const struct mpcnt_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpcnt_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grp                  : %s (" UH_FMT ")\n", (ptr_struct->grp == 0 ? ("PCIE_performance_counters") : ((ptr_struct->grp == 3 ? ("PCIE_physical_layer_indications") : ("unknown")))), ptr_struct->grp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node                 : " UH_FMT "\n", ptr_struct->node);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_index           : " UH_FMT "\n", ptr_struct->pcie_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "depth                : " UH_FMT "\n", ptr_struct->depth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clr                  : " UH_FMT "\n", ptr_struct->clr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	mpcnt_reg_counter_set_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int mpcnt_reg_size(void)
{
	return 104;
}

void mpcnt_reg_dump(const struct mpcnt_reg *ptr_struct, FILE *file)
{
	mpcnt_reg_print(ptr_struct, file, 0);
}

void mpein_reg_pack(const struct mpein_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pcie_index);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->depth);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->capability_mask);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_speed_enabled);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_width_enabled);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_speed_active);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_width_active);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lane0_physical_position);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_vfs);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_pfs);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->bdf0);

	offset = 223;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lane_reversal);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 205;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->pwr_status);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_payload_size);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_read_request_size);

	offset = 244;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pci_power);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->link_peer_max_speed);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_state);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->device_status);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->receiver_detect_result);

}

void mpein_reg_unpack(struct mpein_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 16;
	ptr_struct->node = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->pcie_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->depth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 32;
	ptr_struct->capability_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->link_speed_enabled = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 72;
	ptr_struct->link_width_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->link_speed_active = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 104;
	ptr_struct->link_width_active = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->lane0_physical_position = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->num_of_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->num_of_pfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->bdf0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 223;
	ptr_struct->lane_reversal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 208;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 205;
	ptr_struct->pwr_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 196;
	ptr_struct->max_payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->max_read_request_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 244;
	ptr_struct->pci_power = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 224;
	ptr_struct->link_peer_max_speed = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->port_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 288;
	ptr_struct->device_status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 336;
	ptr_struct->receiver_detect_result = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void mpein_reg_print(const struct mpein_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpein_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node                 : " UH_FMT "\n", ptr_struct->node);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_index           : " UH_FMT "\n", ptr_struct->pcie_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "depth                : " UH_FMT "\n", ptr_struct->depth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability_mask      : " U32H_FMT "\n", ptr_struct->capability_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_enabled   : " UH_FMT "\n", ptr_struct->link_speed_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_enabled   : " UH_FMT "\n", ptr_struct->link_width_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_active    : " UH_FMT "\n", ptr_struct->link_speed_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_active    : " UH_FMT "\n", ptr_struct->link_width_active);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane0_physical_position : " UH_FMT "\n", ptr_struct->lane0_physical_position);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_vfs           : " UH_FMT "\n", ptr_struct->num_of_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_pfs           : " UH_FMT "\n", ptr_struct->num_of_pfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bdf0                 : " UH_FMT "\n", ptr_struct->bdf0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_reversal        : " UH_FMT "\n", ptr_struct->lane_reversal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pwr_status           : " UH_FMT "\n", ptr_struct->pwr_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_payload_size     : " UH_FMT "\n", ptr_struct->max_payload_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_request_size : " UH_FMT "\n", ptr_struct->max_read_request_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci_power            : " UH_FMT "\n", ptr_struct->pci_power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_peer_max_speed  : " UH_FMT "\n", ptr_struct->link_peer_max_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_state           : " UH_FMT "\n", ptr_struct->port_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_status        : %s (" UH_FMT ")\n", (ptr_struct->device_status == 1 ? ("Correctable_error") : ((ptr_struct->device_status == 2 ? ("Non_Fatal_Error_detection") : ((ptr_struct->device_status == 4 ? ("Fatal_Error_detected") : ((ptr_struct->device_status == 8 ? ("Unsupported_request_detected") : ((ptr_struct->device_status == 16 ? ("AUX_power") : ((ptr_struct->device_status == 32 ? ("Transaction_Pending") : ("unknown")))))))))))), ptr_struct->device_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_detect_result : " UH_FMT "\n", ptr_struct->receiver_detect_result);

}

int mpein_reg_size(void)
{
	return 44;
}

void mpein_reg_dump(const struct mpein_reg *ptr_struct, FILE *file)
{
	mpein_reg_print(ptr_struct, file, 0);
}

void mpir_reg_pack(const struct mpir_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->host_buses);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pcie_index);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->depth);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sdm);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->subordinate_bus);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->secondary_bus);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->device);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->bus);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->slot_number);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_con_devices);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->slot_cap);

}

void mpir_reg_unpack(struct mpir_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->host_buses = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->node = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->pcie_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 2;
	ptr_struct->depth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 0;
	ptr_struct->sdm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->subordinate_bus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 48;
	ptr_struct->secondary_bus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->device = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 72;
	ptr_struct->bus = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 64;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 115;
	ptr_struct->slot_number = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset = 104;
	ptr_struct->num_con_devices = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 96;
	ptr_struct->slot_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void mpir_reg_print(const struct mpir_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mpir_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host_buses           : " UH_FMT "\n", ptr_struct->host_buses);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node                 : " UH_FMT "\n", ptr_struct->node);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_index           : " UH_FMT "\n", ptr_struct->pcie_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "depth                : " UH_FMT "\n", ptr_struct->depth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sdm                  : " UH_FMT "\n", ptr_struct->sdm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "subordinate_bus      : " UH_FMT "\n", ptr_struct->subordinate_bus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "secondary_bus        : " UH_FMT "\n", ptr_struct->secondary_bus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device               : " UH_FMT "\n", ptr_struct->device);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bus                  : " UH_FMT "\n", ptr_struct->bus);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_number          : " UH_FMT "\n", ptr_struct->slot_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_con_devices      : " UH_FMT "\n", ptr_struct->num_con_devices);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_cap             : " UH_FMT "\n", ptr_struct->slot_cap);

}

int mpir_reg_size(void)
{
	return 16;
}

void mpir_reg_dump(const struct mpir_reg *ptr_struct, FILE *file)
{
	mpir_reg_print(ptr_struct, file, 0);
}

void mrcs_reg_pack(const struct mrcs_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(0, 96, i, 192, 1);
	ref_clock_stat_db_pack(&(ptr_struct->ref_clock_stat[i]), ptr_buff + offset/8);
	}

}

void mrcs_reg_unpack(struct mrcs_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 2; i++) {
	offset = adb2c_calc_array_field_address(0, 96, i, 192, 1);
	ref_clock_stat_db_unpack(&(ptr_struct->ref_clock_stat[i]), ptr_buff + offset/8);
	}

}

void mrcs_reg_print(const struct mrcs_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mrcs_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i = 0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_clock_stat_%03d:\n", i);
	ref_clock_stat_db_print(&(ptr_struct->ref_clock_stat[i]), file, indent_level + 1);
	}

}

int mrcs_reg_size(void)
{
	return 24;
}

void mrcs_reg_dump(const struct mrcs_reg *ptr_struct, FILE *file)
{
	mrcs_reg_print(ptr_struct, file, 0);
}

void msgi_reg_pack(const struct msgi_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->serial_number[i]);
	}

	for (i = 0; i < 20; i++) {
	offset = adb2c_calc_array_field_address(280, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->part_number[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(472, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->revision[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->manufacturing_date[i]);
	}

	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(536, 8, i, 1024, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->product_name[i]);
	}

}

void msgi_reg_unpack(struct msgi_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i = 0; i < 24; i++) {
	offset = adb2c_calc_array_field_address(24, 8, i, 1024, 1);
	ptr_struct->serial_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->serial_number[24] = '\0';
	for (i = 0; i < 20; i++) {
	offset = adb2c_calc_array_field_address(280, 8, i, 1024, 1);
	ptr_struct->part_number[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->part_number[20] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(472, 8, i, 1024, 1);
	ptr_struct->revision[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->revision[4] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(504, 8, i, 1024, 1);
	ptr_struct->manufacturing_date[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->manufacturing_date[4] = '\0';
	for (i = 0; i < 64; i++) {
	offset = adb2c_calc_array_field_address(536, 8, i, 1024, 1);
	ptr_struct->product_name[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->product_name[64] = '\0';
}

void msgi_reg_print(const struct msgi_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== msgi_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "serial_number        : \"%s\"\n", ptr_struct->serial_number);
	fprintf(file, "part_number          : \"%s\"\n", ptr_struct->part_number);
	fprintf(file, "revision             : \"%s\"\n", ptr_struct->revision);
	fprintf(file, "manufacturing_date   : \"%s\"\n", ptr_struct->manufacturing_date);
	fprintf(file, "product_name         : \"%s\"\n", ptr_struct->product_name);
}

int msgi_reg_size(void)
{
	return 128;
}

void msgi_reg_dump(const struct msgi_reg *ptr_struct, FILE *file)
{
	msgi_reg_print(ptr_struct, file, 0);
}

void msps_reg_pack(const struct msps_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	psu_status_pack(&(ptr_struct->psu0), ptr_buff + offset/8);

	offset = 640;
	psu_status_pack(&(ptr_struct->psu1), ptr_buff + offset/8);

}

void msps_reg_unpack(struct msps_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	psu_status_unpack(&(ptr_struct->psu0), ptr_buff + offset/8);

	offset = 640;
	psu_status_unpack(&(ptr_struct->psu1), ptr_buff + offset/8);

}

void msps_reg_print(const struct msps_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== msps_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psu0:\n");
	psu_status_print(&(ptr_struct->psu0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psu1:\n");
	psu_status_print(&(ptr_struct->psu1), file, indent_level + 1);

}

int msps_reg_size(void)
{
	return 160;
}

void msps_reg_dump(const struct msps_reg *ptr_struct, FILE *file)
{
	msps_reg_print(ptr_struct, file, 0);
}

void mtcap_reg_pack(const struct mtcap_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_count);

}

void mtcap_reg_unpack(struct mtcap_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sensor_count = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void mtcap_reg_print(const struct mtcap_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mtcap_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_count         : " UH_FMT "\n", ptr_struct->sensor_count);

}

int mtcap_reg_size(void)
{
	return 8;
}

void mtcap_reg_dump(const struct mtcap_reg *ptr_struct, FILE *file)
{
	mtcap_reg_print(ptr_struct, file, 0);
}

void mtmp_reg_pack(const struct mtmp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_index);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temperature);

	offset = 65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mtr);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mte);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_threshold_hi);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tee);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_threshold_lo);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(216, 8, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sensor_name_hi[i]);
	}

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 256, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sensor_name_lo[i]);
	}

}

void mtmp_reg_unpack(struct mtmp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sensor_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 48;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->max_temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 65;
	ptr_struct->mtr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ptr_struct->mte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 112;
	ptr_struct->temperature_threshold_hi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->tee = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 144;
	ptr_struct->temperature_threshold_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(216, 8, i, 256, 1);
	ptr_struct->sensor_name_hi[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->sensor_name_hi[4] = '\0';
	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(248, 8, i, 256, 1);
	ptr_struct->sensor_name_lo[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->sensor_name_lo[4] = '\0';
}

void mtmp_reg_print(const struct mtmp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mtmp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_index         : " UH_FMT "\n", ptr_struct->sensor_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : " UH_FMT "\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temperature      : " UH_FMT "\n", ptr_struct->max_temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtr                  : " UH_FMT "\n", ptr_struct->mtr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mte                  : " UH_FMT "\n", ptr_struct->mte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_threshold_hi : " UH_FMT "\n", ptr_struct->temperature_threshold_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tee                  : " UH_FMT "\n", ptr_struct->tee);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_threshold_lo : " UH_FMT "\n", ptr_struct->temperature_threshold_lo);

	fprintf(file, "sensor_name_hi       : \"%s\"\n", ptr_struct->sensor_name_hi);
	fprintf(file, "sensor_name_lo       : \"%s\"\n", ptr_struct->sensor_name_lo);
}

int mtmp_reg_size(void)
{
	return 32;
}

void mtmp_reg_dump(const struct mtmp_reg *ptr_struct, FILE *file)
{
	mtmp_reg_print(ptr_struct, file, 0);
}

void mtwe_reg_pack(const struct mtwe_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning0);

	offset = 32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning1);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning2);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sensor_warning3);

}

void mtwe_reg_unpack(struct mtwe_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->sensor_warning0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->sensor_warning1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->sensor_warning2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->sensor_warning3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void mtwe_reg_print(const struct mtwe_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mtwe_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning0      : " U32H_FMT "\n", ptr_struct->sensor_warning0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning1      : " U32H_FMT "\n", ptr_struct->sensor_warning1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning2      : " U32H_FMT "\n", ptr_struct->sensor_warning2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_warning3      : " U32H_FMT "\n", ptr_struct->sensor_warning3);

}

int mtwe_reg_size(void)
{
	return 16;
}

void mtwe_reg_dump(const struct mtwe_reg *ptr_struct, FILE *file)
{
	mtwe_reg_print(ptr_struct, file, 0);
}

void mvcap_reg_pack(const struct mvcap_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->sensor_map);

}

void mvcap_reg_unpack(struct mvcap_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 0;
	ptr_struct->sensor_map = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void mvcap_reg_print(const struct mvcap_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mvcap_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_map           : " U64H_FMT "\n", ptr_struct->sensor_map);

}

int mvcap_reg_size(void)
{
	return 16;
}

void mvcap_reg_dump(const struct mvcap_reg *ptr_struct, FILE *file)
{
	mvcap_reg_print(ptr_struct, file, 0);
}

void mvcr_reg_pack(const struct mvcr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_index);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->voltage_sensor_value);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->current_sensor_value);

	offset = 128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->sensor_name);

}

void mvcr_reg_unpack(struct mvcr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 25;
	ptr_struct->sensor_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 48;
	ptr_struct->voltage_sensor_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 80;
	ptr_struct->current_sensor_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->sensor_name = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void mvcr_reg_print(const struct mvcr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== mvcr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_index         : " UH_FMT "\n", ptr_struct->sensor_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "voltage_sensor_value : " UH_FMT "\n", ptr_struct->voltage_sensor_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_sensor_value : " UH_FMT "\n", ptr_struct->current_sensor_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_name          : " U64H_FMT "\n", ptr_struct->sensor_name);

}

int mvcr_reg_size(void)
{
	return 24;
}

void mvcr_reg_dump(const struct mvcr_reg *ptr_struct, FILE *file)
{
	mvcr_reg_print(ptr_struct, file, 0);
}

void pcam_reg_pack(const struct pcam_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->access_reg_group);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->feature_group);

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(64, 1, i, 640, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_access_reg_cap_mask[i]);
	}

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(320, 1, i, 640, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->feature_cap_mask[i]);
	}

}

void pcam_reg_unpack(struct pcam_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->access_reg_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 8;
	ptr_struct->feature_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(64, 1, i, 640, 1);
	ptr_struct->port_access_reg_cap_mask[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);
	}

	for (i = 0; i < 128; i++) {
	offset = adb2c_calc_array_field_address(320, 1, i, 640, 1);
	ptr_struct->feature_cap_mask[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);
	}

}

void pcam_reg_print(const struct pcam_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pcam_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_reg_group     : " UH_FMT "\n", ptr_struct->access_reg_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "feature_group        : " UH_FMT "\n", ptr_struct->feature_group);

	for (i = 0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_access_reg_cap_mask_%03d : " UH_FMT "\n", i, ptr_struct->port_access_reg_cap_mask[i]);
	}

	for (i = 0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "feature_cap_mask_%03d : " UH_FMT "\n", i, ptr_struct->feature_cap_mask[i]);
	}

}

int pcam_reg_size(void)
{
	return 80;
}

void pcam_reg_dump(const struct pcam_reg *ptr_struct, FILE *file)
{
	pcam_reg_print(ptr_struct, file, 0);
}

void pddr_reg_pack(const struct pddr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->page_select);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->module_info_ext);

	offset = 64;
	pddr_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void pddr_reg_unpack(struct pddr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 56;
	ptr_struct->page_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 33;
	ptr_struct->module_info_ext = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	pddr_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void pddr_reg_print(const struct pddr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pddr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_select          : " UH_FMT "\n", ptr_struct->page_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_info_ext      : " UH_FMT "\n", ptr_struct->module_info_ext);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	pddr_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int pddr_reg_size(void)
{
	return 256;
}

void pddr_reg_dump(const struct pddr_reg *ptr_struct, FILE *file)
{
	pddr_reg_print(ptr_struct, file, 0);
}

void pemi_reg_pack(const struct pemi_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->status);

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->module_info_ext);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->page_select);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->group_cap_mask);

	offset = 64;
	pemi_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void pemi_reg_unpack(struct pemi_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 26;
	ptr_struct->module_info_ext = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 59;
	ptr_struct->page_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 32;
	ptr_struct->group_cap_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 64;
	pemi_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void pemi_reg_print(const struct pemi_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pemi_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_info_ext      : " UH_FMT "\n", ptr_struct->module_info_ext);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_select          : %s (" UH_FMT ")\n", (ptr_struct->page_select == 0 ? ("Module_Status_Samples") : ((ptr_struct->page_select == 1 ? ("SNR_Samples") : ((ptr_struct->page_select == 2 ? ("Laser_Monitors_Samples") : ((ptr_struct->page_select == 3 ? ("PAM4_Level_Transition_Samples") : ((ptr_struct->page_select == 4 ? ("Pre_FEC_BER_Samples") : ((ptr_struct->page_select == 5 ? ("FERC_Samples") : ((ptr_struct->page_select == 16 ? ("Module_Status_Properties") : ((ptr_struct->page_select == 17 ? ("SNR_Properties") : ((ptr_struct->page_select == 18 ? ("Laser_Monitors_Properties") : ((ptr_struct->page_select == 19 ? ("PAM4_Level_Transition_Properties") : ((ptr_struct->page_select == 20 ? ("Pre_FEC_BER_Properties") : ((ptr_struct->page_select == 21 ? ("FERC_Properties") : ("unknown")))))))))))))))))))))))), ptr_struct->page_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_cap_mask       : %s (" UH_FMT ")\n", (ptr_struct->group_cap_mask == 1 ? ("Module_Status") : ((ptr_struct->group_cap_mask == 2 ? ("SNR") : ((ptr_struct->group_cap_mask == 4 ? ("Laser_Monitors") : ((ptr_struct->group_cap_mask == 8 ? ("PAM4_Level_Transition") : ((ptr_struct->group_cap_mask == 16 ? ("Pre_FEC_BER") : ((ptr_struct->group_cap_mask == 32 ? ("FERC") : ("unknown")))))))))))), ptr_struct->group_cap_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	pemi_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int pemi_reg_size(void)
{
	return 256;
}

void pemi_reg_dump(const struct pemi_reg *ptr_struct, FILE *file)
{
	pemi_reg_print(ptr_struct, file, 0);
}

void peucg_reg_pack(const struct peucg_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->status);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unit);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->enum_init);

	offset = 47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clr);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->db);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->payload_size);

	offset = 86;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->db_index);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->num_of_entries);

	for (i = 0; i < 47; i++) {
	offset = adb2c_calc_array_field_address(96, 32, i, 1600, 1);
	peucg_page_data_pack(&(ptr_struct->page_data[i]), ptr_buff + offset/8);
	}

}

void peucg_reg_unpack(struct peucg_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->unit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->enum_init = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 47;
	ptr_struct->clr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 46;
	ptr_struct->db = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 86;
	ptr_struct->db_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 70;
	ptr_struct->num_of_entries = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	for (i = 0; i < 47; i++) {
	offset = adb2c_calc_array_field_address(96, 32, i, 1600, 1);
	peucg_page_data_unpack(&(ptr_struct->page_data[i]), ptr_buff + offset/8);
	}

}

void peucg_reg_print(const struct peucg_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== peucg_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unit                 : " UH_FMT "\n", ptr_struct->unit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enum_init            : " UH_FMT "\n", ptr_struct->enum_init);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clr                  : " UH_FMT "\n", ptr_struct->clr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db                   : " UH_FMT "\n", ptr_struct->db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_size         : " UH_FMT "\n", ptr_struct->payload_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_index             : " UH_FMT "\n", ptr_struct->db_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_entries       : " UH_FMT "\n", ptr_struct->num_of_entries);

	for (i = 0; i < 47; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data_%03d:\n", i);
	peucg_page_data_print(&(ptr_struct->page_data[i]), file, indent_level + 1);
	}

}

int peucg_reg_size(void)
{
	return 200;
}

void peucg_reg_dump(const struct peucg_reg *ptr_struct, FILE *file)
{
	peucg_reg_print(ptr_struct, file, 0);
}

void pmcr_reg_pack(const struct pmcr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->c_db);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->error_code_response);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cs_sel);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cdr_override_cntl);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cdr_override_value);

	offset = 46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_disable_override_cntl);

	offset = 38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_disable_override_value);

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_amp_override_cntl);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_amp_override_value);

	offset = 78;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_los_override_cntl);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_los_override_admin);

	offset = 126;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_emp_override_cntl);

	offset = 116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_emp_override_value);

	offset = 110;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_post_emp_override_cntl);

	offset = 100;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_post_emp_override_value);

	offset = 158;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_equ_override_cntl);

	offset = 148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_equ_override_value);

	offset = 142;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tx_adaptive_override_value);

	offset = 134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_adaptive_override_cntrl);

	offset = 190;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rs_override_cntl);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rs_override_value);

	offset = 222;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ap_sel_override_cntrl);

	offset = 212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ap_sel_override_value);

	offset = 198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->si_override_cntrl);

}

void pmcr_reg_unpack(struct pmcr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->c_db = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 20;
	ptr_struct->error_code_response = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 6;
	ptr_struct->cs_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 62;
	ptr_struct->cdr_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 52;
	ptr_struct->cdr_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 46;
	ptr_struct->tx_disable_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 38;
	ptr_struct->tx_disable_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 94;
	ptr_struct->rx_amp_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 84;
	ptr_struct->rx_amp_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 78;
	ptr_struct->rx_los_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 70;
	ptr_struct->rx_los_override_admin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 126;
	ptr_struct->rx_emp_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 116;
	ptr_struct->rx_emp_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 110;
	ptr_struct->rx_post_emp_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 100;
	ptr_struct->rx_post_emp_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 158;
	ptr_struct->tx_equ_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 148;
	ptr_struct->tx_equ_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 142;
	ptr_struct->tx_adaptive_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 134;
	ptr_struct->tx_adaptive_override_cntrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 190;
	ptr_struct->rs_override_cntl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 180;
	ptr_struct->rs_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 222;
	ptr_struct->ap_sel_override_cntrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 212;
	ptr_struct->ap_sel_override_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 198;
	ptr_struct->si_override_cntrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void pmcr_reg_print(const struct pmcr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pmcr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "c_db                 : " UH_FMT "\n", ptr_struct->c_db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_code_response  : " UH_FMT "\n", ptr_struct->error_code_response);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cs_sel               : " UH_FMT "\n", ptr_struct->cs_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_override_cntl    : " UH_FMT "\n", ptr_struct->cdr_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_override_value   : " UH_FMT "\n", ptr_struct->cdr_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_disable_override_cntl : " UH_FMT "\n", ptr_struct->tx_disable_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_disable_override_value : " UH_FMT "\n", ptr_struct->tx_disable_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_amp_override_cntl : " UH_FMT "\n", ptr_struct->rx_amp_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_amp_override_value : " UH_FMT "\n", ptr_struct->rx_amp_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_los_override_cntl : " UH_FMT "\n", ptr_struct->rx_los_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_los_override_admin : " UH_FMT "\n", ptr_struct->rx_los_override_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_emp_override_cntl : " UH_FMT "\n", ptr_struct->rx_emp_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_emp_override_value : " UH_FMT "\n", ptr_struct->rx_emp_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_post_emp_override_cntl : " UH_FMT "\n", ptr_struct->rx_post_emp_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_post_emp_override_value : " UH_FMT "\n", ptr_struct->rx_post_emp_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_equ_override_cntl : " UH_FMT "\n", ptr_struct->tx_equ_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_equ_override_value : " UH_FMT "\n", ptr_struct->tx_equ_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_adaptive_override_value : " UH_FMT "\n", ptr_struct->tx_adaptive_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_adaptive_override_cntrl : " UH_FMT "\n", ptr_struct->tx_adaptive_override_cntrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_override_cntl     : " UH_FMT "\n", ptr_struct->rs_override_cntl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_override_value    : " UH_FMT "\n", ptr_struct->rs_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ap_sel_override_cntrl : " UH_FMT "\n", ptr_struct->ap_sel_override_cntrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ap_sel_override_value : " UH_FMT "\n", ptr_struct->ap_sel_override_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "si_override_cntrl    : " UH_FMT "\n", ptr_struct->si_override_cntrl);

}

int pmcr_reg_size(void)
{
	return 28;
}

void pmcr_reg_dump(const struct pmcr_reg *ptr_struct, FILE *file)
{
	pmcr_reg_print(ptr_struct, file, 0);
}

void pmdr_reg_pack(const struct pmdr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mcm_tile_valid);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gb_valid);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->clp_1x);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->clp_4x);

	offset = 49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->cluster);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->module);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pport);

	offset = 89;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ib_port);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->module_lane_mask);

	offset = 77;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->swid);

	offset = 69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->split);

	offset = 124;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sd_lane_mask_rx);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sd_lane_mask_tx);

	offset = 118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sd_4x_rx);

	offset = 116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sd_4x_tx);

	offset = 114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->usr_sd_4x_rx);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->usr_sd_4x_tx);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port_query);

	offset = 97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->label_port_query);

	offset = 153;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->gearbox_die_num);

	offset = 147;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->tile_pport);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mcm_tile_num);

	offset = 132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tile_cluster);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->slot_index);

	offset = 189;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane0_physical_rx);

	offset = 186;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane1_physical_rx);

	offset = 183;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane2_physical_rx);

	offset = 180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane3_physical_rx);

	offset = 177;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane4_physical_rx);

	offset = 174;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane5_physical_rx);

	offset = 171;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane6_physical_rx);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane7_physical_rx);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->vl_num);

	offset = 221;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane0_physical_tx);

	offset = 218;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane1_physical_tx);

	offset = 215;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane2_physical_tx);

	offset = 212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane3_physical_tx);

	offset = 209;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane4_physical_tx);

	offset = 206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane5_physical_tx);

	offset = 203;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane6_physical_tx);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lane7_physical_tx);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pll_index);

	offset = 252;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL0_lane_map);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL1_lane_map);

	offset = 244;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL2_lane_map);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL3_lane_map);

	offset = 236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL4_lane_map);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL5_lane_map);

	offset = 228;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL6_lane_map);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL7_lane_map);

	offset = 284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL8_lane_map);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL9_lane_map);

	offset = 276;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL10_lane_map);

	offset = 272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL11_lane_map);

	offset = 268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL12_lane_map);

	offset = 264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL13_lane_map);

	offset = 260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL14_lane_map);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL15_lane_map);

	offset = 316;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL16_lane_map);

	offset = 312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL17_lane_map);

	offset = 308;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL18_lane_map);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL19_lane_map);

	offset = 300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL20_lane_map);

	offset = 296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL21_lane_map);

	offset = 292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL22_lane_map);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL23_lane_map);

	offset = 348;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL24_lane_map);

	offset = 344;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL25_lane_map);

	offset = 340;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL26_lane_map);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL27_lane_map);

	offset = 332;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL28_lane_map);

	offset = 328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL29_lane_map);

	offset = 324;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL30_lane_map);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->VL31_lane_map);

}

void pmdr_reg_unpack(struct pmdr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 19;
	ptr_struct->mcm_tile_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 18;
	ptr_struct->gb_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 62;
	ptr_struct->clp_1x = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 58;
	ptr_struct->clp_4x = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 49;
	ptr_struct->cluster = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 40;
	ptr_struct->module = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ptr_struct->pport = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 89;
	ptr_struct->ib_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 80;
	ptr_struct->module_lane_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 77;
	ptr_struct->swid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 69;
	ptr_struct->split = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 124;
	ptr_struct->sd_lane_mask_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 120;
	ptr_struct->sd_lane_mask_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 118;
	ptr_struct->sd_4x_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 116;
	ptr_struct->sd_4x_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 114;
	ptr_struct->usr_sd_4x_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 112;
	ptr_struct->usr_sd_4x_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 104;
	ptr_struct->local_port_query = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 97;
	ptr_struct->label_port_query = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 153;
	ptr_struct->gearbox_die_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset = 147;
	ptr_struct->tile_pport = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 136;
	ptr_struct->mcm_tile_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 132;
	ptr_struct->tile_cluster = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 128;
	ptr_struct->slot_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 189;
	ptr_struct->lane0_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 186;
	ptr_struct->lane1_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 183;
	ptr_struct->lane2_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 180;
	ptr_struct->lane3_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 177;
	ptr_struct->lane4_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 174;
	ptr_struct->lane5_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 171;
	ptr_struct->lane6_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 168;
	ptr_struct->lane7_physical_rx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 160;
	ptr_struct->vl_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 221;
	ptr_struct->lane0_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 218;
	ptr_struct->lane1_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 215;
	ptr_struct->lane2_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 212;
	ptr_struct->lane3_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 209;
	ptr_struct->lane4_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 206;
	ptr_struct->lane5_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 203;
	ptr_struct->lane6_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 200;
	ptr_struct->lane7_physical_tx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 192;
	ptr_struct->pll_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 252;
	ptr_struct->VL0_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 248;
	ptr_struct->VL1_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 244;
	ptr_struct->VL2_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 240;
	ptr_struct->VL3_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 236;
	ptr_struct->VL4_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 232;
	ptr_struct->VL5_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 228;
	ptr_struct->VL6_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->VL7_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 284;
	ptr_struct->VL8_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 280;
	ptr_struct->VL9_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 276;
	ptr_struct->VL10_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 272;
	ptr_struct->VL11_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 268;
	ptr_struct->VL12_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 264;
	ptr_struct->VL13_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 260;
	ptr_struct->VL14_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 256;
	ptr_struct->VL15_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 316;
	ptr_struct->VL16_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 312;
	ptr_struct->VL17_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 308;
	ptr_struct->VL18_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 304;
	ptr_struct->VL19_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 300;
	ptr_struct->VL20_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 296;
	ptr_struct->VL21_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 292;
	ptr_struct->VL22_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->VL23_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 348;
	ptr_struct->VL24_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 344;
	ptr_struct->VL25_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 340;
	ptr_struct->VL26_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 336;
	ptr_struct->VL27_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 332;
	ptr_struct->VL28_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 328;
	ptr_struct->VL29_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 324;
	ptr_struct->VL30_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 320;
	ptr_struct->VL31_lane_map = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void pmdr_reg_print(const struct pmdr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pmdr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mcm_tile_valid       : " UH_FMT "\n", ptr_struct->mcm_tile_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gb_valid             : " UH_FMT "\n", ptr_struct->gb_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clp_1x               : " UH_FMT "\n", ptr_struct->clp_1x);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clp_4x               : " UH_FMT "\n", ptr_struct->clp_4x);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cluster              : " UH_FMT "\n", ptr_struct->cluster);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module               : " UH_FMT "\n", ptr_struct->module);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pport                : " UH_FMT "\n", ptr_struct->pport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_port              : " UH_FMT "\n", ptr_struct->ib_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_lane_mask     : " UH_FMT "\n", ptr_struct->module_lane_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swid                 : " UH_FMT "\n", ptr_struct->swid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "split                : " UH_FMT "\n", ptr_struct->split);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_lane_mask_rx      : " UH_FMT "\n", ptr_struct->sd_lane_mask_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_lane_mask_tx      : " UH_FMT "\n", ptr_struct->sd_lane_mask_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_4x_rx             : " UH_FMT "\n", ptr_struct->sd_4x_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_4x_tx             : " UH_FMT "\n", ptr_struct->sd_4x_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "usr_sd_4x_rx         : " UH_FMT "\n", ptr_struct->usr_sd_4x_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "usr_sd_4x_tx         : " UH_FMT "\n", ptr_struct->usr_sd_4x_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port_query     : " UH_FMT "\n", ptr_struct->local_port_query);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "label_port_query     : " UH_FMT "\n", ptr_struct->label_port_query);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gearbox_die_num      : " UH_FMT "\n", ptr_struct->gearbox_die_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tile_pport           : " UH_FMT "\n", ptr_struct->tile_pport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mcm_tile_num         : " UH_FMT "\n", ptr_struct->mcm_tile_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tile_cluster         : " UH_FMT "\n", ptr_struct->tile_cluster);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_index           : " UH_FMT "\n", ptr_struct->slot_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane0_physical_rx    : " UH_FMT "\n", ptr_struct->lane0_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane1_physical_rx    : " UH_FMT "\n", ptr_struct->lane1_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane2_physical_rx    : " UH_FMT "\n", ptr_struct->lane2_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane3_physical_rx    : " UH_FMT "\n", ptr_struct->lane3_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane4_physical_rx    : " UH_FMT "\n", ptr_struct->lane4_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane5_physical_rx    : " UH_FMT "\n", ptr_struct->lane5_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane6_physical_rx    : " UH_FMT "\n", ptr_struct->lane6_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane7_physical_rx    : " UH_FMT "\n", ptr_struct->lane7_physical_rx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_num               : " UH_FMT "\n", ptr_struct->vl_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane0_physical_tx    : " UH_FMT "\n", ptr_struct->lane0_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane1_physical_tx    : " UH_FMT "\n", ptr_struct->lane1_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane2_physical_tx    : " UH_FMT "\n", ptr_struct->lane2_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane3_physical_tx    : " UH_FMT "\n", ptr_struct->lane3_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane4_physical_tx    : " UH_FMT "\n", ptr_struct->lane4_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane5_physical_tx    : " UH_FMT "\n", ptr_struct->lane5_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane6_physical_tx    : " UH_FMT "\n", ptr_struct->lane6_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane7_physical_tx    : " UH_FMT "\n", ptr_struct->lane7_physical_tx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_index            : " UH_FMT "\n", ptr_struct->pll_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL0_lane_map         : " UH_FMT "\n", ptr_struct->VL0_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL1_lane_map         : " UH_FMT "\n", ptr_struct->VL1_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL2_lane_map         : " UH_FMT "\n", ptr_struct->VL2_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL3_lane_map         : " UH_FMT "\n", ptr_struct->VL3_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL4_lane_map         : " UH_FMT "\n", ptr_struct->VL4_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL5_lane_map         : " UH_FMT "\n", ptr_struct->VL5_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL6_lane_map         : " UH_FMT "\n", ptr_struct->VL6_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL7_lane_map         : " UH_FMT "\n", ptr_struct->VL7_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL8_lane_map         : " UH_FMT "\n", ptr_struct->VL8_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL9_lane_map         : " UH_FMT "\n", ptr_struct->VL9_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL10_lane_map        : " UH_FMT "\n", ptr_struct->VL10_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL11_lane_map        : " UH_FMT "\n", ptr_struct->VL11_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL12_lane_map        : " UH_FMT "\n", ptr_struct->VL12_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL13_lane_map        : " UH_FMT "\n", ptr_struct->VL13_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL14_lane_map        : " UH_FMT "\n", ptr_struct->VL14_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL15_lane_map        : " UH_FMT "\n", ptr_struct->VL15_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL16_lane_map        : " UH_FMT "\n", ptr_struct->VL16_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL17_lane_map        : " UH_FMT "\n", ptr_struct->VL17_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL18_lane_map        : " UH_FMT "\n", ptr_struct->VL18_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL19_lane_map        : " UH_FMT "\n", ptr_struct->VL19_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL20_lane_map        : " UH_FMT "\n", ptr_struct->VL20_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL21_lane_map        : " UH_FMT "\n", ptr_struct->VL21_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL22_lane_map        : " UH_FMT "\n", ptr_struct->VL22_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL23_lane_map        : " UH_FMT "\n", ptr_struct->VL23_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL24_lane_map        : " UH_FMT "\n", ptr_struct->VL24_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL25_lane_map        : " UH_FMT "\n", ptr_struct->VL25_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL26_lane_map        : " UH_FMT "\n", ptr_struct->VL26_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL27_lane_map        : " UH_FMT "\n", ptr_struct->VL27_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL28_lane_map        : " UH_FMT "\n", ptr_struct->VL28_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL29_lane_map        : " UH_FMT "\n", ptr_struct->VL29_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL30_lane_map        : " UH_FMT "\n", ptr_struct->VL30_lane_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VL31_lane_map        : " UH_FMT "\n", ptr_struct->VL31_lane_map);

}

int pmdr_reg_size(void)
{
	return 44;
}

void pmdr_reg_dump(const struct pmdr_reg *ptr_struct, FILE *file)
{
	pmdr_reg_print(ptr_struct, file, 0);
}

void ppamp_reg_pack(const struct ppamp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opamp_group_type);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->opamp_group);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->num_of_indices);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->start_index);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->max_num_of_indices);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->max_opamp_group);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(112, 16, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->index_data[i]);
	}

}

void ppamp_reg_unpack(struct ppamp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->opamp_group_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->opamp_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 52;
	ptr_struct->num_of_indices = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 32;
	ptr_struct->start_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 84;
	ptr_struct->max_num_of_indices = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 72;
	ptr_struct->max_opamp_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(112, 16, i, 352, 1);
	ptr_struct->index_data[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void ppamp_reg_print(const struct ppamp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppamp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opamp_group_type     : " UH_FMT "\n", ptr_struct->opamp_group_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opamp_group          : " UH_FMT "\n", ptr_struct->opamp_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_indices       : " UH_FMT "\n", ptr_struct->num_of_indices);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_index          : " UH_FMT "\n", ptr_struct->start_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_of_indices   : " UH_FMT "\n", ptr_struct->max_num_of_indices);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_opamp_group      : " UH_FMT "\n", ptr_struct->max_opamp_group);

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "index_data_%03d      : " UH_FMT "\n", i, ptr_struct->index_data[i]);
	}

}

int ppamp_reg_size(void)
{
	return 44;
}

void ppamp_reg_dump(const struct ppamp_reg *ptr_struct, FILE *file)
{
	ppamp_reg_print(ptr_struct, file, 0);
}

void ppbmp_reg_pack(const struct ppbmp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->monitor_group);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rs_fec_group);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grp_prf_set);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->grp_prf);

	offset = 32;
	ppbmp_monitor_parameters_pack(&(ptr_struct->monitor_parameters), ptr_buff + offset/8);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->time_window);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sampling_rate);

}

void ppbmp_reg_unpack(struct ppbmp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->monitor_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 21;
	ptr_struct->rs_fec_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 20;
	ptr_struct->grp_prf_set = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 5;
	ptr_struct->grp_prf = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 32;
	ppbmp_monitor_parameters_unpack(&(ptr_struct->monitor_parameters), ptr_buff + offset/8);

	offset = 104;
	ptr_struct->time_window = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset = 152;
	ptr_struct->sampling_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void ppbmp_reg_print(const struct ppbmp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppbmp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monitor_group        : %s (" UH_FMT ")\n", (ptr_struct->monitor_group == 0 ? ("Raw_BER_RS") : ((ptr_struct->monitor_group == 1 ? ("Raw_BER_FC") : ((ptr_struct->monitor_group == 2 ? ("Effective_BER") : ((ptr_struct->monitor_group == 5 ? ("Symbol_BER") : ("unknown")))))))), ptr_struct->monitor_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_group         : " UH_FMT "\n", ptr_struct->rs_fec_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grp_prf_set          : " UH_FMT "\n", ptr_struct->grp_prf_set);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grp_prf              : " UH_FMT "\n", ptr_struct->grp_prf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "monitor_parameters:\n");
	ppbmp_monitor_parameters_print(&(ptr_struct->monitor_parameters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_window          : " UH_FMT "\n", ptr_struct->time_window);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sampling_rate        : " UH_FMT "\n", ptr_struct->sampling_rate);

}

int ppbmp_reg_size(void)
{
	return 48;
}

void ppbmp_reg_dump(const struct ppbmp_reg *ptr_struct, FILE *file)
{
	ppbmp_reg_print(ptr_struct, file, 0);
}

void ppcnt_reg_pack(const struct ppcnt_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->grp);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swid);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->prio_tc);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->grp_profile);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->plane_ind);

	offset = 34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->counters_cap);

	offset = 33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lp_gl);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clr);

	offset = 64;
	ppcnt_reg_counter_set_auto_pack(&(ptr_struct->counter_set), ptr_buff + offset/8);

}

void ppcnt_reg_unpack(struct ppcnt_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 26;
	ptr_struct->grp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset = 20;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->swid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 59;
	ptr_struct->prio_tc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 56;
	ptr_struct->grp_profile = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 52;
	ptr_struct->plane_ind = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 34;
	ptr_struct->counters_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 33;
	ptr_struct->lp_gl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 32;
	ptr_struct->clr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 64;
	ppcnt_reg_counter_set_auto_unpack(&(ptr_struct->counter_set), ptr_buff + offset/8);

}

void ppcnt_reg_print(const struct ppcnt_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppcnt_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grp                  : %s (" UH_FMT ")\n", (ptr_struct->grp == 0 ? ("IEEE_802_3_Counters") : ((ptr_struct->grp == 1 ? ("RFC_2863_Counters") : ((ptr_struct->grp == 2 ? ("RFC_2819_Counters") : ((ptr_struct->grp == 3 ? ("RFC_3635_Counters") : ((ptr_struct->grp == 5 ? ("Ethernet_Extended_Counters") : ((ptr_struct->grp == 6 ? ("Ethernet_Discard_Counters") : ((ptr_struct->grp == 8 ? ("Link_Level_Retransmission_Counters") : ((ptr_struct->grp == 16 ? ("Per_Priority_Counters") : ((ptr_struct->grp == 17 ? ("Per_Traffic_Class_Counters") : ((ptr_struct->grp == 18 ? ("Physical_Layer_Counters") : ((ptr_struct->grp == 19 ? ("Per_Traffic_Class_Congestion_Counters") : ((ptr_struct->grp == 21 ? ("Per_Receive_Buffer_Counters") : ((ptr_struct->grp == 22 ? ("Physical_Layer_Statistical_Counters") : ((ptr_struct->grp == 25 ? ("Out_of_Band_Port_Counters") : ((ptr_struct->grp == 32 ? ("InfiniBand_Port_Counters") : ((ptr_struct->grp == 33 ? ("InfiniBand_Extended_Port_Counters") : ((ptr_struct->grp == 34 ? ("PLR_counters_group") : ((ptr_struct->grp == 35 ? ("RS_FEC_Histogram_group") : ((ptr_struct->grp == 36 ? ("USR_XSR_Physical_layer_counters_group") : ((ptr_struct->grp == 37 ? ("InfiniBand_pkts_counters") : ((ptr_struct->grp == 38 ? ("InfiniBand_General_Counters") : ((ptr_struct->grp == 39 ? ("L1_General_Counters") : ((ptr_struct->grp == 40 ? ("InfiniBand_Packet_Size_Histogram") : ((ptr_struct->grp == 41 ? ("Packet_type_Counters") : ((ptr_struct->grp == 42 ? ("InfiniBand_vl_Counters") : ("unknown")))))))))))))))))))))))))))))))))))))))))))))))))), ptr_struct->grp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : %s (" UH_FMT ")\n", (ptr_struct->pnat == 0 ? ("Local_port_number") : ((ptr_struct->pnat == 1 ? ("IB_port_number") : ((ptr_struct->pnat == 2 ? ("host_port_number") : ((ptr_struct->pnat == 3 ? ("OOB_port_number") : ("unknown")))))))), ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swid                 : " UH_FMT "\n", ptr_struct->swid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prio_tc              : " UH_FMT "\n", ptr_struct->prio_tc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grp_profile          : " UH_FMT "\n", ptr_struct->grp_profile);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plane_ind            : " UH_FMT "\n", ptr_struct->plane_ind);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counters_cap         : " UH_FMT "\n", ptr_struct->counters_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_gl                : " UH_FMT "\n", ptr_struct->lp_gl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clr                  : " UH_FMT "\n", ptr_struct->clr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_set:\n");
	ppcnt_reg_counter_set_auto_print(&(ptr_struct->counter_set), file, indent_level + 1);

}

int ppcnt_reg_size(void)
{
	return 256;
}

void ppcnt_reg_dump(const struct ppcnt_reg *ptr_struct, FILE *file)
{
	ppcnt_reg_print(ptr_struct, file, 0);
}

void pphcr_reg_pack(const struct pphcr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->we);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->active_hist_type);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hist_type);

	offset = 40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_of_bins);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hist_min_measurement);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hist_max_measurement);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->bin_range_write_mask);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 640, 1);
	pphcr_bin_range_pack(&(ptr_struct->bin_range[i]), ptr_buff + offset/8);
	}

}

void pphcr_reg_unpack(struct pphcr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->we = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->active_hist_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 60;
	ptr_struct->hist_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 40;
	ptr_struct->num_of_bins = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 88;
	ptr_struct->hist_min_measurement = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 72;
	ptr_struct->hist_max_measurement = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->bin_range_write_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i = 0; i < 16; i++) {
	offset = adb2c_calc_array_field_address(128, 32, i, 640, 1);
	pphcr_bin_range_unpack(&(ptr_struct->bin_range[i]), ptr_buff + offset/8);
	}

}

void pphcr_reg_print(const struct pphcr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pphcr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "we                   : " UH_FMT "\n", ptr_struct->we);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : %s (" UH_FMT ")\n", (ptr_struct->pnat == 0 ? ("Local_port_number") : ((ptr_struct->pnat == 1 ? ("IB_port_number") : ("unknown")))), ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_hist_type     : " UH_FMT "\n", ptr_struct->active_hist_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_type            : " UH_FMT "\n", ptr_struct->hist_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_bins          : " UH_FMT "\n", ptr_struct->num_of_bins);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_min_measurement : " UH_FMT "\n", ptr_struct->hist_min_measurement);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hist_max_measurement : " UH_FMT "\n", ptr_struct->hist_max_measurement);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bin_range_write_mask : " UH_FMT "\n", ptr_struct->bin_range_write_mask);

	for (i = 0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bin_range_%03d:\n", i);
	pphcr_bin_range_print(&(ptr_struct->bin_range[i]), file, indent_level + 1);
	}

}

int pphcr_reg_size(void)
{
	return 80;
}

void pphcr_reg_dump(const struct pphcr_reg *ptr_struct, FILE *file)
{
	pphcr_reg_print(ptr_struct, file, 0);
}

void ppll_reg_pack(const struct ppll_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_plls);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pci_oob_pll);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pll_group);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_pll_groups);

	offset = 32;
	ppll_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void ppll_reg_unpack(struct ppll_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 28;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->num_plls = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pci_oob_pll = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 8;
	ptr_struct->pll_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->num_pll_groups = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 32;
	ppll_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void ppll_reg_print(const struct ppll_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ppll_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : %s (" UH_FMT ")\n", (ptr_struct->version == 0 ? ("products_28nm") : ((ptr_struct->version == 1 ? ("products_16nm") : ((ptr_struct->version == 4 ? ("products_7nm") : ("unknown")))))), ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_plls             : " UH_FMT "\n", ptr_struct->num_plls);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci_oob_pll          : " UH_FMT "\n", ptr_struct->pci_oob_pll);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_group            : " UH_FMT "\n", ptr_struct->pll_group);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pll_groups       : " UH_FMT "\n", ptr_struct->num_pll_groups);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	ppll_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int ppll_reg_size(void)
{
	return 40;
}

void ppll_reg_dump(const struct ppll_reg *ptr_struct, FILE *file)
{
	ppll_reg_print(ptr_struct, file, 0);
}

void prtl_reg_pack(const struct prtl_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rtt_support);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->latency_accuracy);

	offset = 44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->latency_res);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->local_phy_latency);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->local_mod_dp_latency);

	offset = 136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->round_trip_latency);

}

void prtl_reg_unpack(struct prtl_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 0;
	ptr_struct->rtt_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->latency_accuracy = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 44;
	ptr_struct->latency_res = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 80;
	ptr_struct->local_phy_latency = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 112;
	ptr_struct->local_mod_dp_latency = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 136;
	ptr_struct->round_trip_latency = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void prtl_reg_print(const struct prtl_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== prtl_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rtt_support          : " UH_FMT "\n", ptr_struct->rtt_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latency_accuracy     : " UH_FMT "\n", ptr_struct->latency_accuracy);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latency_res          : " UH_FMT "\n", ptr_struct->latency_res);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_phy_latency    : " UH_FMT "\n", ptr_struct->local_phy_latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_mod_dp_latency : " UH_FMT "\n", ptr_struct->local_mod_dp_latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "round_trip_latency   : " UH_FMT "\n", ptr_struct->round_trip_latency);

}

int prtl_reg_size(void)
{
	return 28;
}

void prtl_reg_dump(const struct prtl_reg *ptr_struct, FILE *file)
{
	prtl_reg_print(ptr_struct, file, 0);
}

void ptas_reg_pack(const struct ptas_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_of_repetitions);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->repetitions_mode);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->algorithm_options);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_grade_weight);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->height_grade_weight);

	offset = 76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phase_grade_type);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->height_grade_type);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grade_version);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->adaptive_tap_measure_bits);

	offset = 96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gisim_measure_bits);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ber_bath_mid_error_threshold);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ber_bath_high_error_threshold);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_high_threshold);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ber_bath_low_error_threshold);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_low_mid_threshold);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_high_mid_threshold);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ndeo_error_threshold);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->one_ratio_low_threshold);

	offset = 280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mix90_phase_for_voltage_bath);

	offset = 256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset_step_size);

	offset = 304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset_end);

	offset = 288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mixer_offset_start);

	offset = 341;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->ber_test_time);

}

void ptas_reg_unpack(struct ptas_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 56;
	ptr_struct->num_of_repetitions = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 52;
	ptr_struct->repetitions_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	ptr_struct->algorithm_options = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 88;
	ptr_struct->phase_grade_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 80;
	ptr_struct->height_grade_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 76;
	ptr_struct->phase_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 72;
	ptr_struct->height_grade_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->grade_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->adaptive_tap_measure_bits = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 96;
	ptr_struct->gisim_measure_bits = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 144;
	ptr_struct->ber_bath_mid_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->ber_bath_high_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 176;
	ptr_struct->one_ratio_high_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->ber_bath_low_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 208;
	ptr_struct->one_ratio_low_mid_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 192;
	ptr_struct->one_ratio_high_mid_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 240;
	ptr_struct->ndeo_error_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->one_ratio_low_threshold = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 280;
	ptr_struct->mix90_phase_for_voltage_bath = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 256;
	ptr_struct->mixer_offset_step_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 304;
	ptr_struct->mixer_offset_end = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 288;
	ptr_struct->mixer_offset_start = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 341;
	ptr_struct->ber_test_time = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void ptas_reg_print(const struct ptas_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ptas_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_repetitions   : " UH_FMT "\n", ptr_struct->num_of_repetitions);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "repetitions_mode     : " UH_FMT "\n", ptr_struct->repetitions_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "algorithm_options    : " UH_FMT "\n", ptr_struct->algorithm_options);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_weight   : " UH_FMT "\n", ptr_struct->phase_grade_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_weight  : " UH_FMT "\n", ptr_struct->height_grade_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_grade_type     : " UH_FMT "\n", ptr_struct->phase_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "height_grade_type    : " UH_FMT "\n", ptr_struct->height_grade_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_version        : " UH_FMT "\n", ptr_struct->grade_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_tap_measure_bits : " UH_FMT "\n", ptr_struct->adaptive_tap_measure_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gisim_measure_bits   : " UH_FMT "\n", ptr_struct->gisim_measure_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_bath_mid_error_threshold : " UH_FMT "\n", ptr_struct->ber_bath_mid_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_bath_high_error_threshold : " UH_FMT "\n", ptr_struct->ber_bath_high_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_high_threshold : " UH_FMT "\n", ptr_struct->one_ratio_high_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_bath_low_error_threshold : " UH_FMT "\n", ptr_struct->ber_bath_low_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_low_mid_threshold : " UH_FMT "\n", ptr_struct->one_ratio_low_mid_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_high_mid_threshold : " UH_FMT "\n", ptr_struct->one_ratio_high_mid_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ndeo_error_threshold : " UH_FMT "\n", ptr_struct->ndeo_error_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_ratio_low_threshold : " UH_FMT "\n", ptr_struct->one_ratio_low_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mix90_phase_for_voltage_bath : " UH_FMT "\n", ptr_struct->mix90_phase_for_voltage_bath);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_step_size : " UH_FMT "\n", ptr_struct->mixer_offset_step_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_end     : " UH_FMT "\n", ptr_struct->mixer_offset_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_start   : " UH_FMT "\n", ptr_struct->mixer_offset_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ber_test_time        : " UH_FMT "\n", ptr_struct->ber_test_time);

}

int ptas_reg_size(void)
{
	return 44;
}

void ptas_reg_dump(const struct ptas_reg *ptr_struct, FILE *file)
{
	ptas_reg_print(ptr_struct, file, 0);
}

void ptys_reg_pack(const struct ptys_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->proto_mask);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_tx_aba_param);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->an_disable_cap);

	offset = 1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->an_disable_admin);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved_high);

	offset = 48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->data_rate_oper);

	offset = 36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->max_port_rate);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->an_status);

	offset = 64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ext_eth_proto_capability);

	offset = 96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_proto_capability);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_proto_capability);

	offset = 128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_link_width_capability);

	offset = 160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ext_eth_proto_admin);

	offset = 192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_proto_admin);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_proto_admin);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_link_width_admin);

	offset = 256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ext_eth_proto_oper);

	offset = 288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_proto_oper);

	offset = 336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_proto_oper);

	offset = 320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_link_width_oper);

	offset = 380;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->connector_type);

	offset = 354;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->force_kr_frames_admin);

	offset = 353;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_kr_frames_cap);

	offset = 384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->eth_proto_lp_advertise);

}

void ptys_reg_unpack(struct ptys_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 29;
	ptr_struct->proto_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 20;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->force_tx_aba_param = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->an_disable_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 1;
	ptr_struct->an_disable_admin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->reserved_high = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 48;
	ptr_struct->data_rate_oper = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 36;
	ptr_struct->max_port_rate = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 32;
	ptr_struct->an_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 64;
	ptr_struct->ext_eth_proto_capability = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 96;
	ptr_struct->eth_proto_capability = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 144;
	ptr_struct->ib_proto_capability = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 128;
	ptr_struct->ib_link_width_capability = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 160;
	ptr_struct->ext_eth_proto_admin = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 192;
	ptr_struct->eth_proto_admin = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 240;
	ptr_struct->ib_proto_admin = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 224;
	ptr_struct->ib_link_width_admin = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 256;
	ptr_struct->ext_eth_proto_oper = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 288;
	ptr_struct->eth_proto_oper = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset = 336;
	ptr_struct->ib_proto_oper = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 320;
	ptr_struct->ib_link_width_oper = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 380;
	ptr_struct->connector_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 354;
	ptr_struct->force_kr_frames_admin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 353;
	ptr_struct->force_kr_frames_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 384;
	ptr_struct->eth_proto_lp_advertise = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void ptys_reg_print(const struct ptys_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== ptys_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "proto_mask           : %s (" UH_FMT ")\n", (ptr_struct->proto_mask == 1 ? ("InfiniBand") : ((ptr_struct->proto_mask == 2 ? ("Reserved") : ((ptr_struct->proto_mask == 4 ? ("Ethernet") : ("unknown")))))), ptr_struct->proto_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : %s (" UH_FMT ")\n", (ptr_struct->port_type == 0 ? ("Network_Port") : ((ptr_struct->port_type == 1 ? ("Near") : ((ptr_struct->port_type == 2 ? ("Internal_IC_Port") : ((ptr_struct->port_type == 3 ? ("Far") : ("unknown")))))))), ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_tx_aba_param   : " UH_FMT "\n", ptr_struct->force_tx_aba_param);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_disable_cap       : " UH_FMT "\n", ptr_struct->an_disable_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_disable_admin     : " UH_FMT "\n", ptr_struct->an_disable_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved_high        : " UH_FMT "\n", ptr_struct->reserved_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_rate_oper       : " UH_FMT "\n", ptr_struct->data_rate_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_port_rate        : " UH_FMT "\n", ptr_struct->max_port_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "an_status            : " UH_FMT "\n", ptr_struct->an_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_eth_proto_capability : " U32H_FMT "\n", ptr_struct->ext_eth_proto_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_capability : " U32H_FMT "\n", ptr_struct->eth_proto_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_proto_capability  : %s (" UH_FMT ")\n", (ptr_struct->ib_proto_capability == 1 ? ("SDR") : ((ptr_struct->ib_proto_capability == 2 ? ("DDR") : ((ptr_struct->ib_proto_capability == 4 ? ("QDR") : ((ptr_struct->ib_proto_capability == 8 ? ("FDR10") : ((ptr_struct->ib_proto_capability == 16 ? ("FDR") : ((ptr_struct->ib_proto_capability == 32 ? ("EDR") : ((ptr_struct->ib_proto_capability == 64 ? ("HDR") : ((ptr_struct->ib_proto_capability == 128 ? ("NDR") : ("unknown")))))))))))))))), ptr_struct->ib_proto_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_link_width_capability : " UH_FMT "\n", ptr_struct->ib_link_width_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_eth_proto_admin  : " U32H_FMT "\n", ptr_struct->ext_eth_proto_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_admin      : " U32H_FMT "\n", ptr_struct->eth_proto_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_proto_admin       : " UH_FMT "\n", ptr_struct->ib_proto_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_link_width_admin  : " UH_FMT "\n", ptr_struct->ib_link_width_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_eth_proto_oper   : " U32H_FMT "\n", ptr_struct->ext_eth_proto_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_oper       : " U32H_FMT "\n", ptr_struct->eth_proto_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_proto_oper        : " UH_FMT "\n", ptr_struct->ib_proto_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_link_width_oper   : " UH_FMT "\n", ptr_struct->ib_link_width_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connector_type       : %s (" UH_FMT ")\n", (ptr_struct->connector_type == 0 ? ("No_connector_or_unknown") : ((ptr_struct->connector_type == 1 ? ("PORT_NONE") : ((ptr_struct->connector_type == 2 ? ("PORT_TP") : ((ptr_struct->connector_type == 3 ? ("PORT_AUI") : ((ptr_struct->connector_type == 4 ? ("PORT_BNC") : ((ptr_struct->connector_type == 5 ? ("PORT_MII") : ((ptr_struct->connector_type == 6 ? ("PORT_FIBRE") : ((ptr_struct->connector_type == 7 ? ("PORT_DA") : ((ptr_struct->connector_type == 8 ? ("PORT_OTHER") : ("unknown")))))))))))))))))), ptr_struct->connector_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_kr_frames_admin : " UH_FMT "\n", ptr_struct->force_kr_frames_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_kr_frames_cap  : " UH_FMT "\n", ptr_struct->force_kr_frames_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_lp_advertise : " U32H_FMT "\n", ptr_struct->eth_proto_lp_advertise);

}

int ptys_reg_size(void)
{
	return 64;
}

void ptys_reg_dump(const struct ptys_reg *ptr_struct, FILE *file)
{
	ptys_reg_print(ptr_struct, file, 0);
}

void pucg_reg_pack(const struct pucg_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unit);

	offset = 6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->transaction);

	offset = 54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->address);

	offset = 32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->payload_size);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 32, i, 2144, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rxtx_mask[i]);
	}

	for (i = 0; i < 122; i++) {
	offset = adb2c_calc_array_field_address(208, 16, i, 2144, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->payload_data[i]);
	}

}

void pucg_reg_unpack(struct pucg_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 7;
	ptr_struct->unit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 6;
	ptr_struct->transaction = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 54;
	ptr_struct->address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset = 32;
	ptr_struct->payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i = 0; i < 4; i++) {
	offset = adb2c_calc_array_field_address(64, 32, i, 2144, 1);
	ptr_struct->rxtx_mask[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	for (i = 0; i < 122; i++) {
	offset = adb2c_calc_array_field_address(208, 16, i, 2144, 1);
	ptr_struct->payload_data[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void pucg_reg_print(const struct pucg_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== pucg_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unit                 : " UH_FMT "\n", ptr_struct->unit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transaction          : " UH_FMT "\n", ptr_struct->transaction);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : " UH_FMT "\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_size         : " UH_FMT "\n", ptr_struct->payload_size);

	for (i = 0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rxtx_mask_%03d       : " U32H_FMT "\n", i, ptr_struct->rxtx_mask[i]);
	}

	for (i = 0; i < 122; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_data_%03d    : " UH_FMT "\n", i, ptr_struct->payload_data[i]);
	}

}

int pucg_reg_size(void)
{
	return 268;
}

void pucg_reg_dump(const struct pucg_reg *ptr_struct, FILE *file)
{
	pucg_reg_print(ptr_struct, file, 0);
}

void slcct_reg_pack(const struct slcct_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->conf_index);

	offset = 52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_of_idx);

	for (i = 0; i < 9; i++) {
	offset = adb2c_calc_array_field_address(64, 32, i, 352, 1);
	ctle_calib_set_pack(&(ptr_struct->ctle_calib_set[i]), ptr_buff + offset/8);
	}

}

void slcct_reg_unpack(struct slcct_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 59;
	ptr_struct->conf_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 52;
	ptr_struct->num_of_idx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	for (i = 0; i < 9; i++) {
	offset = adb2c_calc_array_field_address(64, 32, i, 352, 1);
	ctle_calib_set_unpack(&(ptr_struct->ctle_calib_set[i]), ptr_buff + offset/8);
	}

}

void slcct_reg_print(const struct slcct_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slcct_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "conf_index           : " UH_FMT "\n", ptr_struct->conf_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_idx           : " UH_FMT "\n", ptr_struct->num_of_idx);

	for (i = 0; i < 9; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctle_calib_set_%03d:\n", i);
	ctle_calib_set_print(&(ptr_struct->ctle_calib_set[i]), file, indent_level + 1);
	}

}

int slcct_reg_size(void)
{
	return 44;
}

void slcct_reg_dump(const struct slcct_reg *ptr_struct, FILE *file)
{
	slcct_reg_print(ptr_struct, file, 0);
}

void slcdr_reg_pack(const struct slcdr_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cdr_offset);

	offset = 77;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->cdr_op);

	offset = 74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cdr_aeintf_state);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cdr_state);

	offset = 123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->dco_fine);

	offset = 116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dco_coarse);

	offset = 115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dco_coarse_tune_valid);

	offset = 114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dco_fine_tune_valid);

	offset = 113;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_initialized);

	offset = 111;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_fll_en);

	offset = 110;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_pll_en);

	offset = 109;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_seq_en);

	offset = 108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_seq_abort_en);

	offset = 107;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_fll_locked);

	offset = 106;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_pll_unlocked);

	offset = 105;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_error);

	offset = 100;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cdr_error_cnt);

	offset = 148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->frest);

	offset = 133;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->frdot);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->fravg);

	offset = 223;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bg_valid);

	offset = 221;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pll_a_clk_valid);

	offset = 220;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pll_b_clk_valid);

	offset = 219;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mgmt_clk_en_req);

	offset = 218;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pll_clk_en_req);

	offset = 204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rcal_val);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rcal_tx_n_val);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rcal_tx_p_val);

	offset = 251;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tx_dco_cal_idle);

	offset = 250;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tx_cal_idle);

	offset = 248;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tx_pll_clk_valid_error_flag);

	offset = 240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_pll_clk_valid_error_flag);

	offset = 236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_cal_n_val);

	offset = 232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_cal_p_val);

	offset = 228;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_rcal_val);

	offset = 224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_term_rcal_val);

}

void slcdr_reg_unpack(struct slcdr_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 88;
	ptr_struct->cdr_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 77;
	ptr_struct->cdr_op = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 74;
	ptr_struct->cdr_aeintf_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 70;
	ptr_struct->cdr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 123;
	ptr_struct->dco_fine = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 116;
	ptr_struct->dco_coarse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 115;
	ptr_struct->dco_coarse_tune_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 114;
	ptr_struct->dco_fine_tune_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 113;
	ptr_struct->cdr_initialized = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 111;
	ptr_struct->cdr_fll_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 110;
	ptr_struct->cdr_pll_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 109;
	ptr_struct->cdr_seq_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 108;
	ptr_struct->cdr_seq_abort_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 107;
	ptr_struct->cdr_fll_locked = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 106;
	ptr_struct->cdr_pll_unlocked = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 105;
	ptr_struct->cdr_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 100;
	ptr_struct->cdr_error_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 148;
	ptr_struct->frest = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset = 133;
	ptr_struct->frdot = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 176;
	ptr_struct->fravg = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset = 223;
	ptr_struct->bg_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 221;
	ptr_struct->pll_a_clk_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 220;
	ptr_struct->pll_b_clk_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 219;
	ptr_struct->mgmt_clk_en_req = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 218;
	ptr_struct->pll_clk_en_req = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 204;
	ptr_struct->rcal_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 200;
	ptr_struct->rcal_tx_n_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 196;
	ptr_struct->rcal_tx_p_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 251;
	ptr_struct->tx_dco_cal_idle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 250;
	ptr_struct->tx_cal_idle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 248;
	ptr_struct->tx_pll_clk_valid_error_flag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 240;
	ptr_struct->rx_pll_clk_valid_error_flag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 236;
	ptr_struct->tx_cal_n_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 232;
	ptr_struct->tx_cal_p_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 228;
	ptr_struct->rx_rcal_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 224;
	ptr_struct->rx_term_rcal_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void slcdr_reg_print(const struct slcdr_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slcdr_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_offset           : " UH_FMT "\n", ptr_struct->cdr_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_op               : " UH_FMT "\n", ptr_struct->cdr_op);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_aeintf_state     : " UH_FMT "\n", ptr_struct->cdr_aeintf_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_state            : " UH_FMT "\n", ptr_struct->cdr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dco_fine             : " UH_FMT "\n", ptr_struct->dco_fine);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dco_coarse           : " UH_FMT "\n", ptr_struct->dco_coarse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dco_coarse_tune_valid : " UH_FMT "\n", ptr_struct->dco_coarse_tune_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dco_fine_tune_valid  : " UH_FMT "\n", ptr_struct->dco_fine_tune_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_initialized      : " UH_FMT "\n", ptr_struct->cdr_initialized);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_fll_en           : " UH_FMT "\n", ptr_struct->cdr_fll_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_pll_en           : " UH_FMT "\n", ptr_struct->cdr_pll_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_seq_en           : " UH_FMT "\n", ptr_struct->cdr_seq_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_seq_abort_en     : " UH_FMT "\n", ptr_struct->cdr_seq_abort_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_fll_locked       : " UH_FMT "\n", ptr_struct->cdr_fll_locked);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_pll_unlocked     : " UH_FMT "\n", ptr_struct->cdr_pll_unlocked);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_error            : " UH_FMT "\n", ptr_struct->cdr_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_error_cnt        : " UH_FMT "\n", ptr_struct->cdr_error_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frest                : " UH_FMT "\n", ptr_struct->frest);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frdot                : " UH_FMT "\n", ptr_struct->frdot);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fravg                : " UH_FMT "\n", ptr_struct->fravg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bg_valid             : " UH_FMT "\n", ptr_struct->bg_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_a_clk_valid      : " UH_FMT "\n", ptr_struct->pll_a_clk_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_b_clk_valid      : " UH_FMT "\n", ptr_struct->pll_b_clk_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mgmt_clk_en_req      : " UH_FMT "\n", ptr_struct->mgmt_clk_en_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_clk_en_req       : " UH_FMT "\n", ptr_struct->pll_clk_en_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_val             : " UH_FMT "\n", ptr_struct->rcal_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_tx_n_val        : " UH_FMT "\n", ptr_struct->rcal_tx_n_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcal_tx_p_val        : " UH_FMT "\n", ptr_struct->rcal_tx_p_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_dco_cal_idle      : " UH_FMT "\n", ptr_struct->tx_dco_cal_idle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cal_idle          : " UH_FMT "\n", ptr_struct->tx_cal_idle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_pll_clk_valid_error_flag : " UH_FMT "\n", ptr_struct->tx_pll_clk_valid_error_flag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pll_clk_valid_error_flag : " UH_FMT "\n", ptr_struct->rx_pll_clk_valid_error_flag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cal_n_val         : " UH_FMT "\n", ptr_struct->tx_cal_n_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cal_p_val         : " UH_FMT "\n", ptr_struct->tx_cal_p_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_rcal_val          : " UH_FMT "\n", ptr_struct->rx_rcal_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_term_rcal_val     : " UH_FMT "\n", ptr_struct->rx_term_rcal_val);

}

int slcdr_reg_size(void)
{
	return 36;
}

void slcdr_reg_dump(const struct slcdr_reg *ptr_struct, FILE *file)
{
	slcdr_reg_print(ptr_struct, file, 0);
}

void sllm_reg_pack(const struct sllm_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->c_db);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	sllm_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void sllm_reg_unpack(struct sllm_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->c_db = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	sllm_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void sllm_reg_print(const struct sllm_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sllm_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "c_db                 : " UH_FMT "\n", ptr_struct->c_db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	sllm_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int sllm_reg_size(void)
{
	return 48;
}

void sllm_reg_dump(const struct sllm_reg *ptr_struct, FILE *file)
{
	sllm_reg_print(ptr_struct, file, 0);
}

void slpmu_reg_pack(const struct slpmu_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->type);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->pmu_out);

	offset = 51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_pass);

	offset = 50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_valid);

	offset = 95;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_en);

	offset = 94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_chopper_en);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_rd_mode);

	offset = 88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pmu_sel);

	offset = 87;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_rail_en);

	offset = 86;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_rail_high);

	offset = 85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_rail_cal_en);

	offset = 84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_leveldet_en);

	offset = 81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->pmu_res_ctrl);

	offset = 80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_ckdiv2);

	offset = 79;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_en_ovrd);

	offset = 75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_start);

	offset = 74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_start_ovrd);

	offset = 73;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_load);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_load_ovrd);

	offset = 68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pmu_bias_time);

	offset = 67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pmu_fs_sel);

	offset = 117;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->pmu_th_min);

	offset = 101;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->pmu_th_max);

	offset = 157;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->tx_atest_sel);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rx_atest_sel);

	offset = 149;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_bias_atest_sel);

	offset = 147;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_tah_atest_sel);

	offset = 141;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->tx_clkrcv_atest_sel);

	offset = 138;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_clkrcv_atest_sel);

	offset = 134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_rvdd_atest_sel);

	offset = 130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_rvdd_atest_sel);

	offset = 189;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->tx_bias_atest_sel);

	offset = 185;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_clkbuf_atest_sel);

	offset = 181;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_txpll_atest_sel);

	offset = 178;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->tx_cal_adc_atest_sel);

	offset = 173;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_term_atest_sel);

	offset = 167;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rx_vga_atest_sel);

	offset = 161;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_ctle_atest_sel);

	offset = 221;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_dco_atest_sel);

	offset = 215;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rx_adc_atest_sel);

	offset = 210;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_calcomp_atest_sel);

	offset = 207;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atest_en);

	offset = 206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atest_amp_byp);

	offset = 196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->atest_sel);

}

void slpmu_reg_unpack(struct slpmu_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 53;
	ptr_struct->pmu_out = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 51;
	ptr_struct->pmu_pass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 50;
	ptr_struct->pmu_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 95;
	ptr_struct->pmu_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 94;
	ptr_struct->pmu_chopper_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 92;
	ptr_struct->pmu_rd_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 88;
	ptr_struct->pmu_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 87;
	ptr_struct->pmu_rail_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 86;
	ptr_struct->pmu_rail_high = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 85;
	ptr_struct->pmu_rail_cal_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 84;
	ptr_struct->pmu_leveldet_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 81;
	ptr_struct->pmu_res_ctrl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 80;
	ptr_struct->pmu_ckdiv2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 79;
	ptr_struct->pmu_en_ovrd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 75;
	ptr_struct->pmu_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 74;
	ptr_struct->pmu_start_ovrd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 73;
	ptr_struct->pmu_load = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 72;
	ptr_struct->pmu_load_ovrd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 68;
	ptr_struct->pmu_bias_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 67;
	ptr_struct->pmu_fs_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 117;
	ptr_struct->pmu_th_min = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 101;
	ptr_struct->pmu_th_max = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset = 157;
	ptr_struct->tx_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 152;
	ptr_struct->rx_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 149;
	ptr_struct->rx_bias_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 147;
	ptr_struct->rx_tah_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 141;
	ptr_struct->tx_clkrcv_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 138;
	ptr_struct->rx_clkrcv_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 134;
	ptr_struct->tx_rvdd_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 130;
	ptr_struct->rx_rvdd_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 189;
	ptr_struct->tx_bias_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 185;
	ptr_struct->tx_clkbuf_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 181;
	ptr_struct->tx_txpll_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 178;
	ptr_struct->tx_cal_adc_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 173;
	ptr_struct->rx_term_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 167;
	ptr_struct->rx_vga_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 161;
	ptr_struct->rx_ctle_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 221;
	ptr_struct->rx_dco_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 215;
	ptr_struct->rx_adc_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 210;
	ptr_struct->rx_calcomp_atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 207;
	ptr_struct->atest_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 206;
	ptr_struct->atest_amp_byp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 196;
	ptr_struct->atest_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void slpmu_reg_print(const struct slpmu_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slpmu_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : " UH_FMT "\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_out              : " UH_FMT "\n", ptr_struct->pmu_out);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_pass             : " UH_FMT "\n", ptr_struct->pmu_pass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_valid            : " UH_FMT "\n", ptr_struct->pmu_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_en               : " UH_FMT "\n", ptr_struct->pmu_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_chopper_en       : " UH_FMT "\n", ptr_struct->pmu_chopper_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_rd_mode          : " UH_FMT "\n", ptr_struct->pmu_rd_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_sel              : " UH_FMT "\n", ptr_struct->pmu_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_rail_en          : " UH_FMT "\n", ptr_struct->pmu_rail_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_rail_high        : " UH_FMT "\n", ptr_struct->pmu_rail_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_rail_cal_en      : " UH_FMT "\n", ptr_struct->pmu_rail_cal_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_leveldet_en      : " UH_FMT "\n", ptr_struct->pmu_leveldet_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_res_ctrl         : " UH_FMT "\n", ptr_struct->pmu_res_ctrl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_ckdiv2           : " UH_FMT "\n", ptr_struct->pmu_ckdiv2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_en_ovrd          : " UH_FMT "\n", ptr_struct->pmu_en_ovrd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_start            : " UH_FMT "\n", ptr_struct->pmu_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_start_ovrd       : " UH_FMT "\n", ptr_struct->pmu_start_ovrd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_load             : " UH_FMT "\n", ptr_struct->pmu_load);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_load_ovrd        : " UH_FMT "\n", ptr_struct->pmu_load_ovrd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_bias_time        : " UH_FMT "\n", ptr_struct->pmu_bias_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_fs_sel           : " UH_FMT "\n", ptr_struct->pmu_fs_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_th_min           : " UH_FMT "\n", ptr_struct->pmu_th_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmu_th_max           : " UH_FMT "\n", ptr_struct->pmu_th_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_atest_sel         : " UH_FMT "\n", ptr_struct->tx_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_atest_sel         : " UH_FMT "\n", ptr_struct->rx_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_bias_atest_sel    : " UH_FMT "\n", ptr_struct->rx_bias_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_tah_atest_sel     : " UH_FMT "\n", ptr_struct->rx_tah_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_clkrcv_atest_sel  : " UH_FMT "\n", ptr_struct->tx_clkrcv_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_clkrcv_atest_sel  : " UH_FMT "\n", ptr_struct->rx_clkrcv_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_rvdd_atest_sel    : " UH_FMT "\n", ptr_struct->tx_rvdd_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_rvdd_atest_sel    : " UH_FMT "\n", ptr_struct->rx_rvdd_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_bias_atest_sel    : " UH_FMT "\n", ptr_struct->tx_bias_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_clkbuf_atest_sel  : " UH_FMT "\n", ptr_struct->tx_clkbuf_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_txpll_atest_sel   : " UH_FMT "\n", ptr_struct->tx_txpll_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_cal_adc_atest_sel : " UH_FMT "\n", ptr_struct->tx_cal_adc_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_term_atest_sel    : " UH_FMT "\n", ptr_struct->rx_term_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_vga_atest_sel     : " UH_FMT "\n", ptr_struct->rx_vga_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_ctle_atest_sel    : " UH_FMT "\n", ptr_struct->rx_ctle_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_dco_atest_sel     : " UH_FMT "\n", ptr_struct->rx_dco_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_adc_atest_sel     : " UH_FMT "\n", ptr_struct->rx_adc_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_calcomp_atest_sel : " UH_FMT "\n", ptr_struct->rx_calcomp_atest_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atest_en             : " UH_FMT "\n", ptr_struct->atest_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atest_amp_byp        : " UH_FMT "\n", ptr_struct->atest_amp_byp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atest_sel            : " UH_FMT "\n", ptr_struct->atest_sel);

}

int slpmu_reg_size(void)
{
	return 40;
}

void slpmu_reg_dump(const struct slpmu_reg *ptr_struct, FILE *file)
{
	slpmu_reg_print(ptr_struct, file, 0);
}

void slreg_reg_pack(const struct slreg_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->eidx);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	slreg_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slreg_reg_unpack(struct slreg_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 30;
	ptr_struct->eidx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	slreg_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slreg_reg_print(const struct slreg_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slreg_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eidx                 : " UH_FMT "\n", ptr_struct->eidx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	slreg_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int slreg_reg_size(void)
{
	return 76;
}

void slreg_reg_dump(const struct slreg_reg *ptr_struct, FILE *file)
{
	slreg_reg_print(ptr_struct, file, 0);
}

void slrg_reg_pack(const struct slrg_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->test_mode);

	offset = 30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->all_lanes);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	slrg_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrg_reg_unpack(struct slrg_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->test_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 30;
	ptr_struct->all_lanes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	slrg_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrg_reg_print(const struct slrg_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrg_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "test_mode            : " UH_FMT "\n", ptr_struct->test_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "all_lanes            : %s (" UH_FMT ")\n", (ptr_struct->all_lanes == 0 ? ("per_lane_measurement") : ((ptr_struct->all_lanes == 1 ? ("all_lane_measurement") : ("unknown")))), ptr_struct->all_lanes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	slrg_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int slrg_reg_size(void)
{
	return 168;
}

void slrg_reg_dump(const struct slrg_reg *ptr_struct, FILE *file)
{
	slrg_reg_print(ptr_struct, file, 0);
}

void slrip_reg_pack(const struct slrip_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	slrip_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrip_reg_unpack(struct slrip_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	slrip_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrip_reg_print(const struct slrip_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrip_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	slrip_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int slrip_reg_size(void)
{
	return 92;
}

void slrip_reg_dump(const struct slrip_reg *ptr_struct, FILE *file)
{
	slrip_reg_print(ptr_struct, file, 0);
}

void slrp_reg_pack(const struct slrp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->status);

	offset = 32;
	slrp_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrp_reg_unpack(struct slrp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 32;
	slrp_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void slrp_reg_print(const struct slrp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slrp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	slrp_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int slrp_reg_size(void)
{
	return 152;
}

void slrp_reg_dump(const struct slrp_reg *ptr_struct, FILE *file)
{
	slrp_reg_print(ptr_struct, file, 0);
}

void slsir_reg_pack(const struct slsir_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_type);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->imem_chksm_error);

	offset = 62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cdr_error);

	offset = 61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->feq_adc_overload);

	offset = 60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->peq_adc_overload);

	offset = 59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->nop_dsovf_error);

	offset = 58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->nop_dsunf_error);

	offset = 57;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->nop_rsovf_error);

	offset = 56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->nop_rsunf_error);

	offset = 92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_ugl_state);

	offset = 77;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_eq_ugl_state);

	offset = 72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_cal_ugl_state);

	offset = 70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_eom_ugl_state);

	offset = 64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_ugl_state);

	offset = 120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rd_iter_cnt);

	offset = 112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sd_iter_cnt);

	offset = 104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sd_hits_cnt);

	offset = 152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_init_done_cnt);

	offset = 144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_init_abort_cnt);

	offset = 139;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ae_state);

	offset = 184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cal_done_cnt);

	offset = 176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cal_abort_cnt);

	offset = 168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cdr_done_cnt);

	offset = 160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cdr_abort_cnt);

	offset = 216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eom_done_cnt);

	offset = 208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eom_abort_cnt);

	offset = 200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eq_done_cnt);

	offset = 192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eq_abort_cnt);

}

void slsir_reg_unpack(struct slsir_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 24;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 18;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 63;
	ptr_struct->imem_chksm_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 62;
	ptr_struct->cdr_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 61;
	ptr_struct->feq_adc_overload = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 60;
	ptr_struct->peq_adc_overload = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 59;
	ptr_struct->nop_dsovf_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 58;
	ptr_struct->nop_dsunf_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 57;
	ptr_struct->nop_rsovf_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 56;
	ptr_struct->nop_rsunf_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 92;
	ptr_struct->tx_ugl_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 77;
	ptr_struct->rx_eq_ugl_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 72;
	ptr_struct->rx_cal_ugl_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 70;
	ptr_struct->rx_eom_ugl_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 64;
	ptr_struct->rx_ugl_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 120;
	ptr_struct->rd_iter_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 112;
	ptr_struct->sd_iter_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 104;
	ptr_struct->sd_hits_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 152;
	ptr_struct->rx_init_done_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 144;
	ptr_struct->rx_init_abort_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 139;
	ptr_struct->ae_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset = 184;
	ptr_struct->cal_done_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 176;
	ptr_struct->cal_abort_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 168;
	ptr_struct->cdr_done_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 160;
	ptr_struct->cdr_abort_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 216;
	ptr_struct->eom_done_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 208;
	ptr_struct->eom_abort_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 200;
	ptr_struct->eq_done_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 192;
	ptr_struct->eq_abort_cnt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void slsir_reg_print(const struct slsir_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== slsir_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "imem_chksm_error     : " UH_FMT "\n", ptr_struct->imem_chksm_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_error            : " UH_FMT "\n", ptr_struct->cdr_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "feq_adc_overload     : " UH_FMT "\n", ptr_struct->feq_adc_overload);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peq_adc_overload     : " UH_FMT "\n", ptr_struct->peq_adc_overload);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nop_dsovf_error      : " UH_FMT "\n", ptr_struct->nop_dsovf_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nop_dsunf_error      : " UH_FMT "\n", ptr_struct->nop_dsunf_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nop_rsovf_error      : " UH_FMT "\n", ptr_struct->nop_rsovf_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nop_rsunf_error      : " UH_FMT "\n", ptr_struct->nop_rsunf_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_ugl_state         : " UH_FMT "\n", ptr_struct->tx_ugl_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_eq_ugl_state      : " UH_FMT "\n", ptr_struct->rx_eq_ugl_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cal_ugl_state     : " UH_FMT "\n", ptr_struct->rx_cal_ugl_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_eom_ugl_state     : " UH_FMT "\n", ptr_struct->rx_eom_ugl_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_ugl_state         : " UH_FMT "\n", ptr_struct->rx_ugl_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rd_iter_cnt          : " UH_FMT "\n", ptr_struct->rd_iter_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_iter_cnt          : " UH_FMT "\n", ptr_struct->sd_iter_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sd_hits_cnt          : " UH_FMT "\n", ptr_struct->sd_hits_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_init_done_cnt     : " UH_FMT "\n", ptr_struct->rx_init_done_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_init_abort_cnt    : " UH_FMT "\n", ptr_struct->rx_init_abort_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ae_state             : %s (" UH_FMT ")\n", (ptr_struct->ae_state == 0 ? ("AE_STATE_RESET") : ((ptr_struct->ae_state == 1 ? ("AE_STATE_INIT") : ((ptr_struct->ae_state == 2 ? ("AE_STATE_IDLE") : ((ptr_struct->ae_state == 3 ? ("AE_STATE_HALT") : ((ptr_struct->ae_state == 4 ? ("AE_STATE_RXINIT") : ((ptr_struct->ae_state == 5 ? ("AE_STATE_RXINIT_DONE") : ((ptr_struct->ae_state == 6 ? ("AE_STATE_RXINIT_ABORT") : ((ptr_struct->ae_state == 7 ? ("AE_STATE_CDR_SEQ") : ((ptr_struct->ae_state == 8 ? ("AE_STATE_CDR_SEQ_DONE") : ((ptr_struct->ae_state == 9 ? ("AE_STATE_CDR_SEQ_ABORT") : ((ptr_struct->ae_state == 10 ? ("AE_STATE_CAL") : ((ptr_struct->ae_state == 11 ? ("AE_STATE_CAL_DONE") : ((ptr_struct->ae_state == 12 ? ("AE_STATE_CAL_ABORT") : ((ptr_struct->ae_state == 13 ? ("AE_STATE_FEQTRN") : ((ptr_struct->ae_state == 14 ? ("AE_STATE_PEQTRN") : ((ptr_struct->ae_state == 15 ? ("AE_STATE_EQTRN_DONE") : ((ptr_struct->ae_state == 16 ? ("AE_STATE_EQTRN_ABORT") : ((ptr_struct->ae_state == 17 ? ("AE_STATE_EOM") : ((ptr_struct->ae_state == 18 ? ("AE_STATE_EOM_DONE") : ((ptr_struct->ae_state == 19 ? ("AE_STATE_EOM_ABORT") : ((ptr_struct->ae_state == 20 ? ("AE_STATE_RAMP") : ((ptr_struct->ae_state == 21 ? ("AE_STATE_RAMP_ABORT") : ((ptr_struct->ae_state == 22 ? ("AE_STATE_MARGIN") : ((ptr_struct->ae_state == 23 ? ("AE_STATE_MARGIN_YIELD") : ((ptr_struct->ae_state == 24 ? ("AE_STATE_MARGIN_DONE") : ("unknown")))))))))))))))))))))))))))))))))))))))))))))))))), ptr_struct->ae_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_done_cnt         : " UH_FMT "\n", ptr_struct->cal_done_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cal_abort_cnt        : " UH_FMT "\n", ptr_struct->cal_abort_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_done_cnt         : " UH_FMT "\n", ptr_struct->cdr_done_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cdr_abort_cnt        : " UH_FMT "\n", ptr_struct->cdr_abort_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_done_cnt         : " UH_FMT "\n", ptr_struct->eom_done_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eom_abort_cnt        : " UH_FMT "\n", ptr_struct->eom_abort_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eq_done_cnt          : " UH_FMT "\n", ptr_struct->eq_done_cnt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eq_abort_cnt         : " UH_FMT "\n", ptr_struct->eq_abort_cnt);

}

int slsir_reg_size(void)
{
	return 28;
}

void slsir_reg_dump(const struct slsir_reg *ptr_struct, FILE *file)
{
	slsir_reg_print(ptr_struct, file, 0);
}

void sltp_reg_pack(const struct sltp_reg *ptr_struct, u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->c_db);

	offset = 28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port_type);

	offset = 24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane_speed);

	offset = 20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lane);

	offset = 19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->conf_mod);

	offset = 18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tx_policy);

	offset = 16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset = 8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset = 4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset = 3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status);

	offset = 2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lane_broadcast);

	offset = 0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->lp_msb);

	offset = 32;
	sltp_reg_page_data_auto_pack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void sltp_reg_unpack(struct sltp_reg *ptr_struct, const u_int8_t *ptr_buff)
{
	u_int32_t offset;
	int i = 0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset = 31;
	ptr_struct->c_db = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 28;
	ptr_struct->port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset = 24;
	ptr_struct->lane_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 20;
	ptr_struct->lane = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 19;
	ptr_struct->conf_mod = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 18;
	ptr_struct->tx_policy = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset = 4;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset = 3;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 2;
	ptr_struct->lane_broadcast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset = 0;
	ptr_struct->lp_msb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset = 32;
	sltp_reg_page_data_auto_unpack(&(ptr_struct->page_data), ptr_buff + offset/8);

}

void sltp_reg_print(const struct sltp_reg *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== sltp_reg ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "c_db                 : " UH_FMT "\n", ptr_struct->c_db);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_type            : " UH_FMT "\n", ptr_struct->port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_speed           : " UH_FMT "\n", ptr_struct->lane_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane                 : " UH_FMT "\n", ptr_struct->lane);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "conf_mod             : " UH_FMT "\n", ptr_struct->conf_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_policy            : " UH_FMT "\n", ptr_struct->tx_policy);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : " UH_FMT "\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : " UH_FMT "\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : " UH_FMT "\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : " UH_FMT "\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_broadcast       : " UH_FMT "\n", ptr_struct->lane_broadcast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lp_msb               : " UH_FMT "\n", ptr_struct->lp_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_data:\n");
	sltp_reg_page_data_auto_print(&(ptr_struct->page_data), file, indent_level + 1);

}

int sltp_reg_size(void)
{
	return 76;
}

void sltp_reg_dump(const struct sltp_reg *ptr_struct, FILE *file)
{
	sltp_reg_print(ptr_struct, file, 0);
}

void PACKETS_INTERNAL_pack(const union PACKETS_INTERNAL *ptr_struct, u_int8_t *ptr_buff)
{
	ppcnt_reg_pack(&(ptr_struct->ppcnt_reg), ptr_buff);
}

void PACKETS_INTERNAL_unpack(union PACKETS_INTERNAL *ptr_struct, const u_int8_t *ptr_buff)
{
	ppcnt_reg_unpack(&(ptr_struct->ppcnt_reg), ptr_buff);
}

void PACKETS_INTERNAL_print(const union PACKETS_INTERNAL *ptr_struct, FILE *file, int indent_level)
{
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== PACKETS_INTERNAL ========\n");
	int i = 0;
	(void)i;
	(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_LossyLinkConfig:\n");
	SMP_LossyLinkConfig_print(&(ptr_struct->SMP_LossyLinkConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "VendorSpec_PhyConfig:\n");
	VendorSpec_PhyConfig_print(&(ptr_struct->VendorSpec_PhyConfig), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_TemperatureSensing:\n");
	SMP_TemperatureSensing_print(&(ptr_struct->SMP_TemperatureSensing), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_212_255:\n");
	CableInfo_Payload_Addr_212_255_print(&(ptr_struct->CableInfo_Payload_Addr_212_255), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_168_211:\n");
	CableInfo_Payload_Addr_168_211_print(&(ptr_struct->CableInfo_Payload_Addr_168_211), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_128_167:\n");
	CableInfo_Payload_Addr_128_167_print(&(ptr_struct->CableInfo_Payload_Addr_128_167), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_0_47:\n");
	CableInfo_Payload_Addr_0_47_print(&(ptr_struct->CableInfo_Payload_Addr_0_47), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_48_79:\n");
	CableInfo_Payload_Addr_48_79_print(&(ptr_struct->CableInfo_Payload_Addr_48_79), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Addr_80_127:\n");
	CableInfo_Payload_Addr_80_127_print(&(ptr_struct->CableInfo_Payload_Addr_80_127), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_3_Addr_212_255:\n");
	CableInfo_Payload_Page_3_Addr_212_255_print(&(ptr_struct->CableInfo_Payload_Page_3_Addr_212_255), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_3_Addr_128_175:\n");
	CableInfo_Payload_Page_3_Addr_128_175_print(&(ptr_struct->CableInfo_Payload_Page_3_Addr_128_175), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_F0_Addr_128_171:\n");
	CableInfo_Payload_Page_F0_Addr_128_171_print(&(ptr_struct->CableInfo_Payload_Page_F0_Addr_128_171), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_E9_Addr_128_175:\n");
	CableInfo_Payload_Page_E9_Addr_128_175_print(&(ptr_struct->CableInfo_Payload_Page_E9_Addr_128_175), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "CableInfo_Payload_Page_E9_Addr_176_211:\n");
	CableInfo_Payload_Page_E9_Addr_176_211_print(&(ptr_struct->CableInfo_Payload_Page_E9_Addr_176_211), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_MAD_AttrMod_CableInfo:\n");
	SMP_MAD_AttrMod_CableInfo_print(&(ptr_struct->SMP_MAD_AttrMod_CableInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_CableInfo:\n");
	SMP_CableInfo_print(&(ptr_struct->SMP_CableInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAD_SMP_AttrMod_EyeOpen:\n");
	SMP_MAD_AttrMod_EyeOpen_print(&(ptr_struct->MAD_SMP_AttrMod_EyeOpen), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SMP_EyeOpen:\n");
	SMP_EyeOpen_print(&(ptr_struct->SMP_EyeOpen), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDPageIdentification:\n");
	DDPageIdentification_print(&(ptr_struct->DDPageIdentification), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDModuleInfo:\n");
	DDModuleInfo_print(&(ptr_struct->DDModuleInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DDLatchedFlagInfo:\n");
	DDLatchedFlagInfo_print(&(ptr_struct->DDLatchedFlagInfo), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "DD_PhyStatisticalCounters:\n");
	DD_PhyStatisticalCounters_print(&(ptr_struct->DD_PhyStatisticalCounters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfcr_reg:\n");
	mfcr_reg_print(&(ptr_struct->mfcr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfsm_reg:\n");
	mfsm_reg_print(&(ptr_struct->mfsm_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfsl_reg:\n");
	mfsl_reg_print(&(ptr_struct->mfsl_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fore_reg:\n");
	fore_reg_print(&(ptr_struct->fore_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfnr_reg:\n");
	mfnr_reg_print(&(ptr_struct->mfnr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtcap_reg:\n");
	mtcap_reg_print(&(ptr_struct->mtcap_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtmp_reg:\n");
	mtmp_reg_print(&(ptr_struct->mtmp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtwe_reg:\n");
	mtwe_reg_print(&(ptr_struct->mtwe_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mvcap_reg:\n");
	mvcap_reg_print(&(ptr_struct->mvcap_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mvcr_reg:\n");
	mvcr_reg_print(&(ptr_struct->mvcr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msps_reg:\n");
	msps_reg_print(&(ptr_struct->msps_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msgi_reg:\n");
	msgi_reg_print(&(ptr_struct->msgi_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg_reg:\n");
	slrg_reg_print(&(ptr_struct->slrg_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp_reg:\n");
	slrp_reg_print(&(ptr_struct->slrp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp_reg:\n");
	sltp_reg_print(&(ptr_struct->sltp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptas_reg:\n");
	ptas_reg_print(&(ptr_struct->ptas_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmdr_reg:\n");
	pmdr_reg_print(&(ptr_struct->pmdr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppll_reg:\n");
	ppll_reg_print(&(ptr_struct->ppll_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpein_reg:\n");
	mpein_reg_print(&(ptr_struct->mpein_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpir_reg:\n");
	mpir_reg_print(&(ptr_struct->mpir_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrip_reg:\n");
	slrip_reg_print(&(ptr_struct->slrip_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slreg_reg:\n");
	slreg_reg_print(&(ptr_struct->slreg_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slcct_reg:\n");
	slcct_reg_print(&(ptr_struct->slcct_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sllm_reg:\n");
	sllm_reg_print(&(ptr_struct->sllm_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppamp_reg:\n");
	ppamp_reg_print(&(ptr_struct->ppamp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pphcr_reg:\n");
	pphcr_reg_print(&(ptr_struct->pphcr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slcdr_reg:\n");
	slcdr_reg_print(&(ptr_struct->slcdr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slpmu_reg:\n");
	slpmu_reg_print(&(ptr_struct->slpmu_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slsir_reg:\n");
	slsir_reg_print(&(ptr_struct->slsir_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peucg_reg:\n");
	peucg_reg_print(&(ptr_struct->peucg_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peucg_page_data:\n");
	peucg_page_data_print(&(ptr_struct->peucg_page_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pucg_reg:\n");
	pucg_reg_print(&(ptr_struct->pucg_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmcr_reg:\n");
	pmcr_reg_print(&(ptr_struct->pmcr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptys_reg:\n");
	ptys_reg_print(&(ptr_struct->ptys_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pddr_reg:\n");
	pddr_reg_print(&(ptr_struct->pddr_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pemi_reg:\n");
	pemi_reg_print(&(ptr_struct->pemi_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcam_reg:\n");
	pcam_reg_print(&(ptr_struct->pcam_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prtl_reg:\n");
	prtl_reg_print(&(ptr_struct->prtl_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppbmp_reg:\n");
	ppbmp_reg_print(&(ptr_struct->ppbmp_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mrcs_reg:\n");
	mrcs_reg_print(&(ptr_struct->mrcs_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpcnt_reg:\n");
	mpcnt_reg_print(&(ptr_struct->mpcnt_reg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt_reg:\n");
	ppcnt_reg_print(&(ptr_struct->ppcnt_reg), file, indent_level + 1);

}

int PACKETS_INTERNAL_size(void)
{
	return 16777216;
}

void PACKETS_INTERNAL_dump(const union PACKETS_INTERNAL *ptr_struct, FILE *file)
{
	PACKETS_INTERNAL_print(ptr_struct, file, 0);
}

